	SUBROUTINE LOAD_Q(SECT_ADDR)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&LOAD_Q\&
C .nf
C .x LOAD_Q>Defined
C Source:LOAD_Q.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:23-MAR-1987 14:34:02.04
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    SECT_ADDR                  INTEGER*4 (2)                                     
C                               GLOBAL ADDRESS OF THE TEMP GLOBAL SECTION.        
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    QUEUE_DUMP.DAT                                                               
C                               READ                                              
C .X QUEUE_DUMP.DAT>READ
C  
C Other modules referenced:
C  
C .X FTN_IOSTAT>Referenced
C    FTN_IOSTAT                 PRINTS FORTRAN/RMS ERROR STATUS                   
C                                (found in library:INLAND)
C .SK
C .fill
C .SK
C Description:
C .sk    
C This subroutine is responsible for loading the queue from a
C saved dump file.  The subroutine calls the system service
C RTR_WRITE_Q which does a write as if it were the global system
C common.  This subroutines builds its own bogus expanded region
C and fakes the system service out.  
C end.doc ****************************** end.doc  

	INTEGER*4 SECT_ADDR	! Section address (starting, ending V.A.)
	INTEGER*4 Q_BLOCK(2)	! P0 expanded region
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(PEXDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSG)/LIST'
C
	RECORD/PEXDEF/PEX	! P0 expanded region
	CHARACTER*80 LOAD_FILE_NAME  ! Name of the dump file of the queue
	INTEGER*4 LOAD_FILE_NAME_LTH	! length of the load file
	INTEGER*4 LOAD_LUN
	PARAMETER (LOAD_LUN=3)	! Lun for the dump file
c
	INTEGER*4 MAXSIZE
	PARAMETER(MAXSIZE=4096)	! LARGEST MESSAGE TO READ
C
	STRUCTURE/INPREC/
	UNION
	MAP
		BYTE INALL(MAXSIZE+HDR$K_SIZ)
	END MAP
	MAP
		CHARACTER*16 MID	! Message id
		RECORD/HDRDEF/HDR	! Message header
		BYTE MSG(MAXSIZE)	! Data portion of message
	END MAP
	END UNION
	END STRUCTURE
C
	RECORD/INPREC/INPREC
	INTEGER*4 SYS_STATUS	! Return status
	INTEGER*4 DESCP(2)	! CHARACTER TYPE DESCRIPTOR	

C
C We will do what the system service ATTACH_Q does ourselves
c and then link all the blocks in by using the router
c entry.
c The only problem is that there is no checkpoint process,
c but that is no problem as we will checkpoint the file when
c we are all done and the service will still to the function
c as desired.
c
	Q_BLOCK(1)=%LOC(PEX)	! Fake start of expanded region
	Q_BLOCK(2)=Q_BLOCK(1)+PEX$K_LEN  ! fake end of expanded region
c
	PEX.PEX$L_SREG=Q_BLOCK(1)	! starting and ending P0 region
	PEX.PEX$L_EREG=Q_BLOCK(2)
c
	PEX.PEX$Q_GSRETADR(1)=SECT_ADDR(1) ! Where Queue is mapped
	PEX.PEX$Q_GSRETADR(2)=SECT_ADDR(2)
c
	WRITE(*,100)
100	FORMAT('$Enter saved dump file: '
	1	'[Default: SYS$DISK:QUEUE_DUMP.DAT;]:')
	READ(*,200,END=9000)LOAD_FILE_NAME_LTH,
	1	LOAD_FILE_NAME(1:LOAD_FILE_NAME_LTH)
200	FORMAT(Q,A<LOAD_FILE_NAME_LTH>)
	IF(LOAD_FILE_NAME_LTH .EQ. 0)THEN
		LOAD_FILE_NAME='SYS$DISK:QUEUE_DUMP.DAT;'
		LOAD_FILE_NAME_LTH=24	! NUMBER BYTES IN DUMP FILE NAME
	ENDIF
C
	OPEN(UNIT=LOAD_LUN,
	1	NAME=LOAD_FILE_NAME(1:LOAD_FILE_NAME_LTH),
	1	ERR=9100,TYPE='OLD',
	1	FORM='UNFORMATTED')
C
C Read each record from the load file and call system service
c to put it into the queue
c
500	CONTINUE		! Loop here until file is copied
	READ(LOAD_LUN,END=800)INPREC
	TYPE *,' Populating message id: ',INPREC.MID
	DESCP(1)=INPREC.HDR.HDR$W_LEN
	DESCP(2)=%LOC(INPREC.HDR)
C
C Write it to the queue
c
	SYS_STATUS=RTR_WRITE_Q(Q_BLOCK,
	1	INPREC.HDR,
	1	DESCP)
C
	IF(SYS_STATUS .NE. %LOC(QUE_NOCHK))THEN	! error?
		TYPE *,' Error while loading the queue'
		TYPE *,' WRITE_Q_RTR status: ',SYS_STATUS
		TYpe *,' EXITING '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	GO TO 500	! GO UNTIL END OF FILE
800	RETURN
C
9000	TYPE *,' No messages will be loaded into the queue'
	RETURN
9100	TYPE *,' File open error on the load file'
	CALL FTN_IOSTAT
	RETURN
	END
