	OPTIONS/EXTEND
	SUBROUTINE ACK_LAST_WRITE(NRB,BUF,NRBID)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&ACK_LAST_WRITE\&
C .nf
C .x ACK_LAST_WRITE>Defined
C Source:ACK_LAST_WRITE.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:10-SEP-86
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NRB OF NODE WHICH THIS MESSAGE WAS RECEIVED ON.   
C  
C    BUF                        STRUCTURE/BUFDEF/                                 
C                               ACTUAL BUFFER RECEIVED                            
C  
C    NRBID                      STRUCTURE/NRBID/
C	                        NRB MESSAGE ID'S
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON                                                             
C                               MA_ROUTER LOCAL COMMON                            
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG ERROR MESSAGE                                 
C                                (found in library:INLAND)
C  
C .X ACK_READ>Referenced
C    ACK_READ                   ACKNOWLEGE MESSAGE TO QUEUE SYSTEM SERVICE        
C                                (found in library:QUEUE)
C 
C .X MARK_NOPEND>Referenced
c    MARK_NOPEND                CLEAR RESPONSE PENDING BIT IN MID WHEN ALL DONE
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called to acknowlege the last written message
C read from the queue and which the response message is in "BUF".
C The subroutine does some verifications to make sure all is 
C good (such as the index) and simply calls the ACK_READ system
C service.  After acknowleging the message in the queue, the response
c pending bit in the Message ID list head status word is cleared.  Also
c since more messages may have come in, set our wake up event flag
c if there are free buffers.
c 
C .literal
C 	CALLING SEQUENCE:
C 
C 	CALL ACK_LAST_WRITE(NRB,BUF,NRBID)
C .END LITERAL
C 
C 
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(BUFDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBID)/LIST'
	RECORD/BUFDEF/BUF
	RECORD/NRBDEF/NRB
	RECORD/NRBID/NRBID(*)
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$SETEF	! SET EVENT FLAG
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 ACK_READ	! ACKNOWLEGE MESSAGE	
	INTEGER*4 I
	INTEGER*4 ID_DESCP(2)	! MESSAGE ID DESCRIPTOR

C
C VALIDATE THE INDEX
C
	IF(BUF.BUF$S_MSG.MGH$L_IDX .LE. 0 .OR.
	1	BUF.BUF$S_MSG.MGH$L_IDX .GT. NRB.NRB$L_IDCNT)THEN
		SYS_STATUS=OPR_FAO_MSG(RTR_BADIDX,  ! LOG ERROR
	1		%val(BUF.BUF$S_MSG.MGH$L_IDX),
	1		NRB.NRB$C_CURNODE,
	1		BUF.BUF$S_MSG.MGH$C_MID)
C
C		SINCE CAN'T FIND VIA THE INDEX, MUST SCAN THE
C		MESSAGE ID'S FOR THIS NODE VIA THE NRB TO SEE
C 		IF WE CAN FIND ONE.  THIS IS WHERE THE RNA
C		IS STORED SO WE MUST HAVE IT TO ACKNOWLEGE THE
C		READ.
C
		DO I=1,NRB.NRB$L_IDCNT	! LOOP FOR NUMBER MESSAGE IDS DEFINED
		   IF(BUF.BUF$S_MSG.MGH$C_MID .EQ.
	1		NRBID(I).NRBID$C_MSGID)THEN
			IF(NRBID(I).NRBID$L_RNA .EQ.0)THEN  ! NO MESSAGE?
			   SYS_STATUS=OPR_FAO_MSG(RTR_NORNA,
	1			NRB.NRB$C_CURNODE,
	1			BUF.BUF$S_MSG.MGH$C_MID)
			ELSE
D			   SYS_STATUS=OPR_FAO_MSG(RTR_ACKMSG,
D	1			NRB.NRB$C_CURNODE,
D	1			BUF.BUF$S_MSG.MGH$C_MID)
			   SYS_STATUS=ACK_READ(Q_BLOCK,  ! ACK READ THEN
	1			 NRBID(I).NRBID$C_MSGID,
	1			 NRBID(I).NRBID$L_RNA)
			   NRBID(I).NRBID$L_RNA=0    ! WHATEVER ERROR IS, DONE
			   IF(.NOT. SYS_STATUS)THEN  ! QUEUE SERVICE ERROR
				MSGDESC(1)=512
				STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1				MSGDESC(1),MSGDESC,,)
				SYS_STATUS=OPR_FAO_MSG(RTR_ACKRDE,
	1				MSGDESC,
	1				NRB.NRB$C_CURNODE,
	1				BUF.BUF$S_MSG.MGH$C_MID)
			   ENDIF
			 ENDIF
			 RETURN
		   ENDIF
		ENDDO
C
C		COULDN'T EVEN FIND THE MESSAGE ID
C
		SYS_STATUS=OPR_FAO_MSG(RTR_NOSUCHID,
	1		NRB.NRB$C_CURNODE,
	1		BUF.BUF$S_MSG.MGH$C_MID)
		RETURN

C
C  HAVE VALID INDEX, THEN SIMPLY CALL ACK_READ
C
	ELSE
C
	   I=BUF.BUF$S_MSG.MGH$L_IDX
D	   SYS_STATUS=OPR_FAO_MSG(RTR_ACKMSG,
D	1	NRB.NRB$C_CURNODE,
D	1	BUF.BUF$S_MSG.MGH$C_MID)
	   SYS_STATUS=ACK_READ(Q_BLOCK,  ! ACK READ THEN
	1	NRBID(I).NRBID$C_MSGID,
	1	NRBID(I).NRBID$L_RNA)
	   NRBID(I).NRBID$L_RNA=0	 ! WHATEVER ERROR IS, DONE
	   IF(.NOT. SYS_STATUS)THEN  ! QUEUE SERVICE ERROR
		MSGDESC(1)=512
		STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1		MSGDESC(1),MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_ACKRDE,
	1		MSGDESC,
	1		NRB.NRB$C_CURNODE,
	1		BUF.BUF$S_MSG.MGH$C_MID)
	   ENDIF
C
C	   SET WAKE UP EVENT FLAG SO WE WILL ROUTE SOME MORE
C	   AND CLEAR THE RESPONSE PENDING BIT
C
	   IF(BUF_AVAIL .NE. 0)	! IF BUFFERS ARE AVAILABLE, SET EVENT FLAT
	1	SYS_STATUS=SYS$SETEF(%VAL(MESG_EFN)) ! IN CASE MORE TO GO OUT
	   CALL MARK_NOPEND(NRB,BUF,Q_BLOCK) ! FLAG AS NO LONGER WAITING FOR
					     ! RESPONSE
	ENDIF
	RETURN
	END
