$!
$! THIS COMMAND FILE DOES A COMPLETE BACKUP OF ALL THE MA_Q POOP TO TAPE.
$!
$ SET PROCESS/PRIV=ALL
$!
$! CREATE A UNIQUE SAVE SET NAME AND TAPE LABELS, ETC.
$!
$ LAST_DATE =F$TIME()
$ TAPE_LABEL =	F$CVTIME(LAST_DATE,"ABSOLUTE","YEAR") + -
		F$CVTIME(LAST_DATE,"ABSOLUTE","MONTH") + -
	        F$CVTIME(LAST_DATE,"ABSOLUTE","DAY")
$!
$ SAVSET="MAQ"+"'TAPE_LABEL'"
$ JOURNALFILE="MAQ"+"'TAPE_LABEL'"+".BJL"
$!
$!
$ ON ERROR THEN GOTO ABORTBACKUP
$!
$! ALLOCATE TAPE DRIVE AND GET STARTED
$!
$ ALLOC=F$GETDVI("MUA0:","ALL")
$! 
$! SEE IF SOMEONE ALREADY HAS IT
$!
$ IF ALLOC .EQS. "TRUE" THEN GOTO ABORTBACKUP
$!
$! NEW TAPE, INITIALIZE IT 
$!
$ ALLOCATE MUA0:
$!
$TYPE SYS$INPUT
	INITIALIZING THE TAPE FOR
		1) 1600 BPI
		2) TAPE LABEL MAQ
		3) OVERRIDE OWNERSHIP

$ INITIALIZE /DENSITY=1600-
		/OVERRIDE=OWNER_ID-
		MUA0: MAQ
$!
$! MOUNT THE INITIALIZED TAPE
$!
$MOUNT:
$!
$ MOUNT/FOREIGN MUA0:
$!
$! GET THE VOLUME NAME
$!
$ ACTVOLNAM=F$GETDVI("MUA0:","VOLNAM")
$ IF ACTVOLNAM .EQS. "MAQ" THEN GOTO BACKUP
$!
$! VOLUME NAME DON T MATCH
$ TYPE SYS$INPUT
	THE TAPE VOLUME NAME DO NOT MATCH
	TAPE NAME: 'ACTVOLNAM'
	SHOULD HAVE BEEN: MAQ
	BACKUP WILL BE ABORTED.....
$ GOTO STOPME
$!
$! START THE ACTUAL BACKUP
$!
$BACKUP:
$ BACKUP/IGNORE=INTERLOCK-
	/EXCLUDE=(*.SEC,*.QUE,*.LOG,*.LIS,*.MEM,*.OBJ,*.BJL,*.dbs)-
	/FAST-
	/VERIFY-
	/JOURNAL='JOURNALFILE'-
	/COMMENT="COMPLETE BACKUP: 'TAPE_LABEL'"-
	SYS$SYSDEVICE:[...]*.*; -
	MUA0:'SAVSET'/SAVE_SET
$!
$ BACKUP/JOURNAL='JOURNALFILE'/LIST=BACKUP.LIS
$ PRINT BACKUP.LIS
$!
$ TYPE SYS$INPUT
	BACKUP UP COMPLETE, LISTING OF CONTENT OF TAPE IS
	ON THE LINE PRINTER.
$!
$ STOPME:
$  ON ERROR THEN CONTINUE
$  DISMOUNT/NOUNL MUA0:
$  DEALLOCATE MUA0:
$  EXIT
$! 
$ ABORTBACKUP:
$ TYPE SYS$INPUT
	BACKUP BEING ABORTED BECAUSE TAPE ALLOCATED OR
	VOLUME NAMES MISMATCH

$ EXIT
