	OPTIONS/EXTEND
	INTEGER*4 FUNCTION CONNECT_NODE_AST(NRB,R0,R1,PC,PSL)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&CONNECT_NODE_AST\&
C .nf
C .x CONNECT_NODE_AST>Defined
C Source:CONNECT_NODE_AST.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Copy Right: Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 8-MAY-87
C Revision level     :1.2
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE                                         
C                               NODE ROUTING BLOCK (STATUS ABOUT A PARTICULAR     
C                               NODE.                                             
C  
C    R0                         INTEGER*4                                         
C                               SAVED R0 FROM AST                                 
C  
C    R1                         INTEGER*4                                         
C                               SAVED R1 FROM AST                                 
C  
C    PC                         INTEGER*4                                         
C                               SAVED PC FROM AST                                 
C  
C    PSL                        INTEGER*4                                         
C                               SAVED PSL FROM AST                                
C  
C Returns:
C  
C Accesses common(s):
C 
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MA_ROUTER COMMON PARAMETERS SHARED THROUGHTOUT    
C  
C .X EVENT_Q>Common
C    EVENT_Q                    EVENT QUEUE
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X DISCONNECT_NODE>Referenced
c    DISCONNECT_NODE            IF CONNECT ERROR, CALL TO DISCONNECT AND
C                               START RETRY TIMER
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG MESSAGE TO CONSOLE                            
C                                (found in library:INLAND)
C  
C .X WRITE_QREC>Referenced
c    WRITE_QREC                 WRITE NETWORK STATUS MESSAGE TO QUEUE
C	                        (found in library: QUEUE)
C 
C .X PUSH_EVENT_QUE>Referenced
C    PUSH_EVENT_QUE             USED TO PUSH CONNECT EVENT INTO THE EVENT QUEUE   
C 
C .X MARK_AVAIL>Referenced
c    MARK_AVAIL                 Mark all attached Message ids for a NRB
c                               as routeable again
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called by the system AST services when
C a QIO was requested to connect a node with a remote node.  If the
C status was successful (status block in NRB) then the node is marked
C as reachable and useable.  Otherwise, a retry timer is started, the node
C is marked as down, and the network channel is deassigned.  The status
c long word in the message ID list head is cleared denoting a message
c id that is routeabl again.
c 
C 	Calling Sequence (VIA QIO):
C .nofill
C  
C  SYS_STATUS=SYS$QIO(...%VAL(IO$_ACCESS),...,CONNECT_NODE_AST,NRB,....)
C end.doc ****************************** end.doc  
C
C MODIFICATION HISTORY
C	1.2 5/8/87 E. LAKIA
C	When a node is reconnected, mark all of the message id's
c	that are routed to this node as routeable again, ie:
c	call "MARK_AVAIL".
C
C	1.1  2/24/87  E. LAKIA
C	Add support for a network message when a node changes it state. This
c	allows a process to dequeue these messages and know which nodes
c	are currently available.
c

	INTEGER*4 R1,R0,PSL,PC	! AST PARAMETERS THAT WE DON'T USE IN FORTRAN
	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	RECORD/NRBDEF/NRB		! NODE REQUEST BLOCK
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NETMSG)/list'
	RECORD/NETMSG/NETMSG
C
	INCLUDE 'EVENT_Q.INC/NOLIST'
	RECORD /EVENT_ENTRY/EVENT	! EVENT TO BE PUSHED INTO EVENT QUEUE
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$DASSGN	! DEASSIGN CHANNEL
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 SYS$SETIMR	! SET TIMER
	INTEGER*4 SYS$CANTIM 	! CANCEAL TIMER
	INTEGER*4 SYS$BINTIM	! CONVERT ASCII TIME TO BINARY DELTA TIME
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 PUSH_EVENT_QUE ! PUSH ENTRY INTO EVENT QUEUE
	INTEGER*4 RETRY_TIMER(2)  ! QUAD WORD DELTA TIME FOR RETRY
	INTEGER*4 WRITE_QREC	! WRITE A MESSAGE TO THE MA_QUEUE

C
C DEBUG
C
D	SYS_STATUS=OPR_FAO_MSG(RTR_CONAST,NRB.NRB$Q_NCBDES,
D	1	%VAL(NRB.NRB$Q_NETSTS.COND))
C
C FIND OUT HOW THE REQUEST CONNECT CAME OUT
C
	IF (.NOT. NRB.NRB$Q_NETSTS.COND) THEN  ! BAD STATUS?
	  IF( NRB.NRB$Q_NETSTS.COND .NE.	! SAME STATUS AS LAST TIME
	1	NRB.NRB$Q_OLDSTS.COND .OR.	! NO, THEN LOG NEW
	1	NRB.NRB$Q_OLDSTS.COND .EQ. 0)THEN 	
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(NRB.NRB$Q_NETSTS.COND),
	1	   MSGDESC(1),MSGDESC,,)
	   	SYS_STATUS=OPR_FAO_MSG(RTR_REQFAL,MSGDESC,NRB.NRB$Q_NCBDES)
	  ENDIF
C
	  NRB.NRB$Q_OLDSTS=NRB.NRB$Q_NETSTS	! COPY OLD=NEW STATUS
	  CALL DISCONNECT_NODE(NRB)	! CALL TO HAVE NODE DISCONNECTED
	  RETURN

C
C GOOD CONNECT STATUS
C
	ELSE				! GOOD STATUS
	  NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .AND. 
	1	(.NOT. (NRB$M_DWN .OR. NRB$M_ATM)) ! CLEAR DOWN FLAG AND REQ.
	  NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .OR. 
	1	NRB$M_LNKAVL  ! MARK LINK AS AVAILABLE
	  NRB.NRB$Q_OLDSTS=NRB.NRB$Q_NETSTS	! SAVE NEW STATUS
	  MSGDESC(1)=512
	  SYS_STATUS=SYS$GETMSG(%VAL(NRB.NRB$Q_NETSTS.COND),
	1	   MSGDESC(1),MSGDESC,,)
	  SYS_STATUS=OPR_FAO_MSG(RTR_LNKCON,MSGDESC,NRB.NRB$Q_NCBDES)
	  EVENT.EVENT=CON_COMP	! CONNECT COMPLETE
	  EVENT.NRBADD=%LOC(NRB)	! PASS NRB ADDRESS
	  SYS_STATUS=PUSH_EVENT_QUE(EVENT)	! PLACE IN EVENT QUEUE
C
C	  CLEAR THE CONNECT TIMER
C
	  IF((NRB.NRB$L_FLAGS .AND. NRB$M_CONTIMER) .NE. 0)THEN
		SYS_STATUS=SYS$CANTIM(NRB,)	! CANCEAL TIMER
		IF (.NOT. SYS_STATUS)THEN
	 	    MSGDESC(1)=512
	 	    SYS_STATUS=SYS$GETMSG(%VAL(NRB.NRB$Q_NETSTS.COND),
	1	    MSGDESC(1),MSGDESC,,)
	  	    SYS_STATUS=OPR_FAO_MSG(RTR_TMRERR,MSGDESC,
	1		NRB.NRB$C_CURNODE)
		ENDIF		   
		NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .AND.
	1		(.NOT. NRB$M_CONTIMER)  ! CLEAR AS NOLONG ACTIVE
	  ENDIF
	  EVENT.EVENT=FIND_WORK
	  EVENT.NRBADD=%LOC(NRB)
	  SYS_STATUS=PUSH_EVENT_QUE(EVENT)
C
C	  Write a message into the Q for any program that is interested
c	  in the change of the network status
c
	  IF(NETMSGINDEX .NE. 0)THEN
	     NETMSG.PRINODE=NRB.NRB$C_PRINODE	! FILL IN NODE NAMES
	     NETMSG.SECNODE=NRB.NRB$C_SECNODE
	     NETMSG.NETSTATUS=NRB.NRB$Q_NETSTS.COND ! NETWORK STATUS
	     NETMSG.FLAGS=NRB.NRB$L_FLAGS	! NRB FLAGS
	     NETMSG.UPDOWN=1
	     SYS_STATUS=WRITE_QREC(Q_BLOCK,NET_MSG_ID,
	1			NETMSG,NETMSGLTH,
	1			0,NETMSGINDEX)
	     IF(.NOT. SYS_STATUS)THEN	! WRITE TO QUEUE OK?
	 	    MSGDESC(1)=512
	 	    SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	    MSGDESC(1),MSGDESC,,)
	  	    SYS_STATUS=OPR_FAO_MSG(RTR_QRECERROR,MSGDESC)
		    NETMSGINDEX=0	! DON'T DO IT AGAIN
	     ENDIF
	  ENDIF
c
c 	  Mark any message ids routed by this node as routable again.
c
	  CALL MARK_AVAIL(NRB)   ! Mark them as all routeable
	  return
	endif
	end
