	OPTIONS/EXTEND
	SUBROUTINE DISCONNECT_NODE(NRB)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&DISCONNECT_NODE\&
C .nf
C .x DISCONNECT_NODE>Defined
C Source:DISCONNECT_NODE.FOR
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 6-APR-87
C Revision level     :1.4
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NRB OF NODE THAT IS TO BE DISCONNECTED            
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           GLOBAL COMMON USED BY THE MA_ROUER                
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                USED TO LOG ERROR MESSAGES                        
C                                (found in library:INLAND)
C .X WRITE_QREC>Referenced
c    WRITE_QREC                 Write message to queue service.
c                                (found in library: QUEUE)
c  
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called to disconnect the logical link
C with a remote node.  This routine does it not so gracefully 
C as this routine is called because an error has occurred.
C .sk
C .nofill
C CALL DISCONNECT_NODE(NRB)
C end.doc ****************************** end.doc  
C
C MODIFICATION HISTORY:
C  1.2 2/24/87  E. LAKIA
C	Added support for writing of the NET_STATUS message to the
c MA_QUEUE for anyone who wants to know that a node went down.
c 	In addition, support is added to support the Primary node
c logical name.  This means that the reduntancey support is
c provided by the primary node being a logical type node and the
c secondary node name being the actual node name.  IE: primary
c node name might be "PROD" but the actual DECNET node name would be
c "SY880A"
c

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NETMSG)/LIST'
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$QIO	! QIO SERVICE
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$DASSGN	! DEASSIGN CHANNEL
	INTEGER*4 SYS$EXIT	! SYSTEM EXIT
	INTEGER*4 SYS$BINTIM	! ASCII TO BINARY TIME CONVERSION
	integer*4 sys$setimr	! set timer
	INTEGER*4 SYS$CREPRC	! CREATE PROCESS
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*2 RETRY_TIMER(4)  ! QUAD WORD DELTA TIME FOR RETRY
	INTEGER*4 WRITE_QREC	! WRITE MESSAGE TO QUEUE FUNCTION
C
	RECORD/NRBDEF/NRB	! NRB
	RECORD/NETMSG/NETMSG	! NETWORK STATUS MESSAGE RECORD

C
C LOG FACT WE ARE DISCONNECTING NODE
C
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_DWN) .EQ. 0)  THEN  ! ALREADY DOWN
C						! NO, THEN TELL SOMEONE
		SYS_STATUS=OPR_FAO_MSG(RTR_DISNODE,NRB.NRB$C_CURNODE) !LOG IT
C
C	  	Write a message into the Q for any program that is interested
c	  	in the change of the network status
c
		IF(NETMSGINDEX .NE. 0)THEN
		  NETMSG.PRINODE=NRB.NRB$C_PRINODE	! FILL IN NODE NAMES
		  NETMSG.SECNODE=NRB.NRB$C_SECNODE
	  	  NETMSG.NETSTATUS=NRB.NRB$Q_NETSTS.COND ! NETWORK STATUS
		  NETMSG.FLAGS=NRB.NRB$L_FLAGS	! NRB FLAGS
		  NETMSG.UPDOWN=0
		  SYS_STATUS=WRITE_QREC(Q_BLOCK,NET_MSG_ID,
	1			NETMSG,NETMSGLTH,
	1			0,NETMSGINDEX)
		  IF(.NOT. SYS_STATUS)THEN	! WRITE TO QUEUE OK?
		    MSGDESC(1)=512
	 	    SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	    MSGDESC(1),MSGDESC,,)
	  	    SYS_STATUS=OPR_FAO_MSG(RTR_QRECERROR,MSGDESC)
		    NETMSGINDEX=0	! DON'T DO IT AGAIN
		  ENDIF
		ENDIF
	ENDIF
C
c In either case, we may have to request the FIND_SERVICE 
c process to try to find the node that is suppose to service
c us.
c
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_PRILOG) .NE. 0)THEN ! LOGICAL TYPE NODE?
	  NRB.NRB$C_SECNODE(1:1)=CHAR(0) ! STORE INVALID NODE NAME SO NO 
				     ! CONNECTS WILL SUCCEEED UNTIL FIND
				     ! SERVICE FINDS THE TARGET NODE
	   SYS_STATUS=SYS$CREPRC(,	! PID
	1			IMAGE_NAME,	! REQUEST FIND SERVICE
	1			SYSINPUT,	! PROCESS SYS$INPUT
	1			SYSOUTPUT,	! PROCESS SYS$OUTPUT
	1			SYSERROR,	! PROCESS SYS$ERROR
	1			,,	! PRIV, QUOTA
	1			PROC_NAME,
	1			,,,)	! BASE PRI, UIC, MBX UNIT, STATUS
	   IF(.NOT. SYS_STATUS .AND. 	! GOOD STATUS (DUPICATE PROCESS OK TOO)?
	1	SYS_STATUS .NE. SS$_DUPLNAM)THEN
		    MSGDESC(1)=512
	 	    SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	    MSGDESC(1),MSGDESC,,)
	  	    SYS_STATUS=OPR_FAO_MSG(RTR_CREPRC,MSGDESC)
	   ENDIF
	ENDIF
	NRB.NRB$L_FLAGS= NRB.NRB$L_FLAGS .OR. NRB$M_DWN ! FLAG AS DOWN
C
C		CLEAR ALL BITS THAT DON'T MEAN ANYTHING IF NODE IS DOWN
C
	NRB.NRB$L_FLAGS= NRB.NRB$L_FLAGS .AND. 
	1  (.NOT.(NRB$M_LNKAVL .OR. NRB$M_RNRQC .OR. NRB$M_ATM
	1	.OR. NRB$M_CON ))
C
C	DEASSIGN THE NET CHANNEL AND THE TEMP MAILBOX
C
	IF(NRB.NRB$L_CHAN .EQ. 0)RETURN	! ALREADY DONE?, THEN RETURN
C
	SYS_STATUS=SYS$DASSGN(%VAL(NRB.NRB$L_CHAN)) ! DEASSIGN
	IF(.NOT. SYS_STATUS)THEN
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	   MSGDESC(1),MSGDESC,,)
	   	SYS_STATUS=OPR_FAO_MSG(RTR_DEAFAL,MSGDESC,NRB.NRB$Q_NCBDES)
	endif
C
	SYS_STATUS=SYS$DASSGN(%VAL(NRB.NRB$L_NETMBX)) ! DEASSIGN NETWORK MBX
	  IF(.NOT. SYS_STATUS)THEN
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	   MSGDESC(1),MSGDESC,,)
	   	SYS_STATUS=OPR_FAO_MSG(RTR_DEAFAL,MSGDESC,NRB.NRB$Q_NCBDES)
	  endif
	NRB.NRB$L_NETMBX=0	! ZERO CHANNEL FOR MBX
	NRB.NRB$L_CHAN=0	! ZERO CHANNEL FOR NET
C 
C	NOW START A TIMER OFF SO THAT WE CAN RETRY LATER
C	
	SYS_STATUS = SYS$BINTIM(TIME_DELAY,RETRY_TIMER)
	IF(.NOT. SYS_STATUS)THEN
		  MSGDESC(1)=512
		  SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	     MSGDESC(1),MSGDESC,,)
	   	  SYS_STATUS=OPR_FAO_MSG(RTR_RTYTIM,MSGDESC,NRB.NRB$Q_NCBDES)
		  SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C	ACTUALLY START THE TIMER
C
	SYS_STATUS = SYS$SETIMR(,	! EVENT FLAG
	1		%REF(RETRY_TIMER),	! TIMER VALUE
	1		%VAL(CON_TIMER_AST_ADD), ! AST ADDRESS
	1		NRB)		 ! REQUEST ID (= NRB ADDRESS)
	IF(.NOT. SYS_STATUS)THEN
		  MSGDESC(1)=512
		  SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	     MSGDESC(1),MSGDESC,,)
	   	  SYS_STATUS=OPR_FAO_MSG(RTR_RTYTIM,MSGDESC,NRB.NRB$Q_NCBDES)
		  SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))  ! FATAL BUG ERROR
	ENDIF
	NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .OR.
	1	 NRB$M_CONTIMER	! FLAG AS HAVING A TIMER ACTIVE
	RETURN
	END
