	PROGRAM QIT
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;PROGRAM
C .c ;^&QIT\&
C .nf
C .x QIT>Defined
C Source:QIT.MOD
C Designer           :EARL LAKIA (IPACT)
C Author             :Earl Lakia
C  
C Date of last update: 24-SEP-1988
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk
C 	This is a simple utility that allows anyone at
C the DCL level to request a message be removed from the
c MA_QUEUE. The DCL command is:
c .sk
c .nofill
c      QIT/ID:messag_id[/TIME][/NOPRINT][/COUNT=nn] "up to 160 character message"
c .fill
c .sk
c 	The "/TIME" is an optional parameter that if specified,
c will translate the first 8 bytes of the message using SYS$ASCTIM
c into the equivalent 23 character VMS time.
C 	The "/NOPRINT" is an optional parameter that if specified,
c will not print any of the message, or the header information from
c the message.
c	The "/COUNT=nn" is an optional parameter that if specified, will
c dequeue "nn" messages from the queue.  The default is to remove only
c a single message (ie: /COUNT=1).
c c .sk
c .nofill
c 	DQIT/ID:STOCK_AVERAGE/TIME/COUNT=10
C	DQIT/ID:STOCK_MESG
c .fill
C end.doc ****************************** end.doc  

        INTEGER*4 CLI$GET_VALUE ! Get value of a switch
	INTEGER*4 CLI$PRESENT   ! see if a switch is present
	INTEGER*4 SYS$BINTIM
	INTEGER*4 STATUS	! System service status
	CHARACTER*16 MESGID	! Message ID
	INTEGER*4 IDLEN	! number characters in message id
	INTEGER*4 MESGLEN   ! length of user message
	INTEGER*4 COUNT	    ! number of messages to dequeue
	LOGICAL*1 TIME      ! time conversion requested
	LOGICAL*1 NOPRINT   ! don't print the message
	CHARACTER*10 ASCIICNT	! count from command line in ascii	
	INTEGER*4 CNTLEN	! number of bytes in count from command line
	CHARACTER*80 LINEBUF	! for dumping characters
	INTEGER*4 LINCNT	! number chars. in line so far
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSGVAL)'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QEXDEF)'
	RECORD/QEXDEF/QBX
C
	STRUCTURE/MESSAGE/
	UNION
	MAP
		INTEGER*4 TIME(2)	! time type message
	END MAP
	MAP
		CHARACTER*4096 MESSAGE	! user message
	END MAP
	MAP
		BYTE BUFFER(4096)	! plain vanilla message
	END MAP
	END UNION
	END STRUCTURE
C
	RECORD/MESSAGE/MESSAGE
	LOGICAL TIME
c
c

	STATUS=CLI$GET_VALUE('MESGID', ! Get the message id
	1               MESGID,
	1               IDLEN)
	IF(.NOT. STATUS)THEN
		TYPE *,' Bad get of MESSAGE_ID NAME '
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
C
C See if user entered the time switch
c
        IF(CLI$PRESENT('TIME'))THEN
		TIME=.TRUE.
	ELSE
		TIME=.FALSE.
	ENDIF
C
C See if user entered the NOPRINT switch
c
        IF(CLI$PRESENT('NOPRINT'))THEN
		NOPRINT=.TRUE.
	ELSE
		NOPRINT=.FALSE.
	ENDIF
C
C See if the user entered the COUNT switch
C
        IF(CLI$PRESENT('COUNT'))THEN
		STATUS=CLI$GET_VALUE('COUNT', ! Get the output file
	1               ASCIICNT,
	1               CNTLEN)
		IF(.NOT. STATUS)THEN
			TYPE *,' Unable to get count value'
			CALL SYS$EXIT(%VAL(STATUS))
		ELSE
			READ(ASIICNT(1:CNTLEN),FMT='(I<CNTLEN>)')COUNT
		ENDIF
	ELSE
		COUNT=1	! default is to read only one message
	ENDIF	

C
c Actually attach to queue and read the messages
c
	STATUS=ATTACH_QE(QBX)
	IF (.NOT. STATUS) THEN
		TYPE *,'Error attaching to queue'
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
c
	DO 1000  I=1,COUNT
		STATUS = READ_Q(Q_BLOCK, MESSAGE_ID, MESSAGE.MESSAGE, 
     1		  RNA_POINTER)
		IF(.NOT. STATUS)THEN
		  TYPE *,' Error reading message from queue'
		  CALL SYS$EXIT(%VAL(STATUS))
		ENDIF
		IF(NOPRINT) GO TO 500	! print nothing?
		STATUS = SYS$ASCTIM
	1		(, ASCII_TIME, message.MESBUFHDR.HDR$Q_ONQT, )
		TYPE *,' Header follows: '
		TYPE *,'     Source node name:      ',
	1		 message.MESBUFHDR.HDR$C_SNM
		TYPE *,'     Destination node name: ', 
	1		message.MESBUFHDR.HDR$C_DNM
		TYPE *,'     Message type:          ', 
	1		message.MESBUFHDR.HDR$W_TYPE
		TYPE *,'     On Queue time:         ', 
	1		ASCII_TIME
		STATUS = SYS$ASCTIM(, ASCII_TIME, 
	1		message.MESBUFHDR.HDR$Q_OFFQT, )
		TYPE *,'     Off Queue time:        ', 
	1		ASCII_TIME
		TYPE *,'     Message length:        ', 
	1		message.MESBUFHDR.HDR$W_LEN
		TYPE *,'     Sequence number:       ', 
	1		message.MESBUFHDR.HDR$W_QSEQ
C
C 		Determine the total time queued
c
		IF(MESSAGE.MESBUFHDR.HDR$C_SNM .EQ.	! QUEUED ON LOCAL NODE?
	1		MESSAGE.MESBUFHDR.HDR$C_DNM)THEN	! YES
C
			STATUS=SYS$GETTIM(QUEUE_TIME)	! GET CURRENT TIME
			STATUS=LIB$SUBX(QUEUE_TIME,	! TOTAL TIME= CURRENT-
	1		   MESSAGE.MESBUFHDR.HDR$Q_ONQT,  ! ON QUEUE TIME
	1		   QUEUE_TIME)
		ELSE			! ROUTED HERE FROM REMOTE NODE
			CALL LIB$SUBX(MESSAGE.MESBUFHDR.HDR$Q_OFFQT,
	1		  MESSAGE.MESBUFHDR.HDR$Q_ONQT, ! calc. amount of time
	1		  QUEUE_TIME)	! 	it was queued remotely
			STATUS=SYS$GETTIM(CUR_TIME)	! get current time
			CALL LIB$SUBX(MESSAGE.MESBUFHDR.HDR$Q_OFFQT,
	1		  CUR_TIME,		! calc. time on our node.
	1		  CUR_TIME)		! only valid if nodes are
						! time sync'd.
			CALL LIB$ADDX(CUR_TIME,QUEUE_TIME,QUEUE_TIME)
		ENDIF
		CALL LIB$DAY(DAYS,QUEUE_TIME)
		STATUS = SYS$ASCTIM(, ASCII_TIME, QUEUE_TIME,%VAL(1) )
		TYPE *,' Total on queue time: ',DAYS,'days and ',ASCII_TIME(1:11)
C
	 	IF(TIME)THEN
		  STATUS=SYS$ASCTIM(,ASCII_TIME,MESSAGE.TIME,)
		  TYPE *,' MESSAGE TIME: ',MESSAGE.TIME
		  GO TO 500
	   	ENDIF
C
C		Now write the message in ascii or hex
c
		LINCNT=0
		DO J=1,MESSAGE.MESBUFHDR.HDR$W_LEN
		   LINCNT=LINCNT+1
		   IF(MESSAGE.BUFFER(J) .LT. ICHAR(' ') .or.
	1		MESSAGE.BUFFER(J) .LT. ICHAR('}')THEN  ! Control/noprint
			LINEBUF(LINCNT)='^'
		   ELSE
			LINEBUF(LINCNT)=CHAR(MESSAGE.BUFFER(J))
		   ENDIF
		   IF(LINCNT .EQ. 80)THEN
			TYPE *,LINEBUF
			LINCNT=0
		   ENDIF
	        ENDDO
		IF(LINCNT .NE. 0)TYPE *,LINEBUF(1:LINCNT)
500		CONTINUE
		STATUS = ACK_READ(Q_BLOCK, MESSAGE_ID, RNA_POINTER)
		IF(.NOT. STATUS)THEN
		  TYPE *,' Unable to acknowledge message'
		  CALL SYS$MESSAGE(%VAL(STATUS))
		ENDIF
1000	CONTINUE
c
C detach from queue
c
	STATUS=DETACH_Q(QBX)
	IF(.NOT. STATUS) THEN
		TYPE *,'Unable to detach from queue'
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
	CALL SYS$EXIT(%VAL(STATUS))
	END
