	OPTIONS/EXTEND
	INTEGER*4 FUNCTION MA_R_INIT(DUMMY)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&MA_R_INIT\&
C .nf
C .x MA_R_INIT>Defined
C Source:MA_R_INIT.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update: 16-MAR-87
C Revision level     :1.7
C  
C  	        Inland Steel Co.
C               3210 Watling St.
C               East Chicago, IN   46312
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C    MA_R_INIT                  INTEGER*4
C                               COMPLETION STATUS OF SUBROUTINE
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           CHANNEL NUMBER, VIRTUAL ADDRESSES, ETC. THAT
C                               ARE LOADED BY THIS SUBROUTINE AND USED
C                               THROUTHOUT THIS PROGRAM. 
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X NEW_ROUTING_MAP>Referenced
C    NEW_ROUTING_MAP            CALL TO HAVE THE ROUTING MAP SECTION COMMON
C                               CREATED.
C  
C .X MA_ROUTER_EXIT_HAN>Referenced
C    MA_ROUTER_EXIT_HAN         CALL TO SET UP OUR EXIT HANDLER
C 
C .X NON_BLANK_LEN>Referenced
c    NON_BLANK_LEN              RETURN SIZE OF STRING WITHOUT ENDING BLANKS
C
C .X ATTACH_Q>Referenced
c    ATTACH_Q                   ATTACHES US TO THE GLOBAL QUEUE SECTION FILE
C                               (found in queue.olb, system service)
c
C .X OPR_FAO_MSG>Referenced
c    OPR_FAO_MSG                Used to send messages to operator
C .SK
C .fill
C .SK
C Description:
C .sk
C .CENTER;MA_Q_INIT
C 	This subroutine is responsible for initializing the MA_Q process
C on startup.  The following explains what is needed for startup (not
C necessaryly in order).
C .list
C .le;Attach to the Queue Section (ATTACH_Q).
C .le;Create our mailbox (used by all writing processes to tell us
C when a Message ID queue has gone from 0 to 1, by all receiving 
C processes to tell us that they are connecting to a particular message id,
C by exit handler in processes to tell us that they are exiting (and therefore
C disconnecgting from a message id), and by the Queue utility process
C to tell us that a new routing database is to be installed.
C .le;Call BUILD_ROUTE_TABLE to build our local routing database (EG: message
C ID's to target Nodes).
C .le;Allocate any required event flags, channels, etc.
C .LE;Initialize event Queue
C .le;Setup exit handlers.
C .LE;Create network mailbox and assign a channel to NETACP.
c .le;Tell DECNET that we are to be a known object.  Our
c object name is: "MA_ROUTER".  (may wish to make this a parameter
c or the router database or else a logical name later).
C .LE;Make first attempt to connect to remote nodes
c .LE;Setup initial QIO for the MQ_ROUTER mailbox.
c .le;Attach to the queue region 
C .els
C 	To call this subroutine:
C .nofill
C 
C INTEGER*4 SYS_STATUS
C 
C SYS_STATUS=MA_R_INIT()
C 
C 	
C end.doc ****************************** end.doc  
C
C MODIFICATION HISTORY:
C	2/25/87  E. Lakia  Fixed bug that when file open fails, the
c system will not crash (no routing database and fnd_msg changes mode
c to kernel and bye bye.
c

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($PSLDEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'EVENT_Q.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INTEGER*4 DUMMY		! DUMMY ARGUMENT
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$ASSIGN	! ASSIGN MAILBOX
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 SYS$QIO	! QIO SERVICE
	INTEGER*4 SYS$QIOW	! QIO AND WAIT SERVICE
	INTEGER*4 SYS$CREMBX	! CREATE MAILBOX
	INTEGER*4 SYS$GETMSG	! GET MESSAGE SYSTEM SERVICE
	INTEGER*4 SYS$DCLEXH	! DECLARE EXIT HANDLER
	INTEGER*4 SYS$CLREF	! CLEAR EVENT FLAG
	INTEGER*4 LIB$GET_EF	! GET EVENT FLAG NOT IN USE
	INTEGER*4 LIB$GET_LUN	! GET LOGICAL UNIT NUMBER
	INTEGER*4 LIB$ASN_WTH_MBX
	INTEGER*4 NON_BLANK_LEN	! SIZE OF STRING LESS BLANKS AND NULLS
	INTEGER*4 OPR_FAO_MSG	! SEND FAO MESSAGE TO OPERATOR
	INTEGER*4 NEW_ROUTING_MAP	! NEW ROUTING MAP HANDLER (IE: INIT)
	EXTERNAL MA_ROUTER_EXIT_HAN	! EXIT HANDLER 
	INTEGER*4 MA_ROUTER_EXIT_HAN
	EXTERNAL MA_MBX_AST	! AST HANDLER FOR MA MBX I/O COMPLETION
	INTEGER*4 MA_MBX_AST
	EXTERNAL NET_AST	! NETWORK MAIL AST
	INTEGER*4 NET_AST
	EXTERNAL CONNECT_NODE_AST	! QIO TO CONNECT AST
	INTEGER*4 CONNECT_NODE_AST
	EXTERNAL READ_NET_AST		! QIO TO READ AST
	INTEGER*4 READ_NET_AST
	EXTERNAL WRITE_NET_AST		! QIO TO WRITE AST 
	INTEGER*4 WRITE_NET_AST
	EXTERNAL CON_TIMER_AST		! CONNECTION RETRY TIMER AST
	INTEGER*4 CON_TIMER_AST
	INTEGER*4 NET_READ_RESP_AST	! RESPONSE TO A READ COMPLETE AST
	EXTERNAL NET_READ_RESP_AST
	INTEGER*4 UNFULL_AST		! REMOTE NODE NO LONGER FULL TIMER AST
	EXTERNAL UNFULL_AST
	INTEGER*4 DESBLK(4)	! EXIT HANDLER DESCRIPTOR BLOCK
	INTEGER*4 EXIT_STATUS	! PROCESS EXIT STATUS, WILL BE PASSED TO
				! EXIT HANDLER
	CHARACTER*20 ROUTE_DBS_SECTION_NAME ! SECTION NAME MAXIMUM SIZE
	INTEGER*4 OBJDESCP(2)	! OBJECT DESCRIPTOR
	INTEGER*4 NAMEDESCP(2)	! NAME DESCRIPTOR
C
	STRUCTURE /OBJ/		! DECNET OBJECT STRUCTURE 
		BYTE TYPE
		INTEGER*4 OBJNUM
	END STRUCTURE
	RECORD/OBJ/OBJ
C
	STRUCTURE /NAME/	! DECNET NAME STRUCTURE
	   CHARACTER*10 NM
	END STRUCTURE
	RECORD/NAME/NAME
C
	RECORD/NRBDEF/UNSNRB	! FAKE UNSOLICITED REQUEST FOR  NETACP
C
	DATA ROUTE_DBS_SECTION_NAME/ROUTE_DBS_SECT/

C
C FILL IN DATA FOR OUR FIND SERVICE PROGRAM
C
	PROC_NAME='FIND_SERVICE'
	IMAGE_NAME='MA_Q$PROD:FIND_SERVICE.EXE'
	SYSERROR=  'MA_Q$PROD:FIND_SERVICE.ERR'
	SYSINPUT= 'MA_Q$PROD:FIND_SERVICE.INP'
	SYSOUTPUT= 'MA_Q$PROD:FIND_SERVICE.LOG'
C
C INIT OUR MESSAGE DESCRIPTOR FOR ALL GET MESSAGE TYPE CALLS
C
	MSGDESC(1)=512	! NUMBER OF BYTES IN MESSAGE
	MSGDESC(2)=%LOC(MSGBUF(1))  ! ADDRESS TO DATA FOR ASCII STRING
C
C SET UP AST ADDRESSES SO EVERYONE CAN USE
C
	MA_MBX_AST_ADD=%LOC(MA_MBX_AST)		! STORE AST ADDRESS IN COMMON
	NET_AST_ADD=%LOC(NET_AST)		! NETWORK REQUESTS TO MBX
	CONNECT_NODE_AST_ADD=%LOC(CONNECT_NODE_AST)	! CONNECT QIO AST
	READ_NET_AST_ADD=%LOC(READ_NET_AST)	! DECNET READ QIO COMPLETE AST
	WRITE_NET_AST_ADD=%LOC(WRITE_NET_AST)	! DECNET WRITE QIO COMPLETE AST
	CON_TIMER_AST_ADD=%LOC(CON_TIMER_AST)	! CONNECT TIMER AST ADDRESS
	NET_READ_RESP_AST_ADD=%LOC(NET_READ_RESP_AST) ! READ RESP. AST 
	UNFULL_AST_ADD=%LOC(UNFULL_AST)	    ! REMOTE NODE QUEUE FULL TIMER AST
C
	WRITE(*,900)MA_MBX_AST_ADD,NET_AST_ADD,CONNECT_NODE_AST_ADD,
	1	READ_NET_AST_ADD,WRITE_NET_AST_ADD,CON_TIMER_AST_ADD,
	1	NET_READ_RESP_AST_ADD
900	FORMAT(8(1X,Z8))
C
C ASSIGN CHANNELS FOR OUR MAILBOX
C
	MA_R_INIT=SYS$CREMBX(	!  
	1	%VAL(0),	! TEMP MAILBOX (ONLY AROUND WHILE WE ARE)
	1	MA_ROUTE_MBX,	! CHANNEL
	1	%VAL(MBX_SIZE),	! LARGEST SIZE OF A MESSAGE
	1	%VAL(MBX_SIZE * MBX_CNT),	! BUFFER QUOTA
	1	%VAL(0),	! PROTECTION, ANYONE CAN WRITE TO US
	1	%VAL(PSL$C_USER),  ! ACCESS MODE
	1	MA_ROUTE_MBX_NAME)	  ! LOGICAL NAME FOR MBX
C
	IF(.NOT. MA_R_INIT)THEN	! 
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
	   SYS_STATUS=OPR_FAO_MSG(RTR_MBXCRE,MSGDESC)
	   RETURN
	ENDIF
	TYPE *,' MAIL BOX CREATED '
C
C GET A FREE EVENT FLAG TO BE USED FOR WAKE UPS
C
	MA_R_INIT=LIB$GET_EF(WAKE_EFN)
	IF (.NOT. MA_R_INIT)THEN		! DID WE GET ONE?
	  MSGDESC(1)=512
	  SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
	  SYS_STATUS=OPR_FAO_MSG(RTR_NOEFN,MSGDESC)  ! NO, LOG THE ERROR
	  RETURN
	ENDIF
	TYPE *,' GOT EVENT FLAG: ',WAKE_EFN
C
C WAKE UP WHEN NEW MESSAGE ARRIVES
C
	MA_R_INIT=LIB$GET_EF(MESG_EFN)
	IF (.NOT. MA_R_INIT)THEN		! DID WE GET ONE?
	  MSGDESC(1)=512
	  SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
	  SYS_STATUS=OPR_FAO_MSG(RTR_NOEFN,MSGDESC)  ! NO, LOG THE ERROR
	  RETURN
	ENDIF
	TYPE *,' GOT MESSAGE WAKE UP EVENT FLAG: ',MESG_EFN
C
C INIT IT TO NOT SET
C
	SYS_STATUS=SYS$CLREF(%VAL(WAKE_EFN))
C
C GET A FREE LOGICAL UNIT NUMBER
C
	MA_R_INIT=LIB$GET_LUN(ROUTE_DBS(5))	! GET A LUN
	IF (.NOT. MA_R_INIT)THEN		! DID WE GET ONE?
	  MSGDESC(1)=512
	  SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
	  SYS_STATUS=OPR_FAO_MSG(RTR_NOLUN,MSGDESC)  ! NO, LOG THE ERROR
	  RETURN
	ENDIF
	TYPE *,' GOT LUN: ',ROUTE_DBS(5)
C
	ROUTE_DBS(6)=LEN(ROUTE_DBS_SECT)
	ROUTE_DBS(7)=%LOC(ROUTE_DBS_SECTION_NAME)

C
C SET UP EXIT HANDLERS
C
C
C	CALL SYSTEM SERVICE TO LINK IN THE EXIT HANDLER IN
C	USER STATE
C
	DESBLK(2) = %LOC(MA_ROUTER_EXIT_HAN) ! ADDRESS OF EXIT HANDLER
	DESBLK(3) = 1                  ! NUMBER OF ARGUMENTS
	DESBLK(4) = %LOC(EXIT_STATUS)
	MA_R_INIT = SYS$DCLEXH(DESBLK)  ! DECLARE EXIT HANDLER
C
	IF( .NOT. MA_R_INIT)THEN
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_EXTHAN,MSGDESC)
		RETURN
	ENDIF
C
C INITIALIZE THE EVENT QUEUE
C
	event_count=0	! no entries in queue
	event_insert=1	! first entry
	event_remove=1	! first to remove

C
C INIT OUR NETWORK
C
C 	BUILD DESCRIPTORS TO DECLARE OURSELVES TO NETACP
C

	NAMEDESCP(2)=%LOC(NAME)
	NAME.NM='MA_ROUTER'	! ***** HARD CODE NAME   MAY WANT TO CHANGE ****
	NAMEDESCP(1)=LEN(NAME.NM)
	NAMEDESCP(1)=NON_BLANK_LEN(NAME.NM,NAME.NM)
C
	OBJDESCP(1)=5
	OBJDESCP(2)=%LOC(OBJ)
	OBJ.TYPE=21	! BLOCK TYPE (NBF$C_DECLNAME)
	OBJ.OBJNUM=12	! OBJECT NUMBER
C 		$EQU	NFB$C_DECLNAME	21 (NOTE, NOT AVAILABLE IN FORSYSDEF.TLB
C ASSIGN A CHANNEL TO NET
C
	MA_R_INIT=LIB$ASN_WTH_MBX('_NET:',	! ASSIGN TO NETACP
	1	NET_MBX_SIZE,	! SIZE OF MBX
	1	NET_MBX_SIZE*NET_MBX_CNT,	! BUFFER QUOTA
	1	UNSNRB.NRB$L_CHAN,	! NETACP CHANNEL
	1	UNSNRB.NRB$L_NETMBX)  ! NETWORK MESSAGE MAILBOX CHANNEL
C
	IF( .NOT. MA_R_INIT)THEN  ! IS NETWORK UP?
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
		TYPE *,' NET_MBX_SIZE: ',NET_MBX_SIZE
		TYPE *,' NET_MBX BUFFER QUOTA: ',NET_MBX_SIZE*NET_MBX_CNT
		SYS_STATUS=OPR_FAO_MSG(RTR_NETASN,MSGDESC)
		RETURN
	ENDIF
C
C FILL IN OUR FAKE UNSOLICITED NRB (USED BY AST ROUTINES, CONTAINS
C ALL THE POOP TO HANDLE UNSOLICITED CONNECTS, ETC.
C
	UNSNRB.NRB$Q_NCBDES(1)=8		! BUILD A DESCRIPTOR
	UNSNRB.NRB$Q_NCBDES(2)=%LOC(UNSNRB.NRB$C_CURNODE)
	UNSNRB.NRB$C_CURNODE='UNSOLICT'
C
C NOW TELL NET OUR OBJECT NAME
C
	MA_R_INIT=SYS$QIOW(,	! EVENT FLAG
	1	%VAL(UNSNRB.NRB$L_CHAN),	! CHANNEL
	1	%VAL(IO$_ACPCONTROL),	! FUNCTION CODE
	1	IOSTATUS,		! IO STATUS
	1	,,		! AST ROUTINES
	1	OBJDESCP,	! OBJECT DESCRIPTOR
	1	NAMEDESCP,	! NAME DESCRIPTOR
	1	,,,)
C
	IF( .NOT. MA_R_INIT)THEN	! CHECK TO SEE IF SERVICE ACCEPTED
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
		TYPE *,' Unable to define self as network object '
		TYPE *,' STATUS: ',MA_R_INIT
		SYS_STATUS=OPR_FAO_MSG(RTR_NETOBJ,MSGDESC)
		RETURN
	ENDIF
C
	MA_R_INIT=IOSTATUS.COND	! GET CONDITION CODE STATUS
	IF( .NOT. MA_R_INIT)THEN	! GOOD?
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_NETOBJ,MSGDESC)
		RETURN
	ENDIF
C
D	SYS_STATUS=OPR_FAO_MSG(RTR_OBJDEF,'MA_ROUTER')

C
C FAKE OUT A NEW ROUTING MAP AS HAVING BEEN RECEIVED, THIS
C WILL ALSO CAUSE A RECONNECTION ATTEMPT FOR ALL NODES IN THE
C NEW ROUTING DATABASE.
C
	MA_R_INIT=NEW_ROUTING_MAP()
	TYPE *,' BACK FROM NEW ROUTING MAP'
	IF(.NOT. MA_R_INIT)RETURN	! CAN'T CONTINUE, RETURN WITH STATUS
C
C START OFF BY SETTING UP THE INITIAL QIO'S AND
C AST'S FOR OUR LOCAL MAILBOX.
C
C
C AT LEAST QIO TO OUR MAILBOX
C
	MA_R_INIT=SYS$QIO(
	1	,			! EVENT FLAG 
	1	%VAL(MA_ROUTE_MBX),	! CHANNEL
	1	%VAL(IO$_READVBLK ), ! READ FUNCTION
	1	MBX_STATUS,			 ! I/O STATUS BLOCK	
	1	MA_MBX_AST,		! AST ADDRESS
	1	%VAL(0),		! AST PARAMETER
	1	MA_MBX_LETTER,			 ! BUFFER TO READ LETTER INTO
	1	%VAL(MBX_SIZE),,,,)		 ! SIZE OF LETTER BUFFER
C
	IF(.NOT. MA_R_INIT)THEN
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_QIOMBX,MSGDESC)
		RETURN
	ENDIF
C
C SET UP QIO FOR THE UNSOLICITED MESSAGES FROM THE NETWORK
C FOR SUCH THINGS A CONNECTS, ETC.
C
	MA_R_INIT=SYS$QIO(
	1	,		! EVENT FLAG 
	1	%VAL(UNSNRB.NRB$L_NETMBX),	! CHANNEL
	1	%VAL(IO$_READVBLK ), ! READ FUNCTION
	1	UNSNRB.NRB$Q_MBXSTS,	! MAILBOX  I/O STATUS BLOCK	
	1	%VAL(NET_AST_ADD),	! AST ADDRESS
	1	UNSNRB,		! AST PARAMETER (= FAKE NRB FOR UNSOLICITED)
	1	UNSNRB.NRB$L_NETMSG,		! BUFFER TO READ LETTER INTO
	1	%VAL(NET_MBX_SIZE),,,,)		 ! SIZE OF LETTER BUFFER
C
	IF(.NOT. MA_R_INIT)THEN
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(MA_R_INIT),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_NETMBX,MSGDESC)
		RETURN
	ENDIF
	TYPE *,' NRB COUNT: ',NRB_COUNT
	RETURN
	END

