	OPTIONS/EXTEND
	INTEGER*4 FUNCTION NODE_TO_NRB(NODE,NRBADD,FLAGS)
	IMPLICIT NONE

C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&NODE_TO_NRB\&
C .nf
C .x NODE_TO_NRB>Defined
C Source:NODE_TO_NRB.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 28-jun-1988
C Revision level     :1.6
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NODE                       SUB STRUCTURE (INTEGER*2 (6))   
C                               NODE NAME TO LOOK FOR IN A 1 to 6 BYTE ARRAY
C  
C Returns:
C  
C    NODE_TO_NRB                INTEGER*4                                   
C                               STATUS, SS$_NORMAL, OR SS$_NOSUCHDEV IF NODE
C                               NOT FOUND                                   
C  
C    NRBADD                     INTEGER*4                                   
C                               ADDRESS OF THE NRB FOR THE NODE (RELOCATED)
C  
C    FLAGS                      INTEGER*4                                         
C                               FLAG WORD FROM THE NRB                            
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           COMMON FOR THE MA_ROUTER, WE WILL GET             
C                               ROUTING DATABASE VIRTUAL ADDRESSES FROM IT.       
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X AT_ADD>Referenced
C    AT_ADD                     GETS THE LONG WORD VALUE AT THE SPECIFIED         
C                               ADDRESS                                           
C                                (found in library:INLAND)
C  
C .X CMP_NAME>Referenced
C    CMP_NAME                   COMPARES NODE PASSES TO THE CURRENT NODE IN       
C                               THE NRB.                                          
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is used to find the NRB address and the
C flags for a given node string.  At the time writing, it was
C used by an AST routine servicing unsolicted connects from
C remote nodes.  If the node is found, the status is ss$_normal,
C otherwise it is ss$_nosuchdev.
C 	CALLING SEQUENCE:
C .nofill
C   INTEGER*2 NODE(3)
C   DATA NODE/'PA','75','0A'/
C C
C   SYS_STATUS=NODE_TO_NRB(NODE,NRBADD,FLAGS)
C end.doc ****************************** end.doc  
C
C MODIFICATION HISTORY:
c 	6/28/88 E. Lakia (1.6)
c	Allow for connection from nodes with names less than 6 characters.
C	2/25/87  E. LAKIA (1.5)
C	Add support for version and flag word in routing database header
c

	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 NRBADD	! RETURN NRB ADDRESS
	BYTE NODE(6)		! NODE TO COMPARE
	INTEGER*4 FLAGS		! RETURNED VALUE FROM MATCHED NRB
	INTEGER*4 I		! INDEX VARIABLE
	INTEGER*4 OPR_FAO_MSG	! LOG ERROR MESSAGES TO CONSOLE
	LOGICAL CMP_NAME	! COMPARE NODE NAMES
	INTEGER*4 AT_ADD	! GET LONG WORD AT THE ADDRESS
	INTEGER*4 NAME_DESC(2)	! NODE NAME DESCRIPTOR
	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'	

C
C LIST OF NRBS START AT OFFSET 20 IN THE 
C ROUTING DATABASE
C
	NODE_TO_NRB=SS$_NORMAL	! ASSUME SUCCESSFUL
	I=0
	DO WHILE (.TRUE.)	! LOOP FOREVER
	  NRBADD=AT_ADD(%VAL(ROUTE_DBS(1)+(I*4)+20))  ! GET POSSIBLE NRB OFFSET
	  IF(NRBADD .NE. 0)THEN		! VALID OFFSET?
		NRBADD=NRBADD+ROUTE_DBS(1)	! RELOCATE ADDRESS
		IF(CMP_NAME(NODE,%VAL(NRBADD),FLAGS))RETURN !CHECK FOR MATCH?
		I=I+1
	  ELSE
		NODE_TO_NRB=%LOC(RTR_CONUNODE)	! RETURN ERROR CODE
C				! BUILD NODE NAME DESCRIPTOR FOR ENCODE
		NAME_DESC(1)=6	! 6 CHARACTER NODE NAME
		NAME_DESC(2)=%LOC(NODE)	! ADDRESS OF NODE
	   	SYS_STATUS=OPR_FAO_MSG(RTR_CONUNODE,
	1		NAME_DESC)	! LOG THE ERROR
	  	RETURN
	  ENDIF
	END DO
	END
