	OPTIONS/EXTEND
	SUBROUTINE PUT_BACK(MESG_ID,NRBIDIDX,NRBID,NRB)	
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&PUT_BACK\&
C .nf
C .x PUT_BACK>Defined
C Source:PUT_BACK.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 8-may-87
C Revision level     :1.3
C  
C .C ;Formal Parameter List
C Receives:
C  
C    MESG_ID                    CHARACTER*15                                      
C                               MESSAGE ID THAT IS TO BE BACKED UP                
C  
C    NRBIDIDX                   INTEGER*4                                         
C                               NRBID INDEX IN NRB FOR THIS MESSAGE ID            
C  
C    NRBID                      STRUCTURE/NRBID/ ARRAY                            
C                               ARRAY OF NRBIDS                                   
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NRB THAT THIS READ COMPLETED ON                   
C  
C Returns:
C  
C Accesses common(s):
C  
C  MA_ROUTER_COMMON              USED BY MA_ROUTER, (NEED Q_BLOCK)
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X BACKUP_RNA>Referenced
C    BACKUP_RNA                 PLACES THE MESSAGE THAT WAS JUST READ BACK ONTO   
C                               THE TOP OF THE INPUT QUEUE.                       
C                                (found in library:MA_Q$LIB:QUEUE)
C 
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                 Logs messages to operator console
C  
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called so that it is easy to call the
C BACKUP_RNA subroutine.  Any errors are reported here, however, there
C is no real reason exit if this is failes.
C .sk
C CALLING SEQUENCE:
C .SK
C .literal
C        CALL PUT_BACK(MESG_ID,NRBIDIDX,NRBID,NRB)
C .END LITERAL
C end.doc ****************************** end.doc  
c
c 1.8 may 8, 1987  E. Lakia
c	Clear the RNA pointer in the NRBID when a message is
c 	placed back on the queue.

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(NRBID)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSG)/LIST'
	
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
C
	RECORD/NRBDEF/NRB
	RECORD/NRBID/NRBID(*)
C
	INTEGER*4 NRBIDIDX
	CHARACTER*16 MESG_ID

	IF(NRBIDIDX .LT. 1 .OR.		! IS INDEX VALID?
	1	NRBIDIDX .GT. NRB.NRB$L_IDCNT)THEN
		SYS_STATUS=OPR_FAO_MSG(RTR_NRBIDIDX,
	1		%VAL(NRBIDIDX),MESG_ID)
		RETURN
	ENDIF
C
	SYS_STATUS=BACKUP_RNA( Q_BLOCK, MESG_ID,
	1	NRBID(NRBIDIDX).NRBID$L_RNA,
	1	NRBID(NRBIDIDX).NRBID$L_IDX)
C
	IF(.NOT. SYS_STATUS)THEN
	   IF(SYS_STATUS .EQ. %LOC(QUE_INVIDX)) RETURN ! SUCCESS, ONLY WARNING
	   MSGDESC(1)=512
	   SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	MSGDESC(1),MSGDESC,,)
	   SYS_STATUS=OPR_FAO_MSG(RTR_BACKRNA,MSGDESC,MESG_ID)
	ENDIF
	NRBID(NRBIDIDX).NRBID$L_RNA=0 ! ZERO RNA
	RETURN
	END
