	IMPLICIT NONE
C	OPTIONS /EXTEND
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&QUEUE_CHKR\&
C .nf
C .x QUEUE_CHKR>Defined
C Source:QUEUE_CHKR.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update: 19-apr-1988
C Revision level     :1.7
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C .X KDATA>Common
C    KDATA                      CONTAINS DATA LOADED BY KERNAL MODE SUBROUTINE    
C                               SUCH AS CHANNEL NUMBER                            
C  
C Accesses file(s):
C  
C    QUEUE_DEF                                                                    
C                               READ ( QUEUE PARAMETER FILE )
C .X QUEUE_DEF>READ
C 
C  
C Other modules referenced:
C  
C  
C .X KNL_SECT_OPEN>Referenced
C    KNL_SECT_OPEN              MACRO SUBROUTINE TO OPEN AND MAP GLOBAL           
C                               QUEUE SECTION                                     
C  
C .X Q_CHECK>Referenced
C    Q_CHECK                    VERIFIES THE STRUCTURE OF THE QUEUE SECTION       
C  
C
C .X SET_DEF_PROT>Referenced
c    SET_DEF_PROT               USED TO SET DEFAULT PROTECTION OF OUR FILES
C 
C .X OPR_FAO_MSG>Referenced
c    OPR_FAO_MSG                SEND ERROR MESSAGES TO CONSOLE
C .SK
C .fill
C .SK
C Description:
C .sk    
C .FILL
C 	This is the main line program that initially sets up the 
C Queue.  This program then hangs around doing the
C checkpoint of the region and controlling access to the region
C via a lock.
C 	The QUEUE_DEF file is a paramter file that
C is used to define the queue.  The file contains the
C following:
C .list 1,'o'
C .le;Name of the file to checkpoint the region into
C .le;Name of the QUEUE REGION.
C .LE;Name of the lock which is used to control access to
C .els
C 	This program must be run from an account that has
C the privelege change mode to KERNAL (IE: CHMKNL).
C 	To run this program, 
c DEFINE QUEUE_DEF  QUEUE FILE PARAMETER FILE NAME
C	IE: DEFINE QUEUE_DEF SYS$SYSTEM:[HACK.SSGQUE]EARL.DAT;1
C RUN QUEUE_CHKR
C end.doc ****************************** end.doc  
C 
C REVISION LOG:
c 	1.7 E. LAKIA (IPACT Inc.) (9-APR-1988)
c	Reduced some of the output to the log file.  
c 
C	1.6 E. LAKIA (2/23/87) Pass the section lock from the
c	parameter file to the common for the knl_sect_open 
c	subroutine store in the queue header for everyone to
c	access. (this will allow for multiple queues on the same
c	cluster/node and allow different locks)
C		

	INCLUDE 'QUEUE_CHKR_MSG.INC/NOLIST'
	INTEGER*4 REGLUN ! REGION LOGICAL UNIT NUMBER 
	INTEGER*4 PRMLUN ! PARAMETER FILE LUN
	INTEGER*4 IOST	 ! FORTRAN OPEN ERROR STATUS
	INTEGER*4 REGLTH  ! LENGTH OF REGION NAME
	INTEGER*4 FILLTH  ! LENGTH OF REGION FILE NAME
	INTEGER*4 LCKLTH  ! LENGHT OF THE LOCK NAME STRING
	BYTE LOCK_NAME(80) ! ACTUAL NAME FROM FILE FOR LOCK
	CHARACTER*80 REGION_NAME ! ACTUAL NAME FROM FILE FOR REGION
	CHARACTER*80 REGION_FILE_NAME	! REGION FILE NAME
	INTEGER*4 STATUS	! STATUS
	INTEGER*4 SET_DEF_PROT	! SET DEFAULT PROTECTION
	EXTERNAL KNL_SECT_OPEN ! KERNAL OPEN OF SECTION FILE
	integer*4 sys$enqw
	INTEGER*4 SYS$EXIT
	integer*4 sys$hiber
	INTEGER*4 SYS$GETMSG
	INTEGER*4 SYS$UPDSEC
	INTEGER*4 SYS$WAITFR
	INTEGER*4 SYS$CLREF
	INTEGER*4 SYS$SETEF
	INTEGER*4 LIB$GET_EF	! GET EVENT FLAG
	INTEGER*4 OPR_FAO_MSG	! LOG ERRORS
	INTEGER*4 LIB$SIGNAL  ! SIGNAL AN ERROR
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 RET_ADDR(2)	! ACTUAL V. A. OF UPDATED SECTION
	INTEGER*4 UPDATE	! UPDATE FUNCTION ROUTINE
	INTEGER*4 I
C------------------------------------------------------------------------------
C
C COMMON USED BETWEEN MAIN LINE AND KERNAL CODE SUBROUTINES
C PLACEMENT AND ORDER MUST BE PRESERVED.
C
	INTEGER*4 SEC_CHAN	! CHANNEL OPEN ON FILE
	INTEGER*4 SEC_ADDR(2)	! VIRTUAL ADDRESS THAT SECTION IS MAPPED TO
	INTEGER*4 SEC_NAME(2) ! SECTION NAME DESCRIPTOR
	INTEGER*4 LCK_NAME(2)	! LOCK NAME FOR QUEUE
	INTEGER*4 PAG_CNT	! NUMBER OF PAGES IN SECTION
	INTEGER*4 KNL_STATUS	! KERNAL STATUS
	INTEGER*4 KNL_INDEX
	INTEGER*4 UPD_EFN		! KERNAL EVENT FLAG
	INTEGER*4 WAKE_EFN	! WAKE UP EVENT FLAG
	INTEGER*4 IOSTATL(2)	! I/O STATUS FROM CHECKPOINT
	INTEGER*2 IOSTAT(4)	! WORD ADDRESSABLE
	INTEGER*4 UPD_ADDR(2)	! BEGINNING ADDRESS FOR UPDATE SECTION
	EQUIVALENCE (IOSTATL,IOSTAT)
	INTEGER*4 MSGDESC(2)	! MESSAGE DESCRIPTOR
	BYTE MSGBUF(250)	! MESSAGE BUFFER
	COMMON/KDATA/SEC_CHAN,SEC_ADDR,SEC_NAME,
	1	LCK_NAME,PAG_CNT,KNL_STATUS,KNL_INDEX,
	1	UPD_ADDR,UPD_EFN,WAKE_EFN,IOSTATL,MSGDESC,MSGBUF
C-------------------------------------------------------------------------------
C
	DATA PRMLUN/1/
	DATA REGLUN/2/

	MSGDESC(1)=250
	MSGDESC(2)=%LOC(MSGBUF)
C
C OPEN OUR PARAMETER FILE
C
	IOST=SET_DEF_PROT('RWE','RWE','RWE')	! ALLOW EVERYONE WRITE TOO.
	OPEN(UNIT=PRMLUN,NAME='QUEUE_DEF',SHARED,READONLY,
	1	TYPE='OLD',ACCESS='SEQUENTIAL',
	1	RECORDSIZE=128,
	1	IOSTAT=IOST,
	1	ERR=9000)
C
	TYPE *,' PARAMETER FILE OPENED '
C
C GET INFORMATION FROM PARAMETER FILE
C
	READ(PRMLUN,100)FILLTH,REGION_FILE_NAME(1:FILLTH)
100	FORMAT(Q,A<FILLTH>)
C
C
	READ(PRMLUN,300)REGLTH,REGION_NAME(1:REGLTH)
300	FORMAT(Q,A<REGLTH>)
c
	TYPE *,' REGION NAME: ',REGION_NAME(1:REGLTH)
	TYPE *,' REGION FILE NAME: ',REGION_FILE_NAME(1:FILLTH)
	TYPE *,' SIZE OF REGION: ',PAG_CNT
C
C
	SEC_NAME(1)=REGLTH	! BUILD CHARACTER STRING DESCRIPTOR
	SEC_NAME(2)=%LOC(REGION_NAME)  ! FOR KERNAL CODE
C
	WRITE(*,400)SEC_NAME
400	FORMAT(' REGION DESCRIPTOR: ',2(1X,Z8.8))
C
	READ(PRMLUN,410)LCKLTH,(LOCK_NAME(I),I=1,LCKLTH)
410	FORMAT(Q,<LCKLTH>A1)
C
	IF(LCKLTH .GT. 16)THEN
		LCKLTH=16	! MUST TRUNCATE
		TYPE *,' LOCK NAME TOO LONG, TRUNCATING TO 16 BYTES'
	ENDIF
	LCK_NAME(1)=LCKLTH
	LCK_NAME(2)=%LOC(LOCK_NAME)
C
	WRITE(*,412)(LOCK_NAME(I),I=1,LCKLTH)
412	FORMAT(' Queue lock name: ',<LCKLTH>A1)
	CLOSE (UNIT=PRMLUN)

C
C GET EVENT FLAG FOR OTHERS TO WAKE US UP TO CHECKPOINT THE REGION
C
	SYS_STATUS=LIB$GET_EF(WAKE_EFN)	! WAKE UP EVENT FLAG
	IF(.NOT. SYS_STATUS)SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
C
C SET WAKE UP TO FORCE CHECKPOINT AT LEAST ONCE 
C
	SYS_STATUS=SYS$SETEF(%VAL(WAKE_EFN))
	IF (.NOT. SYS_STATUS)THEN
		TYPE *,' SET EVENT FLAG SYSTEM SERVICE FAILURE'
		MSGDESC(1)=250
	   	SYS_STATUS=SYS$GETMSG(SYS_STATUS,
	1		MSGDESC(1),MSGDESC,,)
   		SYS_STATUS=OPR_FAO_MSG(QCK_EFNERR,MSGDESC)
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C OPEN AND CREATE THE GLOBAL SECTION
C
	OPEN(UNIT=REGLUN,NAME=REGION_FILE_NAME(1:FILLTH),
	1	TYPE='OLD',ACCESS='DIRECT',
	2	RECORDSIZE=128,	
	3	USEROPEN=KNL_SECT_OPEN,
	5	IOSTAT=IOST,	
	6	ERR=9000,
	7	SHARED)
C
	TYPE *,' QUEUE FILE OPEN OK, REGION CREATED AND MAPPED'
	WRITE(*,450)SEC_ADDR
450	FORMAT(' STARTING VIRTUAL ADDRESS: ',2(1X,Z8.8))
	TYPE *,' WAKE UP EVENT FLAG IS: ',WAKE_EFN
C
C THE REGION IS NOW CREATED AND MAPPED, WE CAN NOW
C DO A CONSISTENCEY CHECK ON THE REGION.
c
c This is done by the verify_q utility prior to the
c installation of the queue in memory.
C
C	STATUS=Q_CHECK
C 
C
C
C GET EVENT FLAG FOR THE UDPATE SECTION I/O
C
	SYS_STATUS=LIB$GET_EF(UPD_EFN)
	IF(.NOT. SYS_STATUS)SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	TYPE *,' UPDATE SECTION EVENT FLAG: ',UPD_EFN

1000	CONTINUE
d	TYPE *,' WAKE UP EVENT FLAG IS: ',WAKE_EFN
	SYS_STATUS=SYS$WAITFR(%VAL(WAKE_EFN))
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' WAIT FOR EVENT FLAG SYSTEM SERVICE FAILURE'
		MSGDESC(1)=250
	   	SYS_STATUS=SYS$GETMSG(SYS_STATUS,
	1		MSGDESC(1),MSGDESC,,)
   		SYS_STATUS=OPR_FAO_MSG(QCK_EFNERR,MSGDESC)
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C RESUMED, TIME TO CHECKPOINT THE REGION
C
D	TYPE *,' CHECKPOINT REQUESTED '
	SYS_STATUS=SYS$CLREF(%VAL(WAKE_EFN))
	IF (.NOT. SYS_STATUS)THEN
		TYPE *,' UNABLE TO CLEAR WAKE UP EVENT FLAG'
		MSGDESC(1)=250
	   	SYS_STATUS=SYS$GETMSG(SYS_STATUS,
	1		MSGDESC(1),MSGDESC,,)
   		SYS_STATUS=OPR_FAO_MSG(QCK_EFNERR,MSGDESC)
		CALL SYS$EXIT(%VAL(SYS_STATUS))	
	ENDIF
C
	SYS_STATUS=UPDATE()
C
	IF(.NOT.SYS_STATUS)THEN
		TYPE *,' UPDATE FAILURE '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
D	TYPE *,' KNL_INDEX: ',KNL_INDEX,' KNL_STATUS: ',KNL_STATUS
D	TYPE *,' UPDATE STATUS: ',IOSTAT(1)
D	WRITE (*,8000)SEC_ADDR,UPD_ADDR
D8000	FORMAT(' SECTION ADDR: ',Z8,1X,Z8,/,
D	1      '  UPDATE ADDR: ',Z8,1X,Z8)
	GO TO 1000	! GO WAIT AGAIN
C

C
C UNABLE TO OPEN AND MAP THE SECTION
C
9000	TYPE *,' FILE OPEN ERROR (FORTRAN STATUS): ',IOST
	CALL ERRSNS(,,IOST)
	MSGDESC(1)=250
	STATUS=SYS$GETMSG(%VAL(KNL_STATUS),
	1		MSGDESC(1),MSGDESC,,)
   	SYS_STATUS=OPR_FAO_MSG(QCK_KNLOPN,MSGDESC)
	TYPE *,' KERNAL OPEN  STATUS AT INDEX: ',KNL_INDEX
	TYPE *,' PAG_CNT: ',PAG_CNT
	CALL SYS$EXIT(%VAL(KNL_STATUS))
	END
