	OPTIONS/EXTEND
	SUBROUTINE REM_NODE_CON(NRB)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&REM_NODE_CON\&
C .nf
C .x REM_NODE_CON>Defined
C Source:REM_NODE_CON.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 9-JUL-1986 13:33:06.83
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE                                         
C                               NRB OF THE NODE THAT HAS SUCCESSFULLY CONNECTED   
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           COMMON FOR MA_ROUTER                              
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG ERROR MESSAGES                                
C                                (found in library:INLAND)
C  
C .X POST_NET_READ>Referenced
C    POST_NET_READ              POST A READ ON THE CHANNEL ASSIGNED TO THE        
C                               REMOTE NODE                                       
C  
C .X FIND_Q_MESG>Referenced
C    FIND_Q_MESG                                                                  
C  
C .X PUSH_EVENT_QUE>Referenced
C    PUSH_EVENT_QUE             PUSH A MESSAGE REQUESTING A SEARCH FOR NEW        
C                               MESSAGES TO BE OUTPUT.                            
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called when a node has successfully
C been logically connected to.  This subroutine will:
C .list
C .le;Reset the link line sequence number.
C .le;Mark any message ID's that are serviced by this
C node that were marked with a undeliverable because
C the remote node queue was full as now being deliverable.
C .LE;If there are any read but not acknowleged messages,
c then have the messages placed back at the front of the queue.
C .le;Mark the node as available.
C .le;Post a read on the remote node.
C .els
C .nofill
C .sk 2
C CALLING SEQUENCE
C  
C CALL REM_NODE_CON(NRB)
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD/NRBDEF/NRB	! AST PARAMETER IS THE NRB OR DUMMY FOR 
				! UNSOLICITED CONNECTS
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS_STATUS2
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES

C
C THE NODE SHOULD BE MARKED AS AVAILABLE BY THE CONNECT NODE
C AST, SO WE WON'T BOTHER TO DO THAT.
C
C THEREFORE, SIMPLY GO SCAN THE MESSAGE ID LIST AND
C SEE IF ANY WERE MARKED AS UNDELIVERABLE AND
C RESET THE FLAG.
C -------------- CAN'T DO UNTIL PAUL COMPLETES
C
	NRB.NRB$W_LNKSEQI=0	! RESET LINK SEQUENCE NUMBER
	NRB.NRB$W_LNKSEQO=0
C
C  POST A READ ON THIS NODE
C
D	TYPE *,' POSTING A READ ON NODE: ',NRB.NRB$C_PRINODE
C

	CALL NET_READ(NRB)
	RETURN
	END
	   
