$!
$! Documentation command file for making the header
$! portion of all programs and modules.
$! 	Authors:  H. Barta
$!		  C. Johnson
$!		  E. Lakia
$!                B. Read
$!	
$ SET NOVERIFY
$! DEFINE ESCAPE CODES FOR REST OF COM FILE
$ ESC[0,8]=27
$ ES:="''ESC'[2J"
$! INITIALIZE PARAMETERS
$ RECMAX = 80	! MAXIMUM RECORD SIZE
$ FILMAX = 38	! MAXIMUM FILE NAME SIZE (IN CHARACTERS)    
$ PARMAX = 25	! MAXIMUM PARAMETER FIELD SIZE
$ TYPMAX = 40	! MAXIMUM VARIABLE TYPE FIELD SIZE
$ DESMAX = 50	! MAXIMUM DESCRIPTION FIELD SIZE
$ PARCOL = 3	! STARTING COLUMN FOR PARAMETER DISPLAY
$ TYPCOL = 30	! STARTING COLUMN FOR TYPE DISPLAY
$ DESCOL = 30	! STARTING COLUMN FOR DESCRIPTION DISPLAY
$!
$! CLEAR THE SCREEN
$!
$ WRITE SYS$OUTPUT ES
$ TYPE SYS$INPUT

     COMMAND FILE TO SUPPORT MODULE DEFINITION

$ INQUIRE H "Do you want an explanation "
$ IF .NOT. H THEN GOTO  nohelp
$ TYPE SYS$INPUT
  
  	This .COM file was written to help support a method of defining
  	module descriptions that complement the Structure charts. The
  	entries are prompted and assembled into a standard form (runoff
  	compatible) that then can be concatenated to form a design document.
  	Please note that EDT is used to enter the description to make
  	the power of the screen editor available to the user for entering
  	text and also correcting errors which occurred during the prompted
  	part of the session.
  	
  	Each module definition will be placed in a file named using the
  	same method Lakia used for the data dictionary utility (DICT.CMD)
  	The file name and module name are then appended to MODULE.DRR
  	where the first 24 characters of the record are the module name
  	and the remaining part of the record is the corresponding (.MOD)
  	file name.

$ INQUIRE/NOPUNCTUATION MORE " - MORE - "
$ TYPE SYS$INPUT


  
  	Eventually programs will be written that will convert the .MOD
  	files to 'comments' that can become part of the sources for a
  	system. 
  	One of these is COM.TSK (written in FORTRAN) which will read
  	filenames from MODULE.COM and convert them to FORTRAN comments
  	including a "begin.doc" and "end.doc" comments that will be 
  	used by a program (yet to be written) that will extract the 
  	document portion of the comments from the source.
  
  	When the Programmer codes the module, the comment section should
  	be included in the code. This will also give the Programmer the
  	Designers intentions 'on line' while still in the editor. Later on
  	the appropriate part of the design document will remain with the 
  	source listings.

$ INQUIRE/NOPUNCTUATION MORE " - MORE - "
$ TYPE SYS$INPUT

  	A program exists that will extract the comments from the source files
  	on a system. This program (EXTRACT.TSK) will accept a command line
  	argument "@filspec" where "filspec" is a file that contains the
  	sources to be scanned for document sections. "filspc" is assumed to
  	be in the format produced by SRD. EXTRACT can be driven by the
  	command file EXT. Would you like copies of these copied over?
$!
$ NOCOPY:
$ TYPE SYS$INPUT
  
  	It is hoped that when a system is 'maintained', the programmer
  	will modify the comments accordingly. This way, a new and updated
  	design document can be generated whenever it is desired.
  
   	If you have any comments, suggestions or problems using this
  	package please contact H. Barta.
  
  
$ INQUIRE/NOPUNCTUATION dummy  "Hit return to continue "
$ nohelp:
$
$ TYPE SYS$INPUT

	You are operating with version 2.1
	last updated:  October 12, 1985

$ ASKNM:
$ INQUIRE DESN "Enter your name"
$!
$!
$ START:
$! clear the screen
$ WRITE SYS$OUTPUT ES
$!
$!ask for module name
$!
$ GETNAME:
$ WRITE SYS$OUTPUT -
 "Enter module name or hit return to quit. DO NOT USE AN EXTENSION!"
$ WRITE SYS$OUTPUT -
 "(Only the first ",FILMAX," characters will be used for the .MOD filename.)"
$ NCLS:
$!
$ INQUIRE NAME "Module Name"
$! 	see if it is time to quit
$ IF NAME .EQS. "" THEN EXIT
$!
$! PARSE THE NAME for the first FILMAX characters
$! try to open a file with that name. To prevent
$! conflicting names, a check is made to make sure
$! the file does not already exist.  If so, the
$! user is prompted to change the module name.
$!
$ DFLSIZ = F$LENGTH(NAME)
$ IF DFLSIZ .LE. FILMAX THEN GOTO BUILD
$ NAME = F$EXTRACT(0,FILMAX,NAME)
$ BUILD:
$!
$!
$ FNAME=NAME+".MOD"
$ SHOW SYMBOL FNAME
$ IF F$SEARCH(FNAME) .EQS. "" THEN GOTO UNIQUE
$ TYPE SYS$INPUT

   File name is not unique for this module within your directory.  Please 
   change the module name to make it unique.
 
$ GOTO GETNAME
$!
$! FOUND A FILE NAME THAT DOESN'T EXIST SO CREATE IT
$!
$ UNIQUE:
$ OPEN/WRITE OUTFILE 'FNAME'
$ INQUIRE LIB "If part of a library enter library name"
$ LIBRAR = "TO BECOME PART OF LIBRARY:"+LIB
$! Start the file with the module name
$ WRITE outfile " "
$ WRITE outfile ".c ;MODULE"
$ WRITE outfile ".c ;^&",NAME,"\&"
$ WRITE outfile ".nf"
$ WRITE outfile ".x ",NAME,">Defined"
$ WRITE outfile "Source:",FNAME
$ IF F$LENGTH(lib) .EQ. 0 THEN GOTO NOLIB
$ WRITE outfile librar
$ NOLIB:
$ WRITE outfile "Designer           :",desn
$ WRITE outfile "Author             :"
$ WRITE outfile "Copy Right: Inland Steel"
$ WRITE outfile "            Process Automation Department"
$ WRITE outfile "            3210 Watling St.  MS 2-465"
$ WRITE outfile "            East Chicago, IN  46312"
$ WRITE outfile " "
$ TIME = F$TIME()
$ WRITE outfile "Date of last update:",TIME
$ WRITE outfile "Revision level     :1.0"
$ WRITE outfile " "	
$ WRITE outfile ".C ;Formal Parameter List"
$ WRITE outfile "Receives:"
$
$!*****************************************************************************
$!*****************************  ASK FOR PARAMETERS  **************************
$!*****************************************************************************
$!
$!**********FORMAL PARAMETER(S) RECEIVED************
$ RPARM: 
$ WRITE SYS$OUTPUT ES
$ write sys$output " Defining ",NAME," in ",FNAME
$ RPARM1:
$ INQUIRE PARM "Formal parameter received"
$ PARMSZ = F$LENGTH(PARM)
$ IF PARMSZ .EQ. 0 THEN GOTO SPARM
$ IF PARMSZ .LE. PARMAX THEN GOTO PARMOK
$ WRITE SYS$OUTPUT -
         "%Parameter name must be ",PARMAX, " characters or less - ENTER AGAIN"
$ GOTO RPARM1
$
$ PARMOK:
$! ASK FOR VARIABLE TYPE
$ INQUIRE VARTYP "Variable type (REAL*8 or CHAR*32 etc.)"
$ IF F$LENGTH(VARTYP) .LE. TYPMAX THEN GOTO DESC1
$ WRITE SYS$OUTPUT -
         "%Variable type must be ",TYPMAX," characters or less - ENTER AGAIN"
$ GOTO PARMOK
$ 
$ DESC1:
$ WRITE SYS$OUTPUT "Parameter description (",DESMAX," characters at a time)"
$ WRITE SYS$OUTPUT "        .........|.........|.........|.........|.........|"
$ INQUIRE PARDES 
$ IF F$LENGTH(PARDES) .LE. DESMAX THEN GOTO DESCOK
$ WRITE SYS$OUTPUT -
        "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO DESC1
$ 
$ DESCOK:
$ OUTREC[0,RECMAX] := ''
$ OUTREC[PARCOL,PARMAX] := 'PARM'
$ OUTREC[TYPCOL,TYPMAX] := 'VARTYP'
$ WRITE OUTFILE " "
$ WRITE outfile OUTREC
$ DESOK:
$ OUTREC[0,RECMAX] := ""
$ OUTREC[DESCOL,DESMAX] := 'PARDES'
$ WRITE outfile OUTREC
$ P1:
$ INQUIRE PARDES 
$ DESCSZ = F$LENGTH(PARDES)
$ IF DESCSZ .EQ. 0 THEN GOTO RPARM
$ IF DESCSZ .LE. DESMAX THEN GOTO DESOK
$ WRITE SYS$OUTPUT -
        "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO P1
$
$!*************FORMAL PARAMETER(S) RETURNED************
$ SPARM:		
$ WRITE outfile " "    
$ WRITE outfile "Returns:"
$
$ P2:
$ WRITE SYS$OUTPUT ES
$ WRITE sys$output " Defining ",name," in ",FNAME
$ SPARM1:
$ INQUIRE PARM "Formal parameter returned"
$ PARMSZ = F$LENGTH(PARM)
$ IF PARMSZ .EQ. 0 THEN GOTO COMM
$ IF PARMSZ .LE. PARMAX THEN GOTO PRMOK2
$ WRITE SYS$OUTPUT -
         "%Parameter name must be ",PARMAX, " characters or less - ENTER AGAIN"
$ GOTO SPARM1
$
$ PRMOK2:
$! ASK FOR VARIABLE TYPE
$ INQUIRE VARTYP "Variable type (REAL*8 or CHAR*32 etc.)"
$ IF F$LENGTH(VARTYP) .LE. TYPMAX THEN GOTO P2TPOK
$ WRITE SYS$OUTPUT -
         "%Variable type must be ",TYPMAX," characters or less - ENTER AGAIN"
$ GOTO PRMOK2
$
$ P2TPOK:
$ WRITE SYS$OUTPUT "Parameter description (",DESMAX," characters at a time)"
$ WRITE SYS$OUTPUT "        .........|.........|.........|.........|.........|"
$ INQUIRE PARDES 
$ IF F$LENGTH(PARDES) .LE. DESMAX THEN GOTO P2DSOK
$ WRITE SYS$OUTPUT -
        "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO P2TPOK
$ P2DSOK:
$ WRITE outfile " "
$ OUTREC[0,RECMAX] := ""
$ OUTREC[PARCOL,PARMAX] := 'PARM'
$ OUTREC[TYPCOL,TYPMAX] := 'VARTYP'
$ WRITE OUTFILE OUTREC
$ P4:
$ OUTREC[0,RECMAX] := ""
$ OUTREC[DESCOL,DESMAX] := 'PARDES'
$ WRITE OUTFILE OUTREC
$
$ P4A:
$ INQUIRE PARDES 
$ PARSZ = F$LENGTH(PARDES) 
$ IF PARSZ .EQ. 0 THEN GOTO P2
$ IF PARSZ .LE. DESMAX THEN GOTO P4
$ WRITE SYS$OUTPUT -
      "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO P4A
$
$!**************COMMON DATA BLOCKS ACCESSED************
$ COMM:
$ WRITE outfile " "
$ WRITE outfile "Accesses common(s):"
$
$! get common names
$ C1:
$ WRITE SYS$OUTPUT ES
$ write sys$output " Defining ",name," in ",FNAME
$ C1A:
$ INQUIRE COMNAM "Common name"
$ COMNSZ = F$LENGTH(COMNAM)
$ IF COMNSZ .EQ. 0 THEN GOTO FILES
$ IF COMNSZ .LE. PARMAX THEN GOTO CMNMOK
$ WRITE SYS$OUTPUT -
         "%Common name must be ",PARMAX, " characters or less - ENTER AGAIN"
$ GOTO C1A
$
$ CMNMOK:
$ COMNS = COMNAM
$ DESCOM:
$ WRITE SYS$OUTPUT "Parameter description (",DESMAX," characters at a time)"
$ WRITE SYS$OUTPUT "        .........|.........|.........|.........|.........|"
$ INQUIRE COMDES 
$ IF F$LENGTH(COMDES) .LE. DESMAX THEN GOTO CMDSOK
$ WRITE SYS$OUTPUT -
        "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO DESCOM
$
$ CMDSOK:
$ WRITE outfile " "
$ WRITE outfile ".X ",COMNS,">Common"
$ OUTREC[0,RECMAX] := ''
$ OUTREC[PARCOL,PARMAX] := 'COMNAM'
$ C2A:
$ OUTREC[TYPCOL,DESMAX] := ''
$ OUTREC[TYPCOL,DESMAX] := 'COMDES'
$ WRITE OUTFILE OUTREC
$
$! GET REMAINDER OF DESCRIPTION
$ C2:
$ INQUIRE COMDES
$ DESCSZ = F$LENGTH(COMDES)
$ IF DESCSZ .EQ. 0 THEN GOTO C1
$ IF DESCSZ .LE. DESMAX THEN GOTO CMDOK2
$ WRITE SYS$OUTPUT -
        "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO C2
$ CMDOK2:
$ OUTREC[0,RECMAX] := ""
$ GOTO C2A
$
$!***************FILES ACCESSED******************
$ FILES:
$ WRITE outfile " "
$ WRITE outfile "Accesses file(s):"
$ F1:
$ WRITE SYS$OUTPUT ES
$ write sys$output " Defining ",name," in ",FNAME
$ ACFIL0:
$ INQUIRE ACFIL "Accesses  files"
$ ACFLSZ = F$LENGTH(ACFIL)
$ IF ACFLSZ .EQ. 0 THEN GOTO CALL
$ IF ACFLSZ .LE. FILMAX THEN GOTO ACFLOK
$ WRITE SYS$OUTPUT -
        "%File name must be ",FILMAX," characters or less - ENTER AGAIN"
$ GOTO ACFIL0
$ ACFLOK:
$ acfs = acfil
$ ACOVER:
$ WRITE SYS$OUTPUT -
     "File access type (enter on one line) i.e. read/write/create/delete"
$ INQUIRE ACTYP
$ IF F$LENGTH(ACTYP) .LE. DESMAX THEN GOTO ACTPOK
$ WRITE SYS$OUTPUT -
        "%Access type must be ",DESMAX," characters or less - ENTER AGAIN"
$ GOTO ACOVER
$ ACTPOK:
$ WRITE outfile " "
$ OUTREC[0,RECMAX] := ''
$ OUTREC[PARCOL,FILMAX] := 'ACFIL'
$ WRITE OUTFILE OUTREC
$ OUTREC[0,RECMAX] := ""
$ OUTREC[DESCOL,DESMAX] := 'ACTYP'
$ WRITE OUTFILE OUTREC
$ WRITE outfile ".X ",ACFS,">",ACTYP
$ GOTO F1
$
$!*****************OTHER MODULES REFERENCED*****************
$ CALL: 
$ WRITE outfile " "
$ WRITE outfile "Other modules referenced:"
$ REF1:
$ WRITE SYS$OUTPUT ES
$ WRITE SYS$OUTPUT " Defining ",name," in ",FNAME
$ REF2:
$ INQUIRE REFNC "Other modules referenced"
$ REFSIZ = F$LENGTH(REFNC)
$ IF REFSIZ .EQ. 0 THEN GOTO DESC
$ IF REFSIZ .LE. PARMAX THEN GOTO RFSZOK
$ WRITE SYS$OUTPUT -
         "%Module name must be ",PARMAX, " characters or less - ENTER AGAIN"
$ GOTO REF2
$
$ RFSZOK:
$ refs = refnc
$ INQUIRE LIB "In what library"
$ MODDS1:
$ WRITE SYS$OUTPUT "Parameter description (",DESMAX," characters at a time)"
$ WRITE SYS$OUTPUT "        .........|.........|.........|.........|.........|"
$ INQUIRE MODDES 
$ IF F$LENGTH(MODDES) .LE. DESMAX THEN GOTO MDDSOK
$ WRITE SYS$OUTPUT -
        "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO MODDS1
$
$ MDDSOK:
$ WRITE outfile " "
$ WRITE outfile ".X ",REFS,">Referenced"
$ OUTREC[0,RECMAX] := ""
$ OUTREC[PARCOL,PARMAX] := 'REFNC'
$ REF0:
$ OUTREC[DESCOL,DESMAX] := ''
$ OUTREC[DESCOL,DESMAX] := 'MODDES'
$ WRITE OUTFILE OUTREC
$ REF3:
$ INQUIRE MODDES
$ DESSZ = F$LENGTH(MODDES)
$ IF DESSZ .EQ. 0 THEN GOTO LIBR
$ IF DESSZ .LE. DESMAX THEN GOTO DSSZOK
$ WRITE SYS$OUTPUT -
      "%Description must be less than ",DESMAX," characters - ENTER AGAIN"
$ GOTO REF3
$ DSSZOK:
$ OUTREC[0,RECMAX] := ""
$ GOTO REF0
$
$ libr:
$ if f$length(lib) .eq. 0 then goto ref1
$ WRITE outfile "                               (found in library:",lib,")"
$ goto ref1
$
$ DESC:
$ WRITE outfile ".SK"
$ WRITE outfile ".fill"
$ WRITE outfile ".SK"
$ WRITE outfile "Description:"
$ WRITE outfile ".sk    "
$ WRITE outfile -
  "(PLEASE ENTER A DESCRIPTION OF THE MODULE HERE - INCLUDING CALLING SEQUENCE)"
$ write sys$output es
$ close outfile
$ WRITE SYS$OUTPUT -
        "NOW ENTER A TEXT DESCRIPTION USING EDT"
$ WRITE SYS$OUTPUT -
        "           (WAIT...)"
$ SPAWN/NOLOG EDIT/EDT 'FNAME'
$! OPEN/Append outfile MODULE.DRR
$! lname = name
$!	.gosub pack lname 24.	!!!!!!!!!!!!!!!!!!!!!
$! WRITE outfile LNAME,FNAME
$! CLOSE outfil
$! type sys$input
 !  The description is placed in 'FNAME' and now has an entry in MODULE.DRR
 
$ GOTO START
$
$  PAD STRING WITH BLANKS
$.PACK:
$.SETS BL "                         "
$.PARSE COMMAN " " STR LEN
$.SETN LENG 'LEN'
$.TEST 'str'
$.IF <STRLEN> GE LENG .SETS 'str' 'str'[1:LENG]
$.SETN PAD LENG-<STRLEN>
$.IF <STRLEN> LT LENG .SETS 'str' 'STR'+BL[1:PAD]
$.RETURN
$ END:
