	OPTIONS/EXTEND
	SUBROUTINE BUILD_RESP(STATUS,NRB,MESG,RESP_BUF)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&BUILD_RESP\&
C .nf
C .x BUILD_RESP>Defined
C Source:BUILD_RESP.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:14-AUG-86
C Revision level     :1.4
C  
C .C ;Formal Parameter List
C Receives:
C  
C    STATUS                     INTEGER*4                                         
C                               CONTAINS STATUS AS RETURNED FROM THE WRITE_Q      
C                               SUBROUTINE.                                       
C  
C    MSG                        STRUCTURE/MGHDEF/
C                               MESSAGE THAT WAS READ, REMOVE MESSAGE ID, ETC.
C 
C    RESP_BUF                   STRUCTURE/RSPDEF/                                 
C                               BUFFER, I/O STATUS AND LINKS FOR THE RESPONSE     
C
C     NRB                       STRUCTURE/NRBDEF/
C                               NRB OF NODE GETTING THE RESPONSE
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MAIN COMMON                                       
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                ERROR MESSAGS                                     
C                                (found in library:INLAND)
C .X NET_READ_RESP_AST>Referenced
C    NET_READ_RESP_AST          Called via the QIO when
C                               response we are queueing is
C                               complete
C .x DEA_RESP_BUF>Referenced
C    DEA_RESP_BUF               In the event that the QIO
C                               can not be performed, then
C                               the buffer must be released.
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called after the write_q
C subroutine is called.  This subroutine will build
C one of three messages into the response buffer
C provided and do the Qio to the remote network.
C 	If there is a system service error (node
C no longer reachable, etc., channel number is now zero),
C then the buffer is deallocated.  This subroutine will
C complete successfully and handle all errors encountered.
C 	This subroutine will store the address of the 
c NRB into the RESP_BUF.
C 	Calling Sequence:
C .nofill
C .sk
C 	CALL BUILD_RESP(STATUS,NRB,MESG,RESP_BUF)
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(RSPDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QUEMSG)/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD/NRBDEF/NRB	! AST PARAMETER IS THE NRB OR DUMMY FOR 
				! UNSOLICITED CONNECTS
	RECORD/RSPDEF/RESP_BUF
	RECORD/MGHDEF/MESG
C
	INTEGER*4 STATUS	! STATUS FROM WRITE Q
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS_STATUS2
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 OPR_FAO_MSG	! LOG ERROR MESSAGGE
	INTEGER*4 SIZE		! SIZE OF A MESSAGE (FOR DECNET)

C
C DEPENDING ON THE STATUS FROM WRITE_Q, BUILD APPROIATE RESPONSE
C MESSAGE.
C
	RESP_BUF.RSP$L_BUFIDX=%LOC(RESP_BUF)  ! STORE ADDRESS SO CAN BE
					      ! DEALLOCATED LATER
	NRB.NRB$W_LNKSEQO=NRB.NRB$W_LNKSEQO+1  ! INCREMENT LINK SEQUENCE NUMBER
	IF(NRB.NRB$W_LNKSEQO .GT. 9999)NRB.NRB$W_LNKSEQO=1 ! WRAP?
C
	RESP_BUF.RSP$S_MSG.MGH$C_MID=MESG.MGH$C_MID  ! COPY THE MESSAGE ID
	RESP_BUF.RSP$S_MSG.MGH$W_LSQ=NRB.NRB$W_LNKSEQO  ! LINK SEQUENCE NUMBER
	RESP_BUF.RSP$S_MSG.HDR.HDR$C_SNM=
	1	OUR_NODE(1:6)	! STORE OUT NODE NAME
	RESP_BUF.RSP$S_MSG.HDR.HDR$C_DNM=
	1	MESG.HDR.HDR$C_SNM ! GET ORIGINIAL SENDER AND USE
				    ! AS DESTINATION NOW
	RESP_BUF.RSP$S_MSG.HDR.HDR$Q_OFFQT(1)=	! USE SENDERS ORIGINIAL
	1	MESG.HDR.HDR$Q_OFFQT(1)	        ! OFF QUEUE TIME
	RESP_BUF.RSP$S_MSG.HDR.HDR$Q_OFFQT(2)=	! SO HE CAN DETERMINE THE
	1	MESG.HDR.HDR$Q_OFFQT(2)		! TOTAL TURN AROUND TIME
	RESP_BUF.RSP$S_MSG.MGH$L_IDX= MESG.MGH$L_IDX  ! RETURN THE INDEX FOR
						      ! THE REMOTE ROUTER
C
C DETERMINE FROM THE STATUS, WHAT KIND OF TYPE TO SEND
C 	-1 = ACKNOWLEGE (QUE_SUCCESS)
C 	-2 = MESSAGE ID SUB QUEUE IS FULL (QUE_INSFREE or QUE_MIDMAX or
c		QUE_SHUTDOWN)
C 	-3 = MESSAGE ID NOT KNOWN HERE  (QUE_MIDNOTFOUND)
C
	SIZE=%LOC(RESP_BUF.RSP$S_MSG.HDR.HDR$W_QSEQ)	! SIZE OF A
	1	-%LOC(RESP_BUF.RSP$S_MSG.MGH$W_LSQ)	! MESSAGE TO DECNET
C
	
	RESP_BUF.RSP$S_MSG.HDR.HDR$W_LEN= HDR$K_SIZ  ! SIZE OF MESSAGE
	IF ( STATUS .EQ. %LOC(QUE_SUCCESS) .OR.
	1	STATUS .EQ. SS$_NORMAL)THEN
		RESP_BUF.RSP$S_MSG.HDR.HDR$W_TYPE = -1	! SUCCESSFUL TYPE
	ELSEIF (STATUS .EQ. %LOC(QUE_INSFREE) .OR.
	1	STATUS .EQ. %LOC(QUE_SHUTDOWN) .OR.
	1	STATUS .EQ. %LOC(QUE_MIDMAX))THEN
		RESP_BUF.RSP$S_MSG.HDR.HDR$W_TYPE = -2  ! QUEUE FULL
	ELSEIF (STATUS .EQ. %LOC(QUE_MIDNOTFOUND))THEN
		RESP_BUF.RSP$S_MSG.HDR.HDR$W_TYPE = -3	! UNKNOWN ID HERE
	ELSE
C
C 		SOMEKIND OF ABNORMAL ERROR FROM Q_WRITE,....OOPS
C		TELL REMOTE THAT WE DON'T KNOW OF ID HERE (SO WON'T LOOSE 
C		MESSAGE) AND HOPEFULLY WE CAN HAVE SOMEONE FIX US.
C
		RESP_BUF.RSP$S_MSG.HDR.HDR$W_TYPE= -3
		MSGDESC(1)=512
	 	SYS_STATUS=SYS$GETMSG(%VAL(STATUS),
	1		MSGDESC(1),MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_QWRITE,MSGDESC,
	1		MESG.MGH$C_MID,MESG.HDR.HDR$C_SNM)
	ENDIF

C
C DO A QIO TO THE REMOTE NODE
C

	SYS_STATUS=SYS$QIO(,	! EVENT FLAG
	1  %VAL(NRB.NRB$L_CHAN),	! CHANNEL
	1  %VAL(IO$_WRITEVBLK),	        ! FUNCTION CODE
	1  RESP_BUF.RSP$Q_STS,		! NETWORK WRITE STATUS 
	1  %VAL(NET_READ_RESP_AST_ADD),	! AST ROUTINE
	1  RESP_BUF,			! AST PARAMETER= RESP_BUFFER STRUCTURE
	1  %REF(RESP_BUF.RSP$S_MSG), 	! RESPONSE MESSAGE BUFFER
	1  %VAL(SIZE),,,,)  ! SIZE
C
	IF(.NOT. SYS_STATUS)THEN	! QIO NOT ACCEPTED?
		MSGDESC(1)=512
		SYS_STATUS2=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS2=OPR_FAO_MSG(RTR_NTWTQIO,	  ! LOG MESSAGE
	1	  %VAL(8),NRB.NRB$C_CURNODE,MSGDESC)
		CALL DISCONNECT_NODE(NRB)		  ! DISCONNECT NODE
		CALL DEA_RESP_BUF(%LOC(RESP_BUF),	! DEALLOCATE THE
	1		%VAL(RESP_INUSE)) 		! RESPONSE BUFFER
	ELSE
D	  SYS_STATUS=OPR_FAO_MSG(RTR_RSPMSG,	! FOR SOME DEBUG, 
D	1	RESP_BUF.RSP$S_MSG.MGH$C_MID,	! LOG OUR RESPONSE
D	1	RESP_BUF.RSP$S_MSG.HDR.HDR$C_SNM,	
D	1	RESP_BUF.RSP$S_MSG.HDR.HDR$C_DNM,
D	1	%VAL(RESP_BUF.RSP$S_MSG.MGH$W_LSQ),
D	1	%VAL(RESP_BUF.RSP$S_MSG.HDR.HDR$W_TYPE),
D	1	%VAL(RESP_BUF.RSP$S_MSG.MGH$L_IDX),
D	1	%VAL(RESP_BUF.RSP$S_MSG.HDR.HDR$W_LEN),
D	1	%VAL(RESP_BUF.RSP$S_MSG.HDR.HDR$W_QSEQ))

	ENDIF
C
C IF THE STATUS WAS QUEUE SHUTDOWN, THEN WE SHOULD EXIT
C
	IF(STATUS .EQ. %LOC(QUE_SHUTDOWN))
	1	CALL SYS$EXIT(%VAL(STATUS))
	RETURN
	END
