	OPTIONS/EXTEND
	INTEGER*4 FUNCTION BUILD_ROUTE_TABLE(R_DBS)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&BUILD_ROUTE_TABLE\&
C .nf
C .x BUILD_ROUTE_TABLE>Defined
C Source:BUILD_ROUTE_TABLE.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:  3/16/87
C Revision level     :1.4
C  
C .C ;Formal Parameter List
C Receives:
C  
C    R_DBS                      STRUCTURE/NRBDEF/
C                               ROUTING DATABASE SINGLE NODE ROUTING BLOCK
C  
C Returns:
C  
C    BUILD_ROUTE_TABLE          INTEGER*4                                         
C                               RETURN STATUS FROM THIS SUBROUTINE                
C  
C Accesses common(s):
C  
C .X ROUTE_DBS>Common
C    ROUTE_DBS                  ROUTING DATABASE
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           COMMON FOR ALL OF MA_ROUTER                       
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                OPERATOR CONSOLE MESSAGES                         
C                                (found in library:INLAND)
C 
C .X LINK_ID_LST>Referenced
c    LINK_ID_LST                LINKS THE MESSAGE ID LIST TO
C                               THE ID LIST HEAD IN THE QUEUE
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine initializes the new routing database.  It 
C creates descriptors, and relocaates any needed addresses.  Threads
C are made between message ids defined in the routing database
C and the actual message id list heads in the queue.
C end.doc ****************************** end.doc  
C
C MOFIFICATION LOG:
C	2/23/87  E. Lakia
c	Add support for the NRB$M_PRILOG status

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 I
C
	RECORD/NRBDEF/R_DBS	! SINGLE NODE ROUTEING BLOCK

	TYPE *,'BUILD_ROUTE_TABLE------'
	TYPE *,' PROCESSING NODE: ',R_DBS.NRB$C_PRINODE
C
C CLEAR ANY FLAGS AND INITIALIZE VALUES
C
	R_DBS.NRB$L_FLAGS=R_DBS.NRB$L_FLAGS .AND. ! INITIALIZE FLAGS IN CASE 
	1  	 NRB$M_PRILOG 	! REGION  WAS CHECKPOINTED (SAVE THE PRILOG BIT)
	R_DBS.NRB$L_LASTID=0	! LAST ID SCANNED INDEX PRIOR TO BUFFER
				! EXHAUSTION
	R_DBS.NRB$Q_NETSTS.COND=0	! INIT STATUS
C
C SEE IF WE HAVE A LOGICAL NODE NAME
C
	IF((R_DBS.NRB$L_FLAGS .AND. NRB$M_PRILOG).NE. 0)THEN
		R_DBS.NRB$c_secnode(1:1)=CHAR(0) ! STORE NULL SO NOONE CAN
						 ! CAN CONNECT UNTIL WE 
						 ! KNOW WHERE LOGICAL NODE IS
		PRILOG_COUNT=PRILOG_COUNT+1	 ! INCREMENT NUMBER FOUND
						 ! SO WILL REQUEST THAT THE 
						 ! LOGCAIL NODE NAME BE FOUND
						 ! BEFORE WE START CONNECTING.
	ENDIF
C
C RELOCATE ANY POINTERS
C
	WRITE(*,300)ROUTE_DBS(1)
300	FORMAT(' ROUTE DBS STARTING V.A.: ',Z8)
	WRITE(*,400)%LOC(R_DBS)
400	FORMAT(' NRB ADDRESS: ',Z8)
	WRITE(*,200)R_DBS.NRB$L_UNSBUF
200	FORMAT(' READ BUFFER: ',Z8)
	R_DBS.NRB$L_UNSBUF=R_DBS.NRB$L_UNSBUF
	1	+ROUTE_DBS(1) ! RELOCATE READ BUFFER
	WRITE(*,200)R_DBS.NRB$L_UNSBUF
C
C
	WRITE(*,500)R_DBS.NRB$L_UNSBUF+8
500	FORMAT(' CALLING RELOCATE, ADDRESS OF OFFSET: ',Z8)
	call relocate_offset(	! RELOCATE LINK FROM READ BUFFER TO NRB
	1	%VAL(R_DBS.NRB$L_UNSBUF+8),ROUTE_DBS(1))
C
C	TAKE THE SUBSTRUCTURE NRB$Q_MSGID And the count
c	(NRB$L_IDCNT) and call LINK_ID_LST to thread
c 	and relocate the link lists of message ids.
c
c	build_route_table=link_id_lst(....?????)
c
	BUILD_ROUTE_TABLE=SS$_NORMAL	
	RETURN	
	END
