	OPTIONS/EXTEND
	SUBROUTINE CHK_LNK_SEQ(BUF,NRB)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&CHK_LNK_SEQ\&
C .nf
C .x CHK_LNK_SEQ>Defined
C Source:CHK_LNK_SEQ.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 08-DEC-1986
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    BUF                        STRUCTURE/BUFDEF/                                 
C                               MESSAGE AND STATUS BLOCK OF MESSAGE READ          
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NRB FOR THE LINK WHICH THE DATA WAS READ ON
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine simply logs an error if the link sequence
C numbers are not sequentially incrementing and then
C resets the link sequence number to that in the message.
C 	CALLING SEQUENCE
C .SK
C      CALL CHK_LNK_SEQ(BUF,NRB)
C 
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(BUFDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	RECORD/BUFDEF/BUF
	RECORD/NRBDEF/NRB
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 EXP_LNK	! EXPECTED LINK SEQUENCE NUMBER

C
C SEE IF LINK SEQUENCE NUMBER IN MESSAGE MATCHES
C
	EXP_LNK= NRB.NRB$W_LNKSEQI+1  ! EXPECTED IS ONE PLUS PREVIOUS
	IF(EXP_LNK .GT. 9999) EXP_LNK=1  ! TIME TO WRAP?
C
	IF(BUF.BUF$S_MSG.MGH$W_LSQ .NE.	! EQUALL?
	1	EXP_LNK .AND.   ! OR FIRST MESSAGE
	1	NRB.NRB$W_LNKSEQI .NE. 0) THEN   ! NO, THEN LOG ERROR
C
	   SYS_STATUS=OPR_FAO_MSG(RTR_LNKSEQERR,
	1	%VAL(BUF.BUF$S_MSG.MGH$W_LSQ),	! WHAT WE GOT
	1	%VAL(EXP_LNK),			! WHAT WE EXPECTED
	1	NRB.NRB$C_CURNODE)		! CURRENT NODE
	ENDIF
C
	NRB.NRB$W_LNKSEQI=BUF.BUF$S_MSG.MGH$W_LSQ	! SET TO THAT IN MESSAGE
	RETURN
	END

