	OPTIONS/EXTEND
	LOGICAL FUNCTION CMP_NAME(NODE,NRB,FLAGS)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&CMP_NAME\&
C .nf
C .x CMP_NAME>Defined
C Source:CMP_NAME.MOD
C Designer           :EARL LAKIA
C Author             :Earl Lakia
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 28-jun-1988
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NODE                       STRUCTURE CHARACTER*6
C                               NODE NAME ARRAY TO COMPARE                        
C  
C    NRB                        STRUCTURE                                         
C                               NODE ROUTING BLOCK                                
C  
C Returns:
C  
C    CMP_NAME                   LOGICAL                                           
C                               .TRUE. IF NODE MATCHES, ELSE .FALSE.              
C  
C    FLAGS                      INTEGER*4                                         
C                               FLAG LONG WORD FROM THE NRB                       
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is passed a node name and also the NRB for
C some node.  If the passed node name equells either the primary
C or the secondary node name, then it is considered a match.  The
C current value of the flag word is also returned.  The test will
c be done only from up to a "::" in a string if present in the 
c "NODE" parameter.  The same position in the NRB.node position
c must have a blank denoting a less than 6 character node name.
c  
c .nofill
C 	Calling/use:
C  IF( CMP_NAME(NODE,%VAL(NRBADDRESS),FLAGS))THEN
C      ----- GOT A MATCH OF NODE NAMES ------
C  ENDIF
c .fill
c  
C 	If the matching node name is the secondary node name
c the approiate bit is set in the nrb flag word, otherwise it
c is cleared denoting the primary.  
C 
C end.doc ****************************** end.doc  
c
c 1.1 28-jun-1988 Earl Lakia (Ipact)
c 	Allow connection by a node name less than six characters.  
c

	STRUCTURE /NODENAME/
	   CHARACTER*6 NODENAME
	END STRUCTURE
	RECORD/NODENAME/NODE
C
	INTEGER*4 FLAGS	! FLAGS FROM NRB
C
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD /NRBDEF/NRB
	INTEGER*4 IS	! starting position of "::" if found
	INTEGER*4 STR$POSITION ! finds sub string
D	INTEGER*4 STATUS
D	INTEGER*4 OPR_FAO_MSG
D	INTEGER*4 DNODE(2)
C

D	DNODE(1)=6	! BUILD DESCRIPTORS FOR PRINTING
D	DNODE(2)=%LOC(NODE)
D	STATUS=OPR_FAO_MSG(RTR_CMPNAME,
D	1	DNODE,%DESCR(NRB.NRB$C_PRINODE),
D	1	NRB)
C
c
c scan the input string looking for a "::" if it is present, then
c the node name is not a full 6 characters.
c 
	IS=STR$POSITION(NODE.NODENAME,':')
	IF(IS .GT. 6 .OR. IS .LE. 0)THEN
		IS=6
	ELSE
		IS=IS-1		! Don't compare the colon
	ENDIF
C
C 	PRIMARY NODE?
C
	IF(NODE.NODENAME(1:IS) .EQ. NRB.NRB$C_PRINODE(1:IS))THEN
	  IF(IS .NE. 6 .AND. 
	1	  NRB.NRB$C_PRINODE(IS+1:IS+1) .NE. ' ')
	1		GOTO 100 ! If short name, must be a null, try sec. name
	  CMP_NAME=.TRUE.  	! found match to name
	  FLAGS=NRB.NRB$L_FLAGS  ! return flags for caller
	  NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .AND.
	1 	(.NOT. NRB$M_SEC)  ! Mark PRIMARY by clearing secondary
	  RETURN		
	ENDIF
C
C	SECONDARY NODE?
C
100	CONTINUE
	IF(NODE.NODENAME(1:IS) .EQ. NRB.NRB$C_SECNODE(1:IS))THEN
	  IF(IS .NE. 6 .AND. 
	1	NRB.NRB$C_SECNODE(IS+1:IS+1) .NE. ' ')
	1	GO TO 200	 ! If short name, must be a null
	  CMP_NAME=.TRUE. 	! found match of node names
	  FLAGS=NRB.NRB$L_FLAGS ! return flags
	  NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .OR. NRB$M_SEC ! Mark sec. node
	  RETURN
	ENDIF
C
C 	NO MATCH ON NODE NAMES
C
200	CONTINUE
	CMP_NAME=.FALSE.
	RETURN
	END

