	OPTIONS/EXTEND
	SUBROUTINE DEA_RESP_BUF(ADDR,USE)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&DEA_RESP_BUFFER\&
C .nf
C .x DEA_RESP_BUFFER>Defined
C Source:DEA_RESP_BUFFER.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:15-JUL-1986 13:59:27.33
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    ADDR                      INTEGER*4
C                               ADDR OF RESPONSE BUFFER TO DEALLOCATE
C                               
C    USE                        BYTE ARRAY
C                               ARRAY OF IN USE FLAGS
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON                                                             
C                               MA_ROUTER COMMON                                  
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG MESSAGES                                      
C                                (found in library:INLAND)
C .X AT_ADD>Referenced 
c    AT_ADD                     Get value at the given address. 
c                               (found in library: INLAND)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called to deallocate a 
C response buffer.  There is no way that this should fail.
C 	The RSPBUF contains links to the response buffer
C list head such that the entry can freed.
C 	Calling sequence:
C 
C 	CALL DEA_RESP_BUF(ADDR,USE)
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$EXIT
	INTEGER*4 AT_ADD	! GET VALUE AT ADDRESS
C
	integer*4 INDEX,I
	INTEGER*4 ADDR		! ADDR OF THE RESPONSE BUFFER TO FREE
	BYTE USE(RESP_COUNT)

C
C SIMPLY CLEAR THE USE FLAG BYTE AS REFERENCED BY THE ADDR
C
	INDEX=LAST_RESP-1
	DO I=1,RESP_COUNT	! LOOP FOR NUMBER OF ALLOCATED
				! RESPONSE BUFFERS
	   IF(INDEX .LT. 1)INDEX=RESP_COUNT
D	   WRITE(*,300)INDEX,AT_ADD(%VAL(RESP_ADD_LST+ ((INDEX-1)*4)))
D300	   FORMAT(' INDEX: ',I8,' RESP ADD: ',Z8)
	   IF(AT_ADD(%VAL(RESP_ADD_LST + ((INDEX-1)*4)))  .EQ.
	1		ADDR)THEN
		USE(INDEX)=0	! MARK AS NOT IN USE ANY MORE
	   	RETURN
	   ELSE
		INDEX=INDEX-1
	   ENDIF
	ENDDO
C
	WRITE(*,100)ADDR
100	FORMAT(' INVALID ADDRESS PASSED TO DEALLOCATE BUFFER: ',Z8)		
	RETURN
	END
