	OPTIONS/EXTEND
	PROGRAM MA_ROUTER
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&MA_ROUTER\&
C .nf
C .x MA_ROUTER>Defined
C Source:MA_ROUTER.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update:26-AUG-86
C Revision level     :1.4
C  
C               Inland Steel Co.
C               3210 Watling St.
C               East Chicago, IN   46312
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MAIN COMMON USED BY THIS PROGRAM, CHANNEL         
C                               NUMBERS, VIRTUAL ADDRESSES, ETC.                  
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X GET_Q_EVENT>Referenced
C    GET_Q_EVENT                GET AN EVENT OUT OF OUR LOCAL QUEUE OF EVENTS     
C                               SUCH AS I/O COMPLETE, TIMEOUT, MAILBOX MESSAGE.   
C  
C .X MA_R_INIT>Referenced
C    MA_R_INIT                  INITIALIZE THIS PROCESS                           
C  
C .X NEW_ROUTING_MAP>Referenced
C    NEW_ROUTING_MAP            CALLED WHEN A NEW ROUTING DATABASE MESSAGE        
C                               HAS BEEN RECEIVED.                                
C  
C .X RECV_PROCESS_CON>Referenced
C    RECV_PROCESS_CON           CALLED WHEN A RECEIVING PROCESS WISHES TO         
C                               CONNECT TO A MESSAGE ID QUEUE.                    
C  
C .X SHUTDOWN_ROUTER>Referenced
C    SHUTDOWN_ROUTER            CALLED WHEN A MESSAGE TO SHUT US DOWN IS          
C                               RECEIVED                                          
C  
C .X REMOTE_NODE_DIS>Referenced
C    REMOTE_NODE_DIS            CALLED WHEN A REMOTE DECNET NODE DISCONNECTS      
C                               FROM US AND WE GET THE DISCONNECT MESSAGE         
C                               IN OUR NETWORK MAILBOX.                           
C  
C .X NON_EMPTY_Q>Referenced
C    NON_EMPTY_Q                CALLED WHEN A MESSAGE IN OUR MAILBOX HAS          
C                               ARRIVED DENOTING THAT SOME MESSAGE ID HAS         
C                               GONE FROM ZERO TO ONE MESSAGE IN THE QUEUE.       
C  
C  
C .X FIND_ROUTE_MESSAGE>Referenced
C    FIND_ROUTE_MESSAGE         THIS SUBROUTINE IS CALLED TO SCAN FOR             
C                               MESSAGES THAT CAN BE TRANSMITTED.                 
C  
C .X NET_WRITE_COMP>Referenced
C    NET_WRITE_COMP             CALLED WHEN A NETWORK OUTPUT MESSAGE HAS          
C                               COMPLETED.                                        
C  .X OPR_FAO_MSG>Referenced
c     OPR_FAO_MSG               USED TO LOG MESSAGES TO CONSOLE
C  
C .X CON_TIMER_EXPIRE>Referenced
C    CON_TIMER_EXPIRE           CALLED WHEN A TIMER FOR CONNECTING TO OTHER       
C                               REMOTE NODES HAS EXPIRED.                         
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This is the main line program that performs the routing functions
C needed for the routing guaranteed delivery of messages between 
C DECNET nodes.  This process is started via the DCL command string:
C "RUN MA_ROUTER".
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
C
	INCLUDE 'EVENT_Q.INC/NOLIST'
C
	INTEGER*4 SYS_STATUS	! system service status
C
	INTEGER*4 FIND_ROUTE_MSG ! FIND THE MESSAGES TO BE ROUTED
	INTEGER*4 OPR_FAO_MSG	! log error/status to console
	INTEGER*4 GET_Q_EVENT   ! get entry from event queue
	INTEGER*4 CONNECT_NODE	! connect a node after a timeout
	INTEGER*4 MA_R_INIT     ! INIT OURSELVES
	INTEGER*4 NEW_ROUTING_MAP ! NEW ROUTING DATABASE
	INTEGER*4 RECV_PROCESS_CON ! RECEIVING PROCESS CONNECT HANDLING SUBR.
	INTEGER*4 SHUT_DOWN_ROUTER ! REQUEST RECV'D TO SHUT US DOWN
	INTEGER*4 REMOTE_NODE_DIS  ! HANDLE REMOTE DISCONNECTS
	INTEGER*4 NON_EMPTY_Q	   ! RECEIVED NON EMPTY QUEUE MESSAGE
	INTEGER*4 REMOTE_NODE_CONNECT ! REMOTE NODE CONNECTION REQUEST
	INTEGER*4 FIND_Q_MESAGES	! FIND MESSAGES TO BE DEQUEUED
	INTEGER*4 NET_WRITE_COMP	! NETWORK WRITE COMPLETE
	INTEGER*4 CON_TIMER_EXPIRE	! NETWORK CONNECT TIMER EXPIRED
	INTEGER*4 SYS$SETAST		! ABLE/DISABLE AST RECOGNITION
	INTEGER*4 SYS$EXIT		! PROCESS EXIT SYSTEM SERVICE
	INTEGER*4 SYS$CLREF		! CLEAR EVENT FLAG
	INTEGER*4 SYS$WAITFR		! WAIT FOR EVENT FLAG SYSTEM SERVICE
	INTEGER*4 SYS$WFLOR		! WAIT FOR LOGICAL OR OF EFN'S
	INTEGER*4 SYS$READEF		! READ EVENT FLAGS
	INTEGER*4 SYS$BINTIM		! ASCII TO BINARY QUAD DELTA TIME
	INTEGER*4 SYS$SETIMR		! SET MARK TIME
	INTEGER*4 EVENT			! EVENT NUMBER THAT HAS OCCURRED
	INTEGER*4 EVENT_INDEX		! INDEX TO CIRCULAR QUEUE OF DATA
	INTEGER*4 TRY_FULL_TIME(2)	! RETRY TIMER QUAD WORD
	LOGICAL	CHECK_WORK		! SHOULE WE LOOK FOR WORK?
	INTEGER*4 WAIT_MASK		! WAIT MASK FOR WAIT OR MESG EFN'S
	INTEGER*4 MESG_EFN_MASK		! MASK FOR MESG EVENT FLAG
	INTEGER*4 GOT_MESG		! EVENT FLAG MASK LONG WORD

C
C TELL SOMEONE WERE ON THE AIR
C
	SYS_STATUS=OPR_FAO_MSG(RTR_START)
C
C INITIALIZE OURSELVES
C
	SYS_STATUS=SYS$SETAST(%VAL(0))	! DISABLE AST RECOGNITION
	SYS_STATUS=MA_R_INIT()
	IF (.NOT. SYS_STATUS)	! GOOD INIT STATUS?
	1	 SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))	! NO, THEN EXIT
	SYS_STATUS=SYS$SETAST(%VAL(1))	! ENABLE AST RECOGNITION
C
C CREATE WAIT MASK (WAKE AND MESG EVENT FLAGS)
C
	MESG_EFN_MASK=JISHFT('00000001'X,JMOD(MESG_EFN,32))
	WAIT_MASK=JISHFT('00000001'X,JMOD(WAKE_EFN,32)) .OR.
	1	MESG_EFN_MASK
D	WRITE(*,15)WAIT_MASK
D15	FORMAT(' WAIT MASK: ',Z8)
C
C NOW WE JUST WAIT FOR SOMETHING TO HAPPEN,  ALL OF THE
C AST'S AND THE LIKE TRIGGER US BY SETTING OUR 
C WAKE UP EVENT FLAG (WAKE_EFN).
C
700	CONTINUE
D	TYPE *,' WAITING FOR A WAKEUP ON EVENT FLAGS: '
D	TYPE *,WAKE_EFN,MESG_EFN
	SYS_STATUS=SYS$WFLOR(%VAL(WAKE_EFN),%VAL(WAIT_MASK))
	IF(.NOT. SYS_STATUS)THEN	! GOOD SYSTEM SERVICE CALL?
		TYPE *,' BAD WAITFOR  STATUS ON EVENT FLAG: ',WAKE_EFN	
		SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS)) ! NO, THEN 
						      ! SOMETHING NOT KOSHER
	ENDIF
	SYS_STATUS=SYS$READEF(%VAL(MESG_EFN),GOT_MESG) ! SEE IF MESG EFN SET
	IF((GOT_MESG. AND. MESG_EFN_MASK) .NE. 0)THEN
		CHECK_WORK=.TRUE.  ! NEW MESSAGES? 
D		TYPE *,' WAKE UP BECAUSE NE MESSAGE OR WRITE I/O COMPLETE'
	ELSE
		CHECK_WORK=.FALSE. ! ASSUME NO NEED TO LOOK FOR WORK IF NO
				   ! NEW MESSAGES
	ENDIF
C
	SYS_STATUS=SYS$SETAST(%VAL(0))	! DISABLE AST RECOGNITION
C
C CALL TO FIND OUT WHAT EVENT HAS TRANSPIRED
C
800	SYS_STATUS=GET_Q_EVENT(EVENT,EVENT_INDEX) ! GET THE EVENT NUMBER
						  ! AND INDEX
	IF (.NOT. SYS_STATUS)GO TO 1100	! IF NO EVENT, THEN GO WAIT

C
C DEPENDING ON THE EVENT NUMBER, CALL  THE APPROIATE SUBROUTINE
C TO HANDLE THE EVENT (BECAUSE SHARED DATA STRUCTURES, THIS
C HANDLING IS DONE WITH AST RECOGNITION DISABLED
C
D	TYPE *,' EVENT NUMBER: ',EVENT
D	TYPE *,' EVENT  INDEX: ',EVENT_INDEX
C
	IF(EVENT .EQ. CON_COMP)THEN
D		TYPE *,' CONNECTION COMPLETE '
		CHECK_WORK=.TRUE.
		CALL REM_NODE_CON(%VAL(EVENT_QUE(EVENT_INDEX).NRBADD))
C
	ELSE IF(EVENT .EQ. CON_TIMEOUT)THEN
D		TYPE *,' CONNECTION TIMEOUT '
		SYS_STATUS=CONNECT_NODE		! TRY TO CONNECT AGAIN
	1		(%VAL(EVENT_QUE(EVENT_INDEX).NRBADD))
C
	ELSE IF(EVENT .EQ. LINK_TERM)THEN
D		TYPE *,' LINK TERMINATED '
C
	ELSE IF(EVENT .EQ. FIND_WORK)THEN
D		TYPE *,' NEW NODE AVAILABLE  NEED TO '
D		TYPE *,' SEE IF ANY WORK FOR THAT NODE'
		CHECK_WORK=.TRUE.
	ELSE IF(EVENT .EQ. NET_DOWN)THEN
		TYPE *,' NETWORK SHUTTING DOWN'
		TYPE *,' DISCONNECTING ALL NODES '
		TYPE *,' ROUTING FUNCTIONS NOT NEEDED IF NO NETWORK'
		CALL SYS$EXIT(%LOC(RTR_NETDOWN))
	ELSE IF(EVENT .EQ. NEW_DBS)THEN
		TYPE *,' NEW ROUTING DATABASE '
		TYPE *,' ROUTING FUNCTION EXITING UNTIL NEW DATABASE BUILT'
		CALL SYS$EXIT(%LOC(RTR_NEWDBS))
	ELSE IF (EVENT .EQ. FULL_REMOTE)THEN
		TYPE *,' REMOTE NODE HAS A FULL QUEUE'
		IF(.NOT. QNA_TMO)THEN
C
C		 	START A MARK TIME FOR 15 MINUTES
C			AND THEN CLEAR ANY RMOTE NODE QUEUE
C			FULL FLAGS.
C
			QNA_TMO=.TRUE.
			SYS_STATUS = SYS$BINTIM('0 :15:00',TRY_FULL_TIME)
			IF (.NOT. SYS_STATUS)THEN
				TYPE *,' BAD TIME CONVERISION '
				CALL SYS$EXIT(%VAL(SYS_STATUS))
			ENDIF
C
			SYS_STATUS = SYS$SETIMR(,	! EVENT FLAG
	1		%REF(TRY_FULL_TIME),	! TIMER VALUE
	1		%VAL(UNFULL_AST_ADD), ! AST ADDRESS
	1		)		 ! REQUEST ID (= NRB ADDRESS)
			IF (.NOT. SYS_STATUS)THEN
				TYPE *,' BAD SET TIMR STATUS FOR'
				TYPE *,' SETTING UNFILL AST'
				CALL SYS$EXIT(%VAL(SYS_STATUS))
			ENDIF
		ENDIF
	ELSE
		TYPE *,' UNRECOGNIZED EVENT '
	ENDIF
	GO TO 800
C
C SINCE WE COULD ALSO BE AWAKENED BY NEW MESSAGES,
C GO SEE IF ANY
C
1100	CONTINUE
D	TYPE *,' CHECK TO SEE IF ANY MESSAGES TO GO OUT '
	IF(CHECK_WORK)THEN 
		SYS_STATUS=SYS$CLREF(%VAL(MESG_EFN)) 
		IF (.NOT. SYS_STATUS)THEN
			TYPE *,' ERROR IN CLEARING EVENT FLAG: ',MESG_EFN
			SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
		ENDIF
		SYS_STATUS=FIND_ROUTE_MSG()
D		TYPE *,' LAST NRB CHECKED FOR WORK : ',LAST_NRB
		IF(.NOT. SYS_STATUS) CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C
	SYS_STATUS=SYS$CLREF(%VAL(WAKE_EFN))
	IF (.NOT. SYS_STATUS)THEN
		TYPE *,' ERROR IN CLEARING EVENT FLAG: ',WAKE_EFN
		SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	ELSE
		SYS_STATUS=SYS$SETAST(%VAL(1))	! ENABLE AST RECOGNITION
		GO TO 700
	ENDIF
	END

