
	SUBROUTINE MA_ROUTER_EXIT_HAN(EXIT_STATUS)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&MA_ROUTER_EXIT_HAN\&
C .nf
C .x MA_ROUTER_EXIT_HAN>Defined
C Source:ACQUIRE_RELEASE_EXIT.FOR
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update: 11-NOV-1986
C Revision level     :1.1
C  
C               Inland Steel Co.
C               3210 Watling St.
C               East Chicago, IN   46312
C  
C  
C .C ;Formal Parameter List
C Receives:
C
C    EXIT_STATUS                INTEGER*4
C                               SYSTEM EXIT STATUS
C
C Returns:
C	
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           CHANNEL NUMBER, VIRTUAL ADDRESSES, ETC. THAT
C                               ARE LOADED BY THIS SUBROUTINE AND USED
C                               THROUTHOUT THIS PROGRAM. 
C   
C Accesses file(s):
C  
C Other modules referenced:
C
C .SK
C .fill
C .SK
C Description:
C .sk
C 	THIS SUBROUTINE IS CALLED BY THE SYSTEM WHEN THE PROCESS EXITS.
C THIS SUBROUTINE IS A USER EXIT HANDLER.  IT WAS SET UP TO BE
C CALLED BY THE FUNCTION MA_ROUTER_INIT  WHICH PLACED THE ADDRESS 
C OF THIS ROUTINE  INTO THE EXIT HANDLER DESCRIPTOR BLOCK. THIS SUBROUTINE
C WILL:
C .LIST
C .LE;Send disconnect (router SNFU) type message to all processes
c that are connected to message ID's.
c .le;Send if possible to all remote nodes disconnect status.
c .le;Release any resources captured by this process.
c .le;Log a message about why we exited
c .le;Do any other cleanup as deemed necessary
c .els
c 
C end.doc ****************************** end.doc  

	IMPLICIT NONE
	INCLUDE '($SSDEF)'
	INCLUDE '($JBCMSGDEF)/LIST'
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC'
	INTEGER*4 EXIT_STATUS	! SYSTEM EXIT STATUS
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 OPR_FAO_MSG	! FOR SENDING MESSAGE TO OPERATOR
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE

C
	IF (.NOT. EXIT_STATUS) THEN	! WAS THIS AN ABNORMAL CALL?
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(EXIT_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_ABNEXT,MSGDESC)
		IF(EXIT_STATUS .NE. JBC$_JOBABORT) RETURN  ! OK IS SOMEONE 
							  ! ABORTED US
		CALL DUMPNRBREG(%VAL(ROUTE_DBS(1)),ROUTE_DBS(3)) ! DUMP
								! NRB REGION
		RETURN
	ELSE
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(EXIT_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_NMLEXT,MSGDESC)
		RETURN
	ENDIF
	END
	SUBROUTINE DUMPNRBREG(I,ISIZ)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&DUMPNRBREG\&
C .nf
C .x DUMPNRBREG>Defined
C Source:MA_ROUTER_EXIT_HAN.FOR
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:11-NOV-1986 10:00:52.18
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    I                          INTEGER*4 ARRAY                                   
C                               ARRAY TO BE DUMPED                                
C  
C    ISIZ                       INTEGER*4                                         
C                               NUMBER OF DISK BLOCKS IN ARRAY                    
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    SYS$DISK:ROUTEDBS.DMP                                                        
C                               WRITE/CREATE                                      
C .X SYS$DISK:ROUTEDBS.DMP>WRITE/CREATE
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk   
C 	SIMPLE SUBROUTINE TO DUMP THE NRB ROUTEING DATABASE TO A DISK
C FILE FOR EASY LOOKING AT WHEN AN ABORT OCCURS. THE CALLING SEQUENCE
C IS:
C .NOFILL
C 	CALL DUMPNRBREG(I,ISIZ)
C .FILL
C end.doc ****************************** end.doc  
C
	INTEGER*4 ISIZ		! NUMBER OF DISK BLOCKS
	INTEGER*4 I(128,ISIZ)  ! REGION
	INTEGER*4 J,K
C
	OPEN(UNIT=10,
	1	NAME='SYS$DISK:ROUTEDBS.DMP',
	1	TYPE='NEW',
	1	RECL=128,	! NUMBER OF LONG WORDS
	1	ERR=1000,
	1	ACCESS='SEQUENTIAL',
	1	FORM='UNFORMATTED',
	1	RECORDTYPE='FIXED',
	1	INITIALSIZE=ISIZ+3,	! ALLOW SOME FOR HEADER BLOCKS
	1	ORGANIZATION='SEQUENTIAL'
	1	)
C
	DO 100 J=1,ISIZ
		WRITE(10)(I(K,J),K=1,128)
100	CONTINUE
1000	RETURN
	END

