	OPTIONS/EXTEND
	SUBROUTINE NET_READ(NRB)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&NET_READ\&
C .nf
C .x NET_READ>Defined
C Source:NET_READ.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 18-JUL-1986
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               CONTAINS NRB THAT READ IS TO BE DONE FOR          
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MA_ROUTER COMMON USED BY EVERYONE                 
C  
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                ERROR MESSAGES                                    
C                                (found in library:INLAND)
C .X DISCONNECT_NODE
C    DISCONNECT_NODE            USED TO DISCONNECT A NODE
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine will issue a Read qio to the net work
C for the channel in the NRB.  If an error occurrs,  DISCONNECT_NODE
C will be called and the node will be disconnected.  
C .nofill
C .sk 2
C CALLING SEQUENCE
C .SK
C CALL NET_READ(NRB)
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(BUFDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD/NRBDEF/NRB	! AST PARAMETER IS THE NRB OR DUMMY FOR 
				! UNSOLICITED CONNECTS
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS_STATUS2
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER I

C
D	SYS_STATUS=OPR_FAO_MSG(RTR_NTRDPST,
D	1	NRB.NRB$C_CURNODE)
C
	IF(NRB.NRB$L_CHAN .EQ. 0)RETURN  ! MUST HAVE GOT A DICONNECT
C
	SYS_STATUS=SYS$QIO(,	! EVENT FLAG
	1  %VAL(NRB.NRB$L_CHAN),	! CHANNEL
	1  %VAL(IO$_READVBLK),	! FUNCTION CODE
	1  %VAL(NRB.NRB$L_UNSBUF),	! NETWORK READ STATUS 
	1  %VAL(READ_NET_AST_ADD),	! AST ROUTINE
	1  %VAL(NRB.NRB$L_UNSBUF),	! AST PARAMETER= I/O STATUS BLOCK
	1  %VAL(NRB.NRB$L_UNSBUF+BUF$K_BUFOFF), ! BUFFER ADDRESS 
	1  %VAL(NRB.NRB$L_UNSSIZ-BUF$K_BUFOFF),,,,)  ! SIZE
C
	IF(.NOT. SYS_STATUS)THEN	! QIO NOT ACCEPTED?
		MSGDESC(1)=512
		SYS_STATUS2=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS2=OPR_FAO_MSG(RTR_NETRDQIO,
	1	  NRB.NRB$Q_NCBDES,MSGDESC)
		CALL DISCONNECT_NODE(NRB)
	ENDIF
	RETURN
	END
