	SUBROUTINE READ_MBX_NW(CHANNEL,MAXBYTE,BUFFER,icnt,ERR)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&READ_MBX_NW\&
C .nf
C .x READ_MBX_NW>Defined
C Source:READ_MBX_NW.for
C TO BECOME PART OF LIBRARY:PRODUCTION
C Designer           :Earl lakia
C Author             :Earl Lakia
C Date of last update:22-jul-1985
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    CHANNEL		      I*4
C 			      LOGICAL CHANNEL ASSIGNED TO MAILBOX TO BE READ
C 
C    MAXBYTE		      I*4
C 			      MAXIMUM NUMBER OF BYTES TO READ
C Returns:
C  
C    BUFFER                     BYTE(*)                                 
C                               THIS IS THE DATA READ FROM THE SPECIFIED MAILBOX  
C                               THIS READ PERFORMS A DESTRUCTIVE READ WHICH MEANS 
C                               THAT AFTER THE DATA IS READ IT IS ERASED FROM THE 
C                               MAILBOX. YOU MUST READ THE WHOLE BUFFER NOT JUST  
C                               PARTICULAR FIELDS. THE DATA IS RETURNED TO THE    
C                               CALLER IN THE PARAMETER BUFFER                    
C  
C    ICNT                       I*4                                               
C                               THIS IS THE PARAMETER THAT CONTAINS THE ACTUAL
c                               byte count if good status.
c
c
C    ERR			I*4
C                               Error status from the QIO or the system
c                               service call.
c                               
C  
C .SK
C .fill
C .SK
C Description:
C .sk    
C 
C THIS IS A SUBROUTINE TO READ AND NOT WAIT ON A MAILBOX.  THE CALLING PROGRAM
C MUST PROVIDE THE CHANNEL NUMBER WHICH IS ASSIGNED TO THE
C MAIL BOX IN WHICH THE READ IS TO BE PERFORMED, 
C THE MAXIMUM BYTE COUNT POSSIBLE (NOTE: DUE TO A BUG IN VMS, THIS
C MUST BE THE ACTUAL SIZE OF THE MAILBOX), AND
C A BUFFER TO RETURN THE DATA READ.  THIS SUBROUTINE WILL RETURN THE 
C ACTUAL BYTE COUNT  UNLESS THERE IS AN ERROR
C IN WHICH CASE THE ERROR NUMBER IS RETURNED (FROM EITHER
C THE SYSTEM SERVICE ERROR OR QIO STATUS FROM READ).  THE CALLING PROGRAM WILL
C EITHER RECEIVE THE READ DATA OR RETURN WITH A MAILBOX EMPTY ERROR
C CODE. 
C 
C .NOFILL
c .tp 15
c Calling Sequence:
c  
c       INTEGER*4 ERR,ICNT
C 	CALL READ_MBX_NW(CHANNEL,MAXBYTE,BUFFER,ICNT,ERR)
C       IF(.NOT. ERR) THEN 
C               ***** ERROR PROCESSING *****
c                or no data present
C       ELSE
C           ICNT= BYTE COUNT READ
C       ENDIF
C .FILL
C end.doc ****************************** end.doc  
C
	INCLUDE '($IODEF)'
C
	BYTE		BUFFER(*)		! BUFFER FOR RECEIVE FROM MAILBOX
	INTEGER*4	ERR			! BYTE COUNT/ERROR CODE RETURNED
	INTEGER*4	CHANNEL			! CHANNEL ASSIGNED TO MAILBOX
	INTEGER*4	Q_IOSB(2)		! I/O STATUS RETURN FROM QIO
	INTEGER*2	Q_IOSBW(4)		! WORD ADDRESSABLE STATUS
	EQUIVALENCE 	(Q_IOSBW,Q_IOSB)	!
	INTEGER*4 	ICNT			! BYTE COUNT OF READ
	INTEGER*4	SYS$QIO		! SYSTEIM SERVICE ROUTINE
	INTEGER*4	SYS$ASSIGN		! SYSTEM SERVICE ROUTINE
C
C DO A READ, WITHOUT WAITING
C
	ERR = SYS$QIO(,%VAL(CHANNEL),
	1		    %VAL(IO$_READVBLK .OR. IO$M_NOW),
	1		    Q_IOSB,
	1		    ,,
	1		    %REF(BUFFER),
	1		    %VAL(MAXBYTE),
	1		    ,,,)
C
	ICNT= Q_IOSBW(2)  ! RETURN BYTE COUNT READ
	IF(.NOT.ERR)RETURN ! SYSTEM SERVICE ACCEPTED
	ERR=Q_IOSBW(1)	! EXTEND ERROR CODE FOR USER
C
9999	RETURN
	END
