$!
$! START THE MA QUEUING AND ROUTING SOFTWARE COMMAND FILE
$!
$!
$!  5/26/87  E. Lakia-- Fixed the Q_UTL call in the event that
$!			the queue is validated.
$!  2/24/87  E. Lakia-- Enabled the verify test of the queue.
$!
$ SET NOON
$ SET PROCESS/PRIV=ALL
$ STOP/QUEUE/RESET MA$Q
$ DELETE/QUEUE MA$Q
$!
$!************************************************
$! THE LOGICALS SHOULD BE DEFINED
$!
$ TOP = F$TRNLNM("MA_Q$PROD")
$ IF TOP .NES "" THEN GOTO GOTLOG
$ TYPE SYS$INPUT
	LOGICALS ARE NOT SETUP CORRECTLY
$ EXIT
$ GOTLOG:
$! 
$! Set to top directory
$!
$ SET DEF MA_Q$PROD
$!
$!*************************************************
$! INSTALL QUEUE SYSTEM SERVICE (OR REMOVE OLD ONE IF PRESENT)
$!
$ OLDPRIV="CMKRNL,CMEXEC,SYSNAM,GRPNAM,ALLSPOOL,DETACH,DIAGNOSE,LOG_IO,GROUP,ACNT,PRMCEB,PRMMBX,PSWAPM,ALTPRI,SETPRV,TMPMBX,WORLD,MOUNT,OPER,EXQUOTA,NETMBX,VOLPRO,PHY_IO,BUGCHK,PRMGBL,SYSGBL,PFNMAP,SHMEM,SYSPRV,BYPASS,SYSLCK,SHARE,UPGRADE,DOWNGRADE,GRPPRV
$ SET PROC/PRIV=CMKRNL
$ IF  $STATUS THEN GOTO GOTPRIV
$ TYPE SYS$INPUT
	Insuficient privelege to install the service.  Run from a
	priveleged account.
$ EXIT
$ GOTPRIV:
$ INSTALL :== $SYS$SYSTEM:INSTALL/COMMAND
$ install
REMOVE SYS$SYSROOT:[SYSLIB]SSDISP
CREATE SYS$SYSROOT:[SYSLIB]SSDISP-
	/share-
	/PROTECT-
	/PURGE-
	/PRIV=(PHY_IO,CMKRNL,-
	CMEXEC,LOG_IO,OPER,BUGCHK,-
	SYSGBL,SYSNAM,PRMGBL,SYSLCK,SHARE)
$!
$!********************************************************
$!  STOP THE CURRENT QUEUE IF IT IS PRESENT
$!
$!
$! Remove the currently installed queue
$!
$! Options to q_utl are:  Remove function, default queue name
$!
$RUN Q_UTL
R

$EOD
$!
$! Attempt to use the old queue first
$!
$! Options to verify_q are:  Default queue file name specification
$!
$ RUN VERIFY_Q

$EOD
$ IF $STATUS THEN GOTO CURRENTOK
$!
$! The current queue is not any good.  Attempt to dump what we 
$! can to be reloaded later.
$!
$! options to q_utl are:  Dump current queue, default file spec for dump file
$! 
$ RUN Q_UTL
D

$EOD
$!
$! Create a new queue file and load with the dump from above.
$!
$! options to q_utl are:  create function, size of queue, number message ids
$!			  Default file spec, populate file (Y/N), dump file
$!			  file specification.
$!
$RUN Q_UTL
C
1000
30

Y

$EOD
$!*******************************************
$!
$! THE QUEUE HAS BEEN REBUILT OR WAS OK AS ON DISK
$!
$CURRENTOK:
$!
$! System not online, or fall through from above.
$! Restart the batch queue, install service, etc.
$!
$ NOBATCHQ:
$!
$! START UP BATCH QUEUE
$!
$ SET DEF MA_Q$PROD
$!
$ @MA$Q		! DEFINE THE BATCH QUEUE
$!
$! Submit the queue checker to our batch queue (at elevated 
$!	realtime priority)
$!
$ PURGE MA_Q$PROD:QUEUE_CHKR.LOG/KEEP=2
$!
$ SUBMIT/QUEUE=MA$Q-
	/LOG=MA_Q$PROD:QUEUE_CHKR.LOG-
	/NOPRINT-
	/PRIORITY=10-
	/NOPRINT -
	 MA_Q$PROD:RUN_QUEUE_CHKR
$!
$! Submit the router process to our batch queue 
$!
$ PURGE MA_ROUTER.LOG/KEEP=2
$
$ SUBMIT/QUEUE=MA$Q-
	/PRIORITY=4-
	/LOG=MA_Q$PROD:MA_ROUTER.LOG-
	/AFTER="+0:0:20"-
	/NOPRINT -
	MA_Q$PROD:RTR
$!
$! Tell everyone that all is ok
$!
$! REPLY/ENABLE
$! REPLY/ALL/BELL " MA ROUTER FUNCTIONS ARE ENABLED "
