 	INTEGER*4 FUNCTION GET_JOB_STATUS(
	1		QUEUE,
	1		JOB,
	1		ENTRY,
	1		SUB_TIME,
	1		USER,
	1		JOB_STATUS)
C
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&GET_JOB_STATUS\&
C .nf
C .x GET_JOB_STATUS>Defined
C Source:GET_JOB_STATUS.FOR
C TO BECOME PART OF LIBRARY:INLAND
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 3-NOV-1986 07:51:39.61
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    QUEUE                      CHAR(1 TO 39)
C                               QUEUE TO SEARCH FOR JOB IN
C  
C    JOB                        CHAR(1 TO 39)
C                               JOB NAME TO SEARCH THE QUEUE FOR 
C  
C Returns:
C  
C    GET_JOB_STATUS             INTEGER*4 
C                               RETURN STATUS OF THE REQUEST 
C  
C    ENTRY                      INTEGER*4
C                               ENTRY NUMBER IN QUEUE THAT JOB WAS FOUND 
C  
C    JOB_STATUS                 INTEGER*4 
C                               CURRENT STATUS OF THE JOB (SEE SYS$GETQUI) FOR
C                               DEFINITIONS OF THIS WORD, IN PARTICULAR THE
C                               MACRO $QUIDEF WHICH DEFINES THE BIT VALUE
C                               STATUS.
C  
C    SUB_TIME                   INTEGER*4(2)
C                               VAX QUAD WORD TIME OF WHEN JOB WAS SUBMITTED
C  
C    USER                       CHAR(12) 
C                               USER NAME (ZERO FILLED STRING) OF THE USER
C                               NAME OF THE JOB.
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine will call the SYS$GETQUI in an attempt
C to get the desired information about the JOB specified in the
C specified QUEUE.  The status returned are from those returned
C form the SYS$GETQUI system service.  If the QUEUE does not
C exist, then the status: JBC$_NOSUCHQUE is returned.  If the
C job name does not exist in the queue, either the status
C JBC$_NOMOREFILE or JBC$_NOSUCHFILE is returned.  The 
C status status JBC$_NOSUCHFILE is returned if the specified
C QUEUE is empty.  
c 	NOTE: This subroutine uses event flag zero
c to wait for the return of the status from the job controller.
C .sk 2
C .NOFILL
C CALLING SEQUENCE:
C .SK
C 	INTEGER*4 STATUS	! RETURN STATUS
C 	CHARACTER*39 JOB	! JOB NAME TO RETURN STATUS ON
C 	CHARACTER*31 QUEUE	! QUEUE NAME TO SEARCH JOB FOR
C 	INTEGER*4 ENTRY		! ENTRY IN THE QUEUE
C 	INTEGER*2 SUB_TIME(4)	! TIME JOB WAS SUBMITTED RET. AS
C 				! VAX QUAD TIME
C 	CHARACTER*12 USER	! USER NAME WHICH SUBMITTED THE JOB
C 	INTEGER*4 JOB_STATUS	! STATUS OF THE JOB
C 	INTEGER*4 GET_JOB_STATUS ! DEFINE FUNCTION CALL
C C
C 	DATA JOB/"HL60021"/	! JOB NAME
C 	DATA QUEUE/"SNA$RJEREADER"/  ! QUEUE NAME
C C
C 	STATUS= GET_JOB_STATUS(
C 	1		QUEUE,
C 	1		JOB,
C 	1		ENTRY,
C 	1		SUB_TIME,
C 	1		USER,
C 	1		JOB_STATUS)
C C
C 	IF(.NOT. STATUS)THEN 
C 		JOB NOT FOUND, QUEUE NOT FOUND, ETC.
C 	ENDIF
C 
C
C .FILL
C 	NOTE: If logical names such as SYS$BATCH are
c used, then the entry must be called with the
c descriptor operator, ie:  %DESCR('SYS$BATCH').
c 
C end.doc ****************************** end.doc  

	INCLUDE '($QUIDEF)'	! GET QUEUE INFORMATION DEFINITIONS
	INCLUDE '($JPIDEF)'	! GET JOB CONTROL INFORMATIONS DEFINITIONS
	INCLUDE '($SSDEF)'	! I/O AND SYSTEM SERVICE STATUS DEFINITIONS
	INTEGER*4 SYS_STATUS	! RETURN STATUS
	INTEGER*4 ENTRY		! ENTRY IN THE QUEUE
	INTEGER*2 SUB_TIME(4)	! TIME JOB WAS SUBMITTED RET. AS
C 				! VAX QUAD TIME
	INTEGER*4 JOB_STATUS	! STATUS OF THE JOB
	INTEGER*4 RETLTH	! RETURN LENGTH VALUE
	INTEGER*4 SYS$GETQUIW	! GET QUEUE INFORMATION
	INTEGER*4 SYS$SYNCH	! I/O SYNCH
	INTEGER*4 I		! LOOP VARIABLE
	INTEGER*4 EFN		! EVENT FLAG
C
	CHARACTER*(*) JOB		! JOB NAME
	CHARACTER*(*) QUEUE		! QUEUE NAME
	CHARACTER*(*) USER		! USER ACCOUNT
C
	STRUCTURE/STATUS/
		INTEGER*4  COND	! CONDITION CODE
		INTEGER*4  SPARE ! FUTURE USE
	END STRUCTURE
C
	RECORD/STATUS/IOST	! I/O STATUS
	RECORD/STATUS/JBISTS	! STATUS FOR THE 
C
	STRUCTURE/ITMLST/
		INTEGER*2 LTH		! BUFFER LENGTH
		INTEGER*2 CODE		! ITEM CODE
		INTEGER*4 BUFADD 	! BUFFER ADDRESS
		INTEGER*4 RETADD	! RETURN LENGTH ADDRESS
	END STRUCTURE
C
	RECORD/ITMLST/QUE(4)
	RECORD/ITMLST/JBI(6)
	INTEGER*4 SEARCH_FLAGS		! SEARCH FLAGS FOR QUEUE
	CHARACTER*31 QUEUE_NAME		! ACTUAL QUEUE NAME
	CHARACTER*39 TEST_JOB		! JOB NAME FOUND IN QUEUE
	INTEGER*4 USRLTH		! LENGHT OF USER NAME STRING
	INTEGER*4 JOBLTH		! LENGTH OF JOB NAME STRING
C
	DATA EFN/5/
	
C
C CANCEL ANY EXISTING SEARCH OPEATIONS
C
	SYS_STATUS=SYS$GETQUIW(,%VAL(QUI$_CANCEL_OPERATION),,,,,)
C
C Setup to find out about the queue
c
	QUE(1).LTH=LEN(QUEUE)		! LENGTH OF CHAR. DESCRIPTOR
	QUE(1).CODE=QUI$_SEARCH_NAME	! FIND QUEUE BY NAME
	QUE(1).BUFADD=%LOC(QUEUE)	! ADDRESS OF THE QUEUE NAME
	QUE(1).RETADD=0
						! RETURN LENGTH
C
	SEARCH_FLAGS=	QUI$M_SEARCH_WILDCARD .OR.
	1		QUI$M_SEARCH_ALL_JOBS
	QUE(2).LTH=4			! FLAG IS A LONG WORD
	QUE(2).CODE=QUI$_SEARCH_FLAGS
	QUE(2).BUFADD=%LOC(SEARCH_FLAGS)	! ADDRESS OF FLAG
	QUE(2).RETADD=0
C
	QUE(3).LTH=31
	QUE(3).CODE=QUI$_QUEUE_NAME
	QUE(3).BUFADD=%LOC(QUEUE_NAME)
	QUE(3).RETADD=%LOC(RETLTH)
C
	QUE(4).CODE=0			! TERMINATOR
	QUE(4).LTH=0
	QUE(4).BUFADD=0
	QUE(4).RETADD=0
C
	GET_JOB_STATUS=SYS$GETQUIW(%VAL(EFN),	! USE DEFAULT EFN
	1		%VAL(QUI$_DISPLAY_QUEUE),	! FUNCTION CODE
	1		,		! NULL ARGUMENT
	1		QUE,		! ITEM LIST
	1		%REF(IOST),		! STATUS
	1		,)		! AST PARM AND ROUTINE
C
	IF(.NOT. GET_JOB_STATUS)RETURN	! WAS SERVICE ACCEPTED?
	GET_JOB_STATUS=SYS$SYNCH(%VAL(EFN),%REF(IOST))
C
C Now see what the status was
c
	GET_JOB_STATUS=IOST.COND
	IF(.NOT. IOST.COND)RETURN	! Check the condition status

C
C FIND OUT ABOUT THE STATUS OF THE USER SPECIFIED JOB
C
	JBI(1).CODE=QUI$_JOB_NAME	! INPUT IS THE USER JOB NAME
	JBI(1).LTH=39			! NUMBER CHARACTERS IN JOB NAME
	JBI(1).BUFADD=%LOC(TEST_JOB)	! ADDRESS OF JOB TO COMPARE WITH CALLER
	JBI(1).RETADD=%LOC(JOBLTH)	! RETURN LENGTH OF JOB
C
	JBI(2).CODE=QUI$_ENTRY_NUMBER	! WANT ENTRY NUMBER RETURNED
	JBI(2).LTH=4			! NUMBER OF CHARACTER IN ENTRY NUMBER
	JBI(2).BUFADD=%LOC(ENTRY)	! WHERE TO PLACE ENTRY
	JBI(2).RETADD=0
C
	JBI(3).CODE=QUI$_JOB_STATUS	! WANT JOB STATUS RETURNED
	JBI(3).LTH=4
	JBI(3).BUFADD=%LOC(JOB_STATUS)	! WHERE TO PLACE STATUS
	JBI(3).RETADD=0
C
	JBI(4).CODE=QUI$_SUBMISSION_TIME	! WANT SUBMISSION TIME
	JBI(4).LTH=8				! 8 BYTE QUAD WORD
	JBI(4).BUFADD=%LOC(SUB_TIME)		! USER SUPPLIED TIME VARIABLE
	JBI(4).RETADD=0
C
	JBI(5).CODE=QUI$_USERNAME		! WANT USER
	JBI(5).LTH=LEN(USER)			! 12 CHARACTER USER NAME
	JBI(5).BUFADD=%LOC(USER)		! WHERE TO RETURN USER NAME
	JBI(5).RETADD=%LOC(USRLTH)
C
	JBI(6).CODE=0				! TERMINATOR
	JBI(6).LTH=0
	JBI(6).BUFADD=0
	JBI(6).RETADD=0
C
600	CONTINUE	! LOOP LOOKING FOR USER SPECIFIED JOB
	GET_JOB_STATUS=SYS$GETQUIW(%VAL(EFN),	! USE DEFAULT EFN
	1		%VAL(QUI$_DISPLAY_JOB),	! FUNCTION CODE
	1		,		! NULL ARGUMENT
	1		JBI,		! ITEM LIST
	1		JBISTS,		! STATUS
	1		,)		! AST PARM AND ROUTINE
C
	IF(.NOT. GET_JOB_STATUS)RETURN	! WAS SERVICE ACCEPTED?
C
	GET_JOB_STATUS=SYS$SYNCH(%VAL(EFN),%REF(JBISTS))
	IF(.NOT. GET_JOB_STATUS)RETURN
C
C Now see what the status was
c
	GET_JOB_STATUS=JBISTS.COND	! COPY STATUS
	IF(.NOT. GET_JOB_STATUS)THEN	! Check the condition status
		RETURN			! no more jobs, etc.
	ELSE
		IF(JOB .NE. TEST_JOB(1:JOBLTH)) GOTO  600 ! TRY NEXT JOB
	ENDIF
	GET_JOB_STATUS=SS$_NORMAL
	RETURN
	END
