	SUBROUTINE OPR_LOG_MSG(ERR_CODE,USER_MESSAGE,USR_LTH)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&OPR_LOG_MSG\&
C .nf
C .x OPR_LOG_MSG>Defined
C Source:OPR_LOG_MSG.FOR
C TO BECOME PART OF LIBRARY:USER.OLB
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update:10-JUN-1985 
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    ERR_CODE                   INTEGER*4                               
C                               THIS IS THE RESPONSE CODE FROM SYSTEM SERVICE     
C                               TYPE CALLS. (FA0)                                 
C  
C    USER_MESSAGE               CHARACTER*80
C                               THIS CONTAINS OPTIONAL USER SUPPLIED TEXT         
C                               THAT IS OUTPUT ALONG WITH THE TRANSLATION OF      
C                               THE FAO ERROR CODE. IT MIGHT BE SOMETHING         
C                               OF THE FORM: COMMUNICATIONS NOT ESTABLISHED       
C  
C    USR_LTH                    INTEGER*2                               
C                               THIS IS THE BYTE COUNT OF THE USER SUPPLIED       
C                               BUFFER. IF THIS IS ZERO, NO USER BUFFER IS        
C                               APPENDED TO THE ERROR MESSAGE.                    
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X $GETMSG>Referenced
C    $GETMSG                    TRANSLATE ERROR CODE TO ASCII                     
C                                (found in library:SYSTEM)
C  
C .X $SNDOPR>Referenced
C    $SNDOPR                    SEND MESSAGE TO THE OPERATOR.                     
C                                (found in library:SYSTEM)
C  
C .X $GETJPI>Referenced
C    $GETJPI                    GET JOB/PROCESS INFORMATION FOR OUTPUT IN         
C                               MESSAGE. ONLY PROCESS NAME IS USED.               
C                                (found in library:SYSTEM)
c .X LIB$STOP>Referenced
c    LIB$STOP                   Stop and display status
c                                (found in library: RUNTIME LIBRARY)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine simply allows for a common way of formatting
C and outputting of system errors from programs.  It is left
C up to the caller to recover from the error but at
C least he need not worry about logging the error.  If this
c subroutine encounters an error, the subroutine calls sys$libstop
c to log the error.  This subroutine should not encounter
c an error and should always return to the caller.
C 	The caller should use something like the following
C when calling this routine:
C .NOFILL
c
C      INTEGER*4 SYS_STAT
C      INTEGER*4 SYS$CANTIM
C      INTEGER*4 SYS$CANEXH
C      SYS_STAT=SYS$CANTIM(%VAL(0),)
C      IF( .not. sys_stat)CALL OPR_LOG_MSG(syst_stat,,0)
c      SYS_STAT=SYS$CANEXH
c      IF(.not. sys_stat)CALL OPR_LOG_MSG(syst_stat,
c      1      ' ALL TRANSACTIONS STOPPED ',28)
C 
C .fill
C 	The format of the error report is the following:
C .nofill
C Process Name
C System translated error message
C User supplied error message
C 
C end.doc ****************************** end.doc  

C
C LOCAL PARAMETERS
C
	IMPLICIT NONE
	INTEGER*2 ILOOP			! LOOP COUNTER, 
	INTEGER*4 ERR_CODE		! USER SUPPLIED ERROR CODE
	CHARACTER*80 USER_MESSAGE	! USER SUPPLIED MESSAGE
	INTEGER*2 USR_LTH		! LENGTH OF USER SUPPLIED MESSAGE
	CHARACTER*264 SND_OPR_BUF	! SEND TO OPERATOR MESSAGE BUFFER
	INTEGER*2 SND_OPR_LTH		! LENGTH OF OPERATOR MESSAGE BUFFER
	CHARACTER*15 PROCESS_NAME	! PROCESS NAME
	BYTE PROCESS_NAME_B		! WITHOUT CHARACTER DESCRIPTOR
	EQUIVALENCE (PROCESS_NAME_B,PROCESS_NAME)
	INTEGER*4 ITEMS(4)		! GET JPI ITEMS LIST
	INTEGER*2 ITEMSW(8)		! WORD ADDRESSABLE GET JPI ITEM LIST
	EQUIVALENCE (ITEMS,ITEMSW)
	INTEGER*4 PROCESS_NAME_LENGTH	! Size of current process name
	INCLUDE '($JPIDEF)'		! DEFINE GET JPI ITEM CODES
	INCLUDE '($OPCDEF)'		! DEFINE SND OPR CODES
	INTEGER*4 SYS$GETJPI		! GET CURRENT PROCESS
	INTEGER*4 SYS$GETTIM		! GET SYSTEM TIME
	INTEGER*4 SYS$GETMSG		! TRANSLATE CODE TO SYMBOLIC MESSAGE
	INTEGER*4 SYS$SNDOPR		! SEND TO OPERATOR SYSTEM SERVICE
	INTEGER*4 SYS_STATUS		! SYSTEM STATUS
	CHARACTER*256 MSG_BUF		! SYMBOLIC MESSAGE BUFFER
	INTEGER*2 MSG_LEN		! LENGTH OF MESSAGE BUFFER
	INTEGER*2 OVER_RUN		! NUMBER OF BYTES OVER 256 (MAX FOR SEND
					! OPERATOR MESSAGE BUFFER)
	CHARACTER*2 CRLF		! CARRIAGE RETURN LINEFEED
	CHARACTER*8 SND_OPR_REQ		! OPERATOR BUFFER REQUEST
	INTEGER*4 TARGET_MASK		! FOR SEND OPERATOR, TARGET MASK
	BYTE MASKB(4)			! BYTE ADDRESSABLE TARGET MASK
	EQUIVALENCE(MASKB,TARGET_MASK)
C
	

C
C SET UP INFORMATION FOR SNDOPR COMMAND
C
	SND_OPR_REQ(1:1)=CHAR(OPC$_RQ_RQST)
	TARGET_MASK=OPC$M_NM_OPER1	! TARGET MASK WORDS
	SND_OPR_REQ(2:2)=CHAR(MASKB(1))
	SND_OPR_REQ(3:3)=CHAR(MASKB(2))
	SND_OPR_REQ(4:4)=CHAR(MASKB(3))
	SND_OPR_REQ(5:5)=CHAR(0)
	SND_OPR_REQ(6:6)=CHAR(0)
	SND_OPR_REQ(7:7)=CHAR(0)
	SND_OPR_REQ(8:8)=CHAR(0)
	CRLF=CHAR(13)//CHAR(10)	! CARRIAGE RETURN LINE FEED
C
C GET CURRENT PROCESS NAME (IE: THE CALLER)
C
	ITEMSW(1)=15			! PROCESS NAME BUFFER SIZE
	ITEMSW(2)=JPI$_PRCNAM		! GET PROCESS NAME 
	ITEMS(2)=%LOC(PROCESS_NAME_B)	! ADDRESS OF PROCESS NAME
	ITEMS(3)=%LOC(PROCESS_NAME_LENGTH) ! ADDRESS OF PROCESS NAME LENGTH
	ITEMS(4)=0			! TERMINATOR FOR GETJPI
	SYS_STATUS=SYS$GETJPI(,,,ITEMS,,,)
	IF(.NOT.SYS_STATUS)CALL LIB$STOP(%VAL(SYS_STATUS))

C
C TRANSLATE THE ERROR CODE TO SYMBOLIC
C
	SYS_STATUS= SYS$GETMSG(%VAL(ERR_CODE),MSG_LEN,MSG_BUF,,) ! SYMBOLIC
	IF(.NOT. SYS_STATUS)CALL LIB$STOP(%VAL(SYS_STATUS)) ! ERROR
C
C NOW MERGE THE PROCESS, ERROR CODE TRANSLATED, AND USER MESSAGE
C
	OVER_RUN=256-PROCESS_NAME_LENGTH-
	1		MSG_LEN-USR_LTH-20-8  ! WILL MESSAGE BE TOO LARGE?
	IF(OVER_RUN .LT. 0)MSG_LEN=MSG_LEN-OVER_RUN ! DON'T SEND ALL THEN
C
	SND_OPR_LTH=PROCESS_NAME_LENGTH+
	1		MSG_LEN+USR_LTH+14  ! SIZE OF OPERATOR MESSAGE
C
	IF(USR_LTH .EQ. 0)THEN		! ANY USER SUPPLIED MESSAGE?
		SND_OPR_BUF=SND_OPR_REQ//
	1		' PROCESS: '//
	1		PROCESS_NAME(1:PROCESS_NAME_LENGTH)//
	2		CRLF//MSG_BUF(1:MSG_LEN)
	ELSE           			! YES
		SND_OPR_BUF=SND_OPR_REQ//
	1		' PROCESS: '//
	1		PROCESS_NAME(1:PROCESS_NAME_LENGTH)//
	2		CRLF//MSG_BUF(1:MSG_LEN)//
	3		CRLF//USER_MESSAGE(1:USR_LTH)
	ENDIF
C
C SEND THE THING TO THE OPERATOR FOR HARD COPY LOGGING
C
	SYS_STATUS=SYS$SNDOPR(SND_OPR_BUF,) ! SEND TO OPER.
	IF( .NOT. SYS_STATUS) CALL LIB$STOP(%VAL(SYS_STATUS)) 
	RETURN
	END
