	PROGRAM MENU 
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&MENU\&
C .nf
C .x MENU>Defined
C Source:MENU.MOD
C Designer           :PAUL VESTUTO
C Author             :PAUL VESTUTO, EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 6-may-87
C Revision level     :2.5
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C 
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C
C .fill
C .SK
C Description:
C .sk    
C 	Prototype for maintaining a linked list of data in a common area.
C This program calls the various MA_Q routines for routing messages between 
C different application programs.  This program may be used as an example
C for application programmers using the MA_Q facilities.
C
C The program may be run from DCL as simply "$ RUN MENU".  A menu will be 
C displayed to the user along with a prompt for the next command.  Control-Z
C may be hit at any prompt to return to the main menu, or it already there,
C to exit the program entirely.  A working knowledge of the MA_Q routines
C is needed for the user to understand what options to select and when to
C select them.
C 
C end.doc ****************************** end.doc  
C
C 2-APR-87  E. Lakia
c	Fixed problem with add and change message id of only
c allowing 2 digit maximum number of message ids.
c	Fixed problem with change message id of always storing
c a zero for the maximum count.
c	Added support to scan the defined message id's.
c

C
	INCLUDE '($SSDEF)'
c
c Define the QUEUEING specific values
c
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(PEXDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QHDDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(MIDDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSG)/LIST'

	RECORD /PEXDEF/ EXPANDED_REGION
	RECORD /QHDDEF/ QUEUE_HEAD
	RECORD /MIDDEF/ M_ID_BLOCK
	STRUCTURE /ID_REC/
	  CHARACTER*16 MSG_ID  ! MESSAGE ID
	  INTEGER*4 MAX_COUNT  ! MAXIMUM NUMBER TO BE ALLOWED IN QUEUE
	END STRUCTURE
C
	RECORD/ID_REC/ID_REC
C
C PCB DEFINITION MACRO
C extracted from sys$library:lib.mlb ($PCBDEF) and converted 
c to fortran
c
	INTEGER*4 PCB$K_LENGTH
	PARAMETER(PCB$K_LENGTH=288)
	STRUCTURE/PCBDEF/
	 UNION
	 MAP
	    BYTE DUMMY(PCB$K_LENGTH)
	 END MAP
	 MAP
	    INTEGER*4 PCBDUMP(PCB$K_LENGTH/4)
	 ENDMAP
	 MAP
		INTEGER*4 PCB$L_SQFL
		INTEGER*4 PCB$L_SQBL
		INTEGER*2 PCB$W_SIZE
		BYTE PCB$B_TYPE	
		BYTE PCB$B_PRI	
		BYTE PCB$B_ASTACT
		BYTE PCB$B_ASTEN
		INTEGER*2 PCB$W_MTXCNT
		INTEGER*4 PCB$L_ASTQFL
		INTEGER*4 PCB$L_ASTQBL
		INTEGER*4 PCB$L_PHYPCB
		INTEGER*4 PCB$L_OWNER
		INTEGER*4 PCB$L_WSSWP
		INTEGER*4 PCB$L_STS
		UNION
		MAP
			INTEGER*4 PCB$L_WTIME
		END MAP
		MAP
			BYTE PCB$B_PRISAV
			BYTE PCB$B_PRIBSAV
			BYTE PCB$B_DPC
			BYTE PCB$B_AUTHPRI
		END MAP
		END UNION
		INTEGER*2 PCB$W_STATE
		BYTE PCB$B_WEFC	
		BYTE PCB$B_PRIB	
		INTEGER*2 PCB$W_APTCNT
		INTEGER*2 PCB$W_TMBU
		INTEGER*2 PCB$W_GPGCNT
		INTEGER*2 PCB$W_PPGCNT
		INTEGER*2 PCB$W_ASTCNT
		INTEGER*2 PCB$W_BIOCNT
		INTEGER*2 PCB$W_BIOLM
		INTEGER*2 PCB$W_DIOCNT
		INTEGER*2 PCB$W_DIOLM
		INTEGER*2 PCB$W_PRCCNT
		BYTE C1
		CHARACTER*7 PCB$T_TERMINAL
		INTEGER*4 PCB$L_EFWM
		INTEGER*4 PCB$L_EFCS
		INTEGER*4 PCB$L_EFCU
		INTEGER*4 PCB$L_EFC2P
		INTEGER*4 PCB$L_EFC3P
		INTEGER*4 PCB$L_PID
		INTEGER*4 PCB$L_EPID
		INTEGER*4 PCB$L_EOWNER	
		INTEGER*4 PCB$L_PHD
		BYTE C2
		CHARACTER*15 PCB$T_LNAME
		INTEGER*4 PCB$L_JIB
		INTEGER*4 PCB$Q_PRIV(2)
		INTEGER*4 PCB$L_ARB(12)
		UNION
		MAP
			INTEGER*4 PCB$L_UIC
		END MAP
		MAP
			INTEGER*2 PCB$W_MEM	
			INTEGER*2 PCB$W_GRP	
		END MAP
		END UNION
		INTEGER*4 PCB$L_XXXX(15)  ! UNKNOWN FILLER
		INTEGER*4 PCB$L_ACLFL	
		INTEGER*4 PCB$L_ACLBL	
		INTEGER*4 PCB$L_LOCKQFL	
		INTEGER*4 PCB$L_LOCKQBL	
		INTEGER*4 PCB$L_DLCKPRI	
		INTEGER*4 PCB$L_IPAST	
		INTEGER*4 PCB$L_DEFPROT	
		INTEGER*4 PCB$L_WAITIME	
		INTEGER*4 PCB$L_PMB
	 END MAP
	 END UNION
	 END STRUCTURE
C
	INTEGER*4 PCBNUM
	PARAMETER (PCBNUM=25)	! NUMBER OF PCB TO GET BACK
	RECORD /PCBDEF/PCB(PCBNUM)	! SOME PLACE TO STORE THE 
	INTEGER*4 FNDCNT		! NUMBER OF PCBS FOUND
c
c Define the message header  and the rest of the read message packet
c
	STRUCTURE /MESBUF/
	  UNION
	    MAP
		CHARACTER MESSAGE_ALL*(9212) ! 18 BLOCKS MAX 
	    END MAP
	    MAP
		RECORD /HDRDEF/ MESBUFHDR
		CHARACTER MESSAGE_BUF*(4608) ! 9 BLOCKS MAX 
					! USER TEXT + 8 BLOCKS PAD 
	    END MAP
	  END UNION
	END STRUCTURE

	RECORD /mesbuf/ MESSAGE
c
c Define local parameters
c
	INTEGER*2 QUEUE_TIME(4)	! USED FOR CALCULATIONS OF ON QUEUE TIME
	INTEGER*2 CUR_TIME(4)	! CURRENT TIME FOR ON QUEUE TIME CALCS.
	INTEGER*4 DAYS		! NUMBER OF DAYS
	INTEGER*4 STATUS
	INTEGER*4 C1,C2	! BYTE COUNTS FOR CHARACTER STRINGS
	INTEGER*4 CHOICE
	INTEGER*4 LIB$ADDX	! QUAD WORD ADD
	INTEGER*4 LIB$SUBX	! QUAD WORD SUB
	INTEGER*4 LIB$DAY	! NUMBER OF DAYS
	INTEGER*4 SYS$GETMSG
	INTEGER*4 SYS$GETTIM
	INTEGER*4 SYS$CLREF
	INTEGER*4 SYS$ASCTIM
	INTEGER*4 Q_BLOCK(2)
	INTEGER*4 RNA_POINTER
	INTEGER*4 TMP_RNA_POINTER
	INTEGER*2 efn
	INTEGER*2 NUM_MESSAGE
	INTEGER*2 MSGLEN
	INTEGER*2 MIDX
	INTEGER*2 BOGUS_Q_BLOCK
	INTEGER*2 MESSAGE_LENGTH
	INTEGER*2 TEMPLEN
	INTEGER*2 TYPES
	INTEGER*2 POINTER
	INTEGER*2 REPEAT
	INTEGER*2 RTR_FLAG
	INTEGER*2 I		! LOOP  VARIABLE
	INTEGER*2 IC		! NUMBER OF BYTES IN RESPONSE
	CHARACTER MSGBUF*256
	CHARACTER MESSAGE_ID*16
	CHARACTER Q_NAME*(*)
	CHARACTER ASCII_TIME*23
	INTEGER*4 IOSTAT	! RMS FILE OPEN STATUS
	INTEGER*4 ID_LUN	! Lun of the keyed message id file
	PARAMETER(ID_LUN=7)
C
C Initialize section ...
C
	PARAMETER (Q_NAME = 'MA_Q_NAME')  ! FOR DIFFERENT QUEUE NAMES
	STATUS = 1
	EFN = 0
	MSGBUF = 'Test puppy for queueing...'
C
C Display a menu to the user
C
20	if (.not. status) THEN
		STATUS=SYS$GETMSG( %val(STATUS), MSGLEN, MSGBUF,,)
		type *,MsgBUF(1:msglen)	! Display the last message
	else
		type *,msgbuf(1:78)
	END IF
	msgbuf = ' '

	TYPE *,' '
	TYPE *,'   1 - Attach to queue [DEFAULT GLOBAL SECTION NAME]'
	type *,'              MESSAGES'
	TYPE *,'   2 - Add a message '
	TYPE *,'   3 - Get a message '
	TYPE *,'   4 - Acknowledge message'
	type *,'              MESSAGE IDS'
	TYPE *,'   5 - Add a message ID'
	TYPE *,'   6 - Change a message ID'
	TYPE *,'   7 - Display a message ID'
	TYPE *,'   8 - Delete a message ID'
	TYPE *,'   9 - Connect to Message ID for read'
	type *,'              QUEUE HEADER AND TESTS'
	TYPE *,'   10 - Display the queue header information'
	TYPE *,'   11 - Do some funky tests with Privileged Routines'
	TYPE *,'   12 - Do some funky tests with User Written System Service'
	TYPE *,'   13 - Scan the message ids (summary of status each id) '
	type *,'   14 - Change message id list head  status long word '
	TYPE *,' '
	TYPE 10005
	READ  (5,10004, end=10000, ERR=20) CHOICE
	GOTO (100,200,300,350,500,600,700,800,900,
	1	1700,1800,1900,2000,2200), CHOICE
	TYPE *, ' Invalid, try again '
	GOTO 20
C
C Attach the queue sections
C
100	CONTINUE
	STATUS = ATTACH_Q(Q_BLOCK)
	msgbuf = ' The queue global section has been attached '
	goto 20
C
C Add a message
C
200	CONTINUE
	RTR_FLAG = 0
202	TYPE 10006			! Get message ID
	READ (5, 10001, END=20, ERR=20) MESSAGE_ID
	TYPE 10035
	READ (5, 10004, END=20, ERR=20) MIDX	! Get MID index
	MESSAGE.message_buf = ' '
	type *, ' Enter your message: '	! Get message text
	READ (5, FMT='(Q,A)', END=20, ERR=20) 
     1		MESSAGE_LENGTH, MESSAGE.message_buf(1:MESSAGE_LENGTH)
	TYPE 10007			! Get message type
	READ (5, 10012, END=20, ERR=20) TYPES
	IF ((types .ne. 1) .and. (types .ne. 2)) types = 0
	TYPE 10002			! Get number of blocks
	READ (5, 10012, END=20, ERR=20) REPEAT
	IF (REPEAT .GT.8) REPEAT = 8	! Set to maximum
	TYPE 10033			! Get number of messages to write
	READ (5, 10034, END=20, ERR=20) NUM_MESSAGE
	IF (NUM_MESSAGE .EQ. 0) NUM_MESSAGE=1	! Set to minimum
	POINTER = MESSAGE_LENGTH+1	! Point to char after original message
	DO WHILE (REPEAT .GT. 0)
		DO I=POINTER, POINTER+512
			MESSAGE.MESSAGE_BUF(I:I) = CHAR(REPEAT+48)
		END DO
		REPEAT = REPEAT-1
		POINTER = POINTER+512
		MESSAGE_LENGTH = MESSAGE_LENGTH+512
	END DO
	TYPE *,'    Message length to be written: ',message_length
	IF (RTR_FLAG .EQ.  0) THEN
		DO 210 I=1,NUM_MESSAGE 
			if (midx .eq. 0) then
				STATUS = WRITE_Q(Q_BLOCK, MESSAGE_ID, 
     1				MESSAGE.message_buf, MESSAGE_LENGTH, TYPES)
			else
				STATUS = WRITE_Q(Q_BLOCK, MESSAGE_ID, 
     1				MESSAGE.message_buf, MESSAGE_LENGTH, TYPES,
     1				midx)
			end if
			if (.NOT. status) GOTO 20
210		CONTINUE
		msgbuf = ' Message(s) added to queue'
	ELSE
		MESSAGE.MESBUFHDR.HDR$C_SNM(1:6) = 'SRCNOD'
		MESSAGE.MESBUFHDR.HDR$C_DNM(1:6) = 'DESNOD'
		STATUS = SYS$GETTIM(MESSAGE.MESBUFHDR.HDR$Q_OFFQT)
		MESSAGE.MESBUFHDR.HDR$W_TYPE = TYPES
		STATUS = SYS$GETTIM(MESSAGE.MESBUFHDR.HDR$Q_ONQT)
		MESSAGE.MESBUFHDR.HDR$W_LEN = MESSAGE_LENGTH
		MESSAGE.MESBUFHDR.HDR$W_QSEQ = 11
		DO 220 I=1,NUM_MESSAGE 
			if (midx .eq. 0) then
				STATUS = RTR_WRITE_Q(Q_BLOCK, MESSAGE_ID, 
     1				MESSAGE.message_all, MESSAGE_LENGTH, TYPES)
			else
				STATUS = RTR_WRITE_Q(Q_BLOCK, MESSAGE_ID, 
     1				MESSAGE.message_all, MESSAGE_LENGTH, TYPES,
     1				midx)
			end if
			if (.NOT. status) GOTO 20
220		CONTINUE
		msgbuf = ' Message(s) added to queue without header'
	END IF
	goto 20
C
C Get a message
C
300	continue
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) message_id	! Get message ID
	MESSAGE.message_buf = ' '
	TYPE 10035
	READ (5, 10004, END=20, ERR=20) MIDX	! Get MID index
	IF (MIDX .EQ. 0) THEN
		STATUS = READ_Q(Q_BLOCK, MESSAGE_ID, MESSAGE.MESSAGE_ALL, 
     1		RNA_POINTER)
	ELSE
		STATUS = READ_Q(Q_BLOCK, MESSAGE_ID, MESSAGE.MESSAGE_ALL, 
     1		RNA_POINTER, MIDX)
	END IF
	if (status) WRITE (5,10019) RNA_POINTER
	if (.NOT. status) GOTO 20
	STATUS = SYS$ASCTIM(, ASCII_TIME, message.MESBUFHDR.HDR$Q_ONQT, )
	TYPE *,' Header follows: '
	TYPE *,'     Source node name:      ', message.MESBUFHDR.HDR$C_SNM
	TYPE *,'     Destination node name: ', message.MESBUFHDR.HDR$C_DNM
	TYPE *,'     Message type:          ', message.MESBUFHDR.HDR$W_TYPE
	TYPE *,'     On Queue time:         ', ASCII_TIME
	STATUS = SYS$ASCTIM(, ASCII_TIME, message.MESBUFHDR.HDR$Q_OFFQT, )
	TYPE *,'     Off Queue time:        ', ASCII_TIME
	TYPE *,'     Message length:        ', message.MESBUFHDR.HDR$W_LEN
	TYPE *,'     Sequence number:       ', message.MESBUFHDR.HDR$W_QSEQ
C
C 	Determine the total time queued
c
	IF(MESSAGE.MESBUFHDR.HDR$C_SNM .EQ.	! QUEUED ON LOCAL NODE?
	1	MESSAGE.MESBUFHDR.HDR$C_DNM)THEN	! YES
C
		STATUS=SYS$GETTIM(QUEUE_TIME)	! GET CURRENT TIME
		STATUS=LIB$SUBX(QUEUE_TIME,	! TOTAL TIME= CURRENT-
	1		MESSAGE.MESBUFHDR.HDR$Q_ONQT,  ! ON QUEUE TIME
	1		QUEUE_TIME)
	ELSE					! ROUTED HERE FROM REMOTE NODE
		STATUS=LIB$SUBX(MESSAGE.MESBUFHDR.HDR$Q_OFFQT,
	1		MESSAGE.MESBUFHDR.HDR$Q_ONQT, ! calc. amount of time
	1		QUEUE_TIME)	! 	it was queued remotely
		STATUS=SYS$GETTIM(CUR_TIME)	! get current time
		STATUS=LIB$SUBX(MESSAGE.MESBUFHDR.HDR$Q_OFFQT,
	1		CUR_TIME,		! calc. time on our node.
	1		CUR_TIME)		! only valid if nodes are
						! time sync'd.
		STATUS=LIB$ADDX(CUR_TIME,QUEUE_TIME,QUEUE_TIME)
	ENDIF
	STATUS=LIB$DAY(DAYS,QUEUE_TIME)
	STATUS = SYS$ASCTIM(, ASCII_TIME, QUEUE_TIME,%VAL(1) )
	TYPE *,' Total on queue time: ',DAYS,'days and ',ASCII_TIME(1:11)
	TYPE 10014			! let the user read the header
	read (5,10004, END=20, ERR=20) choice
	TYPE *,' Message follows: '
	POINTER=1			! Point to first of real data
	MESSAGE_LENGTH = message.MESBUFHDR.HDR$W_LEN	! Length 
	do WHILE (MESSAGE_LENGTH .GT. 0) 
		TEMPLEN = 60
		IF (MESSAGE_LENGTH .LT. 60) TEMPLEN = MESSAGE_LENGTH
		TYPE *,'     ',POINTER,'/',
     1			MESSAGE.message_buf(POINTER:POINTER+TEMPLEN-1),'/'
		POINTER = POINTER+TEMPLEN
		MESSAGE_LENGTH = MESSAGE_LENGTH - TEMPLEN
	END do
	TYPE 10014			! let the user read the buffer
	read (5,10004, END=20, ERR=20) choice
	goto 20
c
c Acknowledge Read
c
350	continue
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) message_id	! Get message ID
	TYPE 10021, RNA_POINTER
	READ (5, 10020, END=20, ERR=20) TMP_RNA_POINTER	! Get RNA pointer
	IF (TMP_RNA_POINTER .NE. 0) RNA_POINTER = TMP_RNA_POINTER
	TYPE 10035
	READ (5, 10004, END=20, ERR=20) MIDX	! Get MID index
	IF (MIDX .EQ. 0) THEN
		STATUS = ACK_READ(Q_BLOCK, MESSAGE_ID, RNA_POINTER)
		MSGBUF = ' RNA Message has been acknowledged  ' 
	ELSE
		STATUS = ACK_READ(Q_BLOCK, MESSAGE_ID, RNA_POINTER,
     1				    MIDX)
		MSGBUF = ' RNA Message has been acked using index' 
	END IF
	goto 20
c
c Add a message ID
c
500	continue
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) MESSAGE_ID
	TYPE 10009
	READ (5, 10040, END=20, ERR=20)IC,NUM_MESSAGE
	status=Add_message_id (q_block, message_id, num_message)
	msgbuf = ' Message ID has been added!'
	goto 20
c
c Change a Message id
c
600	continue
	TYPE 10006				! Get message ID
	READ (5, 10001, END=20, ERR=20) message_id
	TYPE 10009				! Get maximum # messages
	READ (5, 10040, END=20, ERR=20)IC,M_ID_BLOCK.MID$W_MAX
	status = change_message_id (q_block,
	1	 message_id, 
	1	%REF(M_ID_BLOCK.MID$W_MAX))
	msgbuf = ' Message ID max count has been changed!'
	goto 20
c
c Display a message ID
c
700	continue
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) MESSAGE_ID
750	status = display_message_id (q_block, message_id, m_id_block)
	if (( STATUS .EQ. %LOC(QUE_MIDNOTFOUND) ) .and. 
     1				message_id .eq. ' ') then
		status = SS$_NORMAL
		goto 20
	end if
	IF (.NOT. STATUS) GOTO 20
	TYPE 10013, m_id_block.mid$c_mid, m_id_block.mid$L_flk,
     1	m_id_block.mid$l_blk, m_id_block.mid$w_max, m_id_block.mid$w_cnt,
     1	m_id_block.mid$w_nvcnt, m_id_block.mid$l_rna, 
     1  m_id_block.mid$l_brna, 
     1	m_id_block.mid$w_qseq, m_id_block.mid$l_stat, 
     1	m_id_block.mid$l_cpid,
     1	m_id_block.mid$l_pcb, m_id_block.mid$W_efn, 
     1	m_id_block.mid$l_ipid
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_RQF) .NE. 0)
	1	TYPE *,' Remote queue is full for this message id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_DEL) .NE. 0)
	1	TYPE *,' Message id is marked as being deleted'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_IOPND) .NE. 0)
	1	TYPE *,' Router has an outstanding write to remote node this id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_ACKPND) .NE. 0)
	1	TYPE *,' Router waiting on a ACK from remote node this id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_NOROUTE) .NE. 0)
	1	TYPE *,' Message id is not routeable (not known at remote)'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_QUERDERR) .NE. 0)
	1	TYPE *,' Queue error while reading from queue, not routeable '
c
	TYPE *,' '
	read (5,10004, END=20, ERR=20) choice
	goto 20
c
c Delete a Message id
c
800	continue
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) MESSAGE_ID
	status = delete_message_id (q_block, message_id)
	msgbuf = ' Message ID has been deleted!'
	goto 20
c
c Connect to read
c
900	continue
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) MESSAGE_ID 
	EFN = EFN + 1			! Bump event flag number
	STATUS = CONNECT_READ(Q_BLOCK, MESSAGE_ID, EFN, MIDX)
	if (status) TYPE *,'    Message index is: ',MIDX
	MSGBUF = ' Connected to message ID '
	GOTO 20	
c
c Display the queue header
c
1700	continue
	status = display_queue_head (q_block, queue_head)
	if (.NOT. status) GOTO 20
	STATUS = SYS$ASCTIM(, ASCII_TIME, queue_head.qhd$q_UPD, )
	TYPE 10008, queue_head.qhd$l_siz, ascii_time,
     1  queue_head.qhd$l_AID, queue_head.qhd$l_IDC,
     1  queue_head.qhd$Q_FLS(1), queue_head.qhd$Q_FLS(2), 
     1	queue_head.qhd$l_FREE, QUEUE_HEAD.QHD$L_STAT, 
     1	QUEUE_HEAD.QHD$L_insrv,
     1	queue_head.qhd$c_CLOCK, queue_head.qhd$c_RMBX, 
     1	queue_head.qhd$c_NODE, queue_head.qhd$L_EFN,
     1	queue_head.qhd$L_PID, queue_head.qhd$L_IPID, 
     1	queue_head.qhd$L_PCB,
     1	queue_head.qhd$W_version
	WRITE(*,1705)QUEUE_HEAD.QHD$L_LKID
1705	FORMAT('     QHD$L_LKID: ',Z8.8,' (HEX)')
	WRITE(*,1706)QUEUE_HEAD.QHD$L_LKB
1706	FORMAT('     QHD$L_LKB:  ',Z8.8,' (HEX)')
	WRITE(*,1707)QUEUE_HEAD.QHD$L_RSB
1707	FORMAT('     QHD$L_RSB:   'Z8.8,' (HEX)')
	TYPE *,' '
	TYPE 10014			! let them read it
	read (5,10004, END=20, ERR=20) choice
	goto 20
c
c Do some tests with the privileged routines
c
1800	msgbuf = ' Done with test'
	TYPE *,' '
	TYPE *,'     1 - Call ADD_MESSAGE_ID with only 2 arguments '
	TYPE *,'     2 - Call ADD_MESSAGE_ID with invalid q_block parameter'
	TYPE *,'     3 - Call ADD_MESSAGE_ID with bogus start address for P0'
	TYPE *,'     4 - Call ADD_MESSAGE_ID with bogus ending address for P0'
	TYPE *,'     5 - Call CHANGE_MESSAGE_ID with invalid MID buffer '
	TYPE *,'     6 - Call ADD_MESSAGE_ID with invalid Mess #'
	TYPE *,'     7 - Clear event flag '
	TYPE *,'     8 - Call DISPLAY REGION '
	TYPE *,'     9 - Display processes attached to queue'
	TYPE *,' '
	TYPE 10005
	READ  (5,10004, end=20) CHOICE
	GOTO (1810,1820,1830,1840,1850,1860,1870,1880,1890), CHOICE
	type *, ' Invalid, try again '
	GOTO 1800
1810	status = add_message_id(q_block, message_id)
	goto 20
1820	status = add_message_id(, message_id, num_message)
	goto 20
1830	q_block(1) = 123			!???where is this starting?
	status = add_message_id(q_block, message_id, num_message)
	goto 20
1840	q_block(2) = 123			!???where is this ending?
	status = add_message_id(q_block, message_id, num_message)
	goto 20
1850	status = change_message_id(q_block, , num_message)
	goto 20
1860	status = add_message_id(q_block, message_id, )
	goto 20
c
c Clear an event flag
c
1870	CONTINUE
	TYPE 10031
	READ (5, 10012, END=20, ERR=20) efn
	status = sys$clref(%val(efn))
	if (status .eq. ss$_wasclr) msgbuf = 'Event flag was clear'
	if (status .eq. ss$_wasset) msgbuf = 
	1		'Event flag was set and is now clear'
	goto 20
c
c Display expanded region
c
1880	continue
	STATUS = DISPLAY_REGION(Q_BLOCK, EXPANDED_REGION)
	if (.NOT. status) GOTO 20
	TYPE 10017, EXPANDED_REGION.PEX$L_SREG,
     1	EXPANDED_REGION.PEX$L_EREG,
     1	EXPANDED_REGION.PEX$Q_GSINADR,
     1	EXPANDED_REGION.PEX$Q_GSRETADR,
     1	EXPANDED_REGION.PEX$L_PID,
     1	EXPANDED_REGION.PEX$L_PIDL,
     1	EXPANDED_REGION.PEX$L_IPID,
     1	EXPANDED_REGION.PEX$C_PNAME,
     1	EXPANDED_REGION.PEX$L_PNAMEL,
     1	EXPANDED_REGION.PEX$L_STAT,
     1	EXPANDED_REGION.PEX$W_SETMID,
     1	EXPANDED_REGION.PEX$W_CURMID,
     1	EXPANDED_REGION.PEX$L_EXTHDL,
     1	EXPANDED_REGION.PEX$L_P0VA,
     1	EXPANDED_REGION.PEX$Q_WORKLINKS,
     1	EXPANDED_REGION.PEX$L_HEADLINK
	WRITE(*,1887)EXPANDED_REGION.PEX$L_RSB
1887	FORMAT('      PEX$L_RSB (HEX): ',Z8.8)
	WRITE(*,1889)EXPANDED_REGION.PEX$C_LOCK(6),
	1		EXPANDED_REGION.PEX$C_LOCK(5)
1889	FORMAT('      Lock id:  ',Z2.2,Z2.2)
C
	DO I=1, EXPANDED_REGION.PEX$W_CURMID
		WRITE (5,10030) EXPANDED_REGION.PEX$C_MIDLIST(I)
	END DO
	TYPE *,' '
	TYPE 10014			! let them read it
	read (5,10004, END=20, ERR=20) choice
	goto 20
c
C CALL TO DISPLAY ALL THE ATTACHED PROCESSES TO THE QUEUE
C
1890	CONTINUE
	STATUS=FIND_Q_PROCESSES(Q_BLOCK,
	1	PCB,%VAL(PCBNUM),FNDCNT)
C
	IF (.NOT. STATUS)THEN
		TYPE *,' REQUEST FAILED '
		GO TO 20
	ELSE
	  TYPE *,' Number of connected processes: ',FNDCNT
D	  I=%LOC(PCB(2))-%LOC(PCB(1))
D	  TYPE *,' SIZE OF A PCB: ',I
	  DO I=1,FNDCNT
D		WRITE(*,9870)PCB(I).PCBDUMP
D9870		FORMAT(20(/,8(1X,Z8.8)))
		C1=PCB(I).C1	! number characters in terminal name
D		TYPE *,' Number characters in terminal name:  ',C1
		IF(C1. GT. 6) C1=6
		C2=PCB(I).C2	! Number characters in process name
D		TYPE *,' Number characters in process name: ',C2
		IF(C2 .GT. 15) C2=15
		TYPE *,' '
		WRITE(*,1891)PCB(I).PCB$T_LNAME(1:C2),
	1	PCB(I).PCB$T_TERMINAL(1:C1),
	1	PCB(I).PCB$L_PID,PCB(I).PCB$L_EPID
1891		FORMAT(/,1X,' Process name: ',A<C2>,/,1X,
	1		'    From terminal: ',A<C1>,/,1X,
	1		'          PID: ',Z8.8,/,1X,
	1		' EXTENDED PID: ',Z8.8,/,
	1		'$ Hit <CR> for next Process ')
		READ(5,10037,END=20,ERR=20)CHOICE
	   ENDDO
	ENDIF
	GO TO 20
c
c Do some tests with User Written System Service
c
1900	msgbuf = ' Done with test'
	TYPE *,' '
	TYPE *,'     1 - Call ATTACH_Q with no arguments '
	TYPE *,'     2 - Call ATTACH_Q with invalid q_block parameter'
	TYPE *,'     3 - Call ATTACH_Q with GS NAME specified in call'
	TYPE *,'     4 - Call ATTACH_Q with Maximum MIDs specified in call'
	TYPE *,'     5 - Call GET_MID_INDEX '
	TYPE *,'     6 - Call DETACH_Q '
	TYPE *,'     7 - Call RTR_WRITE_Q '
	TYPE *,'     8 - Call BACKUP_RNA '
	TYPE *,'     9 - Call SHUTDOWN_Q'
	TYPE *,' '
	TYPE 10005
	READ  (5,10004, end=20) CHOICE
	GOTO (1910,1920,1930,1940,1950,1960,1970,1980,1990), CHOICE
	type *, ' Invalid, try again '
	GOTO 1900
1910	status = ATTACH_Q()
	goto 20
1920	status = ATTACH_Q(BOGUS_Q_BLOCK)
	goto 20
1930	CONTINUE
	TYPE *,'    using parameter with value = ',Q_NAME
	STATUS = ATTACH_Q(Q_BLOCK, Q_NAME)
	msgbuf = ' The queue global section has been attached '
	goto 20
1940	CONTINUE
	TYPE 10029
	READ  (5,10004, end=20) MIDX
	STATUS = ATTACH_Q(Q_BLOCK, ,MIDX)
	msgbuf = ' The queue global section has been attached '
	goto 20
c
c Get Message ID index
c
1950	CONTINUE
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) MESSAGE_ID
	status = GET_MID_INDEX(q_block, message_id, MIDX)
	type *,' Index: ', MIDX
	goto 20
c
c Call detach_Q
c
1960	CONTINUE
	status = DETACH_Q(q_block)
	msgbuf = ' The queue global section has been detached '
	goto 20
C
C Call RTR_WRITE_Q
C
1970	CONTINUE
	RTR_FLAG = 1
	GOTO 202
c
c Backup RNA
c
1980	CONTINUE
	TYPE 10006
	READ (5, 10001, END=20, ERR=20) message_id	! Get message ID
	TYPE 10021, RNA_POINTER
	READ (5, 10020, END=20, ERR=20) TMP_RNA_POINTER	! Get RNA pointer
	IF (TMP_RNA_POINTER .NE. 0) RNA_POINTER = TMP_RNA_POINTER
	TYPE 10035
	READ (5, 10004, END=20, ERR=20) MIDX	! Get MID index
	IF (MIDX .EQ. 0) THEN
		STATUS = BACKUP_RNA(Q_BLOCK, MESSAGE_ID, RNA_POINTER)
		MSGBUF = ' RNA Message has been backed up ' 
	ELSE
		STATUS = BACKUP_RNA(Q_BLOCK, MESSAGE_ID, RNA_POINTER, 
     1				    MIDX)
		MSGBUF = ' RNA Message has been backed up using index' 
	END IF
	goto 20
c
c SHUTDOWN THE QUEUE
C
1990	STATUS= SHUTDOWN_Q(Q_BLOCK)
	TYPE *,' Shutdown attempted'
	GO TO 20

C
C Scan the queue and print summary of the message ids.
c We will do this by opening the message id file and
c asking for status for each message id.  Note, if
c the user has not modified the QUEUE_IDS.DAT file, 
c then obviously this won't work.
c
2000 	CONTINUE
	TYPE *,' OPENNING THE KEYED MESSAGE ID FILE'
	OPEN(UNIT=ID_LUN,
	1	TYPE='OLD',
	1	READONLY,
	1	IOSTAT=IOSTAT,
	1	NAME='MA_Q$PROD:QUEUE_IDS.DAT;',
	1	ERR=2100,
	1	INITIALSIZE=15,
	1	RECL=5,
	1	ORGANIZATION='INDEXED',
	1	RECORDTYPE='FIXED',
	1	KEY=(1:16:CHARACTER),
	1	FORM='UNFORMATTED',
	1	ACCESS='KEYED')
C
C Loop here reading the keyed file in ASCII ascending order until
c we get an end of file
c
2010	READ(UNIT=ID_LUN,END=2025)ID_REC
	STATUS = DISPLAY_MESSAGE_ID (q_block, ID_REC.MSG_ID, m_id_block)
	IF (( STATUS .EQ. %LOC(QUE_MIDNOTFOUND) ))THEN
		TYPE *,' Message id: ',ID_REC.MSG_ID
		TYPE *,' Was not found in the installed queue'
		TYPE *,' The queue message id file is not consistant with'
		TYPE *,' with the installed queue.  You should update '
		TYPE *,' the valid message ids with Q_UTL. '
		GO TO 2010  ! go get next message id
	ENDIF
	IF (.NOT. STATUS) GOTO 2025
	TYPE 10013, m_id_block.mid$c_mid, m_id_block.mid$L_flk,
     1	m_id_block.mid$l_blk, m_id_block.mid$w_max, m_id_block.mid$w_cnt,
     1	m_id_block.mid$w_nvcnt, m_id_block.mid$l_rna, 
     1  m_id_block.mid$l_brna, 
     1	m_id_block.mid$w_qseq, m_id_block.mid$l_stat, 
     1	m_id_block.mid$l_cpid,
     1	m_id_block.mid$l_pcb, m_id_block.mid$W_efn, 
     1	m_id_block.mid$l_ipid
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_RQF) .NE. 0)
	1	TYPE *,' Remote queue is full for this message id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_DEL) .NE. 0)
	1	TYPE *,' Message id is marked as being deleted'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_IOPND) .NE. 0)
	1	TYPE *,' Router has an outstanding write to remote node this id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_ACKPND) .NE. 0)
	1	TYPE *,' Router waiting on a ACK from remote node this id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_NOROUTE) .NE. 0)
	1	TYPE *,' Message id is not routeable (not known at remote)'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_QUERDERR) .NE. 0)
	1	TYPE *,' Message id was unreadaable from the queue ',
	1	       ' because of an error'
c
	TYPE *,' Enter <CR> to see next message id ^Z to go back to menu'
	read (5,10003, END=2025, ERR=2025) choice
	GO TO 2010
C
2025	CLOSE(UNIT=ID_LUN)
	GO TO 20
c
2100	TYPE *,' Unable to open the message id keyed file'
	CALL SYS$EXIT(%VAL(IOSTAT))
c
c Update the message id list head status long word
c
2200	continue
	WRITE(*,2210)
2210	FORMAT('$Enter message id: ')
	READ(5,10001,END=20,ERR=20)MESSAGE_ID  ! GET THE ID
	WRITE(*,2220)
2220	FORMAT('$The update status (in hex)')
	READ(5,2230,END=20,ERR=20)IC,IOSTAT
2230	FORMAT(Q,Z<IC>.<IC>)
	STATUS=	 CONNECT_READ(Q_BLOCK, MESSAGE_ID, EFN, MIDX)
	IF(.NOT. STATUS)THEN
		TYPE *,' Unable to connect to the message id'
		GO TO 20
	ENDIF
C
	STATUS=UPDATE_MID_STAT(Q_BLOCK,
	1		MESSAGE_ID,
	1		%VAL(IOSTAT))
	GO TO 20    
C
C Exit
C
10000	CONTINUE
	TYPE *,'Exiting... will attempt to deatach the queue'
	STATUS= DETACH_Q(Q_BLOCK)	! DEALLOCATE FROM THE QUEUE
	CALL SYS$EXIT(%VAL(STATUS))
C
C Format statements
C
10001	FORMAT (A16)
10002	FORMAT ('$ Enter number of blocks to pad message (max=8): ')
10003	FORMAT (A)
10004	format(i4)
10005	FORMAT ('$ Enter a menu option: ')
10006	FORMAT ('$ Enter a message ID: ')
10007	format ('$ Enter 0 (volatile), 1 or 2 [Default:0]: ')
10008	FORMAT (/'    Size of Queue in blocks:       ',I, 
     1		/',   Last updated time stamp:       ',a,
     1		/',   Allocated ID slots:            ',i,
     1		/',   Current IDs,                   ',i,
     1		/',   Free list B/F pointers:        ',2z8,
     1 		/',   Number of free blocks for msgs:',i,
     1		/',   Status flag long word:         ',z8,
     1		/',   In service count:              ',z8,
     1	        /',   Change lock name:              ',A,
     1		/',   Router MBX name:               ',A,
     1		/',   Local node name:               ',A,
     1		/',   Checkpoint task Event flag:    ',i,
     1		/',   Checkpoint task PID:           ',Z8,
     1		/',   Checkpoint task Index PID:     ',z8,
     1		/',   Checkpoint task PCB:           ',z8,
     1		/,'   Queue software version number: ',z4)
10009	FORMAT ('$ Enter maximum number of messages: ')
10010	FORMAT ('$ Enter current message count: ')
10011	FORMAT ('$ Enter current message sequence: ')
10012	format (i2)
10013	format (/'    Message ID:              ',a16,
     1		/',   Message links:           ',2z8, 
     1		/',   Max messages:            ',i,
     1		/',   Current messages:        ',i,
     1		/',   Non-volatile messages:   ',i,
     1		/',   Rna pointers:            ',2z8,
     1		/',   Current sequence:        ',i,
     1		/',   Status:                  ',Z8,
     1		/',   Connected process PID:   ',z8,
     1		/',   Connected process PCB:   ',z8,
     1		/',   Connected process EFN:   ',z8,
     1		/',   Connected process IPID:  ',z8)
10014	FORMAT ('$ Press <CR> to continue ...')
10015	FORMAT ('$ Enter connected process PID: ')
10016	FORMAT ('$ Enter current message status: ')
10017	format (/',   Start/End PEX address:     ',2z8,
     1		/',   GS INADR address:          ',2z8,
     1		/',   GS RETADR address:         ',2z8,
     1		/',   PID:                       ',Z8,
     1		/',   PID length:                ',i,
     1		/',   Index PID:                 ',Z8,
     1		/',   Process Name:              ',a,
     1		/',   Process Name length:       ',i,
     1		/',   Status long words:         ',z8,
     1		/',   Max # attached MIDs:       ',i,
     1		/',   Current # attached MIDs:   ',i,
     1		/',   Exit handler block:        ',4z8,
     1		/',   Exit handler P0 Start ADR: ',z8,
     1		/',   Work links for write:      ',2z8,
     1		/',   Head link for write:       ',z8)
10018	FORMAT ('$ Enter read-not-acknowleged pointer: ')
10019	FORMAT ('  Returned RNA pointer: ',z8)
10020	format (z8)
10021	FORMAT ('$ Enter RNA pointer address [DEFAULT: ',z8,']: ')
10022	FORMAT ('$ Enter current non-volatile count: ')
10023	FORMAT ('$ Enter forward link offset: ')
10024	FORMAT ('$ Enter backward link offset: ')
10025	FORMAT ('$ Enter read-not-acknowleged backward pointer: ')
10026	FORMAT ('$ Enter event flag: ')
10027	FORMAT ('$ Enter PCB address: ')
10028	FORMAT ('$ Enter Index PID: ')
10029	FORMAT ('$ Enter maximum number of message IDs: ')
10030   format ('           MID: ',A)
10031   format ('$ Enter event flag: ')
10032	FORMAT ('$ Enter New name for message ID [DEFAULT: ',A,' ]: ')
10033	FORMAT ('$ Enter number of messages [DEFAULT: 1]: ')
10034	FORMAT (I6)
10035	FORMAT ('$ Enter a message ID index [0 means use MID name]: ')
10037	FORMAT (A4)
10040	FORMAT (Q,I<IC>)
	END
