/* This header file was created by Joe Meadows, and is not copyrighted
   in any way. No guarantee is made as to the accuracy of the contents
   of this header file. This header file was last modified on Sep. 8th,
   1987. */
#define ACE$C_KEYID	1
#define ACE$C_RMSJNL_BI	2
#define ACE$C_RMSJNL_AI	3
#define ACE$C_RMSJNL_AT	4
#define ACE$C_AUDIT	5
#define ACE$C_ALARM	6
#define ACE$C_INFO	7
#define ACE$C_RMSJNL_RU_DEFAULT	8
#define ACE$C_DIRDEF	9
#define ACE$C_RMSJNL_RU	10
#define ACE$C_RESERVED	255
#define ACE$C_CUST	1
#define ACE$C_CSS	2
#define ACE$C_VMS	3
#define ACE$M_SUCCESS	1
#define ACE$M_FAILURE	2
#define ACE$M_DEFAULT	256
#define ACE$M_PROTECTED	512
#define ACE$M_HIDDEN	1024
#define ACE$M_NOPROPAGATE	2048
#define ACE$M_READ	1
#define ACE$M_WRITE	2
#define ACE$M_EXECUTE	4
#define ACE$M_DELETE	8
#define ACE$M_CONTROL	16
#define ACE$K_LENGTH	8
#define ACE$C_LENGTH	8
#define ACE$S_RMSJNL_RU_DEFAULT	17
#define ACE$M_JOURNAL_DISABLED	1
#define ACE$M_BACKUP_DONE	2
#define ACE$S_RMSJNL_RU	38
#define ACE$S_RMSJNL	50
#define ACE$S_ACEDEF	50
#define ACE$S_INFO_TYPE	4
#define ACE$S_RESERVED	4

#define ACE$S_AUDITNAME	16
#define ACE$S_VOLNAM	12
#define ACE$S_FID	6
#define ACE$S_CDATE	8
#define ACE$S_MODIFICATION_TIME	8
#define DATE {unsigned : 32; unsigned : 32;}

struct acedef {
  unsigned char ace$b_size;
  unsigned char ace$b_type;

  variant_union {
    unsigned short int ace$w_flags;
    variant_struct {
      unsigned : 8;
      unsigned ace$v_default : 1;
      unsigned ace$v_protected : 1;
      unsigned ace$v_hidden : 1;
      unsigned ace$v_nopropagate : 1;
    } ace$dummy_common_flags;		/* common to all ace's */
    variant_struct {
      unsigned ace$v_success : 1;
      unsigned ace$v_failure : 1;
    } ace$dummy_alarm_flags;		/* for alarm ace */
    unsigned ace$v_info_type : 4;	/* for application ace */
    unsigned ace$v_reserved : 4;	/* for identifier ace */
  } ace$dummy_flags_union;

  variant_union {

    /* alarm and identifier ace */
    variant_struct {
      variant_union {
        unsigned long int ace$l_access;
        variant_struct {
          unsigned ace$v_read : 1;
          unsigned ace$v_write : 1;
          unsigned ace$v_execute : 1;
          unsigned ace$v_delete : 1;
          unsigned ace$v_control : 1;
        } ace$dummy_access_bits;
      } ace$dummy_access_union;
      variant_union {
        unsigned long int ace$l_key;
        char ace$t_auditname[ACE$S_AUDITNAME];
      } ace$dummy_alarm_id_union;
    } ace$dummy_alarm_id_ace;

    /* application ace */
    variant_struct {
      unsigned long int ace$l_info_flags;
      char ace$t_info_start;
    } ace$dummy_application_ace;

    /* default protection ace */
    variant_struct {
      unsigned long int ace$l_spare1;
      unsigned long int ace$l_sys_prot;
      unsigned long int ace$l_own_prot;
      unsigned long int ace$l_grp_prot;
      unsigned long int ace$l_wor_prot;
    } ace$dummy_protectionc_ace;

    variant_struct {
      char ace$t_volnam[ACE$S_VOLNAM];
      unsigned char ace$b_volnam_len;
      unsigned char ace$b_rjrver;
      variant_union {
        unsigned char ace$r_fid_overlay[ACE$S_FID];
        unsigned short int ace$w_fid[ACE$S_FID/2];
        variant_struct {
          unsigned short int ace$w_fid_num;
          unsigned short int ace$w_fid_seq;
          variant_union {
            unsigned char ace$r_fid_rvn_overlay[2];
            unsigned short int ace$w_fid_rvn;
            variant_struct {
              unsigned char ace$b_fid_rvn;
              unsigned char ace$b_fid_nmx;
            } ace$r_fid_rvn_fields;
          } ace$dummy_fid_rvn_fields;
        } ace$r_fid_fields;
      } ace$dummy_fid_fields;
      variant_union {
        unsigned short int ace$w_rmsjnl_flags;
        variant_struct {
          unsigned ace$v_journal_disabled : 1;
          unsigned ace$v_backup_done : 1;
        } ace$dummy_rmsjnl_flags_bits;
      } ace$dummy_rmsjnl_flags_union;
      unsigned long int ace$l_jnlidx;
      struct DATE ace$q_cdate;
      unsigned long int ace$l_backup_seqno;
      struct DATE ace$q_modification_time;
    } ace$dummy_undocumented_ace;
  } ace$dummy_ace_fields;
};
