/*
 * this file was made by hand, and has NOT been tested yet.
 */

/**** MODULE $WCBDEF *** */
/* + */
/*  WCB - WINDOW CONTROL BLOCK */
/*  */
/*  THERE IS A WINDOW CONTROL BLOCK FOR EACH FILE ACCESSED BY A PROCESS. */
/*  IT CONTAINS MAPPING INFORMATION SUCH THAT A LARGE PERCENTAGE OF VIRTUAL */
/*  FILE I/O CAN BE MAPPED FROM VIRTUAL TO LOGICAL BLOCK NUMBERS WITHOUT */
/*  HAVING TO READ THE RESPECTIVE FILE HEADER. */
/* - */
#define WCB$M_READ 1
#define WCB$M_WRITE 2
#define WCB$M_NOTFCP 4
#define WCB$M_SHRWCB 8
#define WCB$M_OVERDRAWN 16
#define WCB$M_COMPLETE 32
#define WCB$M_CATHEDRAL 64
#define WCB$M_EXPIRE 128
#define WCB$K_MAP 48                 /*  MAP POINTERS START HERE  */
#define WCB$C_MAP 48                 /*  MAP POINTERS START HERE  */
#define WCB$K_LENGTH 48              /*  LENGTH OF STANDARD WCB SANS POINTERS  */
#define WCB$C_LENGTH 48              /*  LENGTH OF STANDARD WCB SANS POINTERS  */
#define WCB$S_WCBDEF 60
#define WCB$S_WCBDEF1 6

struct wcbdef {
  long int wcb$l_wlfl;	/*  WINDOW LIST FORWARD LINK  */
  long int wcb$l_wlbl;	/*  WINDOW LIST BACKWARD LINK  */
  short int wcb$w_size;	/*  SIZE OF WINDOW BLOCK IN BYTES  */
  unsigned char wcb$b_type;	/*  STRUCTURE TYPE OF WCB  */
  variant_union {
    unsigned char wcb$b_access;	/*  ACCESS CONTROL BYTE  */
    variant_struct {
      unsigned wcb$v_read:1;	/*  READ ACCESS ALLOWED (1=YES)  */
      unsigned wcb$v_write:1;	/*  WRITE ACCESS ALLOWED (1=YES)  */
      unsigned wcb$v_notfcp:1;	/*  FILE NOT ACCESSED BY FCP IF SET  */
      unsigned wcb$v_shrwcb:1;	/*  SHARED WINDOW  */
      unsigned wcb$v_overdrawn:1;	/*  FILE ACCESSOR HAS OVERDRAWN HIS QUOTA */
      unsigned wcb$v_complete:1;	/*  SET WINDOW MAPS ENTIRE FILE  */
      unsigned wcb$v_cathedral:1;	/*  LARGE, COMPLEX WINDOW (SIC) TO MAP  */
      /*  FILE COMPLETELY */
      unsigned wcb$v_expire:1;	/*  FILE EXPIRATION DATE MAY NEED TO BE SET */
    } wcb_fields_1;
  } wcb_overlay_1;
  variant_union {
    long int wcb$l_pid;	/*  PROCESS ID OF ACCESSOR PROCESS  */
    variant_struct {
      short int wcb_fill_1;
      short int wcb$w_refcnt;	/*  REFERENCE COUNT FOR SHARED WINDOW  */
    } wcb_fields_2;
  } wcb_overlay_2;
  long int wcb$l_orgucb;	/*  ADDRESS OF ORIGINAL UCB FROM CCB  */
  variant_union {
    short int wcb$w_acon;	/*  ACCESS CONTROL INFORMATION  */
    variant_struct {
      /*  NOTE - THESE BITS TRACK THE BITS */
      /*  IN FIB$L_ACCTL */
      unsigned wcb$v_nowrite:1;	/*  NO OTHER WRITERS  */
      unsigned wcb$v_dlock:1;	/*  ENABLE DEACCESS LOCK  */
      unsigned :2;
      unsigned wcb$v_spool:1;	/*  SPOOL FILE ON CLOSE  */
      unsigned wcb$v_writeck:1;	/*  ENABLE WRITE CHECK  */
      unsigned wcb$v_seqonly:1;	/*  SEQUENTIAL ONLY ACCESS  */
      unsigned :1;
      unsigned wcb$v_writeac:1;	/*  WRITE ACCESS  */
      unsigned wcb$v_readck:1;	/*  ENABLE READ CHECK  */
      unsigned wcb$v_noread:1;	/*  NO OTHER READERS  */
      unsigned wcb$v_notrunc:1;	/*  NO TRUNCATES  */
      unsigned wcb$v_control:1;	/*  CONTROL ACCESS TO FILE */
    } wcb_fields_3;
    variant_struct {
      /*  THE FOLLOWING FIELD OVERLAYS THE FIRST */
      /*  UNUSED FLAG IN WCB$W_ACON ABOVE. */
      unsigned :2;
      unsigned wcb$v_noacclock:1;	/*  NO ACCESS LOCK CHECKING */
      unsigned :9;
      unsigned wcb$v_readinit:1;	/*  A READINIT WAS DONE OVER THIS CHANNEL  */
      unsigned wcb$v_write_turn:1;	/*  FORCE WINDOW TURN ON WRITES */
    } wcb_fields_4;
  } wcb_overlay_3;
  /*  SIZE DEVICE INDEPENDENT PART OF WCB */
  short int wcb$w_nmap;	/*  NUMBER OF MAPPING POINTERS  */
  long int wcb$l_fcb;	/*  ADDRESS OF FCB  */
  long int wcb$l_rvt;	/*  ADDRESS OF RELATIVE VOLUME TABLE  */
  long int wcb$l_link;	/*  LINK TO NEXT WINDOW SEGMENT  */
  long int wcb$l_reads;	/*  COUNT OF READS PERFORMED  */
  long int wcb$l_writes;	/*  COUNT OF WRITES PERFORMED  */
  long int wcb$l_stvbn;	/*  STARTING VBN MAPPED BY WINDOW  */
  /*  NOTE THAT VIRTUAL MAPPING */
  /*  NEEDS P1_COUNT IMMEDIATELY */
  /*  FOLLOWING STVBN */
  short int wcb$w_p1_count;	/*  COUNT FIELD OF FIRST POINTER  */
  long int wcb$l_p1_lbn;	/*  LBN FIELD OF SECOND POINTER  */
  short int wcb$w_p2_count;	/*  COUNT FIELD OF SECOND POINTER  */
  long int wcb$l_p2_lbn;	/*  LBN FIELD OF FIRST POINTER  */
};

/*  FORMAT OF RETRIEVAL POINTER */
struct wcbdef1 {
  short int wcb$w_count;	/*  COUNT FIELD  */
  long int wcb$l_lbn;	/*  LBN FIELD  */
};
