#include smgdef
#include descrip
#include "menu_def.h"

struct Item *first_item(struct MenuList *,struct Menu *,int *);
struct Item *last_item(struct MenuList *,struct Menu *,int *);
struct Item *move_up(struct MenuList *,struct Menu *,struct Item *,int *);
struct Item *move_down(struct MenuList *,struct Menu *,struct Item *,int *);

loop(node,menuname,dfltname,currentmenu,itemname,pending)
  struct MenuList *node;
  char *menuname, *dfltname, *currentmenu, *itemname, *pending;
{
  struct MenuList *lastnode;
  struct Menu *menu,*menus,*lastmenu;
  struct Item *item,*items,*tmpitm;
  struct AString *astrings, *arrowstr;
  char *str,*hlp,*tpc;
  unsigned short int len,term;
  int line = 0,cmenu,startline,prevline;
  int repeating, samemenu;

  if (pending && (strlen(pending) == 0))
    pending = 0;

  lastnode = node;
  if (node->flag)
    lastmenu = node->array_menus + 1;
  else
    lastmenu = node->menu->link.next;

  repeating = 1;
  while (repeating)
  {
    if ((menu = lookup_menu(node,currentmenu)) == 0)
      menu = lastmenu;
    lastmenu = menu;

    if (pending == 0)
    {
      init_key_table();

      /* add node keydefs, and menu keydefs */
      init_local_keys(node,menu);

      display_menu(node, menu);
    }

    if (node->flag)
      items = node->array_items + (int)(menu->display_itm);
    else
      items = menu->display_itm;

    line = 0;
    if (itemname && strlen(itemname))
    { /* find line this item is on */
      item = lookup_list(items,sizeof(struct Item),itemname);
      line = line_number(items,item);
    }

    if ((line == 0) && menu->default_item)
    {
      item = lookup_list(items,sizeof(struct Item),menu->default_item);
      line = line_number(items,item);
    }

    if (line == 0) /* find first line an item is on */
      item = first_item(node,menu,&line);

    samemenu = 1;
    while (samemenu)
    {
      if (pending)
      {
        str = pending;
        pending = strchr(pending,'-');
        if (pending)
        {
          *pending = '\0';
          ++pending;
        }
        len = strlen(str);
        samemenu = 0;
      }
      else
      {
        place_arrow(node, menu, line);
        len = 0;
        prompt(node,menu,&str,&len,&term);

        pending = strchr(str,'-');
        if (pending)
        {
          *pending = '\0';
          ++pending;
        }

        if (node->flag == 0)
          arrowstr = menu->arrow;
        else
          arrowstr = node->array_astrings + (int)(menu->arrow);
        erase_arrow(line, arrowstr);
      }

      if ((len > 1) && (str[0] == 0x7f))
      { /* internal trick for trapping UP, DOWN, PREV, NEXT, HELP etc. */
        switch (str[1])
        {
          case 'U':	/* UP (move arrow up) */
            /* recompute line */
            item = move_up(node,menu,item,&line);
            break;
          case 'D':	/* DOWN (move arrow down) */
            /* recompute line */
            item = move_down(node,menu,item,&line);
            break;
          case 'P':	/* PREVIOUS_SCREEN */
            /* item = move_up_page(node,menu,item,&line); */
            /* not currently implemented */
            break;
          case 'N':	/* NEXT_SCREEN */
            /* item = move_down_page(node,menu,item,&line); */
            /* not currently implemented */
            break;
          case 'E':	/* EXIT */
            sclose();
            lib_do_command("goto end_of_comfile");
            break;
          case 'H':	/* HELP */
            hlp = 0;
            if (menu->helpfile && strlen(menu->helpfile))
              hlp = menu->helpfile;
            if (item->helpfile && strlen(item->helpfile))
              hlp = item->helpfile;
            tpc = 0;
            if (menu->helptopic && strlen(menu->helptopic))
              tpc = menu->helptopic;
            if (item->helptopic && strlen(item->helptopic))
              tpc = item->helptopic;
            if (hlp || tpc)
            {
              samemenu = 0;
              itemname = item->link.name;
              sclose();
              output_help(hlp,tpc);
              sopen(menu->length, menu->width);
            }
            break;
          default:
            printf("\nSome unimplemented internal trick %s!\n",&str[1]);
            break;
        } /* switch (str[1]) */
      } /* if ((len > 1) && (str[0] == 0x7f)) */
      else /* not an internal trick */
      {
        if (len)
        {
          strupcase(str);
          tmpitm = lookup_item(node,menu,str);
          if (tmpitm)
          {
            item = tmpitm;
            len = 0; /* used to show that an item was found */
          }
          else
          { /* signal an error ! */
            printf("\nIllegal or ambiguous item name %s!\n", str);
          }
        } /* if (len) */
        else
        { /* if they just hit ^Z, then we should be getting out */
          if (term == SMG$K_TRM_CTRLZ) /* get set up for a fall */
          {
            sclose();
            lib_do_command("goto end_of_comfile");
          }
        }

        if (len == 0)
        {
          switch(item->command[0])
          {
            case CMDTYPANYMNU:
              samemenu = 0;
              itemname = item->dflt;
              currentmenu = & (item->command[1]);
              if ((menu = lookup_menu(node,currentmenu)) == 0)
              {
                currentmenu = 0;
                node = add_menu(&(item->command[1]),dfltname);
                if (node)
                {
                  lastnode = node;
                  if (node->flag)
                    lastmenu = node->array_menus + 1;
                  else
                    lastmenu = node->menu->link.next;
                }
                else
                  node = lastnode;
              }
              break;
            case CMDTYPINTMNU:
              currentmenu = & (item->command[1]);
              samemenu = 0;
              itemname = item->dflt;
              break;
            case CMDTYPEXTMNU:
              samemenu = 0;
              itemname = item->dflt;
              currentmenu = 0;
              node = add_menu(&(item->command[1]),dfltname);
              if (node)
              {
                lastnode = node;
                if (node->flag)
                  lastmenu = node->array_menus + 1;
                else
                  lastmenu = node->menu->link.next;
              }
              else
                node = lastnode;
              break;
            case CMDTYPINTCMD:
              switch (lookup_word(&(item->command[1]),"EXIT,SPAWN,COMPILE"))
              {
                case 1:
                  sclose();
                  lib_do_command("goto end_of_comfile");
                  break;
                case 2:
                  samemenu = 0;
                  itemname = item->link.name;
                  str = strchr(&(item->command[1]),' ');
                  sclose();
                  lib_spawn(str);
                  sopen(menu->length, menu->width);
                  break;
                case 3:
                  /* this is the ONLY exit from "loop", this will
                     cause the interpreter to fall through to the
                     call to the compile function, and the compiled
                     version will simply exit */
                  return;
                  break;
                default:
                  printf("\nSupposed to perform internal command %s!\n",
                         &(item->command[1]));
                  break;
              }
              break;
            case CMDTYPEXTCMD:
              lib_set_symbol("mnu$menu_file",node->link.name);
              lib_set_symbol("mnu$default_menu",dfltname);
              lib_set_symbol("mnu$current_menu",menu->link.name);
              if (item->dflt)
                lib_set_symbol("mnu$default_item",item->dflt);
              else
                lib_set_symbol("mnu$default_item",item->link.name);
              switch ((pending?1:0) + (item->forcecmd?2:0))
              {
                case 0:
                  lib_set_symbol("mnu$pending",0);
                  break;
                case 1:
                  lib_set_symbol("mnu$pending",pending);
                  break;
                case 2:
                  lib_set_symbol("mnu$pending",item->forcecmd);
                  break;
                case 3:
                  /* concatenate the two strings, with a dash ("-") */
                  str = calloc(1,strlen(pending)+strlen(item->forcecmd)+2);
                  /* the +2 = one for dash, one for null */
                  strcpy(str,pending);
                  strcat(str,"-");
                  strcat(str,item->forcecmd);
                  lib_set_symbol("mnu$pending",str);
                  break;
              }
              if (item->wait)
                lib_set_symbol("mnu$wait",item->wait);
              else
                lib_set_symbol("mnu$wait",menu->wait);
              sclose();
              lib_do_command(&(item->command[1]));
              break;
            default:
              printf("\nSome unknown option %c!\n",item->command[0]);
              break;
          } /* switch(item->command[0]) */
        } /* if (len == 0) */
      } /* else - not an internal trick */
    } /* while (samemenu) */
  } /* while (repeating) */
}

struct Item *move_down(node,menu,item,line)
  struct MenuList *node;
  struct Menu *menu;
  struct Item *item;
  int *line;
{
  struct Item *tmp;

  tmp = next_node(item,sizeof(struct Item));
  ++(*line);

  while (tmp && (check_item(node,tmp) == 0))
  {
    tmp = next_node(tmp,sizeof(struct Item));
    ++(*line);
  }

  if (tmp == 0)
    tmp = first_item(node,menu,line);

  return(tmp);
}

struct Item *move_up(node,menu,item,line)
  struct MenuList *node;
  struct Menu *menu;
  struct Item *item;
  int *line;
{
  struct Item *tmp;
  int tmpline;

  tmp = prev_node(item,sizeof(struct Item));
  --(*line);

  while (tmp && (check_item(node,tmp) == 0))
  {
    tmp = prev_node(tmp,sizeof(struct Item));
    --(*line);
  }

  if (tmp == 0)
    tmp = last_item(node,menu,line);

  return(tmp);
}

struct Item *first_item(node,menu,line)
  struct MenuList *node;
  struct Menu *menu;
  int *line;
{
  struct Item *item,*items;

  if (node->flag == 1)
    items = node->array_items + (int)(menu->display_itm);
  else
    items = menu->display_itm;

  item = items; /* assume there's an item somewhere! */
  *line = 1;
  while (item && (check_item(node,item) == 0))
  {
    item = next_node(item,sizeof(struct Item));
    ++(*line);
  }
  if (!item || (check_item(node,item) == 0))
    *line = 1; /* egads, no selectable items! */

  return(item);
}

struct Item *last_item(node,menu,line)
  struct MenuList *node;
  struct Menu *menu;
  int *line;
{
  struct Item *item, *items, *tmp;
  int tmpline;

  item = first_item(node,menu,line);
  /* okay, got the first, let's move to the last */

  tmp = item;
  tmpline = *line;
  while (tmp)
  {
    if (check_item(node,tmp))
    {
      item = tmp;
      *line = tmpline;
    }
    tmp = next_node(tmp,sizeof(struct Item));
    ++tmpline;
  }

  return(item);
}

lib_do_command(s)
  char *s;
{
  struct dsc$descriptor sdesc = {strlen(s),0,0,s};

  lib$do_command(&sdesc);
}

lib_spawn(s)
  char *s;
{
  struct dsc$descriptor sdesc = {s?strlen(s):0,0,0,s};
  int status;

  if (s && strlen(s))
    status = lib$spawn(&sdesc);
  else
    status = lib$spawn();

  if ((status & 1) == 0)
  {
    lib$signal(status);
  }
}

init_local_keys(node,menu)
  struct MenuList *node;
  struct Menu *menu;
{
  struct KeyDef *key;

  if (node->flag)
    key = node->array_keydefs + (int)(node->menu->keydefs);
  else
    key = node->menu->keydefs ;

  while (key)
  {
    define_key(key->string);
    if (key->next == -1)
      ++key;
    else
      key = key->next;
  }

  if (node->flag)
    key = node->array_keydefs + (int)(menu->keydefs);
  else
    key = menu->keydefs ;

  while (key)
  {
    define_key(key->string);
    if (key->next == -1)
      ++key;
    else
      key = key->next;
  }
}
  
lookup_word(s,k)
  char *s, *k;
{
  char *d = k;
  int i = 0;

  /* assume they are both uppercase already */
  /* strupcase(s); */
  /* strupcase(k); */

  while(d)
  {
    ++i;
    if (strncmp(s,d,strlen(s)) == 0)
      d = 0;
    else
      d = strchr(d,',');
    if (d)
      ++d;
  }

  return(i);
}

lib_set_symbol(s,e)
  char *s,*e;
{
  struct dsc$descriptor sdesc = {s?strlen(s):0,0,0,s};
  struct dsc$descriptor edesc = {e?strlen(e):0,0,0,e};
  int N2 = 2;

  lib$set_symbol(&sdesc,&edesc,&N2);
}

line_number(items,item)
  struct Item *items, *item;
{
  struct Item *tmpitm;
  int line = 0;

  if (item)
  { /* get line number of this item */
    tmpitm = items;
    ++line;
    while (tmpitm && (item != tmpitm))
    {
      tmpitm = next_node(tmpitm,sizeof(struct Item));
      ++line;
    }
    if (tmpitm == 0) /* this shouldn't happen */
      line = 0;
  }
  return(line);
}

extern int lbr$output_help();
extern int lib$put_output();
extern int lib$get_input();

#define HLP$M_PROMPT 0x00000001
#define HLP$M_PAGE 0x00000100

output_help(file,topic)
  char *file, *topic;
{
  struct dsc$descriptor fdesc = {file?strlen(file):0,0,0,file};
  struct dsc$descriptor tdesc = {topic?strlen(topic):0,0,0,topic};
  int mask;

  if (file || topic)
  {
    mask = HLP$M_PROMPT | HLP$M_PAGE;
    lbr$output_help(&lib$put_output,0,&tdesc,&fdesc,&mask,&lib$get_input);
  }
}
