#include smgdef
#include "menu_def.h"

int make_astring(string)
  char *string;
{
  struct AString *head = 0, *current = 0, *tmp = 0;
  char *tmpstr;
  int caret, format, lastmode = 0, mode = 0, stringlength = 0, 
      first = 0, start = 0, i = 0, chars = 0;

  /* this goes through the string, looking for ^R, ^B, ^F, ^N
     and for each one it finds it creates a part of the astring
     structure.. It returns a pointer to an AString.
  */
  while (caret = strchr(&string[start],'^'))
  {
    i = caret - (int)string;	/* how many chars in? */
    chars = i - first;	/* how many characters? */
    start = i + 2;	/* where does next string start? */

    format = -1; /* assume it's a formatting char */
    switch(string[++i]) /* point past caret */
    {
      case 'B': case 'b':
        /* set bolding flag */
        mode |= SMG$M_BOLD;
        break;
      case 'F': case 'f':
        /* set flashing flag */
        mode |= SMG$M_BLINK;
        break;
      case 'N': case 'n':
        /* set normal mode */
        mode = SMG$M_NORMAL;
        break;
      case 'R': case 'r':
        /* set reverse flag */
        mode |= SMG$M_REVERSE;
        break;
      case 'U': case 'u':
        /* set flashing flag */
        mode |= SMG$M_UNDERLINE;
        break;
      default:
        /* just move next char untouched */
        format = 0; /* it's not a formatting char */
        break;
    }
    /* okay, if there are chars to move, then allocate an AString, and
       initialize it. Set the mode, and the length fields. The pointer
       field will be filled in as an offset for now. After we know the
       real length of the string, and have copied it off to a safe spot,
       we will add in the address of the copied string.
    */
    if (chars)
    {
      if (head == 0)
      {
        head = calloc(1,sizeof(struct AString));
        current = head;
      }
      else
      {
        current->next = calloc(1,sizeof(struct AString));
        current = current->next;
      }
      current->length = chars;
      current->string = &string[first];
      current->mode = lastmode;
      stringlength += current->length;
    }
    first = start;	/* first char of string, may be before start if '^' */
    if (!format) --first;
    lastmode = mode;
  } /* end of while */

  /* add in the last chunk of the string (possibly whole string) */
  if (head == 0)
  {
    head = current = calloc(1,sizeof(struct AString));
  }
  else
  {
    current->next = calloc(1,sizeof(struct AString));
    current = current->next;
  }
  current->length = strlen(string) - first;
  current->string = &string[first];
  current->mode = mode;
  stringlength += current->length;

  /* okay, we now have an almost ready AString, we need to allocate
     'stringlength' bytes and copy each chunk of string into this space.
     Note that if there were ^^ or other non formatting ^ options, than
     we can coelesce the AString nodes together. We will do this by seeing
     if the next AString has the same 'mode' as the current.. */
  tmpstr = calloc(1,stringlength);
  strncpy(tmpstr, head->string, head->length);
  head->string = tmpstr; /* point to real beginning of string */
  stringlength = head->length;
  current = head;
  while (current->next)
  {
    /* see if the next can be coalesced with the current */
    if (current->mode == current->next->mode)
    {
      /* coalesce them... */
      tmp = current->next;
      strncat(head->string,tmp->string,tmp->length);
      current->length += tmp->length;
      stringlength += tmp->length;
      current->next = tmp->next; /* skip past tmp (now defunct) */
      cfree(tmp); /* lose the defunct chunk.. */
    }
    else
    {
      current = current->next;
      strncat(head->string,current->string,current->length);
      current->string = head->string + stringlength;
      stringlength += current->length;
    }
  }
  return((int)head);
}
