#include ssdef
#include stdio
#include string

#include "menu_def.h"

int REAL_ENTRY$ROUTINE();
struct Menu *menu_init();

ENTRY$ROUTINE(menufile,dfltfile,node)
  char *menufile, *dfltfile;
  struct MenuList *node;
{
  node->menu = menu_init(menufile,dfltfile);
  /* we need to create a tree, with the menufile and this node ptr... */
  /* so that the REAL_ENTRY$ROUTINE can find it again later! */
  node->entrypnt = &REAL_ENTRY$ROUTINE;
}

REAL_ENTRY$ROUTINE(node,menuname,dfltname,currentmenu,currentitem,pending)
  struct MenuList *node;
  char *menuname,*dfltname,*currentmenu,*currentitem,*pending;
{
  struct Menu *menu;
  char *str;

  loop(node,menuname,dfltname,currentmenu,currentitem,pending);

  menu_compile(node->link.name,node->menu);
}

#define NEWMENU 1
#define INCLUDE 2
struct Menu *menu_init(menuname,dfltname)
  char *menuname,*dfltname;
{
  struct Menu *Head, *current, *next;
  struct file_list *menufile;
  FILE *compiled;
  char fname[256];
  char str[1024];
  int i,more,state;

  menufile = mem_alloc(sizeof(struct file_list));
  strcpy(fname,"dna = ");
  strcat(fname,dfltname);
  menufile->file = fopen(menuname,"r",fname);
  if (!menufile->file)
  {
    printf("Unable to open menu file:\n");
    printf("    name = %s\n",menuname);
    printf("    dflt = %s\n",dfltname);
    sys$exit(SS$_ABORT);
  }

  Head = mem_alloc(sizeof(struct Menu));
  Head->arrow = make_astring(DFLT_ARROW);
  Head->align = DFLT_ALIGN;
  Head->numeric = DFLT_NUMERIC;
  Head->width = DFLT_WIDTH;
  Head->separator = DFLT_SEPARATOR;
  Head->helpfile = DFLT_HELPFILE;
  Head->helptopic = DFLT_HELPTOPIC;
  Head->prompt = make_astring(DFLT_PROMPT);
  Head->wait = DFLT_WAIT;

  current = Head;
  if (!fgets(str,sizeof(str),menufile->file))
  {
    printf("Menu file is empty!\n");
    sys$exit(SS$_ABORT);
  }
  ++menufile->line_number;
  if (str[strlen(str) - 1] == '\n')
  {
    str[strlen(str) - 1] = '\0';
  }

  more = -1;
  while(more)
  {
    /* if str ends in '-', append next line to it */
    /* do so until line doesn't end with '-'. */
    /* you aren't allowed to continue a line over the bounds */
    /* of an include file.. */
    while(str[strlen(str) - 1] == '-')
    {
      str[strlen(str) - 1] = '\0'; /* kill the dash */
      if (!fgets(&str[strlen(str)],sizeof(str)-strlen(str),menufile->file))
      {
        printf("Illegal continuation line, continues past end of file!\n");
        printf("on line %d of %s\n",menufile->line_number,
		fgetname(menufile->file,fname) );
        sys$exit(SS$_ABORT);
      }
      ++menufile->line_number;
      if (str[strlen(str) - 1] == '\n')
      {
        str[strlen(str) - 1] = '\0';
      }
    }
    state = parse(current,str,menufile);
    switch(state)
    {
      case NEWMENU:
        /* string now looks like "menuname" */
        next = mem_alloc(sizeof(struct Menu));
        next->link.name = trim_string(str);
        strupcase(next->link.name);
        insert_unsorted(&(Head->link.next), next, sizeof(struct Menu),"menu");
        next->arrow = Head->arrow;
        next->align = Head->align;
        next->numeric = Head->numeric;
        next->width = Head->width;
        next->separator = Head->separator;
        next->helpfile = Head->helpfile;
        next->helptopic = Head->helptopic;
        next->prompt = Head->prompt;
        next->wait = Head->wait;
        next->default_item = Head->default_item;
        current = next;
        /* set the current menu defaults from the Head menu defaults */
        break;
      case INCLUDE:
        menufile->next = mem_alloc(sizeof(struct file_list));
        menufile->next->prev = menufile;
        menufile = menufile->next;
        strcpy(fname,"dna = ");
        strcat(fname,dfltname);
        menufile->file = fopen(str,"r",fname);
        if (!menufile->file)
        {
          printf("Unable to open menu include file:\n");
          printf("    name = %s\n",str);
          printf("    dflt = %s\n",dfltname);
          printf("on line %d of %s\n",menufile->prev->line_number,
		fgetname(menufile->prev->file,fname) );
          sys$exit(SS$_ABORT);
        }
        break;
    }

    while (more && (!fgets(str,sizeof(str),menufile->file)))
    {
      fclose(menufile->file);
      menufile = menufile->prev;
      if (!menufile)
      {
        more = 0;
      }
    }

    if (more)
    {
      ++menufile->line_number;
      if (str[strlen(str) - 1] == '\n')
      {
        str[strlen(str) - 1] = '\0';
      }
    }
  }

  return(Head);
}

mem_alloc(size)
  int size;
{
  int ptr;

  ptr = calloc(1,size);
  if (!ptr)
  {
    lib$signal(SS$_INSFMEM);
    sys$exit(SS$_ABORT);
  }     
  return(ptr);
}

mem_free(ptr)
  char *ptr;
{
  cfree(ptr);
}
