#include iodef
#include ssdef
#include "pcbdef.h"
#include "starlet.h"
#include "server.h"

globalvalue EXE$GL_ABSTIM;

int io_complete();

get_header(indx)
  int indx;
{
  static int zero = 0;
  int i,status,size;

  /* get_header - check for an syi list, if exists, call getsyi
		call getjpi on self */
  if (syi_items[indx][0].code != 0) {
    if (syi_items[indx][0].bufadr == 0) {
      size = 0;
      for (i = 0; syi_items[indx][i].code != 0; i++)
        size += syi_items[indx][i].length;
      syi_items[indx][0].bufadr = malloc(size);
      for (i = 1; syi_items[indx][i].code != 0; i++)
        syi_items[indx][i].bufadr += (int) syi_items[indx][0].bufadr;
    };
    status = sys$getsyi(0,0,0,syi_items[indx],0,0,0);
    if (!(status & 1)) sys$exit(status);
  };

  getjpi(indx,&zero);

  format_line(indx,&gbl_headers[indx],0);

  zero = 0;
  status = sys$qiow(0,gbl_links[indx].chan,IO$_WRITEVBLK,
		&gbl_links[indx].iosb,0,0,&zero,1,0,0,0,0);
  if (!(status & 1)) sys$exit(status); /* couldn't queue? sanity check */

  status = sys$qio(0,gbl_links[indx].chan,IO$_READVBLK,
		&gbl_links[indx].iosb,&io_complete,indx,
		gbl_links[indx].buffer,BUFFERSIZE,0,0,0,0);

}

get_display(indx)
  int indx;
{
  int i,status,nomatch;
  int zero = 0;

  if (gbl_links[indx].pid == 0) /* in case it was never initialized */
    gbl_links[indx].pid = -1;

  if ((status = getjpi(indx,&gbl_links[indx].pid)) == SS$_NOMOREPROC)
  {
    gbl_links[indx].pid = -1; /* hey, we're done, get ready for next */
  }
  else
  {
    nomatch = -1;
    while (nomatch)
    {
      if ((status & 1) && matches(indx,&gbl_select[indx],1)
          && !matches(indx,&gbl_reject[indx],0))
      {
        format_line(indx,&gbl_displays[indx],&get_display);
        nomatch = 0;
      }
      else
      {
        if ((status = getjpi(indx,&gbl_links[indx].pid)) == SS$_NOMOREPROC)
        {
          gbl_links[indx].pid = -1; /* hey, we're done, get ready for next */
          nomatch = 0;
        }
      }
    }
  }

  if (gbl_links[indx].pid == -1) /* have we finished this round? */
  {
    status = sys$qiow(0,gbl_links[indx].chan,IO$_WRITEVBLK,
		&gbl_links[indx].iosb,0,0,&zero,1,0,0,0,0);
    status = sys$qio(0,gbl_links[indx].chan,IO$_READVBLK,
		&gbl_links[indx].iosb,&io_complete,indx,
		gbl_links[indx].buffer,BUFFERSIZE,0,0,0,0);
  }
}

getjpi(indx,pid)
  int indx;
  int *pid;
{
  struct iosbdef iosb;
  unsigned int *slot,*sts, *thispid, *master;
  unsigned char *buff,*jpi;
  int i,offset,status,time,sameproc = -1;

  time = *(int *)EXE$GL_ABSTIM;

  status = sys$getjpiw(0,pid,0,system_jpi.pcb_items,&iosb,0,0);
  if (status & 1)
    status = iosb.status;
  if (!(status & 1))
  {
    if (status != SS$_NOMOREPROC)
      printf("Error getting PCB items, status = %d\n",status);
    return(status);
  }
  slot = system_jpi.pcb_items[0].bufadr;
  thispid = system_jpi.pcb_items[1].bufadr;
  sts = system_jpi.pcb_items[2].bufadr;
  master = system_jpi.pcb_items[3].bufadr;

  jpi = system_jpi.data;

  if (*pid)
  {
    while (*master == 0)
    {
      status = sys$getjpiw(0,pid,0,system_jpi.pcb_items,&iosb,0,0);
      if (status & 1)
        status = iosb.status;
      if (!(status & 1))
      {
        if (status != SS$_NOMOREPROC)
          printf("Error getting PCB items, status = %d\n",status);
        return(status);
      }
    };
  };

  /* copy this data to the proper slot */
  buff = jpi;
  buff += (JPIMAXBUFFLEN + (4 * JPIMAXITEMCNT)) * *slot;

  offset = system_jpi.pcb_items[1].bufadr - jpi;
  if (*thispid != *(int *)(buff + offset))
  {
    sameproc = 0;
  }

  move_data(jpi, buff, system_jpi.pcb_items,time,sameproc);

  if (! sameproc)
  {
    clear_data(buff,system_jpi.phd_items);
    move_data(jpi, buff, system_jpi.phd_items,time,sameproc);
  }
  if (*sts & PCB$M_PHDRES)
  {
    status = sys$getjpiw(0,thispid,0,system_jpi.phd_items,&iosb,0,0);
    if (status & 1)
      status = iosb.status;
    if (!(status & 1))
    {
      printf("Error getting PHD items, status = %d\n",status);
      return(status | 1); /* Hey, we got enough to display something */
    }
    else
    {
      if (status != 1)
        printf("Getting PHD items, status = %d\n");
      move_data(jpi, buff, system_jpi.phd_items,time,sameproc);
    }
  }

  if (! sameproc)
  {
    clear_data(buff,system_jpi.ctl_items);
    move_data(jpi, buff, system_jpi.ctl_items,time,sameproc);
  }
  if (*sts & PCB$M_RES)
  {
    status = sys$getjpiw(0,thispid,0,system_jpi.ctl_items,&iosb,0,0);
    if (status & 1)
      status = iosb.status;
    if (!(status & 1))
    {
      printf("Error getting CTL items, status = %d\n",status);
      return(status | 1); /* Hey, we got enough to display something */
    }
    else
    {
      if (status != 1)
        printf("Getting CTL items, status = %d\n");
      move_data(jpi, buff, system_jpi.ctl_items,time,sameproc);
    }
  }

  return(status);
};

write_text(indx,msg,len,routine)
  int indx;
  unsigned char *msg;
  int len;
  int routine;
{
  int status,start;

  start = 0;
  if (len > 255) {
    while (len > 255) {
      msg[start] = 255;
      len -= 254;
      status = sys$qiow(0,gbl_links[indx].chan,IO$_WRITEVBLK,
			&gbl_links[indx].iosb,0,0,
			&msg[start],msg[start],0,0,0,0);
      /* we need to add space for the leading byte count */
      start += 254;
    }
  }

  /* Okay, if we have an ast routine to use then do so */
  msg[start] = len;
  if (routine)
  {
    status = sys$qio(0,gbl_links[indx].chan,IO$_WRITEVBLK,
		&gbl_links[indx].iosb,routine,indx,
		&msg[start],msg[start],0,0,0,0);
  }
  else
  {
    status = sys$qiow(0,gbl_links[indx].chan,IO$_WRITEVBLK,
		&gbl_links[indx].iosb,0,0,
		&msg[start],msg[start],0,0,0,0);
  }
}

format_line(indx,fmt,routine)
  int indx;
  struct FmtItemsList *fmt;
  int routine;
{
  int eos,i;
  unsigned char *msg;

  msg = gbl_links[indx].buffer;

  eos = 1;
  msg[eos] = '\0';
  for (i = 0; i < fmt->maxitems; ++i) {
    if (fmt->item[i].keyindx != -1) {
      (*keywords[fmt->item[i].keyindx].frmt_routine) (fmt,i,&msg[eos],indx);
      final_format(fmt,i,&msg[eos],indx);
      eos += strlen(&msg[eos]);
    };
  };

  write_text(indx,msg,eos,routine);

}

matches(indx,fmt,nullaction)
  int indx;
  struct FmtItemsList *fmt;
  int nullaction;
{
  struct LinkedList *list;
  unsigned char string[1024];
  int i;

  if (fmt->maxitems == 0) return(nullaction);

  for (i = 0; i < fmt->maxitems; ++i) {
    if (fmt->item[i].keyindx != -1) {
      (*keywords[fmt->item[i].keyindx].frmt_routine) (fmt,i,string,indx);
      /* okay, compare string against list */
      list = fmt->item[i].list;
      while (list) {
        if (compare(string, list->string, list->length))
        {
          return(1);
        }
        list = list->next;
      };
    };
  };

  return(0);
}

move_data(from, to, itemlist, when, same)
  unsigned char *from, *to;
  struct itmlst itemlist[];
  int when,same;
{
  int i, offset;
  char *src, *dst;

  i = 0;
  while (itemlist[i].code)
  {
    offset = itemlist[i].bufadr - from;
    src = from + offset;
    dst = to + offset;

    /* compare new data with old data */
    if (!same || memcmp(src, dst, itemlist[i].length))
    {
      if (itemlist[i].code == JPI$_CPUTIM)
      {
        if (same && ((*(int *)src) - (*(int *)dst)) < 2)
        {
          /* barely different, so store but don't save change time */
          memcpy(dst, src, itemlist[i].length);
        }
        else
        {
          /* different, so store & save change time */
          memcpy(dst, src, itemlist[i].length);
          dst += itemlist[i].length;
          memcpy(dst, &when, 4);
        }
      }
      else
      {
        /* different, so store & save change time */
        memcpy(dst, src, itemlist[i].length);
        dst += itemlist[i].length;
        memcpy(dst, &when, 4);
      }
    }
    ++i;
  }
}

clear_data(from,itemlist)
  char *from;
  struct itmlst itemlist[];
{
  int i, offset;
  char *dst;

  i = 0;
  while (itemlist[i].code)
  {
    offset = itemlist[i].bufadr - from;
    dst = from + offset;
    memset(dst, '\0', itemlist[i].length);
    ++i;
  }
}

get_idle()
{
  static int pid = -1;
  int status;

  if ((status = getjpi_idleloop(&pid)) != SS$_NOMOREPROC)
  {
    status = sys$dclast(&get_idle,0,0);
  }
  else
  {
    pid = -1;
  }
}

getjpi_idleloop(pid)
  int *pid;
{
  struct iosbdef iosb;
  unsigned int *slot,*sts, *thispid, *master;
  unsigned char *buff,*jpi;
  int i,offset,status,time,sameproc = -1;

  time = *(int *)EXE$GL_ABSTIM;

  status = sys$getjpiw(0,pid,0,system_jpi.pcb_items,&iosb,0,0);
  if (status & 1)
    status = iosb.status;
  if (!(status & 1)) return(status);

  slot = system_jpi.pcb_items[0].bufadr;
  thispid = system_jpi.pcb_items[1].bufadr;
  sts = system_jpi.pcb_items[2].bufadr;
  master = system_jpi.pcb_items[3].bufadr;

  jpi = system_jpi.data;

  if (*pid)
  {
    while (*master == 0)
    {
      status = sys$getjpiw(0,pid,0,system_jpi.pcb_items,&iosb,0,0);
      if (status & 1)
        status = iosb.status;
      if (!(status & 1))
      {
        return(status);
      }
    };
  };

  /* copy this data to the proper slot */
  buff = jpi;
  buff += (JPIMAXBUFFLEN + (4 * JPIMAXITEMCNT)) * *slot;

  offset = system_jpi.pcb_items[1].bufadr - jpi;
  if (*thispid != *(int *)(buff + offset))
  {
    sameproc = 0;
  }
  move_data(jpi, buff, system_jpi.pcb_items,time,sameproc);

  if (! sameproc)
  {
    clear_data(buff,system_jpi.phd_items);
  }
  if (*sts & PCB$M_PHDRES)
  {
    status = sys$getjpiw(0,thispid,0,system_jpi.phd_items,&iosb,0,0);
    if (status & 1)
      status = iosb.status;
    if (!(status & 1))
    {
      return(status);
    }
    else
    {
      move_data(jpi, buff, system_jpi.phd_items,time,sameproc);
    }
  }

  return(status);
};
