#include ctype
#include descrip

#include "status.h"
extern int (*init[])();
extern int (*format[])();
extern struct node keywords[];

struct info {
  variant_union {
    char *ptr;
    variant_struct {
      short int just;
      short int width;
    } dummy$struct;
  } dummy$union;
};

build_lists(name, jpi, syi, list, vals, index, fmt, susp, max)
  int name;
  struct itmlst jpi[], syi[];
  int list[];
  struct info vals[];
  int *index;
  int (*fmt[])();
  char susp[];
  int max;
{
  static char *listname[3] = {"display","header","title"};
  static struct dsc$descriptor str={0, DSC$K_DTYPE_T, DSC$K_CLASS_D, 0};
  int keyword,textkey;
  char *ptr;
  char buff[40]; /* hmm, this should be big enough for all item names */
  char text[512]; /* this should be big enough for all text */
  short int start, jst, width, repeating = 0;
  int i,j,k;
  int numbytes;

  if (!(cli_present(listname[name]) & 1)) return;
  textkey = search_keywords("TEXT");
  while (cli_next_qual(listname[name]) & 1) {
    if (repeating) {
      if (textkey >= 0) {
        vals[*index].ptr = "\n";
        fmt[*index] = keywords[textkey].fmt_ptr;
        (*init[keywords[textkey].ini_ptr])(keywords[textkey].ini_data,
                jpi, syi, list, susp, index);
      };
    };
    repeating = 1;
    while (cli_get_value(listname[name],&str) & 1) {
      if (str.dsc$a_pointer[str.dsc$w_length - 1] == '-')
        if (repeating) { /* line ends in "-" - possible continuation? */
          repeating = 0;
          str.dsc$a_pointer[str.dsc$w_length - 1] = '\0';
        }
      start = 0;
      while (start < str.dsc$w_length) {
        for (i=start;
             (i < str.dsc$w_length) && (str.dsc$a_pointer[i] != '%');
             ++i);
        if (i > start) {
          /* make it TEXT */
          if (textkey >= 0) {
            numbytes = i - start + 1;
            if (lib$get_vm(&numbytes, &ptr) & 1) {
              vals[*index].ptr = ptr;
	      for (j = start; j < i; j++)
                ptr[j-start] = str.dsc$a_pointer[j];
              ptr[i - start] = '\0';
              fmt[*index] = keywords[textkey].fmt_ptr;
            }
            else {
              printf("Unable to allocate memory for text\n");
              vals[*index].ptr = 0;
            };
            (*init[keywords[textkey].ini_ptr])(keywords[textkey].ini_data,
                    jpi, syi, list, susp, index);
          };
        };
        start = i;
        if (i < str.dsc$w_length) {
          ++i; /* skip past the % */
          jst = -1; /*left*/
          if (str.dsc$a_pointer[i] == '+') {
            jst = -1; /* left */
            ++i;
          } else if (str.dsc$a_pointer[i] == '.') {
            jst = 0; /* center */
            ++i;
          }
          else if (str.dsc$a_pointer[i] == '-') {
            jst = 1; /* right */
            ++i;
          };
          /* get item width, if present */
          k = 0;
          for (j = i;
               (j < str.dsc$w_length) && isdigit(str.dsc$a_pointer[j]);
               ++j)
            buff[k++] = str.dsc$a_pointer[j];
          if (k > 0) {
            buff[k] = '\0';
            width = atoi(buff);
          }
          else
            width = 0;
          k = 0;
          for (i = j; (i < str.dsc$w_length)
               && (isalpha(str.dsc$a_pointer[i])
                   || (str.dsc$a_pointer[i] == '_')); i++)
            buff[k++] = toupper(str.dsc$a_pointer[i]);
          buff[k] = '\0';
          start = i; /* where does next thing start? */

          /* lookup keyword (in buff) */
          if (*index >= max) {
            printf("No memory left for more keywords!\n");
            printf("%.*s will not be used\n", str.dsc$w_length, buff);
            return;
          };
          keyword = search_keywords(buff);
          if (keyword < 0) {
            printf("%.*s is %s%\n", str.dsc$w_length, buff,
                   (keyword == -1)?"unknown":"ambiguous");
          }
          else {
            vals[*index].just = jst;
            vals[*index].width = width;
            fmt[*index] = keywords[keyword].fmt_ptr;
            (*init[keywords[keyword].ini_ptr])(keywords[keyword].ini_data,
                    jpi, syi, list, susp, index);
          };
        };
      };
    };
  };
}
