#include string
#include rms
#define DEFAULT "sys$system:.location"
#define FILENAME "status_terminals"

lookup_terminal(in,out,maxout)
  char in[], out[];
  int maxout; /* specifies how long 'out' is, including trailing NULL */
{
  /* this does a 'database' lookup and returns the result,
     if not found, it returns the input as the output, and
     returns a result of 0 */
  static struct FAB fab;
  static struct RAB rab;
  static struct XABKEY xab;
  int status;

  if (fab.fab$b_bid == 0) {
    /* initialize the FAB and RAB, open the file for indexed accessed */
    fab = cc$rms_fab;
    fab.fab$l_dna = DEFAULT;
    fab.fab$b_dns = sizeof DEFAULT - 1;
    fab.fab$b_fac = FAB$M_GET;
    fab.fab$l_fna = FILENAME;
    fab.fab$b_fns = sizeof FILENAME -1;
    fab.fab$b_shr = FAB$M_SHRGET;
    fab.fab$b_acmodes = 1; /* disable anything less then exec mode logicals ?? hope so */
    fab.fab$l_xab = &xab;
    xab = cc$rms_xabkey; /* find out how large the key is */
    /* note, code assumes there is ONE key, with only ONE segment, and
       that the key starts at the beginning of the record. Everything
       after the key will be returned */

    status = sys$open(&fab);
    if (! (status & 1)) {
      strncpy(out,in,maxout); /* can't open file? return the input */
      return(0);
    };

    rab = cc$rms_rab;
    rab.rab$l_fab = &fab;
    rab.rab$b_rac = RAB$C_KEY;
    rab.rab$l_rop = RAB$M_NLK; /* why lock the record? */

    status = sys$connect(&rab);
    if (! (status & 1)) {
      strncpy(out,in,maxout); /* can't connect rab? return the input */
      return(0);
    };
  }

  /* set up the key and buffer address/lengths */
  rab.rab$l_kbf = in;
  rab.rab$b_ksz = strlen(in);
  rab.rab$l_ubf = out;
  rab.rab$w_usz = maxout;

  status = sys$get(&rab);
  if (! (status & 1)) {
    strncpy(out,in,maxout); /* not found? return the input */
    return(0);
  };


  /* add a NULL to the end of the string */
  out[rab.rab$w_rsz] = '\0';

  /* okay, lets remove the key portion of the string */
  strcpy(out,&out[xab.xab$b_siz0]);

  return(1);
}
