#include <stdio.h>
#include <descrip.h>
#include <ssdef.h>

#include <syidef.h>
#include <jpidef.h>
#include "global_values.h"
#include "status.h"
#include "keywords.h"

/* taken from $pcbdef - pcb$v_phdres = 18, 1 << 18 = 262144 */
#define PCB$M_PHDRES 262144

#define MAXITEMS 200

#define SELECT 1
#define SORT 2
#define DISPLAY 3
#define HEADER 4
#define TITLE 5

main()
{
  /* declare these as static so they will be initialized to zero */
  static struct itmlst jpilst[85], syilst[306];
  static char *jpidata, *syidata;
  static char *vals[MAXITEMS];
  static int list[MAXITEMS];
  static int fmt[MAXITEMS];
  static char susp[MAXITEMS];
  /* if 0 data is always valid,
     if 1, data is valid only when proc. header is resident,
     if 2, data is invalid when process is suspended */

  int status, pid, i, j, ndx;
  int lst[6] = {0,0,0,0,0,0};
  int jbrk[6] = {0,0,0,0,0,0};
  int sbrk[6] = {0,0,0,0,0,0};
  int repeating = 0, repeated = 0, index = 0, selected, suspended;
  int jpilen = 0, syilen = 0;

  struct {
    variant_union {
      int fmtlong;
      variant_struct {
        short int just;
        short int width;
      } dummy$struct;
    } dummy$union;
  } frmt;

  char *ptr;
  char str[4096]; /* big enough buffer? */
  int sptr = 0;
        
  /* always get these items */
  jpilst[0].length = 4;
  jpilst[0].code = JPI$_PID;
  jpilst[1].length = 4;
  jpilst[1].code = JPI$_PROC_INDEX;
  jpilst[2].length = 4;
  jpilst[2].code = JPI$_MASTER_PID;
  jpilst[3].length = 4;
  jpilst[3].code = JPI$_STS;

  build_select(jpilst, syilst, list, vals, &index, fmt, susp, MAXITEMS);
  for (ndx=SORT; ndx <= TITLE; ndx++) {
    lst[ndx] = index;
    for (i=jbrk[ndx - 1]; jpilst[i].code != 0; i++); /* find last item */
    jbrk[ndx] = i;
    jpilst[i].code = -1; /* make this spot unusable */
    jpilst[i].length = 0;
    for (i=sbrk[ndx - 1]; syilst[i].code != 0; i++); /* find last item */
    sbrk[ndx] = i;
    syilst[i].code = -1; /* make this spot unusable */
    syilst[i].length = 0;

    switch (ndx) {
      case SORT:
	build_sort(jpilst, syilst, list, vals, &index, fmt, susp, MAXITEMS);
	break;
      default:
    	build_lists(ndx - 3,jpilst,syilst,list,vals,&index,fmt,susp,MAXITEMS);
        break;
    };
  };
       
  /* go through the item lists, calculate the buffer size */
  for (i=0; jpilst[i].code != 0; i++)
    jpilen += jpilst[i].length;
  lib$get_vm(&jpilen, &jpidata);
  jpilst[0].bufadr = jpidata;
  for (i=1; jpilst[i].code != 0; i++)
    jpilst[i].bufadr = jpilst[i - 1].bufadr + jpilst[i - 1].length;

  for (i=0; syilst[i].code != 0; i++)
    syilen += syilst[i].length;
  lib$get_vm(&syilen, &syidata);
  syilst[0].bufadr = syidata;
  for (i=1; syilst[i].code != 0; i++)
    syilst[i].bufadr = syilst[i - 1].bufadr + syilst[i - 1].length;

  for (i=SORT; i <= TITLE; i++) {
    jpilst[jbrk[i]++].code = 0;
    syilst[sbrk[i]++].code = 0;
  };

  /* get the title info - it may need info in earlier lists, so get all */
  for (i=SELECT; i <= TITLE; i++) {
    if (jpilst[jbrk[i]].code)
      status = sys$getjpiw(0,0,0,&jpilst[jbrk[i]],0,0,0);
    if (syilst[sbrk[i]].code)
      status = sys$getsyiw(0,0,0,&syilst[sbrk[i]],0,0,0);
  };

  /* find out if we should keep repeating */
  if (cli_present("Continuous") & 1)
    repeating = 1;

  /* display the title info */
  sptr = 0;
  for (i=lst[TITLE]; i < index; i++)
    if (fmt[i]) {
      if ((!suspended) || (susp[i] == 0)
          || ((susp[i] == 1) && (*(int *)jpilst[3].bufadr & PCB$M_PHDRES)))
        (*format[fmt[i]])(i, list, vals, &str[sptr]);
      else {
        frmt.fmtlong = vals[i];
        cvt$$format(&str[sptr],"",frmt.just,frmt.width);
      };
      j = strlen(&str[sptr]);
      sptr += j;
    };
  if (lst[TITLE] < index)
    puts(str);

  while(repeating || (! repeated)) {
    repeated = 1;

    /* get the header info (updated once each time through the cycle) */
    for (i=SELECT; i <= HEADER; i++) {
      if (jpilst[jbrk[i]].code)
        status = sys$getjpiw(0,0,0,&jpilst[jbrk[i]],0,0,0);
      if (syilst[sbrk[i]].code)
       status = sys$getsyiw(0,0,0,&syilst[sbrk[i]],0,0,0);
    };
    sptr = 0;
    for (i=lst[HEADER]; i < lst[TITLE]; i++)
      if (fmt[i]) {
        if ((!suspended) || (susp[i] == 0)
          || ((susp[i] == 1) && (*(int *)jpilst[3].bufadr & PCB$M_PHDRES)))
          (*format[fmt[i]])(i, list, vals, &str[sptr]);
        else {
          frmt.fmtlong = vals[i];
          cvt$$format(&str[sptr],"",frmt.just,frmt.width);
        };
        j = strlen(&str[sptr]);
        sptr += j;
      };
    if (lst[HEADER] < lst[TITLE])
      puts(str);

    pid = -1;
    status = sys$getjpiw(0,&pid,0,&jpilst[jbrk[SELECT]],0,0,0);
    while(status != SS$_NOMOREPROC) {
      if ((status != SS$_SUSPENDED) && (!(status & 1))) {
        printf("error in select getjpiw\n");
      } else {
        if ( (*(int *)jpilst[2].bufadr) == 0)
          selected = 0;
        else {
          if (status == SS$_SUSPENDED)
            suspended = -1;
          else
            suspended = 0;

          status = sys$getsyiw(0,0,0,&syilst[sbrk[SELECT]],0,0,0);
          /* okay, we have all the selection info */
          if (lst[SELECT] < lst[SORT])
            selected = 0; /* /SELECT present, must match something */
          else
            selected = 1;
          for (i=lst[SELECT]; (i < lst[SORT]) && (! selected); i++)
            if (fmt[i]) {
              ptr = vals[i]; vals[i] = 0;
              if ((!suspended) || (susp[i] == 0)
                  || ((susp[i] == 1) && 
                      (*(int *)jpilst[3].bufadr & PCB$M_PHDRES)))
                (*format[fmt[i]])(i, list, vals, str);
              else {
                frmt.fmtlong = vals[i];
                cvt$$format(str,"",frmt.just,frmt.width);
              };
              vals[i] = ptr;
              if (compare(str, vals[i]) == 0)
                selected = 1;
            };
        };

        if (selected) {
          /* okay, now that we've 'selected' this stuff, lets boogy */


          if (jpilst[jbrk[SORT]].code) /* if items to get, get them */
            status = sys$getjpiw(0,jpidata,0,&jpilst[jbrk[SORT]],0,0,0);
          else
            status = 1;
          if ((status != SS$_SUSPENDED) && (!(status & 1))) {
            printf("Error in sort getjpiw\n");
          }
          else {
            if (status == SS$_SUSPENDED)
              suspended = -1;
            else
              suspended = 0;

            if (syilst[jbrk[SORT]].code) /* if items to get, get them */
              status = sys$getsyiw(0,0,0,&syilst[sbrk[SORT]],0,0,0);

            for (i=lst[SORT];i < lst[DISPLAY]; i++)
              if (fmt[i]) {
                /* ptr = vals[i]; vals[i] = 0; */
                if ((!suspended) || (susp[i] == 0)
                    || ((susp[i] == 1) && 
                        (*(int *)jpilst[3].bufadr & PCB$M_PHDRES)))
                  (*format[fmt[i]])(i, list, vals, str);
                else {
                  frmt.fmtlong = vals[i];
                  cvt$$format(str,"",frmt.just,frmt.width);
                };
                /* vals[i] = ptr; */
              };
          };


          if (jpilst[jbrk[DISPLAY]].code) /* if items to get, get them */
            status = sys$getjpiw(0,jpidata,0,&jpilst[jbrk[DISPLAY]],0,0,0);
          else
            status = 1;
          if ((status != SS$_SUSPENDED) && (!(status & 1))) {
            printf("Error in display getjpiw\n");
          }
          else {
            if (status == SS$_SUSPENDED)
              suspended = -1;
            else
              suspended = 0;

            if (syilst[jbrk[DISPLAY]].code) /* if items to get, get them */
              status = sys$getsyiw(0,0,0,&syilst[sbrk[DISPLAY]],0,0,0);
            /* here we have all the data we need */
            sptr = 0;
            for (i=lst[DISPLAY]; i < lst[HEADER]; i++)
              if (fmt[i]) {
                if ((!suspended) || (susp[i] == 0)
                    || ((susp[i] == 1) &&
                        (*(int *)jpilst[3].bufadr & PCB$M_PHDRES)))
                  (*format[fmt[i]])(i, list, vals, &str[sptr]);
                else {
                  frmt.fmtlong = vals[i];
                  cvt$$format(&str[sptr],"",frmt.just,frmt.width);
                };
                j = strlen(&str[sptr]);
                sptr += j;
              };
            if (lst[DISPLAY] < lst[HEADER])
              puts(str);
          };
        };
      };
      status = sys$getjpiw(0,&pid,0,&jpilst[jbrk[SELECT]],0,0,0);
    };
  };
}
