#include stdio
#include stdlib
#include ctype
#include time

int compare();
int allocate();
void write_node();
void write_routines();

struct node {
  struct node *left;
  struct node *right;
  unsigned short int reserved;
  unsigned short int index;
  unsigned char ptr[4];
  unsigned char fill;
  unsigned char str[132];
};

#define BUFSIZ 132
int flag;
FILE *infile,*outfile;

char *month[12] = {"Jan","Feb","Mar","Apr","May","Jun",
                   "Jul","Aug","Sep","Oct","Nov","Dec"};
struct node *head_name = 0, *head_init = 0, *head_format = 0,
            *node = 0, *dummy = 0;

main()
{
  struct tm *time_struct;
  int time_val;
  unsigned char str[BUFSIZ];
  int index,nextchar;
  int zero = 0;
  int status,i;
  int lines = 0, pm = 0;

  if ((infile=fopen("KEYWORDS.DAT","r")) == NULL)
    return;

  if ((outfile=fopen("KEYWORDS.H","w")) == NULL)
    return;

  time(&time_val);
  time_struct = localtime(&time_val);

  while (fgets(str,BUFSIZ,infile)) {
    if (str[0] != '!') {
      ++lines;
      /* compress all white space out of string */
      index = 0;
      while (index<strlen(str)) {
        if (isspace(str[index])) {
          nextchar = index + 1;
          while (isspace(str[nextchar])) ++nextchar;
          str[index] = str[nextchar];
          str[nextchar] = ' ';
        };
        ++index;
      };

      /* insert this node into the 'item-name' tree */
      status = lib$insert_tree(&head_name,str,&zero,compare,allocate,&node);
      if (!(status & 1)) return(status);

      /* insert this node into the 'init-routine' tree */
      status = lib$insert_tree(&head_init,&(*node).str[node->ptr[0]],
                               &zero,compare,allocate,&dummy);
      if (!(status & 1)) return(status);

      /* insert this node into the 'format-routine' tree */
      status = lib$insert_tree(&head_format,&(*node).str[node->ptr[2]],
                               &zero,compare,allocate,&dummy);
      if (!(status & 1)) return(status);

    };
  };

  /* traverse the trees, fill in the index */
  i = 1;
  traverse_tree(head_init,&i);
  i = 1;
  traverse_tree(head_format,&i);

  if (time_struct->tm_hour > 12) {
    pm = -1;
    time_struct->tm_hour -= 12;
  };

  fprintf(outfile,"/* KEYWORDS.H Created on %d-%s-%d %d:%02d %s */\n\n",
          time_struct->tm_mday,
          month[time_struct->tm_mon],
          time_struct->tm_year,
          time_struct->tm_hour,
          time_struct->tm_min,
          pm?"pm":"am");
  fprintf(outfile,"struct ItemNode {\n");
  fprintf(outfile,"  char *name;\n");
  fprintf(outfile,"  int (*init_routine)();\n");
  fprintf(outfile,"  int ini_data;\n");
  fprintf(outfile,"  int (*frmt_routine)();\n");
  fprintf(outfile,"  unsigned short int clearance;\n");
  fprintf(outfile,"};\n");
  fprintf(outfile,"\n");
  fprintf(outfile,"#ifdef GLOBAL\n");
  fprintf(outfile,"int /* declare all initialization routines */\n");
  flag = 1;
  write_routines(head_init,1);
  fprintf(outfile,";\n");
  fprintf(outfile,"int /* declare all formatting routines */\n");
  flag = 1;
  write_routines(head_format,1);
  fprintf(outfile,",\n  format_literal();");
  fprintf(outfile,";\n");
  fprintf(outfile,"globaldef int max_keywords = %d;\n",lines);
  fprintf(outfile,"\n");
  fprintf(outfile,"globaldef struct ItemNode keywords[] = {\n");
  write_node(head_name);
  fprintf(outfile,"    {\"\", 0, 0, format_literal}");
  fprintf(outfile,"  };\n");
  fprintf(outfile,"\n");
  fprintf(outfile,"#else\n");
  fprintf(outfile,"globalref struct ItemNode keywords[];\n");
  fprintf(outfile,"globalref int max_keywords;\n");
  fprintf(outfile,"#endif\n");
  fclose(outfile);
}

void write_node(node)
  struct node *node;
{
  static int index = 0;

  if (node->left)
    write_node(node->left);

  fprintf(outfile,"    {\"%s\", ",node->str);
  dummy = lookup(&(*node).str[node->ptr[0]], head_init);
  fprintf(outfile,"%s, ",dummy->str);
  fprintf(outfile,"%s, ",&(*node).str[node->ptr[1]]);
  dummy = lookup(&(*node).str[node->ptr[2]], head_format);
  fprintf(outfile,"%s, ",dummy->str);
  fprintf(outfile,"%s},\n",&(*node).str[node->ptr[3]]);

  if (node->right)
    write_node(node->right);
}

compare(symstr,node,dummy)
  unsigned char *symstr;
  struct node *node;
  unsigned int dummy;
{
  short int cmp;

  cmp = strcmp(symstr, node->str);
  if (cmp > 0) cmp = 1;
  if (cmp < 0) cmp = -1;
  return(cmp);
}

allocate(symstr,node,dummy)
  unsigned char *symstr;
  struct node **node;
  unsigned int dummy;
{
  static int numbytes = sizeof(struct node);
  int i, j = 0;
  int status;

  /* allocate the node */
  status = lib$get_vm(&numbytes, node);
  if (!(status & 1)) return(status);

  /* symstr is a BUFSIZ character string, with commas in it */
  /* symstr actually should be 5 strings in 1, to get this */
  /* effect, we replace all the commas with \0, and store the */
  /* offset in the node.ptr[] array.. There should be 4 commas */
  for (i = 0; i < strlen(symstr); i++)
    if (symstr[i] == ',') {
      (*node)->str[i] = '\0';
      if (j < 4) /* ignore extra commas */
        (*node)->ptr[j++] = i+1;
    }
    else
      (*node)->str[i] = symstr[i];
  return(1);
}

traverse_tree(node,indexval)
  struct node *node;
  int *indexval;
{
  if (node->left)
    traverse_tree(node->left, indexval);

  node->index = *indexval;
  *indexval += 1;

  if (node->right)
    traverse_tree(node->right, indexval);
}

lookup(key,node)
  char *key;
  struct node *node;
{
  int compare;

  if (node == 0)
    return(0);

  compare = strncmp(key, (*node).str, strlen(key));
  if (compare < 0)
    return(lookup(key,node->left));
  else if (compare > 0)
    return(lookup(key,node->right));
  else
    return(node);
}
void write_routines(node,zart)
  struct node *node;
  int zart;
{
  if (node->left)
    write_routines(node->left,zart);

  if (flag) {
    fprintf(outfile,"  %s%s",node->str,zart?"()":"");
    flag = 0;
  }
  else
    fprintf(outfile,",\n  %s%s",node->str,zart?"()":"");

  if (node->right)
    write_routines(node->right,zart);
}
