/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:45:49 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFFL.S */
#ifndef $JPIDEF_H
#define $JPIDEF_H
 
/*** MODULE $JPIDEF ***/
/*+                                                                           */
/*                                                                            */
/* Get Job Process Information Data Identifier Definitions                    */
/*                                                                            */
/* **** NOTE ****                                                             */
/*                                                                            */
/*        New items must always be added to the END of each item list         */
/*        (preceeding the ENDlistname item) so that users will not have       */
/*        to relink.                                                          */
/*-                                                                           */
/* DEFINE TABLE NUMBERS                                                       */
/* STRUCTURE CODES MUST START AT 1                                            */
#define JPI$C_ADRTYPE 1 /* ITEM IS ADDRESS OF DATA                            */
#define JPI$C_CTLTYPE 2 /* ITEM IS IN CONTROL REGION                          */
#define JPI$C_PCBTYPE 3 /* ITEM IN PCB                                        */
#define JPI$C_PHDTYPE 4 /* ITEM IN PHD                                        */
#define JPI$C_PCBFLDTYPE 5      /* ITEM IS BIT FIELD                          */
#define JPI$C_PHDFLDTYPE 6      /* ITEM IS BIT FIELD                          */
#define JPI$C_JIBTYPE 7 /* ITEM IN JIB (SUBTYPE)                              */
#define JPI$C_MAXSTRUC 6        /* TOTAL OF 6 TABLES                          */
#define JPI$C_LISTEND 0 /* DEFINE ITMLST TERMINATOR                           */
#define JPI$_CHAIN -1   /* CHAIN INDICATOR                                    */
/*                                                                            */
/* NOTE!! The following constants match values in $JIBDEF.                    */
/*                                                                            */
#define JPI$K_OTHER 0   /* JPI$_Mode values                                   */
#define JPI$K_NETWORK 1 /* JPI$_Mode values                                   */
#define JPI$K_BATCH 2   /* JPI$_Mode values                                   */
#define JPI$K_INTERACTIVE 3     /* JPI$_Mode values                           */
#define JPI$K_DETACHED 0        /* JPI$_JOBTYPE values                        */
#define JPI$K_LOCAL 3   /* JPI$_JOBTYPE values                                */
#define JPI$K_DIALUP 4  /* JPI$_JOBTYPE values                                */
#define JPI$K_REMOTE 5  /* JPI$_JOBTYPE values                                */
/* (also BATCH & INTERACTIVE)                                                 */
/* ITEM IDENTIFIERS FOR PCB                                                   */
#define JPI$_ASTACT 768 /* ACCESS MODES WITH ACTIVE ASTS                      */
#define JPI$_ASTEN 769  /* ACCESS MODES WITH ASTS ENABLED                     */
#define JPI$_PRI 770    /* CURRENT PROCESS PRIORITY                           */
#define JPI$_OWNER 771  /* PID OF CREATOR PROCESS                             */
#define JPI$_UIC 772    /* UIC OF PROCESS                                     */
#define JPI$_STS 773    /* PROCESS STATUS                                     */
#define JPI$_STATE 774  /* PROCESS STATE                                      */
#define JPI$_MEM 775    /* MEMBER FIELD OF UIC                                */
#define JPI$_GRP 776    /* GROUP FIELD OF UIC                                 */
#define JPI$_PRIB 777   /* PROCESS BASE PRIORITY                              */
#define JPI$_APTCNT 778 /* ACTIVE PAGE TABLE COUNT                            */
#define JPI$_TMBU 779   /* TERMINATION MAILBOX UNIT                           */
#define JPI$_GPGCNT 780 /* GLOBAL PAGE COUNT IN WORKING SET                   */
#define JPI$_PPGCNT 781 /* PROCESS PAGE COUNT IN WORKING SET                  */
#define JPI$_ASTCNT 782 /* AST COUNT REMAINING                                */
#define JPI$_BIOCNT 783 /* BUFFERED I/O COUNT REMAINING                       */
#define JPI$_BIOLM 784  /* BUFFERED I/O LIMIT                                 */
#define JPI$_BYTCNT 785 /* BYTE COUNT REMAINING FOR BUFFERED I/O              */
#define JPI$_DIOCNT 786 /* DIRECT I/O COUNT REMAINING                         */
#define JPI$_DIOLM 787  /* DIRECT I/O COUNT LIMIT                             */
#define JPI$_FILCNT 788 /* COUNT REMAINING OF OPEN FILES                      */
#define JPI$_TQCNT 789  /* COUNT REMAINING OF TIMER QUEUE ENTRIES             */
#define JPI$_EFWM 790   /* EVENT FLAG WAIT MASK                               */
#define JPI$_EFCS 791   /* LOCAL EVENT FLAGS 0-31                             */
#define JPI$_EFCU 792   /* LOCAL EVENT FLAGS 32-63                            */
#define JPI$_PID 793    /* PROCESS IDENTIFICATION                             */
#define JPI$_BYTLM 794  /* BUFFERED I/0 BYTE COUNT LIMIT                      */
#define JPI$_PRCCNT 795 /* SUBPROCESS COUNT                                   */
#define JPI$_PRCNAM 796 /* PROCESS NAME                                       */
#define JPI$_TERMINAL 797       /* LOGIN TERMINAL NAME                        */
#define JPI$_JOBPRCCNT 798      /* TOTAL COUNT OF SUBPROCESSES IN A JOB       */
#define JPI$_ENQCNT 799 /* ENQUEUE COUNT REMAINING                            */
#define JPI$_ENQLM 800  /* ENQUEUE COUNT LIMIT                                */
#define JPI$_SWPFILLOC 801      /* SWAP FILE BACKING STORE ADDRESS            */
#define JPI$_MODE 802   /* MODE VALUE (FROM STS) - DEFINED ABOVE              */
#define JPI$_JOBTYPE 803        /* JOB TYPE CODE                              */
#define JPI$_PROC_INDEX 804     /* PROCESS INDEX                              */
#define JPI$_MASTER_PID 805     /* MASTER PROCESS PID                         */
/* ADD ITEM-CODES BEFORE THIS COMMENT                                         */
#define JPI$_LASTPCB 806        /* MAX INDEX IN PCB TABLE                     */
/* ITEM IDENTIFIERS FOR PHD                                                   */
#define JPI$_CURPRIV 1024       /* CURRENT PROCESS PRIVILEGE MASK             */
#define JPI$_WSAUTH 1025        /* AUTHORIZED WORKING SET SIZE                */
#define JPI$_WSQUOTA 1026       /* QUOTA ON WORKING SET SIZE                  */
#define JPI$_DFWSCNT 1027       /* DEFAULT WORKING SET SIZE                   */
#define JPI$_FREP0VA 1028       /* FIRST FREE VIRTUAL ADDR. AT END OF P0 SPACE        */
#define JPI$_FREP1VA 1029       /* FIRST FREE ADDR. AT END OF P1 SPACE        */
#define JPI$_DFPFC 1030 /* DEFAULT PAGE FAULT CLUSTER                         */
#define JPI$_CPUTIM 1031        /* ACCUMULATED CPU TIME                       */
#define JPI$_PRCLM 1032 /* SUBPROCESS QUOTA                                   */
#define JPI$_ASTLM 1033 /* AST LIMIT                                          */
#define JPI$_PAGEFLTS 1034      /* COUNT OF PAGE FAULTS                       */
#define JPI$_DIRIO 1035 /* PROCESS DIRECT I/O OPERATIONS                      */
#define JPI$_BUFIO 1036 /* PROCESS BUFFERED I/O OPERATIONS                    */
#define JPI$_CPULIM 1037        /* LIMIT ON CPUTIM FOR PROCESS                */
#define JPI$_PGFLQUOTA 1038     /* MAX. VIRTUAL PAGE COUNT                    */
#define JPI$_FILLM 1039 /* OPEN FILE LIMIT                                    */
#define JPI$_TQLM 1040  /* TIMER QUEUE LIMIT                                  */
#define JPI$_WSSIZE 1041        /* CURRENT WORKING SET SIZE                   */
#define JPI$_AUTHPRIV 1042      /* AUTHORIZED PRIVILEGE MASK                  */
#define JPI$_IMAGPRIV 1043      /* INSTALLED IMAGE PRIVILEGE MASK             */
#define JPI$_PAGFILCNT 1044     /* PAGES CHARGED TO PAGE FILE QUOTA           */
#define JPI$_FREPTECNT 1045     /* ROOM FOR EXPANSION OF P0 OR P1 SPACE       */
#define JPI$_WSEXTENT 1046      /* EXTENT OF WORKING SET SIZE                 */
#define JPI$_WSAUTHEXT 1047     /* MAX EXTENT OF WORKING SET SIZE             */
#define JPI$_AUTHPRI 1048       /* AUTHORIZED PRIORITY FOR $SETPRI            */
#define JPI$_PAGFILLOC 1049     /* PAGE FILE BACKING STORE ADDRESS            */
#define JPI$_IMAGECOUNT 1050    /* IMAGE COUNTER (CLOCKED BY RUNDOWN)         */
#define JPI$_PHDFLAGS 1051      /* PROCESS HEADER FLAGS WORD                  */
/* ADD ITEM-CODES BEFORE THIS COMMENT                                         */
#define JPI$_LASTPHD 1052       /* MAX INDEX IN PROCESS HEADER                */
/* ITEM IDENTIFIERS FOR CONTROL REGION                                        */
#define JPI$_VIRTPEAK 512       /* PEAK VIRTUAL SIZE                          */
#define JPI$_WSPEAK 513 /* PEAK WORKING SET SIZE                              */
#define JPI$_USERNAME 514       /* USERNAME STRING                            */
#define JPI$_ACCOUNT 515        /* ACCOUNT NAME STRING                        */
#define JPI$_PROCPRIV 516       /* PROCESS PRIVILEGE MASK                     */
#define JPI$_VOLUMES 517        /* VOLUMES MOUNTED                            */
#define JPI$_LOGINTIM 518       /* TIME OF LOGIN OR PROCESS CREATION          */
#define JPI$_IMAGNAME 519       /* CURRENT IMAGE FILE NAME                    */
#define JPI$_SITESPEC 520       /* PER-PROCESS SITE-SPECIFIC CELL             */
#define JPI$_MSGMASK 521        /* PROCESS DEFAULT MESSAGE FLAGS              */
#define JPI$_CLINAME 522        /* COMMAND LANGUAGE INTERPRETER NAME          */
#define JPI$_TABLENAME 523      /* COMMAND LANGUAGE INTERPRETER TABLE NAME    */
#define JPI$_CREPRC_FLAGS 524   /* $CREPRC FLAGS USED TO CREATE THIS PROCESS  */
#define JPI$_UAF_FLAGS 525      /* FLAGS FROM UAF RECORD                      */
#define JPI$_MAXDETACH 526      /* MAXIMUM DETACHED PROCESSES FOR SINGLE USER */
#define JPI$_MAXJOBS 527        /* MAXIMUM ACTIVE PROCESSES FOR SINGLE USER   */
#define JPI$_SHRFILLM 528       /* MAXIMUM OPEN SHARED FILES                  */
/* ADD ITEM-CODES BEFORE THIS COMMENT                                         */
#define JPI$_LASTCTL 529        /* MAX INDEX IN CONTROL REGION                */
/* ITEM IDENTIFIERS FOR ADDRESS DATA                                          */
#define JPI$_EXCVEC 256 /* ADDRESS OF "EXCEPTION VECTOR" VECTOR               */
#define JPI$_FINALEXC 257       /* ADDRESS OF LAST CHANCE EXCEPTION VECTORS   */
/* ADD ITEM-CODES BEFORE THIS COMMENT                                         */
#define JPI$_LASTADR 258        /* MAX INDEX IN ADDRESS TABLE                 */
/* ITEM IDENTIFIERS FOR PCBFLD                                                */
/* ADD ITEM-CODES BEFORE THIS COMMENT                                         */
#define JPI$_LASTPCBFLD 1280    /* MAX INDEX IN PCBFLD TABLE                  */
/* ITEM IDENTIFIERS FOR PHDFLD                                                */
/* ADD ITEM-CODES BEFORE THIS COMMENT                                         */
#define JPI$_LASTPHDFLD 1536    /* MAX INDEX IN PHDFLD TABLE                  */
#endif
