/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:47:35 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFQZ.S */
#ifndef $SECDEF_H
#define $SECDEF_H
 
/*** MODULE $SECDEF ***/
/*+                                                                           */
/* PROCESS OR GLOBAL SECTION DEFINITIONS                                      */
/*-                                                                           */
/*                                                                            */
/* ***** L_VBN, L_WINDOW, AND B_PFC MUST BE THE SAME OFFSET VALUES AS THE     */
/* ***** EQUIVALENTLY NAMED OFFSETS IN $PFLDEF                                */
/*                                                                            */
#define SEC$M_GBL 0x00000001
#define SEC$M_CRF 0x00000002
#define SEC$M_DZRO 0x00000004
#define SEC$M_WRT 0x00000008
#define SEC$M_SHMGS 0x00000010
#define SEC$M_WRTMOD 0x000000C0
#define SEC$M_AMOD 0x00000300
#define SEC$M_RESIDENT 0x00002000
#define SEC$M_PERM 0x00004000
#define SEC$M_SYSGBL 0x00008000
#define SEC$M_PFNMAP 0x00010000
#define SEC$M_EXPREG 0x00020000
#define SEC$M_PROTECT 0x00040000
#define SEC$M_PAGFIL 0x00080000
#define SEC$M_EXECUTE 0x00100000
struct secdef {
    union {
        unsigned long int sec$l_gsd;    /*GLOBAL SECTION DESCRIPTOR ADDRESS   */
        unsigned long int sec$l_ccb;    /*CHANNEL CONTROL BLOCK ADDRESS IF PROCESS SECTION    */
        } sec$r_gsd_overlay;
    unsigned short int sec$w_secxfl;    /*SECTION INDEX FORWARD LINK          */
    unsigned short int sec$w_secxbl;    /*SECTION INDEX BACKWARD LINK         */
    union {
        unsigned long int sec$l_vpxpfc; /*START VIRT PAGE INDEX & PFC         */
        struct {
            unsigned sec$v_vpx : 22;    /* STARTING VIRTUAL PAGE INDEX        */
            unsigned secdef$$_fill_1 : 2;       /* UNUSED                     */
            unsigned sec$v_pfc : 8;     /* PAGE FAULT CLUSTER                 */
            } sec$r_vpxpfc_bits;
        struct {
            char secdef$$_fill_5 [3];
            unsigned char sec$b_pfc;    /*PAGE FAULT CLUSTER                  */
            } sec$r_vpxpfc_fields;
        } sec$r_vpxpfc_overlay;
    unsigned long int sec$l_window;     /*WINDOW CONTROL BLOCK                */
    unsigned long int sec$l_vbn;        /*BASE VIRTUAL BLOCK NUMBER           */
    union {
        unsigned short int sec$w_flags; /*VARIOUS CONTROL FLAGS               */
        struct {
            unsigned sec$v_gbl : 1;     /* GLOBAL SECTION                     */
            unsigned sec$v_crf : 1;     /* COPY ON REFERENCE                  */
            unsigned sec$v_dzro : 1;    /* DEMAND ZERO                        */
            unsigned sec$v_wrt : 1;     /* WRITABLE                           */
            unsigned sec$v_shmgs : 1;   /* SHARED MEMORY GLOBAL SECTION       */
            unsigned secdef$$_fill_2 : 1;       /* SPARE                      */
            unsigned sec$v_wrtmod : 2;  /* WRITE ACCESS MODE FOR SECTION      */
            unsigned sec$v_amod : 2;    /* ACCESS MODE OF SECTION             */
            unsigned secdef$$_fill_3 : 3;       /* SPARE                      */
            unsigned sec$v_resident : 1;        /* RESIDENT GLOBAL            */
            unsigned sec$v_perm : 1;    /* PERMANENT SECTION                  */
            unsigned sec$v_sysgbl : 1;  /* 1 = SYSTEM GLOBAL, 0 = GROUP GLOBAL        */
/*                                                                            */
/* *****  THE FOLLOWING FLAGS ARE INDICATORS FOR $MGBLSC AND $CRMPSC SYSTEM   */
/* *****  SERVICE REQUESTS AND ARE NOT STORED IN THE FLAGS WORD FIELD.        */
/*                                                                            */
            unsigned sec$v_pfnmap : 1;  /* MAP TO SPECIFIC PFN'S              */
            unsigned sec$v_expreg : 1;  /* MAP INTO FIRST FREE ADDRESS SPACE  */
            unsigned sec$v_protect : 1; /* CHECK WRITE ACCESS MODE (WRTMOD)   */
            unsigned sec$v_pagfil : 1;  /* GLOBAL SECTION HAS PAGE FILE BACKING STORE */
            unsigned sec$v_execute : 1; /* CHECK FOR EXECUTE ACCESS           */
            unsigned sec$v_fill_0 : 3;
            } sec$r_flags_bits;
        } sec$r_flags_overlay;
} ;
#define SEC$K_LENGTH 32 /*SIZE OF PSTE/GSTE                                   */
#define SEC$C_LENGTH 32 /*SIZE OF PSTE/GSTE                                   */
/*+                                                                           */
#define SEC$K_MATALL 0  /* MATCH ALWAYS, USE GLOBAL SECTION                   */
#define SEC$K_MATEQU 1  /* MATCH IF ISD$L_IDENT EQU GBL ID                    */
#define SEC$K_MATLEQ 2  /* MATCH IF ISD$L_IDENT LEQ GBL ID                    */
struct secdef1 {
    char secdef$$_fill_6 [21];
    unsigned char sec$b_amod;   /*ACCESS MODE OF SECTION                      */
    short int secdef$$_fill_4;  /*SPARE                                       */
    unsigned long int sec$l_refcnt;     /*COUNT OF PTE'S REFERENCING THIS SECTION     */
    unsigned long int sec$l_pagcnt;     /*NO. OF PAGES IN THE SECTION         */
/*                                                                            */
/* ***** NOTE THAT NUMBER OF LONG WORDS MUST BE EVEN                          */
/*                                                                            */
/* MATCH CONTROL VIELD VALUES                                                 */
/*-                                                                           */
/* BASE OF ZERO , INCR 1                                                      */
} ;
#endif
