/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:34:47 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFFL.S */
#ifndef $LKIDEF_H
#define $LKIDEF_H
 
/*** MODULE $LKIDEF ***/
/*+                                                                           */
/*                                                                            */
/* Get Lock Information Data Identifier Definitions                           */
/*                                                                            */
/* **** NOTE ****                                                             */
/*                                                                            */
/*        New items must always be added to the END of each item list         */
/*        (preceeding the ENDlistname item) so that users will not have       */
/*        to relink.                                                          */
/*-                                                                           */
/* ITEM LIST BLOCKS                                                           */
#define LKI$K_LENGTH 24 /*LENGTH OF LIST BLOCK                                */
#define LKI$C_LENGTH 24 /*LENGTH OF LIST BLOCK                                */
struct lkidef {
    union {
        unsigned long int lki$l_mstlkid;        /*LOCK ID ON MASTER           */
        unsigned long int lki$l_lockid; /*OLD SYMBOL                          */
        } lki$r_u1;
    unsigned long int lki$l_pid;        /*PROCESS ID                          */
    union {
        unsigned long int lki$l_mstcsid;        /*CSID OF MASTER              */
        unsigned long int lki$l_sysid;  /*OLD SYMBOL                          */
        } lki$r_u2;
    unsigned char lki$b_rqmode; /*REQUEST MODE                                */
    unsigned char lki$b_grmode; /*GRANTED MODE                                */
    char lki$b_queue;   /*LOCK QUEUE                                          */
    char lki$$$_spare;  /*SPARE BYTE                                          */
    union {
        unsigned long int lki$l_lkid;   /*LOCK ID ON PROCESS NODE             */
        unsigned long int lki$l_remlkid;        /*OLD SYMBOL                  */
        } lki$r_u3;
    union {
        unsigned long int lki$l_csid;   /*CSID OF PROCESS NODE                */
        unsigned long int lki$l_remsysid;       /*OLD SYMBOL                  */
        } lki$r_u4;
} ;
/* DEFINE NAMSPACE FIELDS                                                     */
#define LKI$M_SYSNAM 0x80000000
struct namspace {
    union {
        struct {
            unsigned short int lki$w_group;     /*GROUP OF OWNER UIC          */
            unsigned char lki$b_rmod;   /*ACCESS MODE OF REQUEST              */
            unsigned char lki$b_status; /*STATUS OF RESOURCE                  */
            } lki$r_namspace_fields;
        struct {
            unsigned lki$$_fill : 31;   /* SPARE                              */
            unsigned lki$v_sysnam : 1;  /* SYSTEM WIDE RSB                    */
            } lki$r_status_bits;
        } lki$r_namspace_union;
} ;
/* DEFINE STATE FIELDS                                                        */
struct statef {
    unsigned char lki$b_state_rqmode;   /*REQUEST MODE                        */
    unsigned char lki$b_state_grmode;   /*GRANTED MODE                        */
    char lki$b_state_queue;     /*LOCK STATE CODE                             */
} ;
/*LOCK STATE CODE VALUES                                                      */
#define LKI$C_GRANTED 1 /* GRANTED                                            */
#define LKI$C_CONVERT 0 /* CONVERSION                                         */
#define LKI$C_WAITING -1        /* WAITING                                    */
#define LKI$C_RETRY -2  /* RETRY REQUEST                                      */
#define LKI$C_SCSWAIT -3        /* SCS WAIT                                   */
#define LKI$C_RSPNOTQED -4      /* RESPONSE NOT QUEUED                        */
#define LKI$C_RSPQUEUED -5      /* RESPONSE QUEUED                            */
#define LKI$C_RSPGRANTD -6      /* RESPONSE GRANTED                           */
#define LKI$C_RSPDOLOCL -7      /* RESPONSE DO LOCALLY                        */
#define LKI$C_RSPRESEND -8      /* RESPONSE RESEND                            */
/* DEFINE TABLE NUMBERS                                                       */
/* STRUCTURE CODES MUST START AT 1                                            */
#define LKI$C_LKBTYPE 1 /* ITEM IN LKB                                        */
#define LKI$C_RSBTYPE 2 /* ITEM IN RSB                                        */
#define LKI$C_LISTEND 0 /* DEFINE ITMLST TERMINATOR                           */
/* ITEM IDENTIFIERS FOR LKB                                                   */
#define LKI$_PID 256    /* PROCESS ID                                         */
#define LKI$_STATE 257  /* CURRENT LOCK STATE                                 */
#define LKI$_PARENT 258 /* ID OF PARENT LOCK                                  */
#define LKI$_LCKREFCNT 259      /* SUB-LOCK REFERENCE COUNT                   */
#define LKI$_LOCKID 260 /* LOCK ID                                            */
#define LKI$_REMLKID 261        /* REMOTE LOCK ID                             */
#define LKI$_MSTLKID 262        /* LOCK ID ON RESOURCE MASTER                 */
#define LKI$_LKID 263   /* LOCK ID ON PROCESS NODE                            */
#define LKI$_CSID 264   /* CSID OF PROCESS NODE                               */
#define LKI$_LASTLKB 265        /* MAX INDEX IN LKB TABLE                     */
/* ITEM IDENTIFIERS FOR RSB                                                   */
#define LKI$_NAMSPACE 512       /* RESOURCE NAME SPACE                        */
#define LKI$_RESNAM 513 /* RESOURCE NAME                                      */
#define LKI$_RSBREFCNT 514      /* SUB-RESOURCE REFERENCE COUNT               */
#define LKI$_VALBLK 515 /* VALUE BLOCK                                        */
#define LKI$_SYSTEM 516 /* SYSTEM ID OF SYSTEM WITH RESOURCE                  */
#define LKI$_LCKCOUNT 517       /* COUNT OF LOCKS ON RESOURCE                 */
#define LKI$_BLOCKEDBY 518      /* LIST OF LOCKS BLOCKED BY CURRENT LOCK      */
#define LKI$_BLOCKING 519       /* LIST OF LOCKS BLOCKING CURRENT LOCK        */
#define LKI$_LOCKS 520  /* LIST OF ALL LOCKS ON RESOURCE                      */
#define LKI$_CVTCOUNT 521       /* COUNT OF LOCKS ON CONVERSION QUEUE         */
#define LKI$_WAITCOUNT 522      /* COUNT OF LOCKS ON WAIT QUEUE               */
#define LKI$_GRANTCOUNT 523     /* COUNT OF LOCKS ON GRANT QUEUE              */
#define LKI$_MSTCSID 524        /* CSID OF RESOURCE MASTER                    */
#define LKI$_LASTRSB 525        /* MAX INDEX IN RSB                           */
#endif
