/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:36:21 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFMP.S */
#ifndef $NSARECDEF_H
#define $NSARECDEF_H
 
/*** MODULE $NSARECDEF ***/
/*+                                                                           */
/* Security Auditing record definitions                                       */
/*-                                                                           */
#define NSA$C_REC_MAXLENGTH 1024        /* Maximum record size                */
#define NSA$K_REC_MAXLENGTH 1024        /* Maximum record size                */
#define NSA$S_REC_MAXLENGTH 1024        /* Maximum record size                */
/*+                                                                           */
/* Audit record type definitions                                              */
/*-                                                                           */
#define NSA$K_RECTYP_FIL 1      /* File access                                */
#define NSA$K_RECTYP_SYSUAF 2   /* System UAF                                 */
#define NSA$K_RECTYP_NETUAF 3   /* Network UAF                                */
#define NSA$K_RECTYP_LOGB 4     /* Login breakin detection                    */
#define NSA$K_RECTYP_LOGI 5     /* Successful login                           */
#define NSA$K_RECTYP_LOGF 6     /* Login failure                              */
#define NSA$K_RECTYP_LOGO 7     /* Logout                                     */
#define NSA$K_RECTYP_VOL 8      /* Volume operations                          */
#define NSA$K_RECTYP_GBL 9      /* Global section access                      */
#define NSA$K_RECTYP_INSTAL 10  /* INSTALL operations                         */
#define NSA$K_RECTYP_RIGHTS 11  /* Rights database operations                 */
#define NSA$K_RECTYP_AUDIT 12   /* SET AUDIT operations                       */
#define NSA$K_RECTYPNUM 12
/*+                                                                           */
/* Audit record subtype and ID definitions                                    */
/*-                                                                           */
/* File access                                                                */
#define NSA$K_RECTYP_FIL_SUCC 1 /* Successful file access                     */
#define NSA$K_RECTYP_FIL_FAIL 2 /* File access failure                        */
#define NSA$K_RECTYPNUM_FIL 2
#define NSA$K_RECID_FIL_SUCC 65537
#define NSA$K_RECID_FIL_FAIL 131073
/* Global section access                                                      */
#define NSA$K_RECTYP_GBL_SUCC 1 /* Successful Global section access           */
#define NSA$K_RECTYP_GBL_FAIL 2 /* Global section access failure              */
#define NSA$K_RECTYPNUM_GBL 2
#define NSA$K_RECID_GBL_SUCC 65545
#define NSA$K_RECID_GBL_FAIL 131081
/* System UAF                                                                 */
#define NSA$K_RECTYP_SYSUAF_ADD 1       /* System UAF record addition         */
#define NSA$K_RECTYP_SYSUAF_DEL 2       /* System UAF record deletion         */
#define NSA$K_RECTYP_SYSUAF_MOD 3       /* System UAF record modification     */
#define NSA$K_RECTYP_SYSUAF_COP 4       /* System UAF record copied           */
#define NSA$K_RECTYP_SYSUAF_REN 5       /* System UAF record renamed          */
#define NSA$K_RECTYPNUM_SYSUAF 5
#define NSA$K_RECID_SYSUAF_ADD 65538
#define NSA$K_RECID_SYSUAF_DEL 131074
#define NSA$K_RECID_SYSUAF_MOD 196610
#define NSA$K_RECID_SYSUAF_COP 262146
#define NSA$K_RECID_SYSUAF_REN 327682
/* Network UAF                                                                */
#define NSA$K_RECTYP_NETUAF_ADD 1       /* Network UAF record addition        */
#define NSA$K_RECTYP_NETUAF_DEL 2       /* Network UAF record deletion        */
#define NSA$K_RECTYP_NETUAF_MOD 3       /* Network UAF record modification    */
#define NSA$K_RECTYPNUM_NETUAF 3
#define NSA$K_RECID_NETUAF_ADD 65539
#define NSA$K_RECID_NETUAF_DEL 131075
#define NSA$K_RECID_NETUAF_MOD 196611
/* Login breakin detection                                                    */
#define NSA$K_RECTYP_LOGB_DIA 1 /* Dialup interactive breakin detection       */
#define NSA$K_RECTYP_LOGB_LOC 2 /* Local interactive breakin detection        */
#define NSA$K_RECTYP_LOGB_REM 3 /* Remote interactive breakin detection       */
#define NSA$K_RECTYP_LOGB_NET 4 /* Network breakin detection                  */
#define NSA$K_RECTYP_LOGB_DET 5 /* Detached process breakin detection         */
#define NSA$K_RECTYPNUM_LOGB 5
#define NSA$K_RECID_LOGB_DIA 65540
#define NSA$K_RECID_LOGB_LOC 131076
#define NSA$K_RECID_LOGB_REM 196612
#define NSA$K_RECID_LOGB_NET 262148
#define NSA$K_RECID_LOGB_DET 327684
/* Successful login                                                           */
#define NSA$K_RECTYP_LOGI_BAT 1 /* Batch process login                        */
#define NSA$K_RECTYP_LOGI_DIA 2 /* Dialup interactive login                   */
#define NSA$K_RECTYP_LOGI_LOC 3 /* Local interactive login                    */
#define NSA$K_RECTYP_LOGI_REM 4 /* Remote interactive login                   */
#define NSA$K_RECTYP_LOGI_NET 5 /* Network login                              */
#define NSA$K_RECTYP_LOGI_SUB 6 /* Subprocess login                           */
#define NSA$K_RECTYP_LOGI_DET 7 /* Detached process login                     */
#define NSA$K_RECTYPNUM_LOGI 7
#define NSA$K_RECID_LOGI_BAT 65541
#define NSA$K_RECID_LOGI_DIA 131077
#define NSA$K_RECID_LOGI_LOC 196613
#define NSA$K_RECID_LOGI_REM 262149
#define NSA$K_RECID_LOGI_NET 327685
#define NSA$K_RECID_LOGI_SUB 393221
#define NSA$K_RECID_LOGI_DET 458757
/* Login failure                                                              */
#define NSA$K_RECTYP_LOGF_BAT 1 /* Batch process login failure                */
#define NSA$K_RECTYP_LOGF_DIA 2 /* Dialup interactive login failure           */
#define NSA$K_RECTYP_LOGF_LOC 3 /* Local interactive login failure            */
#define NSA$K_RECTYP_LOGF_REM 4 /* Remote interactive login failure           */
#define NSA$K_RECTYP_LOGF_NET 5 /* Network login failure                      */
#define NSA$K_RECTYP_LOGF_SUB 6 /* Subprocess login failure                   */
#define NSA$K_RECTYP_LOGF_DET 7 /* Detached process login failure             */
#define NSA$K_RECTYPNUM_LOGF 7
#define NSA$K_RECID_LOGF_BAT 65542
#define NSA$K_RECID_LOGF_DIA 131078
#define NSA$K_RECID_LOGF_LOC 196614
#define NSA$K_RECID_LOGF_REM 262150
#define NSA$K_RECID_LOGF_NET 327686
#define NSA$K_RECID_LOGF_SUB 393222
#define NSA$K_RECID_LOGF_DET 458758
/* Logout                                                                     */
#define NSA$K_RECTYP_LOGO_BAT 1 /* Batch process logout                       */
#define NSA$K_RECTYP_LOGO_DIA 2 /* Dialup interactive logout                  */
#define NSA$K_RECTYP_LOGO_LOC 3 /* Local interactive logout                   */
#define NSA$K_RECTYP_LOGO_REM 4 /* Remote interactive logout                  */
#define NSA$K_RECTYP_LOGO_NET 5 /* Network logout                             */
#define NSA$K_RECTYP_LOGO_SUB 6 /* Subprocess logout                          */
#define NSA$K_RECTYP_LOGO_DET 7 /* Detached process logout                    */
#define NSA$K_RECTYPNUM_LOGO 7
#define NSA$K_RECID_LOGO_BAT 65543
#define NSA$K_RECID_LOGO_DIA 131079
#define NSA$K_RECID_LOGO_LOC 196615
#define NSA$K_RECID_LOGO_REM 262151
#define NSA$K_RECID_LOGO_NET 327687
#define NSA$K_RECID_LOGO_SUB 393223
#define NSA$K_RECID_LOGO_DET 458759
/* Volume operations                                                          */
#define NSA$K_RECTYP_VOL_MOU 1  /* Volume mounts                              */
#define NSA$K_RECTYP_VOL_DMOU 2 /* Volume dismounts                           */
#define NSA$K_RECTYPNUM_VOL 2
#define NSA$K_RECID_VOL_MOU 65544
#define NSA$K_RECID_VOL_DMOU 131080
/* INSTALL operations                                                         */
#define NSA$K_RECTYP_INSTAL_ADD 1       /* Add known file                     */
#define NSA$K_RECTYP_INSTAL_REM 2       /* Remove known file                  */
#define NSA$K_RECTYPNUM_INSTAL 2
/* Rights database operations                                                 */
#define NSA$K_RECTYP_RIGHTS_CRE 1       /* Create rights database             */
#define NSA$K_RECTYP_RIGHTS_ADD 2       /* Add identifier                     */
#define NSA$K_RECTYP_RIGHTS_REM 3       /* Remove identifier                  */
#define NSA$K_RECTYP_RIGHTS_MOD_ID 4    /* Modify identifier                  */
#define NSA$K_RECTYP_RIGHTS_MOD_HO 5    /* Modify identifier holder           */
#define NSA$K_RECTYP_RIGHTS_GRANT 6     /* Grant identifier                   */
#define NSA$K_RECTYP_RIGHTS_REVOK 7     /* Revoke identifier                  */
#define NSA$K_RECTYPNUM_RIGHTS 7
/* SET AUDIT operations                                                       */
#define NSA$K_RECTYP_AUDIT_ENA_AL 1     /* Enable alarm                       */
#define NSA$K_RECTYP_AUDIT_DIS_AL 2     /* Disable alarm                      */
#define NSA$K_RECTYP_AUDIT_ENA_JL 3     /* Enable journal                     */
#define NSA$K_RECTYP_AUDIT_DIS_JL 4     /* Disable journal                    */
#define NSA$K_RECTYPNUM_AUDIT 4
/*+                                                                           */
/* SYSUAFF stuff                                                              */
/*-                                                                           */
struct sysuaff_bits {
    union {
        unsigned int nsa$q_sysuaff [2]; /* SYSUAFF flags:                     */
        struct {
            unsigned nsa$v_access : 1;  /*  ACCESS modified                   */
            unsigned nsa$v_account : 1; /*  ACCOUNT modified                  */
            unsigned nsa$v_astlm : 1;   /*  ASTLM modified                    */
            unsigned nsa$v_batch : 1;   /*  BATCH modified                    */
            unsigned nsa$v_biolm : 1;   /*  BIOLM modified                    */
            unsigned nsa$v_bytlm : 1;   /*  BYTLM modified                    */
            unsigned nsa$v_cli : 1;     /*  CLI modified                      */
            unsigned nsa$v_clitables : 1;       /*  CLITABLES modified        */
            unsigned nsa$v_cputime : 1; /*  CPUTIME modified                  */
            unsigned nsa$v_defprivileges : 1;   /*  DEFPRIVILEGES modified    */
            unsigned nsa$v_device : 1;  /*  DEVICE modified                   */
            unsigned nsa$v_dialup : 1;  /*  DIALUP modified                   */
            unsigned nsa$v_diolm : 1;   /*  DIOLM modified                    */
            unsigned nsa$v_directory : 1;       /*  DIRECTORY modified        */
            unsigned nsa$v_enqlm : 1;   /*  ENQLM modified                    */
            unsigned nsa$v_expiration : 1;      /*  EXPIRATION modified       */
            unsigned nsa$v_fillm : 1;   /*  FILLM modified                    */
            unsigned nsa$v_flags : 1;   /*  FLAGS modified                    */
            unsigned nsa$v_interactive : 1;     /*  INTERACTIVE modified      */
            unsigned nsa$v_jtquota : 1; /*  JTQUOTA modified                  */
            unsigned nsa$v_lgicmd : 1;  /*  LGICMD modified                   */
            unsigned nsa$v_local : 1;   /*  LOCAL modified                    */
            unsigned nsa$v_maxdetach : 1;       /*  MAXDETACH modified        */
            unsigned nsa$v_maxjobs : 1; /*  MAXJOBS modified                  */
            unsigned nsa$v_maxacctjobs : 1;     /*  MAXACCTJOBS modified      */
            unsigned nsa$v_network : 1; /*  NETWORK modified                  */
            unsigned nsa$v_owner : 1;   /*  OWNER modified                    */
            unsigned nsa$v_password : 1;        /*  PASSWORD modified         */
            unsigned nsa$v_pbytlm : 1;  /*  PBYTLM modified                   */
            unsigned nsa$v_pflags : 1;  /*  PFLAGS modified                   */
            unsigned nsa$v_p_restrict : 1;      /*  P_RESTRICT modified       */
            unsigned nsa$v_pgflquota : 1;       /*  PGFLQUOTA modified        */
            unsigned nsa$v_prclm : 1;   /*  PRCLM modified                    */
            unsigned nsa$v_primedays : 1;       /*  PRIMEDAYS modified        */
            unsigned nsa$v_priority : 1;        /*  PRIORITY modified         */
            unsigned nsa$v_privileges : 1;      /*  PRIVILEGES modified       */
            unsigned nsa$v_pwdlifetime : 1;     /*  PWDLIFETIME modified      */
            unsigned nsa$v_pwdminimum : 1;      /*  PWDMINIMUM modified       */
            unsigned nsa$v_quepriority : 1;     /*  QUEPRIORITY modified      */
            unsigned nsa$v_remote : 1;  /*  REMOTE modified                   */
            unsigned nsa$v_sflags : 1;  /*  SFLAGS modified                   */
            unsigned nsa$v_s_restrict : 1;      /*  S_RESTRICT modified       */
            unsigned nsa$v_shrfillm : 1;        /*  SHRFILLM modified         */
            unsigned nsa$v_tqelm : 1;   /*  TQELM modified                    */
            unsigned nsa$v_uic : 1;     /*  UIC modified                      */
            unsigned nsa$v_wsdefault : 1;       /*  WSDEFAULT modified        */
            unsigned nsa$v_wsextent : 1;        /*  WSEXTENT modified         */
            unsigned nsa$v_wsquota : 1; /*  WSQUOTA modified                  */
            } nsa$r_fill_5;
        } nsa$r_fill_4;
} ;
/*+                                                                           */
/* Record header offset definitions                                           */
/*-                                                                           */
#define NSA$M_REC_FLAGS_PKTCON 0x00000001
#define NSA$C_RECHDR_LENGTH 76
#define NSA$K_RECHDR_LENGTH 76
struct nsarechdrdef {
    union {
        unsigned long int nsa$l_rec_id; /* Record identification longword     */
        struct {
            unsigned short int nsa$w_rec_type;  /* Record type                */
            unsigned short int nsa$w_rec_subtype;       /* Record subtype     */
            } nsa$r_rec_id_fields;
        } nsa$r_rec_id_overlay;
    unsigned char nsa$b_rec_seqnum;     /* This records sequence number       */
    unsigned char nsa$b_rec_seqlast;    /* Last records sequence number       */
    union {
        unsigned char nsa$b_rec_flags;  /* Record flags byte                  */
        struct {
            unsigned nsa$v_rec_flags_pktcon : 1;        /* Last packet in record is   */
/* continued in next record                                                   */
            unsigned nsa$v_fill_6 : 7;
            } nsa$r_rec_flags_bits;
        } nsa$r_rec_flags_overlay;
    unsigned char nsa$b_rec_pktnum;     /* Number of data packets in record   */
    unsigned short int nsa$w_rec_pktoff;        /* Offset to first packet     */
    unsigned short int nsa$w_rec_pkthdrsiz;     /* Data packet header size    */
    unsigned long int nsa$l_rec_epid;   /* Extended PID                       */
    unsigned int nsa$q_rec_time [2];    /* Event time (EXE$GQ_SYSTIME)        */
    char nsa$t_rec_clusnam [16];        /* Cluster node name                  */
    char nsa$t_rec_procnam [16];        /* Process name                       */
    char nsa$t_rec_usernam [12];        /* username                           */
    char nsa$t_rec_acctnam [8]; /* Account name                               */
} ;
/*+                                                                           */
/* Data packet type definitions                                               */
/*-                                                                           */
#define NSA$K_PKTTYP_IMGNAM 1   /* Image name packet                          */
#define NSA$K_PKTTYP_FACMOD 2   /* File access mode                           */
#define NSA$K_PKTTYP_PRIVUSED 3 /* Privilege used to access file              */
#define NSA$K_PKTTYP_FILNAM 4   /* File name                                  */
#define NSA$K_PKTTYP_DEVNAM 5   /* Device name                                */
#define NSA$K_PKTTYP_LOGNAM 6   /* Logical name                               */
#define NSA$K_PKTTYP_VOLNAM 7   /* Volume name                                */
#define NSA$K_PKTTYP_VOLSNAM 8  /* Volume set name                            */
#define NSA$K_PKTTYP_NODENAM 9  /* Node name                                  */
#define NSA$K_PKTTYP_USERNAM 10 /* User name                                  */
#define NSA$K_PKTTYP_PASSWORD 11        /* Password                           */
#define NSA$K_PKTTYP_UIC 12     /* User identification code                   */
#define NSA$K_PKTTYP_VOLPRO 13  /* Volume protection                          */
#define NSA$K_PKTTYP_MOUFLG 14  /* Mount flags                                */
#define NSA$K_PKTTYP_DMOUFLG 15 /* Dismount flags                             */
#define NSA$K_PKTTYP_NODEID 16  /* Node ID                                    */
#define NSA$K_PKTTYP_EPID 17    /* Extended PID                               */
#define NSA$K_PKTTYP_SYSUAFF 18 /* System UAF record fields                   */
#define NSA$K_PKTTYP_STATUS 19  /* Status longword                            */
#define NSA$K_PKTTYP_SECNAM 20  /* Global section name                        */
#define NSA$K_PKTTYP_PRIVS 21   /* Full privilege mask                        */
#define NSA$K_PKTTYP_INSFLG 22  /* Install flags                              */
#define NSA$K_PKTTYP_IDNAME 23  /* Identifier name                            */
#define NSA$K_PKTTYP_IDVAL 24   /* Identifier value                           */
#define NSA$K_PKTTYP_IDATTR 25  /* Identifier attributes                      */
#define NSA$K_PKTTYP_HOLDER 26  /* Identifier holder                          */
#define NSA$K_PKTTYP_AUDIT 27   /* Audit item                                 */
#define NSA$K_PKTTYP_DEFUSERNAM 28      /* Default proxy name                 */
#define NSA$K_PKTTYP_OLDUSERNAM 29      /* Old proxy name                     */
#define NSA$K_PKTTYP_OLDDEFUNAM 30      /* Old default local proxy name       */
#define NSA$K_PKTTYP_OLDNODENAM 31      /* Old remote node name               */
#define NSA$K_PKTTYPNUM 31
/*+                                                                           */
/* Data packet offset definitions                                             */
/*-                                                                           */
#define NSA$C_PKTHDR_LENGTH 4
#define NSA$K_PKTHDR_LENGTH 4
#define NSA$M_PKT_INS_OPEN 0x00000002
#define NSA$M_PKT_INS_HDR 0x00000004
#define NSA$M_PKT_INS_SHARE 0x00000008
#define NSA$M_PKT_INS_EXEC 0x00000010
#define NSA$M_PKT_INS_WRITE 0x00000020
#define NSA$M_PKT_INS_PRIV 0x00000040
#define NSA$M_PKT_INS_PROT 0x00000080
#define NSA$M_PKT_INS_NOPRG 0x00000100
#define NSA$M_PKT_INS_ACC 0x00000200
struct nsapktdef { /* WARNING: aggregate has origin of -4 */
    unsigned short int nsa$w_pkt_type;  /* Packet data type                   */
    unsigned short int nsa$w_pkt_size;  /* Packet size                        */
    char nsa$t_pkt_data [];
    union {
        char nsa$t_pkt_imgnam [444];    /* Image name                         */
        unsigned long int nsa$l_pkt_facmod;     /* File access mode           */
        unsigned long int nsa$l_pkt_privused;   /* Privilege used to access file      */
        char nsa$t_pkt_filnam [444];    /* File name                          */
        char nsa$t_pkt_devnam [64];     /* Device and access port name        */
        char nsa$t_pkt_lognam [255];    /* Logical name                       */
        char nsa$t_pkt_volnam [12];     /* Volume name                        */
        char nsa$t_pkt_volsnam [12];    /* Volume set name                    */
        char nsa$t_pkt_nodenam [6];     /* Node name                          */
        char nsa$t_pkt_usernam [32];    /* User name                          */
        char nsa$t_pkt_password [32];   /* Password                           */
        unsigned long int nsa$l_pkt_uic;        /* Volume UIC                 */
        unsigned short int nsa$w_pkt_volpro;    /* Volume protection          */
        unsigned long int nsa$l_pkt_mouflg;     /* Mount flags                */
        unsigned short int nsa$w_pkt_dmouflg;   /* Dismount flags             */
        unsigned int nsa$q_pkt_nodeid [2];      /* Node ID                    */
        unsigned long int nsa$l_pkt_epid;       /* Extended PID               */
        unsigned int nsa$q_pkt_sysuaff [2];     /* System UAF record fields   */
        unsigned long int nsa$l_pkt_status;     /* Status longword            */
        char nsa$t_pkt_secnam [54];     /* Global section name                */
        unsigned int nsa$q_pkt_privs [2];       /* Full privilege mask        */
        union {
            unsigned long int nsa$l_pkt_insflg; /* Install flags              */
            struct {
                unsigned nsa$v_pkt_ins_fill : 1;        /* Bit 0 must be unused       */
                unsigned nsa$v_pkt_ins_open : 1;        /* /OPEN              */
                unsigned nsa$v_pkt_ins_hdr : 1; /* /HEADER_RESIDENT           */
                unsigned nsa$v_pkt_ins_share : 1;       /* /SHARE             */
                unsigned nsa$v_pkt_ins_exec : 1;        /* /EXECUTE           */
                unsigned nsa$v_pkt_ins_write : 1;       /* /WRITE             */
                unsigned nsa$v_pkt_ins_priv : 1;        /* /PRIVILEGE         */
                unsigned nsa$v_pkt_ins_prot : 1;        /* /PROTECTED         */
                unsigned nsa$v_pkt_ins_noprg : 1;       /* /NOPURGE           */
                unsigned nsa$v_pkt_ins_acc : 1; /* /ACCOUNTING                */
                unsigned nsa$v_fill_9 : 6;
                } nsa$r_fill_8;
            } nsa$r_fill_7;
        char nsa$t_pkt_idname [32];     /* Identifier name                    */
        unsigned long int nsa$l_pkt_idval;      /* Identifier value           */
        unsigned long int nsa$l_pkt_idattr;     /* Identifier attributes      */
        unsigned int nsa$q_pkt_holder [2];      /* Identifier holder          */
        char nsa$r_pkt_audit [];        /* Audit item (not used)              */
        char nsa$t_pkt_defusernam [32]; /* Default proxy name                 */
        char nsa$t_pkt_oldusernam [32]; /* Old proxy name                     */
        char nsa$t_pkt_olddefunam [32]; /* Old default local proxy name       */
        char nsa$t_pkt_oldnodenam [6];  /* Old remote node name               */
        } nsa$r_pkt_data_overlay;
} ;
#endif
