/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:36:21 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFMP.S */
#ifndef $PR9RRDEF_H
#define $PR9RRDEF_H
 
/*** MODULE $PR9RRDEF ***/
#define PR9RR$_ICCS 24  /* Interval Clock Control/Status                      */
#define PR9RR$_TODR 27  /* Time of Year Clock                                 */
#define PR9RR$_RXCS 32  /* Console Receiver Control/Status                    */
#define PR9RR$_RXDB 33  /* Console Receiver Data Buffer                       */
#define PR9RR$_TXCS 34  /* Console Transmit Control/Status                    */
#define PR9RR$_TXDB 35  /* Console Transmit Data Buffer                       */
#define PR9RR$_MCESR 38 /* Machine Check Error Register                       */
#define PR9RR$_ACCS 40  /* Floating Point Accellerator Register               */
#define PR9RR$_SAVPC 42 /* Console SAVED PC                                   */
#define PR9RR$_SAVPSL 43        /* Console SAVED PSL                          */
#define PR9RR$_TBTAG 47 /* Translation Buffer Tag                             */
#define PR9RR$_IORESET 55       /* IO BUS RESET                               */
#define PR9RR$_TBDATA 59        /* Translation Buffer Data                    */
#define PR9RR$_SID 62   /* System Identification Register                     */
#define PR9RR$_BCBTS 113        /* Backup Cache Tag Store                     */
#define PR9RR$_BCP1TS 114       /* Backup Cache P1 Tag Store                  */
#define PR9RR$_BCP2TS 115       /* Backup Cache P2 Tag Store                  */
#define PR9RR$_BCRFR 116        /* Backup Cache Refresh Register              */
#define PR9RR$_BCIDX 117        /* Backup Cache Index Register                */
#define PR9RR$_BCSTS 118        /* Backup Cache Status Register               */
#define PR9RR$_BCCTL 119        /* Backup Cache Control Register              */
#define PR9RR$_BCERR 120        /* Backup Cache Error Register                */
#define PR9RR$_BCFBTS 121       /* Backup Cache Flush Backup Tag Store        */
#define PR9RR$_BCFPTS 122       /* Backup Cache Flush Primary Tag Store       */
#define PR9RR$_PCTAG 124        /* Primary Cache Tag Store                    */
#define PR9RR$_PCIDX 125        /* Primary Cache Index Register               */
#define PR9RR$_PCERR 126        /* Primary Cache Error Register               */
#define PR9RR$_PCSTS 127        /* Primary Cache StatusRegister               */
#define PR9RR$M_ACCS_NS 0x00000001
#define PR9RR$M_ACCS_FCHIP 0x00000002
#define PR9RR$M_ACCS_WEP 0x80000000
#define PR9RR$M_PCS_FHIT 0x00000001
#define PR9RR$M_PCS_ENA 0x00000002
#define PR9RR$M_PCS_FLUSH 0x00000004
#define PR9RR$M_PCS_RFR 0x00000008
#define PR9RR$M_PCS_PHIT 0x00000010
#define PR9RR$M_PCS_INT 0x00000020
#define PR9RR$M_PCS_TRAP2 0x00000040
#define PR9RR$M_PCS_TRAP1 0x00000080
#define PR9RR$M_PCS_TPERR 0x00000100
#define PR9RR$M_PCS_DDPERR 0x00000200
#define PR9RR$M_PCS_PDPERR 0x00000400
#define PR9RR$M_PCS_BERR 0x00000800
#define PR9RR$M_PCS_BHIT 0x00001000
#define PR9RR$M_BCS_LOCK 0x00000001
#define PR9RR$M_BCS_BTPERR 0x00000002
#define PR9RR$M_BCS_P1TPER 0x00000004
#define PR9RR$M_BCS_P2TPER 0x00000008
#define PR9RR$M_BCS_BERR 0x00000010
#define PR9RR$M_BCS_BTCMP 0x00020000
#define PR9RR$M_BCS_BTHIT 0x00040000
#define PR9RR$M_BCS_P1THIT 0x00080000
#define PR9RR$M_BCS_P2THIT 0x00100000
#define PR9RR$M_BCS_DALCMD 0x01E00000
#define PR9RR$M_BCS_IBCYC 0x02000000
#define PR9RR$M_BCS_PPAR 0x04000000
#define PR9RR$M_BCC_FHIT 0x00000001
#define PR9RR$M_BCC_ENA_BTS 0x00000002
#define PR9RR$M_BCC_ENA_PTS 0x00000004
#define PR9RR$M_BCC_RFR 0x00000008
#define PR9RR$M_BCC_RAMSPD 0x00000010
union pr9rrdef {
    struct {    /* Floating Point Accelerator Register                        */
        unsigned pr9rr$v_accs_ns : 1;   /* NS present                         */
        unsigned pr9rr$v_accs_fchip : 1;        /* F-Chip present             */
        unsigned pr9rr$$_accs_fill : 29;        /*                            */
        unsigned pr9rr$v_accs_wep : 1;  /* Write even parity                  */
        } pr9rr$r_pr9rraccs_bits;
    struct {    /* System Identification Register                             */
        unsigned pr9rr$v_sid_rvaxrev : 8;       /*  9RR chip microcode revision level */
        } pr9rr$r_pr9rrsid_bits;
    struct {    /* XSID (SYS_TYPE) Register                                   */
        unsigned pr9rr$v_xsid_arch : 8; /* Architectural ID (=1)              */
        unsigned pr9rr$v_xsid_sys_var : 8;      /* System Variant (=1)        */
        unsigned pr9rr$v_xsid_xrpfwrev : 8;     /* XRP firmware revision level        */
        } pr9rr$r_pr9rrxsid_bits;
    struct {    /* PCSTS Register                                             */
        unsigned pr9rr$v_pcs_fhit : 1;  /* Force hit                          */
        unsigned pr9rr$v_pcs_ena : 1;   /* Enable PTS                         */
        unsigned pr9rr$v_pcs_flush : 1; /* Flush cache                        */
        unsigned pr9rr$v_pcs_rfr : 1;   /* Enable Refresh                     */
        unsigned pr9rr$v_pcs_phit : 1;  /* P-Cache hit                        */
        unsigned pr9rr$v_pcs_int : 1;   /* Error interrupt pending            */
        unsigned pr9rr$v_pcs_trap2 : 1; /* 2ND TRAP                           */
        unsigned pr9rr$v_pcs_trap1 : 1; /* 1ST TRAP                           */
        unsigned pr9rr$v_pcs_tperr : 1; /* Tag parity error                   */
        unsigned pr9rr$v_pcs_ddperr : 1;        /* DAL Data parity error      */
        unsigned pr9rr$v_pcs_pdperr : 1;        /* P-Cache Data parity error  */
        unsigned pr9rr$v_pcs_berr : 1;  /* BUS error                          */
        unsigned pr9rr$v_pcs_bhit : 1;  /* B-Cache hit                        */
        unsigned pr9rr$v_fill_33 : 3;
        } pr9rr$r_pr9rrpcsts_bits;
    struct {    /* BCSTS Register                                             */
        unsigned pr9rr$v_bcs_lock : 1;  /* BCSTS and BCERR locked             */
        unsigned pr9rr$v_bcs_btperr : 1;        /* B-Cache Tag Parity Error   */
        unsigned pr9rr$v_bcs_p1tper : 1;        /* P1 Tag Parity Error        */
        unsigned pr9rr$v_bcs_p2tper : 1;        /* P2 Tag Parity Error        */
        unsigned pr9rr$v_bcs_berr : 1;  /* BUS Error                          */
        unsigned pr9rr$v_bcs_fill : 12; /* RESERVED bits                      */
        unsigned pr9rr$v_bcs_btcmp : 1; /* B-Cache Tag Compare Result         */
        unsigned pr9rr$v_bcs_bthit : 1; /* B-Cache Tag hit                    */
        unsigned pr9rr$v_bcs_p1thit : 1;        /* P1 Tag hit                 */
        unsigned pr9rr$v_bcs_p2thit : 1;        /* P2 Tag hit                 */
        unsigned pr9rr$v_bcs_dalcmd : 4;        /* Last DAL command           */
        unsigned pr9rr$v_bcs_ibcyc : 1; /* IBUS Cycle                         */
        unsigned pr9rr$v_bcs_ppar : 1;  /* Predicted parity                   */
        unsigned pr9rr$v_fill_34 : 5;
        } pr9rr$r_pr9rrbcsts_bits;
    struct {    /* BCCTL Register                                             */
        unsigned pr9rr$v_bcc_fhit : 1;  /* Force B-cache hit                  */
        unsigned pr9rr$v_bcc_ena_bts : 1;       /* Enable B-Cache             */
        unsigned pr9rr$v_bcc_ena_pts : 1;       /* Enable Primary Tag Store   */
        unsigned pr9rr$v_bcc_rfr : 1;   /* Enable refresh                     */
        unsigned pr9rr$v_bcc_ramspd : 1;        /* RAM speed                  */
        unsigned pr9rr$v_fill_35 : 3;
        } pr9rr$r_pr9rrbcctl_bits;
} ;
#endif
