/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:38:12 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFQZ.S */
#ifndef $SYIDEF_H
#define $SYIDEF_H
 
/*** MODULE $SYIDEF ***/
/*+                                                                           */
/* Get System Information Data Identifier Definitions                         */
/*                                                                            */
/* **** NOTE ****                                                             */
/*                                                                            */
/*        New items must always be added to the END of each item list         */
/*        (preceeding the ENDlistname item) so that users will not have       */
/*        to relink.                                                          */
/*-                                                                           */
/* DEFINE TABLE TYPES                                                         */
#define SYI$C_EXETYPE 1 /* Executive cells                                    */
#define SYI$C_FLDTYPE 2 /* Sub-field data                                     */
#define SYI$C_RSDTYPE 3 /* Reduced system data                                */
/*      The following item-codes are for executive data cells.                */
/*      Processor registers are a special case of this type.                  */
/*      Some EXE-type cells have frequently used sub-fields,                  */
/*      which have item-codes in the FLD section. (after this one)            */
#define SYI$_VERSION 4096       /* VMS version number                         */
#define SYI$_SID 4097   /* System ID register                                 */
#define SYI$_PFCDEFAULT 4098    /* Default page fault cluster size            */
#define SYI$_PAGTBLPFC 4099     /* Default page table page fault cluster      */
#define SYI$_SYSPFC 4100        /* Page fault cluster for system paging       */
#define SYI$_KFILSTCNT 4101     /* Number of known file lists                 */
#define SYI$_GBLSECTIONS 4102   /* Global section count                       */
#define SYI$_GBLPAGES 4103      /* Global page count                          */
#define SYI$_GBLPAGFIL 4104     /* Global page page file page limit           */
#define SYI$_MAXPROCESSCNT 4105 /* Maximum process count                      */
#define SYI$_PIXSCAN 4106       /* Process scan count                         */
#define SYI$_PROCSECTCNT 4107   /* Process section count                      */
#define SYI$_MINWSCNT 4108      /* Minimum working set size                   */
#define SYI$_PAGFILCNT 4109     /* Number of paging files                     */
#define SYI$_SWPFILCNT 4110     /* Number of swap files                       */
#define SYI$_SYSMWCNT 4111      /* System working set count                   */
#define SYI$_INTSTKPAGES 4112   /* Interrupt stack size                       */
#define SYI$_DLCKEXTRASTK 4113  /* Extra int stack for deadlock searches      */
#define SYI$_BALSETCNT 4114     /* Balance set count                          */
#define SYI$_IRPCOUNT 4115      /* Count of I/O packets                       */
#define SYI$_IRPCOUNTV 4116     /* Limit of extension of IRP list             */
#define SYI$_WSMAX 4117 /* Max size of process working set                    */
#define SYI$_NPAGEDYN 4118      /* Non-paged dynamic pool                     */
#define SYI$_NPAGEVIR 4119      /* Limit of extension of above                */
#define SYI$_PAGEDYN 4120       /* Paged dynamic pool                         */
#define SYI$_VIRTUALPAGECNT 4121        /* Max virtual page count             */
#define SYI$_SPTREQ 4122        /* Requested SPT extension                    */
#define SYI$_EXUSRSTK 4123      /* Extra user stack provided                  */
#define SYI$_LRPCOUNT 4124      /* Number of large request packets            */
#define SYI$_LRPCOUNTV 4125     /* Limit of extension of LRP list             */
#define SYI$_LRPSIZE 4126       /* Size of large request packet               */
#define SYI$_LRPMIN 4127        /* Min alloc request for LRPs                 */
#define SYI$_SRPCOUNT 4128      /* Number of small request packets            */
#define SYI$_SRPCOUNTV 4129     /* Limit of extension of SRP list             */
#define SYI$_SRPSIZE 4130       /* Size of small request packet               */
#define SYI$_SRPMIN 4131        /* Min alloc request for SRPs                 */
#define SYI$_CHANNELCNT 4132    /* Number of permanent I/O channels           */
#define SYI$_PIOPAGES 4133      /* Process I/O pages                          */
#define SYI$_CTLPAGES 4134      /* Control region impure pages                */
#define SYI$_CTLIMGLIM 4135     /* Limit on use of proc alloc region          */
#define SYI$_IMGIOCNT 4136      /* Default image I/O address space            */
#define SYI$_QUANTUM 4137       /* Process quantum                            */
#define SYI$_MPW_WRTCLUSTER 4138        /* Page write cluster factor          */
#define SYI$_MPW_HILIMIT 4139   /* Modified page list high limit              */
#define SYI$_MPW_LOLIMIT 4140   /* Modified page list low limit               */
#define SYI$_MPW_PRIO 4141      /* Modified page writer I/O priority          */
#define SYI$_SWP_PRIO 4142      /* Swapper I/O priority                       */
#define SYI$_MPW_THRESH 4143    /* Modified page writer lower threshold       */
#define SYI$_MPW_WAITLIMIT 4144 /* Modified page writer busy wait limit       */
#define SYI$_TBSKIPWSL 4145     /* Max number WSlist entries to skip          */
#define SYI$_PHYSICALPAGES 4146 /* Max number of physical pages to use        */
#define SYI$_PFRATL 4147        /* Page fault rate lower threshold            */
#define SYI$_PFRATH 4148        /* Page fault rate high threshold             */
#define SYI$_PFRATS 4149        /* Page fault rate system threshold           */
#define SYI$_WSINC 4150 /* Working set increment                              */
#define SYI$_WSDEC 4151 /* Working set decrement                              */
#define SYI$_AWSMIN 4152        /* Working set minimum                        */
#define SYI$_AWSTIME 4153       /* Working set measurement interval           */
#define SYI$_SWPRATE 4154       /* Swap rate control (max)                    */
#define SYI$_SWPOUTPGCNT 4155   /* Desired proc page cnt for an outswap       */
#define SYI$_SWPALLOCINC 4156   /* Swap file allocation increment value       */
#define SYI$_IOTA 4157  /* I/O time allowance                                 */
#define SYI$_LONGWAIT 4158      /* When HIB or LEF proc becomes longwait      */
#define SYI$_SWPFAIL 4159       /* Swap fail count                            */
#define SYI$_VMSD1 4160 /* Reserved to VMS development (DYNAMIC)              */
#define SYI$_VMSD2 4161 /* "                                                  */
#define SYI$_VMSD3 4162 /* "                                                  */
#define SYI$_VMSD4 4163 /* "                                                  */
#define SYI$_VMS5 4164  /* Reserved to VMS development (STATIC)               */
#define SYI$_VMS6 4165  /* "                                                  */
#define SYI$_VMS7 4166  /* "                                                  */
#define SYI$_VMS8 4167  /* "                                                  */
#define SYI$_USERD1 4168        /* Reserved for users (DYNAMIC)               */
#define SYI$_USERD2 4169        /* "                                          */
#define SYI$_USER3 4170 /* Reserved for users (STATIC)                        */
#define SYI$_USER4 4171 /* "                                                  */
#define SYI$_EXTRACPU 4172      /* Extra CPU time allowed on expiration       */
#define SYI$_MAXSYSGROUP 4173   /* Max group code for system UIC              */
#define SYI$_MVTIMEOUT 4174     /* Timeout for mount verification             */
#define SYI$_MAXBUF 4175        /* Maximum allowable buffered I/O size        */
#define SYI$_DEFMBXBUFQUO 4176  /* Def buffer quota for mailbox creation      */
#define SYI$_DEFMBXMXMSG 4177   /* Def max msg size for mailbox creation      */
#define SYI$_DEFMBXNUMMSG 4178  /* Def number of messages for "               */
#define SYI$_FREELIM 4179       /* Desired free list length                   */
#define SYI$_FREEGOAL 4180      /* Target free list length                    */
#define SYI$_GROWLIM 4181       /* Free > growlim to grow proc > wsquota      */
#define SYI$_BORROWLIM 4182     /* Same as above???                           */
#define SYI$_LOCKRETRY 4183     /* Multi-CPU lock retry count                 */
#define SYI$_XFMAXRATE 4184     /* Max DR32 data rate                         */
#define SYI$_LAMAPREGS 4185     /* Number of UBA map regs for LPA11           */
#define SYI$_REALTIME_SPTS 4186 /* SPT entries for CONINTERR processes        */
#define SYI$_CLISYMTBL 4187     /* Number of pages for CLI symbol table       */
#define SYI$_LOCKIDTBL 4188     /* Size of lock ID table                      */
#define SYI$_RESHASHTBL 4189    /* Size of resource hash table                */
#define SYI$_DEADLOCK_WAIT 4190 /* Deadlock detection timeout period          */
#define SYI$_SCSBUFFCNT 4191    /* SCS buffer descriptor table entries        */
#define SYI$_SCSCONNCNT 4192    /* SCS connect descriptor table entries       */
#define SYI$_SCSRESPCNT 4193    /* SCS response descriptor table entries      */
#define SYI$_SCSMAXDG 4194      /* SCS maximum datagram size                  */
#define SYI$_SCSMAXMSG 4195     /* SCS max sequenced message size             */
#define SYI$_SCSFLOWCUSH 4196   /* SCS flow control cushion                   */
#define SYI$_SCSSYSTEMID 4197   /* SCS system ID (48 bits)                    */
#define SYI$_SCSSYSTEMIDH 4198  /* High bits of above                         */
#define SYI$_SCSNODE 4199       /* SCS system node name                       */
/* Used to be SCSNODEH. Unused for now.                                       */
#define SYI$_PRCPOLINTERVAL 4201        /* SCA process polling interval       */
#define SYI$_PASTIMOUT 4202     /* CI port START/STACK timeout                */
#define SYI$_PASTDGBUF 4203     /* CI port DG buffers for START handshake     */
#define SYI$_PANUMPOLL 4204     /* Number of CI ports to poll                 */
#define SYI$_PAPOLLINTERVAL 4205        /* Time between CI port polls         */
#define SYI$_PAPOOLINTERVAL 4206        /* Time between SYSAPs pool check     */
#define SYI$_TIMEPROMPTWAIT 4207        /* Time prompt timeout (when booting) */
#define SYI$_UDABURSTRATE 4208  /* Max number of longwords per NPR - 1        */
#define SYI$_LNMSHASHTBL 4209   /* Size of system space log name hash table   */
#define SYI$_LNMPHASHTBL 4210   /* Size of process space "                    */
#define SYI$_TTY_SCANDELTA 4211 /* Delta time for dialup timer scan           */
#define SYI$_TTY_DIALTYPE 4212  /* Flags for dialup type                      */
#define SYI$_TTY_SPEED 4213     /* Terminal default: speed                    */
#define SYI$_TTY_RSPEED 4214    /* " " receive speed                          */
#define SYI$_TTY_PARITY 4215    /* " " parity                                 */
#define SYI$_TTY_BUF 4216       /* " " line width                             */
#define SYI$_TTY_DEFCHAR 4217   /* " " characteristics                        */
#define SYI$_TTY_DEFCHAR2 4218  /* " " characteristics, 2nd longword          */
#define SYI$_TTY_TYPAHDSZ 4219  /* Size of typeahead buffer                   */
#define SYI$_TTY_ALTYPAHD 4220  /* Alternate typeahead size                   */
#define SYI$_TTY_ALTALARM 4221  /* Alt typeahead alarm size                   */
#define SYI$_TTY_DMASIZE 4222   /* Dma size                                   */
#define SYI$_TTY_PROT 4223      /* Default terminal alloc protection          */
#define SYI$_TTY_OWNER 4224     /* Default terminal owner                     */
#define SYI$_TTY_CLASSNAME 4225 /* Default terminal class name prefix         */
#define SYI$_TTY_SILOTIME 4226  /* Default silo timeout for DMF32             */
#define SYI$_TTY_DEFPORT 4227   /* DEFAULT PORT ACTION PARAMETER              */
#define SYI$_RMS_DFMBC 4228     /* RMS default: multi-block count             */
#define SYI$_RMS_DFMBFSDK 4229  /* " " multi-buffer count for disk (SEQ)      */
#define SYI$_RMS_DFMBFSMT 4230  /* " " multi-buffer count for tape            */
#define SYI$_RMS_DFMBFSUR 4231  /* " " multi-buffer count for unit record     */
#define SYI$_RMS_DFMBFREL 4232  /* " " multi-buffer count for REL files       */
#define SYI$_RMS_DFMBFIDX 4233  /* " " multi-buffer count for ISAM files      */
#define SYI$_RMS_DFMBFHSH 4234  /* " " multi-buffer count for HASH files      */
#define SYI$_RMS_PROLOGUE 4235  /* " " prolog                                 */
#define SYI$_RMS_EXTEND_SIZE 4236       /* " " file extend quantity           */
#define SYI$_RMS_FILEPROT 4237  /* " " file protection                        */
#define SYI$_PQL_DASTLM 4238    /* Def AST limit                              */
#define SYI$_PQL_MASTLM 4239    /* Min "                                      */
#define SYI$_PQL_DBIOLM 4240    /* Def buffered I/O limit                     */
#define SYI$_PQL_MBIOLM 4241    /* Min "                                      */
#define SYI$_PQL_DBYTLM 4242    /* Def buffered I/O byte count limit          */
#define SYI$_PQL_MBYTLM 4243    /* Min "                                      */
#define SYI$_PQL_DCPULM 4244    /* Def CPU time limit                         */
#define SYI$_PQL_MCPULM 4245    /* Min "                                      */
#define SYI$_PQL_DDIOLM 4246    /* Def direct I/O limit                       */
#define SYI$_PQL_MDIOLM 4247    /* Min "                                      */
#define SYI$_PQL_DFILLM 4248    /* Def open file limit                        */
#define SYI$_PQL_MFILLM 4249    /* Min "                                      */
#define SYI$_PQL_DPGFLQUOTA 4250        /* Def paging file quota              */
#define SYI$_PQL_MPGFLQUOTA 4251        /* Min "                              */
#define SYI$_PQL_DPRCLM 4252    /* Def sub-process limit                      */
#define SYI$_PQL_MPRCLM 4253    /* Min "                                      */
#define SYI$_PQL_DTQELM 4254    /* Def timer queue entry limit                */
#define SYI$_PQL_MTQELM 4255    /* Min "                                      */
#define SYI$_PQL_DWSDEFAULT 4256        /* Def working set default size       */
#define SYI$_PQL_MWSDEFAULT 4257        /* Min "                              */
#define SYI$_PQL_DWSQUOTA 4258  /* Def working set quota                      */
#define SYI$_PQL_MWSQUOTA 4259  /* Min "                                      */
#define SYI$_PQL_DWSEXTENT 4260 /* Def working set extent                     */
#define SYI$_PQL_MWSEXTENT 4261 /* Min "                                      */
#define SYI$_PQL_DENQLM 4262    /* Def enqueue limit                          */
#define SYI$_PQL_MENQLM 4263    /* Min "                                      */
#define SYI$_ACP_MAPCACHE 4264  /* Number of blocks in bitmap cache           */
#define SYI$_ACP_HDRCACHE 4265  /* Number of blocks in file header cache      */
#define SYI$_ACP_DIRCACHE 4266  /* Number of blocks in directory cache        */
#define SYI$_ACP_WORKSET 4267   /* ACP working set                            */
#define SYI$_ACP_FIDCACHE 4268  /* Number of cached index file slots          */
#define SYI$_ACP_EXTCACHE 4269  /* Number of cached disk extents              */
#define SYI$_ACP_EXTLIMIT 4270  /* Max fraction of disk to cache              */
#define SYI$_ACP_QUOCACHE 4271  /* Number of file quota entries to cache      */
#define SYI$_ACP_SYSACC 4272    /* Default access for system volumes          */
#define SYI$_ACP_MAXREAD 4273   /* Max number of direct blks to read          */
#define SYI$_ACP_WINDOW 4274    /* Default window size for system volumes     */
#define SYI$_ACP_WRITEBACK 4275 /* Deferred cache writeback enable            */
#define SYI$_ACP_DATACHECK 4276 /* ACP datacheck enable flags                 */
#define SYI$_ACP_BASEPRIO 4277  /* ACP base priority                          */
#define SYI$_ACP_SWAPFLGS 4278  /* ACP swap flags                             */
#define SYI$_DEFPRI 4279        /* Default priority for Job Initiations       */
#define SYI$_IJOBLIM 4280       /* Limit for interactive jobs                 */
#define SYI$_BJOBLIM 4281       /* Limit for batch jobs                       */
#define SYI$_NJOBLIM 4282       /* Limit for network jobs                     */
#define SYI$_RJOBLIM 4283       /* Limit for remote terminal jobs             */
#define SYI$_QUORUM 4284        /* Connection manager cluster QUORUM          */
#define SYI$_VOTES 4285 /* Connection manager VOTES from this system          */
#define SYI$_RECNXINTERVAL 4286 /* Connection manager reconnect interval      */
#define SYI$_BOOTTIME 4287      /* 64-bit abs. system time at system boot     */
#define SYI$_LOCKIDTBL_MAX 4288 /* Maximum size of lock ID table.             */
#define SYI$_TAILORED 4289      /* Is this system tailored?                   */
#define SYI$_STARTUP_P1 4290    /* Parameters for passing information         */
#define SYI$_STARTUP_P2 4291    /* to system startup procedure.               */
#define SYI$_STARTUP_P3 4292
#define SYI$_STARTUP_P4 4293
#define SYI$_STARTUP_P5 4294
#define SYI$_STARTUP_P6 4295
#define SYI$_STARTUP_P7 4296
#define SYI$_STARTUP_P8 4297
#define SYI$_CLUSTER_NODES 4298 /* total number of nodes in cluster           */
#define SYI$_CLUSTER_VOTES 4299 /*  "     "     "  votes "   "                */
#define SYI$_CLUSTER_QUORUM 4300        /*  "     quorum in cluster           */
#define SYI$_CLUSTER_FSYSID 4301        /* founding systemid                  */
#define SYI$_CLUSTER_FTIME 4302 /* founding boottime                          */
#define SYI$_CLUSTER_MEMBER 4303        /* true if in a live cluster          */
#define SYI$_NODE_CSID 4304     /* cluster system id of target node           */
#define SYI$_NODE_VOTES 4305    /* votes of target node                       */
#define SYI$_NODE_QUORUM 4306   /* quorum of "      "                         */
#define SYI$_NODE_SYSTEMID 4307 /* systemid of "    "                         */
#define SYI$_NODE_SWINCARN 4308 /* S/W incarnation of "     "                 */
#define SYI$_NODE_SWTYPE 4309   /* S/W type of  "     "                       */
#define SYI$_NODE_SWVERS 4310   /* S/W version of "   "                       */
#define SYI$_NODE_HWTYPE 4311   /* H/W type of    "   "                       */
#define SYI$_NODE_HWVERS 4312   /* H/W version of "   "                       */
#define SYI$_NODENAME 4313      /* SCS nodename of "    "                     */
#define SYI$_ARCHFLAG 4314      /* Flags used by uVAX code                    */
#define SYI$_SCS_EXISTS 4315    /* Flag to indicate presence of SCS           */
#define SYI$_DISK_QUORUM 4316   /* Cluster quorum device name (in ASCII)      */
#define SYI$_XSID 4317  /* Extended System Identification Register            */
/* Used to be DISK_QUORUM3. Unused for now.                                   */
/* Used to be DISK_QUORUM4. Unused for now.                                   */
#define SYI$_PAMAXPORT 4320     /* Max PA port to poll                        */
#define SYI$_PASANITY 4321      /* PA sanity timer enable/disable switch      */
#define SYI$_DEFQUEPRI 4322     /* Default Que Priority                       */
#define SYI$_MAXQUEPRI 4323     /* Max Que Priority                           */
#define SYI$_QDSKINTERVAL 4324  /* Disk Quorum Interval                       */
#define SYI$_ALLOCLASS 4325     /* Allocation class                           */
#define SYI$_LGI_RETRY_LIM 4326 /* Login retry limit                          */
#define SYI$_LGI_RETRY_TMO 4327 /* Login retry timeout                        */
#define SYI$_LGI_BRK_LIM 4328   /* Login failure limit                        */
#define SYI$_LGI_BRK_TMO 4329   /* Login suspect timeout                      */
#define SYI$_LGI_HID_TIM 4330   /* Login evasive action time                  */
#define SYI$_LGI_PWD_TMO 4331   /* System password drop dead time             */
#define SYI$_PQL_DJTQUOTA 4332  /* Default Job-wide Logical Name Table Creation Quota */
#define SYI$_PQL_MJTQUOTA 4333  /* Minimum Job-wide Logical Name Table Creation Quota */
#define SYI$_VAXCLUSTER 4334    /* VAXcluster participation                   */
#define SYI$_LOCKDIRWT 4335     /* Lock manager directory system weight       */
#define SYI$_QDSKVOTES 4336     /* Votes held by quorum disk                  */
#define SYI$_DORMANTWAIT 4337   /* When low pri COM proc becomes dormant      */
#define SYI$_PAGEFILE_PAGE 4338 /* Total pagefile pages                       */
#define SYI$_SWAPFILE_PAGE 4339 /* Total swapfile pages                       */
#define SYI$_PAGEFILE_FREE 4340 /* Free pagefile pages                        */
#define SYI$_SWAPFILE_FREE 4341 /* Free swapfile pages                        */
#define SYI$_TTY_TIMEOUT 4342   /* Seconds for virtual terminal timeout       */
#define SYI$_TTY_AUTOCHAR 4343  /* autobaud recognition character             */
#define SYI$_PANOPOLL 4344      /* Disable/enable CI port polling             */
#define SYI$_PE1 4345   /* Reserved TO PEDRIVER (DYNAMIC)                     */
#define SYI$_PE2 4346   /* "                                                  */
#define SYI$_PE3 4347   /* "                                                  */
#define SYI$_PE4 4348   /* "                                                  */
#define SYI$_PE5 4349   /* Reserved TO PEDRIVER (STATIC)                      */
#define SYI$_PE6 4350   /* "                                                  */
#define SYI$_RMS_GBLBUFQUO 4351 /* RMS global buffer quota                    */
#define SYI$_RMS_DFNBC 4352     /* " " network block count                    */
#define SYI$_ACP_DINDXCACHE 4353        /* File system directory index cache blocks   */
#define SYI$_MAXATTACHPRI 4354  /* Maximum scheduling prio for ASMP attached processor*/
#define SYI$_SMP_CPUS 4355      /* Number of CPUs to boot in SMP system       */
#define SYI$_SMP_CPUSH 4356     /* Hi Number of CPUs to boot in SMP system    */
#define SYI$_FALLBACK_MODE 4357 /* Cluster fallback mode                      */
#define SYI$_MPW_LOWAITLIMIT 4358       /* Modified page writer lower busy wait limit */
#define SYI$_MPW_IOLIMIT 4359   /* Modified page writer max concurrent I/O count      */
#define SYI$_S0_PAGING 4360     /* System space paging flags                  */
#define SYI$_HW_MODEL 4361      /* VAX model number (from SB$B_HWVERS)        */
#define SYI$_HW_NAME 4362       /* VAX model name from #/name trans. table    */
#define SYI$_SCH_CTLFLAGS 4363  /* CPU scheduling control flags               */
#define SYI$_NODE_EVOTES 4364   /* Votes expected by target node              */
#define SYI$_CLUSTER_EVOTES 4365        /* Number of expected votes in cluster*/
#define SYI$_MULTIPROCESSING 4366       /* Multiprocessor participation       */
#define SYI$_FREE_GBLPAGES 4367 /* Total, free global pages                   */
#define SYI$_CONTIG_GBLPAGES 4368       /* Maximum, contiguous free global pages      */
#define SYI$_FREE_GBLSECTS 4369 /* Total, free global sections                */
#define SYI$_EXPECTED_VOTES 4370        /* Expected votes                     */
#define SYI$_PU_OPTIONS 4371    /* Select PUDRIVER load options               */
#define SYI$_WPTTE_SIZE 4372    /* # Watchpoint Trace Table Entries           */
#define SYI$_WPRE_SIZE 4373     /* Watchpoint Restore Entry size              */
#define SYI$_SMP_SANITY_CNT 4374        /* # SMP Sanity events bef. timeout   */
#define SYI$_SMP_TICK_CNT 4375  /* Clock ticks between SMP sanity time cycles */
#define SYI$_QBUS_MULT_INTR 4376        /* uVAX/QBUS multi-level interrupt enable flag*/
#define SYI$_RIGHTSLIST 4377    /* System rights segment descriptor           */
#define SYI$_SMP_SPINWAIT 4378  /* SMP normal busywait timeout                */
#define SYI$_SMP_LNGSPINWAIT 4379       /* SMP LONG busywait timeout          */
#define SYI$_TIME_CONTROL 4380  /* Time-related control functions             */
#define SYI$_AVAILCPU_CNT 4381  /* Number of CPUs in this machine             */
#define SYI$_ACTIVECPU_CNT 4382 /* Number of CPUs up and running              */
/* Used to be LAVC_CONV_BOOT. Unused now.                                     */
/* Used to be LAVC_LOAD_PEA0. Unused now.                                     */
/* Used to be LAVC_PORT_SERV. Unused now.                                     */
#define SYI$_MSCP_LOAD 4386     /* Load MSCP server at boot time              */
#define SYI$_MSCP_SERVE_ALL 4387        /* Serve all disks                    */
#define SYI$_POOLCHECK 4388     /* Pool debugging in MEMORYALC.MAR            */
#define SYI$_TAPE_MVTIMEOUT 4389        /* Magtape mount verification         */
#define SYI$_PSEUDOLOA 4390     /* Pseudoloa image size for tape boot         */
#define SYI$_MINCLASSPRI 4391   /* Min. priority for class scheduling         */
#define SYI$_MAXCLASSPRI 4392   /* Max. priority for class scheduling         */
#define SYI$_MINPRPRI 4393      /* Min. priority for preemptive-resume scheduling     */
#define SYI$_AUTOCONFIG_ALGO 4394       /* Selects which algorithmn SYSGEN uses to autoconfigure.     */
#define SYI$_ERRORLOGBUFFERS 4395       /* Number of buffers for error logging*/
#define SYI$_JOBCTLD 4396       /* Dynamic SYSGEN flag to handle job controller diagnostics and Rolling upgrade.      */
#define SYI$_WINDOW_SYSTEM 4397 /* Default windowing system for workstation   */
#define SYI$_MSCP_BUFFER 4398   /* Pages allocated to server local pool       */
#define SYI$_MSCP_CREDITS 4399  /* Number of send credits extended by server  */
#define SYI$_BREAKPOINTS 4400   /* Mask of INI$BRK callers in exec used in this boot  */
#define SYI$_CLOCK_INTERVAL 4401        /* Time  (in usec) between interval timer clock interrupts    */
#define SYI$_DUMPSTYLE 4402     /* Mask specifying desired format of dump file (full dump or subset dump)     */
#define SYI$_NISCS_PORT_SERV 4403       /* Port services flag                 */
#define SYI$_RSRVPAGCNT 4404    /* No. of pagefile pages to escrow            */
/*      ADD 'EXE' ITEM-CODES ONLY JUST BEFORE THIS COMMENT ***********        */
#define SYI$_LASTEXE 4405       /* LAST INDEX                                 */
/*  ) equals SYI$C_EXETYPE@12 increment 1  prefix SYI tag $;                  */
/*      The following item-codes are for 'sub-field data' items.              */
/*      There usually exists another item-code to retrieve the                */
/*      whole parent cell (longword) - in the EXE section above.              */
#define SYI$_CPU 8192   /* CPU type                                           */
#define SYI$_BUGREBOOT 8193     /* Bugcheck reboot enable                     */
#define SYI$_CRDENABLE 8194     /* Memory error checking enable               */
#define SYI$_DUMPBUG 8195       /* Bugcheck dump enable                       */
#define SYI$_BUGCHECKFATAL 8196 /* All bugchecks become fatal                 */
#define SYI$_ACP_MULTIPLE 8197  /* New ACP for each disk class                */
#define SYI$_NOAUTOCONFIG 8198  /* Auto configuration inhibit                 */
#define SYI$_NOCLOCK 8199       /* Interval timer inhibit                     */
#define SYI$_NOCLUSTER 8200     /* Page read clustering inhibit               */
#define SYI$_POOLPAGING 8201    /* Enable paging of paged pool                */
#define SYI$_SBIERRENABLE 8202  /* SBI error detection enable                 */
#define SYI$_SETTIME 8203       /* Force entry of time at system boot         */
#define SYI$_ACP_SHARE 8204     /* Enable sharing of F11ACP                   */
#define SYI$_SYSPAGING 8205     /* Enable paging of system code               */
#define SYI$_UAFALTERNATE 8206  /* Select alternate authorization file        */
#define SYI$_WRITABLESYS 8207   /* Leave system writable for debugging        */
#define SYI$_RESALLOC 8208      /* Enable resource allocation checking        */
#define SYI$_SSINHIBIT 8209     /* Inhibit system services for processes      */
#define SYI$_CONCEAL_DEVICES 8210       /* Enable concealed devices           */
#define SYI$_SAVEDUMP 8211      /* Save dump if it's in page file             */
#define SYI$_MOUNTMSG 8212      /* Enable oper notification of vol mounts     */
#define SYI$_DISMOUMSG 8213     /* Enable oper notification of vol dism       */
#define SYI$_LOADERAPT 8214     /* Load alt erase pattern generator           */
#define SYI$_LOADCHKPRT 8215    /* Load alt protection check routine          */
#define SYI$_XCPU 8216  /* CPU subtype (Extended SID info)                    */
#define SYI$_CJFLOAD 8217       /* Load common journaling code                */
#define SYI$_CJFSYSRUJ 8218     /* Load recovery unit journaling code         */
#define SYI$_NODE_AREA 8219     /* System ID node area                        */
#define SYI$_NODE_NUMBER 8220   /* System ID node number                      */
#define SYI$_CLASS_PROT 8221    /* Non-discretionary check flag               */
#define SYI$_CHARACTER_EMULATED 8222    /* Character string instructions emulated     */
#define SYI$_DECIMAL_EMULATED 8223      /* Decimal string instructions emulated       */
#define SYI$_D_FLOAT_EMULATED 8224      /* D floating instructions emulated   */
#define SYI$_F_FLOAT_EMULATED 8225      /* F floating instructions emulated   */
#define SYI$_G_FLOAT_EMULATED 8226      /* G floating instructions emulated   */
#define SYI$_H_FLOAT_EMULATED 8227      /* H floating instructions emulated   */
#define SYI$_LOADMTACCESS 8228  /* Load installation specific access routine  */
#define SYI$_ACP_XQP_RES 8229   /* Resident XQP                               */
#define SYI$_WRITESYSPARAMS 8230        /* Write active parameters to the system .PAR file    */
#define SYI$_LGI_BRK_TERM 8231  /* Use term name in breakin detection         */
#define SYI$_LGI_BRK_DISUSER 8232       /* Disable user account on breakin    */
#define SYI$_ACP_REBLDSYSD 8233 /* Rebuild system disk when mounting it       */
#define SYI$_WS_OPA0 8234       /* Workstation using QVSS for OPA0            */
#define SYI$_NOPGFLSWP 8235     /* Inhibit swapping into pagefiles            */
#define SYI$_SHADOWING 8236     /* Load Volume Shadowing code (DSDRIVER)      */
#define SYI$_LOAD_SYS_IMAGES 8237       /* Load System Images                 */
#define SYI$_NISCS_CONV_BOOT 8238       /* Allow remote conversational boot   */
#define SYI$_NISCS_LOAD_PEA0 8239       /* Load NI-SCS driver for PEA0        */
/*      ADD 'FLD' ITEM-CODES ONLY JUST BEFORE THIS COMMENT ***********        */
#define SYI$_LASTFLD 8240       /* LAST INDEX                                 */
/*  ) equals SYI$C_FLDTYPE@12 increment 1  prefix SYI tag $;                  */
/******************************************************************************/
/**                                                                           */
/**     THE FOLLOWING DEFINITIONS EXIST FOR COMPATIBILITY WITH THE 1ST        */
/**     IMPLEMENTATION OF SYS$GETSYI.  DO NOT CHANGE THEM!!!                  */
/**     ADD NEW GETSYI ITEM-CODES ONLY TO THE PREVIOUS LISTS.                 */
/**                                                                           */
/******************************************************************************/
#define SYI$C_SFWTYPE 1 /* SYSTEM SOFTWARE ITEM                               */
#define SYI$C_HDWTYPE 2 /* HARDWARE ITEM                                      */
#define SYI$C_LISTEND 0 /* ITMLST TERMINATOR                                  */
/* IDENTIFIER FOR SYSTEM SOFTWARE                                             */
#define SYI$_OLDVERSION 256     /* VMS VERSION NUMBER                         */
#define SYI$_LASTSFW 257        /* LAST INDEX                                 */
/* *******************************************************************        */
/* ********************* BEGIN TEMP FIX ******************************        */
/* ********************* BEGIN TEMP FIX ******************************        */
/* *******************************************************************        */
/*  ) equals SYI$C_SFWTYPE@8 increment 1  prefix SYI tag $;                   */
/* *******************************************************************        */
/* ********************** END TEMP FIX *******************************        */
/* ********************** END TEMP FIX *******************************        */
/* *******************************************************************        */
/* IDENTIFIER FOR HARDWARE TYPE                                               */
#define SYI$_OLDCPU 512 /* CPU TYPE                                           */
#define SYI$_OLDSID 513 /* SYSTEM ID REGISTER                                 */
#define SYI$_LASTHDW 514        /* LAST INDEX                                 */
/*    ) equals SYI$C_HDWTYPE@8 increment 1  prefix SYI tag $;                 */
#endif
