/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:10:20 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]DTKDEF.SDI; */
#ifndef DTKDEF_H
#define DTKDEF_H
 
/*** MODULE $DTKDEF ***/
/* Definitions for RTL DECtalk Management                                     */
/*                                                                            */
/*      Phone keypad keys.                                                    */
/*                                                                            */
#define DTK$K_TRM_ZERO 48
#define DTK$K_TRM_ONE 49
#define DTK$K_TRM_TWO 50
#define DTK$K_TRM_THREE 51
#define DTK$K_TRM_FOUR 52
#define DTK$K_TRM_FIVE 53
#define DTK$K_TRM_SIX 54
#define DTK$K_TRM_SEVEN 55
#define DTK$K_TRM_EIGHT 56
#define DTK$K_TRM_NINE 57
#define DTK$K_TRM_A 65
#define DTK$K_TRM_B 66
#define DTK$K_TRM_C 67
#define DTK$K_TRM_D 68
#define DTK$K_TRM_NUMBER_SIGN 35
#define DTK$K_TRM_ASTERISK 42
/* Conditions                                                                 */
#define DTK$K_TRM_CANCELLED 508 /* I/O cancelled                              */
#define DTK$K_TRM_TIMEOUT 509   /* Timeout period expired                     */
#define DTK$K_TRM_BUFFER_FULL 510       /* Buffer is full                     */
#define DTK$K_TRM_UNKNOWN 511   /* Unknown terminator                         */
/*                                                                            */
/*      Self-test constants.                                                  */
/*                                                                            */
#define DTK$K_TEST_POWER 1
#define DTK$K_TEST_HDATA 2
#define DTK$K_TEST_HCONTROL 3
#define DTK$K_TEST_DATA 4
#define DTK$K_TEST_SPEAK 5
/*                                                                            */
/*      Phone dialing constants.                                              */
/*                                                                            */
#define DTK$K_DIAL_TONE 0
#define DTK$K_DIAL_PULSE 1
/*                                                                            */
/*      DECtalk types.                                                        */
/*                                                                            */
#define DTK$K_DTC_UNKNOWN 0
#define DTK$K_DTC_01 1
#define DTK$K_DTC_03 2
/*                                                                            */
/*      Keypad modes.                                                         */
/*                                                                            */
#define DTK$K_KEYPAD_OFF 0
#define DTK$K_KEYPAD_ON 1
#define DTK$K_KEYPAD_AUTO 2
/*                                                                            */
/*      Voices.                                                               */
/*                                                                            */
#define DTK$K_VOICE_MALE 0
#define DTK$K_VOICE_FEMALE 1
#define DTK$K_VOICE_CHILD 2
#define DTK$K_VOICE_DEEP_MALE 3
#define DTK$K_VOICE_DEEP_FEMALE 4
#define DTK$K_VOICE_OLDER_MALE 5
#define DTK$K_VOICE_LIGHT_FEMALE 6
/*                                                                            */
/*      Speaking modes.                                                       */
/*                                                                            */
#define DTK$K_SPEAK 0
#define DTK$K_STOP 1
#define DTK$K_HALT 2
/*                                                                            */
/*      Return modes.                                                         */
/*                                                                            */
#define DTK$K_IMMED 0   /* Return immedately after sending text.              */
#define DTK$K_WAIT 1    /* Wait until text is completely spoken be returning. */
#define DTK$K_STATUS 2  /* Wait for text to be spoken and return phone status.*/
/*                                                                            */
/*        DEFINE BIT MASKS AND VALUES FOR MODE ATTRIBUTES                     */
/*                                                                            */
#define DTK$M_SQUARE 0x00000001
#define DTK$M_ASCII 0x00000002
#define DTK$M_MINUS 0x00000004
#define DTK$M_EUROPE 0x00000008
#define DTK$M_SPELL 0x00000010
#define DTK$M_NORMAL 0  /* no bits set                                        */
#define DTK$K_SQUARE 0  /* Mode square bitvector index                        */
#define DTK$K_ASCII 1   /* asky mode                                          */
#define DTK$K_MINUS 2   /* Say dash as minus bitvector index                  */
#define DTK$K_EUROPE 3  /* European type numbers                              */
#define DTK$K_SPELL 4   /* Spell all words                                    */
#define DTK$M_HOST 0x00000001
#define DTK$M_SPEAK_ALL 0x00000002
#define DTK$M_EDITED 0x00000004
#define DTK$M_HARD 0x00000008
#define DTK$M_SETUP 0x00000010
#define DTK$M_FILTER 0x00000020
#define DTK$K_HOST 0    /* Send all chars typed to host.                      */
#define DTK$K_SPEAK_ALL 1       /* Speak all chars typed.                     */
#define DTK$K_EDITED 2  /* Line edit all chars typed.                         */
#define DTK$K_HARD 3    /* Do local echo in hardcopy format.                  */
#define DTK$K_SETUP 4   /* Speak all chars displayed in setup mode.           */
#define DTK$K_FILTER 5  /* Don't send DECtalk specific sequences.             */
#define DTK$M_TEXT 0x00000001
#define DTK$M_PHONEME 0x00000002
#define DTK$M_RAWHOST 0x00000004
#define DTK$M_INHOST 0x00000008
#define DTK$M_OUTHOST 0x00000010
#define DTK$M_ERROR 0x00000020
#define DTK$M_TRACE 0x00000040
#define DTK$M_DEBUG 0x00000080
#define DTK$K_TEXT 0    /* Log ASCII text.                                    */
#define DTK$K_PHONEME 1 /* Log phonemic text.                                 */
#define DTK$K_RAWHOST 2 /* Log all chars without inspection.                  */
#define DTK$K_INHOST 3  /* Log text read from host.                           */
#define DTK$K_OUTHOST 4 /* Log text sent to host.                             */
#define DTK$K_ERROR 5   /* Log error messages.                                */
#define DTK$K_TRACE 6   /* Log sequences symbolically                         */
#define DTK$K_DEBUG 7   /* Reserved                                           */
union dtkdef {
/*                                                                            */
/*      DEFINE BITS, MASKS, AND FIELDS FOR THE CONTROL MODES.                 */
/*                                                                            */
    struct {
        unsigned dtk$v_square : 1;      /* Set mode square on                 */
        unsigned dtk$v_ascii : 1;       /* asky mode                          */
        unsigned dtk$v_minus : 1;       /* Say dash as minus                  */
        unsigned dtk$v_europe : 1;      /* Europe                             */
        unsigned dtk$v_spell : 1;       /* Spell all words                    */
        unsigned dtk$v_fill_0 : 3;
        } dtk$r_dtkmode_bits;
    struct {
        unsigned dtk$v_host : 1;        /* Send all chars typed to host.      */
        unsigned dtk$v_speak_all : 1;   /* Speak all chars typed.             */
        unsigned dtk$v_edited : 1;      /* Line edit all chars typed.         */
        unsigned dtk$v_hard : 1;        /* Do local echo in hardcopy format.  */
        unsigned dtk$v_setup : 1;       /* Speak all chars displayed in setup mode.   */
        unsigned dtk$v_filter : 1;      /* Don't send DECtalk specific sequences.     */
        unsigned dtk$v_fill_1 : 2;
        } dtk$r_dtkterm_bits;
    struct {
        unsigned dtk$v_text : 1;        /* Log ASCII text.                    */
        unsigned dtk$v_phoneme : 1;     /* Log phonemic text.                 */
        unsigned dtk$v_rawhost : 1;     /* Log all chars without inspection.  */
        unsigned dtk$v_inhost : 1;      /* Log text read from host.           */
        unsigned dtk$v_outhost : 1;     /* Log text sent to host.             */
        unsigned dtk$v_error : 1;       /* Log error messages.                */
        unsigned dtk$v_trace : 1;       /* Log sequences symbolically         */
        unsigned dtk$v_debug : 1;       /* Reserved                           */
        } dtk$r_dtklog_bits;
} ;
#endif
