/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:12:32 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]LIB$ROUTINE */
#ifndef LIB$ROUTINES_H
#define LIB$ROUTINES_H
 
/*** MODULE LIB$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    LIB$ADAWI                                                               */
/*                                                                            */
/*    Add Adjacent Word with Interlock                                        */
/*                                                                            */
/*    The Add Aligned Word with Interlock routine allows the user to perform an       */
/*    interlocked add operation using an aligned word.                        */
/*                                                                            */
/*+~lib$adawi~+*/
unsigned long int lib$adawi(
    const short int  *add,
    short int  *sum,
    short int  *result
    ) ;
/*~-lib$adawi-~*/
/*    LIB$ADD_TIMES                                                           */
/*                                                                            */
/*    Add Two Quadword Times                                                  */
/*                                                                            */
/*    The Add Two Quadword Times routine adds two VMS internal time format times.     */
/*                                                                            */
/*+~lib$add_times~+*/
unsigned long int lib$add_times(
    const unsigned int  *time1 [2],
    const unsigned int  *time2 [2],
    unsigned int  *resultant_time [2]
    ) ;
/*~-lib$add_times-~*/
/*    LIB$ADDX                                                                */
/*                                                                            */
/*    Add Two Multiple-Precision Binary Numbers                               */
/*                                                                            */
/*    The Add Two Multiple-Precision Binary Numbers routine adds two signed two's     */
/*    complement integers of arbitrary length.                                */
/*                                                                            */
/*+~lib$addx~+*/
unsigned long int lib$addx(
    const int  *addend_array,
    const int  *augend_array,
    int  *resultant_array,
    ...
    /* const long int  *array_length */
    ) ;
/*~-lib$addx-~*/
/*    LIB$ANALYZE_SDESC                                                       */
/*                                                                            */
/*    Analyze String Descriptors                                              */
/*                                                                            */
/*    The Analyze String Descriptors routine extracts the length and the address at   */
/*    which the data starts for a variety of string descriptor classes.       */
/*                                                                            */
/*+~lib$analyze_sdesc~+*/
unsigned long int lib$analyze_sdesc(
    const unsigned int  *input_descriptor [2],
    unsigned short int  *data_length,
    int * *data_address
    ) ;
/*~-lib$analyze_sdesc-~*/
/*    LIB$ASN_WTH_MBX                                                         */
/*                                                                            */
/*    Assign Channel with Mailbox                                             */
/*                                                                            */
/*    The Assign Channel with Mailbox routine assigns a channel to a specified device */
/*    and associates a mailbox with the device. It returns both the device channel and*/
/*    the mailbox channel.                                                    */
/*                                                                            */
/*+~lib$asn_wth_mbx~+*/
unsigned long int lib$asn_wth_mbx(
    const struct dsc$descriptor *device_name,
    const long int  *maximum_message_size,
    const long int  *buffer_quota,
    unsigned short int  *device_channel,
    unsigned short int  *mailbox_channel
    ) ;
/*~-lib$asn_wth_mbx-~*/
/*    LIB$AST_IN_PROG                                                         */
/*                                                                            */
/*    AST in Progress                                                         */
/*                                                                            */
/*    The AST in Progress routine indicates whether an AST is currently in progress.  */
/*                                                                            */
/*+~lib$ast_in_prog~+*/
char lib$ast_in_prog() ;
/*~-lib$ast_in_prog-~*/
/*    LIB$ATTACH                                                              */
/*                                                                            */
/*    Attach Terminal to Process                                              */
/*                                                                            */
/*    The Attach Terminal to Process routine requests the calling process's Command   */
/*    Language Interpreter (CLI) to detach the terminal of the calling process and to */
/*    reattach it to a different process.                                     */
/*                                                                            */
/*+~lib$attach~+*/
unsigned long int lib$attach(
    const unsigned long int  *process_id
    ) ;
/*~-lib$attach-~*/
/*    LIB$BBCCI                                                               */
/*                                                                            */
/*    Test and Clear Bit with Interlock                                       */
/*                                                                            */
/*    The Test and Clear Bit with Interlock routine tests and clears a selected bit   */
/*    under memory interlock. LIB$BBCCI makes the VAX BBCCI instruction available as a*/
/*    callable routine.                                                       */
/*                                                                            */
/*+~lib$bbcci~+*/
unsigned long int lib$bbcci(
    const long int  *position,
    const int *bit_zero_address
    ) ;
/*~-lib$bbcci-~*/
/*    LIB$BBSSI                                                               */
/*                                                                            */
/*    Test and Set Bit with Interlock                                         */
/*                                                                            */
/*    The Test and Set Bit with Interlock routine tests and sets a selected bit under */
/*    memory interlock. LIB$BBSSI makes the VAX BBSSI instruction available as a      */
/*    callable routine.                                                       */
/*                                                                            */
/*+~lib$bbssi~+*/
unsigned long int lib$bbssi(
    const long int  *position,
    const int *bit_zero_address
    ) ;
/*~-lib$bbssi-~*/
/*    LIB$CALLG                                                               */
/*                                                                            */
/*    Call Routine with General Argument List                                 */
/*                                                                            */
/*    The Call Routine with General Argument List routine calls a routine with an     */
/*    argument list specified as an array of longwords, the first of which is a count */
/*    of the remaining longwords. LIB$CALLG is a callable version of the VAX CALLG    */
/*    instruction.                                                            */
/*                                                                            */
/*+~lib$callg~+*/
unsigned long int lib$callg(
    const int  *argument_list,
    const int *user_procedure
    ) ;
/*~-lib$callg-~*/
/*    LIB$CREATE_DIR                                                          */
/*                                                                            */
/*    Create a Directory                                                      */
/*                                                                            */
/*    The Create a Directory routine creates a directory or subdirectory.     */
/*                                                                            */
/*+~lib$create_dir~+*/
unsigned long int lib$create_dir(
    const struct dsc$descriptor *device_directory_spec,
    ...
    /* const unsigned long int  *owner_uic, */
    /* const unsigned short int  *protection_enable, */
    /* const unsigned short int  *protection_value, */
    /* const unsigned short int  *maximum_versions, */
    /* const unsigned short int  *relative_volume_number */
    ) ;
/*~-lib$create_dir-~*/
/*    LIB$CHAR                                                                */
/*                                                                            */
/*    Transform Byte to First Character of String                             */
/*                                                                            */
/*    The Transform Byte to First Character of String routine transforms a single     */
/*    8-bit ASCII character to an ASCII string consisting of a single character       */
/*    followed by trailing spaces, if needed, to fill out the string.  The range of   */
/*    the input byte is 0 through 255.                                        */
/*                                                                            */
/*+~lib$char~+*/
unsigned long int lib$char(
    struct dsc$descriptor *one_character_string,
    const unsigned char  *ascii_code
    ) ;
/*~-lib$char-~*/
/*    LIB$CONVERT_DATE_STRING                                                 */
/*                                                                            */
/*    Convert Date String to Quadword                                         */
/*                                                                            */
/*    The Convert Date String to Quadword routine converts an absolute date   */
/*    string into a VMS internal format date-time quadword. That is, given    */
/*    an input date/time string of a specified format,                        */
/*    LIB$CONVERT_DATE_STRING converts this string to a VMS internal format   */
/*    time.                                                                   */
/*                                                                            */
/*+~lib$convert_date_string~+*/
unsigned long int lib$convert_date_string(
    const struct dsc$descriptor *date_string,
    unsigned int  *date_time [2],
    ...
    /* unsigned long int  *user_context, */
    /* const unsigned long int  *flags, */
    /* const unsigned short int  *defaults [1], */
    /* unsigned long int  *defaulted_fields */
    ) ;
/*~-lib$convert_date_string-~*/
/*    LIB$CRC                                                                 */
/*                                                                            */
/*    Calculate a Cyclic Redundancy Check (CRC)                               */
/*                                                                            */
/*    The Calculate a Cyclic Redundancy Check routine calculates the cyclic redundancy*/
/*    check (CRC) for a data stream. LIB$CRC makes the VAX CRC instruction available  */
/*    as a callable routine.                                                  */
/*                                                                            */
/*+~lib$crc~+*/
unsigned long int lib$crc(
    const long int  *crc_table [1],
    const long int  *initial_crc,
    const struct dsc$descriptor *stream
    ) ;
/*~-lib$crc-~*/
/*    LIB$CRC_TABLE                                                           */
/*                                                                            */
/*    Construct a Cyclic Redundancy Check (CRC) Table                         */
/*                                                                            */
/*    The Construct a Cyclic Redundancy Check Table routine constructs a 16-longword  */
/*    table that uses a cyclic redundancy check polynomial specification as a bit     */
/*    mask.                                                                   */
/*                                                                            */
/*+~lib$crc_table~+*/
int lib$crc_table(
    const unsigned long int  *polynomial_coefficient,
    long int  *crc_table [1]
    ) ;
/*~-lib$crc_table-~*/
/*    LIB$CRF_INS_KEY                                                         */
/*                                                                            */
/*    Insert Key in Cross-Reference Table                                     */
/*                                                                            */
/*    The Insert Key in Cross-Reference Table routine inserts information about a key */
/*    into a cross-reference table.                                           */
/*                                                                            */
/*+~lib$crf_ins_key~+*/
int lib$crf_ins_key(
    const long int  *control_table [1],
    const struct dsc$descriptor *key_string,
    const long int  *symbol_value,
    const unsigned long int  *flags
    ) ;
/*~-lib$crf_ins_key-~*/
/*    LIB$CRF_INS_REF                                                         */
/*                                                                            */
/*    Insert Reference to a Key in the Cross-Reference Table                  */
/*                                                                            */
/*    The Insert Reference to a Key in the Cross-Reference Table routine inserts a    */
/*    reference to a key in a cross-reference symbol table.                   */
/*                                                                            */
/*+~lib$crf_ins_ref~+*/
int lib$crf_ins_ref(
    const long int  *control_table [1],
    const long int  *longword_integer_key,
    const struct dsc$descriptor *reference_string,
    long int  *longword_integer_reference,
    const long int  *ref_definition_indicator
    ) ;
/*~-lib$crf_ins_ref-~*/
/*    LIB$CRF_OUTPUT                                                          */
/*                                                                            */
/*    Output Cross-Reference Table Information                                */
/*                                                                            */
/*    The Output Cross-Reference Table Information routine extracts the information   */
/*    from the cross-reference tables and formats the output pages.           */
/*                                                                            */
/*+~lib$crf_output~+*/
int lib$crf_output(
    const long int  *control_table [1],
    const long int  *output_line_width,
    const long int  *page1,
    const long int  *page2,
    const long int  *mode_indicator,
    const long int  *delete_save_indicator
    ) ;
/*~-lib$crf_output-~*/
/*    LIB$CURRENCY                                                            */
/*                                                                            */
/*    Get System Currency Symbol                                              */
/*                                                                            */
/*    The Get System Currency Symbol routine returns the system's currency symbol.    */
/*                                                                            */
/*+~lib$currency~+*/
unsigned long int lib$currency(
    struct dsc$descriptor *currency_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$currency-~*/
/*    LIB$CREATE_USER_VM_ZONE                                                 */
/*                                                                            */
/*    Create User-Defined Storage Zone                                        */
/*                                                                            */
/*    The Create User-Defined Storage Zone routine creates a new user-defined storage */
/*    zone.                                                                   */
/*                                                                            */
/*+~lib$create_user_vm_zone~+*/
unsigned long int lib$create_user_vm_zone(
    unsigned long int  *zone_id,
    ...
    /* const unsigned long int  *user_argument, */
    /* const int *user_allocation_procedure, */
    /* const int *user_deallocation_procedure, */
    /* const int *user_reset_procedure, */
    /* const int *user_delete_procedure, */
    /* const struct dsc$descriptor *zone_name */
    ) ;
/*~-lib$create_user_vm_zone-~*/
/*    LIB$CVT_DX_DX                                                           */
/*                                                                            */
/*    General Data Type Conversion Routine                                    */
/*                                                                            */
/*    The General Data Type Conversion routine converts a VAX standard atomic or string datum described by a  */
/*    source descriptor to another VAX standard atomic or string datum described      */
/*    by a destination descriptor. This conversion is supported over a subset of      */
/*    the VAX standard data types.                                            */
/*                                                                            */
/*+~lib$cvt_dx_dx~+*/
unsigned long int lib$cvt_dx_dx(
    const int  *source_item,
    int  *destination_item,
    ...
    /* unsigned short int  *word_integer_dest_length */
    ) ;
/*~-lib$cvt_dx_dx-~*/
/*    LIB$CVTF_FROM_INTERNAL_TIME                                             */
/*                                                                            */
/*    Convert Internal Time to External Time (F-floating Point Value)         */
/*                                                                            */
/*    The Convert Internal Time to External Time (F-floating point value)     */
/*    routine converts a delta internal VMS system time into an external      */
/*    F-floating time.                                                        */
/*                                                                            */
/*+~lib$cvtf_from_internal_time~+*/
unsigned long int lib$cvtf_from_internal_time(
    const unsigned long int  *operation,
    float  *resultant_time,
    const unsigned int  *input_time [2]
    ) ;
/*~-lib$cvtf_from_internal_time-~*/
/*    LIB$CVT_FROM_INTERNAL_TIME                                              */
/*                                                                            */
/*    Convert Internal Time to External Time                                  */
/*                                                                            */
/*    The Convert Internal Time to External Time routine converts an internal VMS system time */
/*    (either absolute or delta) into an external time.                       */
/*                                                                            */
/*+~lib$cvt_from_internal_time~+*/
unsigned long int lib$cvt_from_internal_time(
    const unsigned long int  *operation,
    unsigned long int  *resultant_time,
    ...
    /* const unsigned int  *input_time [2] */
    ) ;
/*~-lib$cvt_from_internal_time-~*/
/*    LIB$CVTF_TO_INTERNAL_TIME                                               */
/*                                                                            */
/*    Convert External Time to Internal Time (F-Floating Point Value)         */
/*                                                                            */
/*    The Convert External Time to Internal Time (F-floating point value) routine     */
/*    converts an external time interval into a VMS internal format F-floating delta  */
/*    time.                                                                   */
/*                                                                            */
/*+~lib$cvtf_to_internal_time~+*/
unsigned long int lib$cvtf_to_internal_time(
    const unsigned long int  *operation,
    const float  *input_time,
    unsigned int  *resultant_time [2]
    ) ;
/*~-lib$cvtf_to_internal_time-~*/
/*    LIB$CVT_TO_INTERNAL_TIME                                                */
/*                                                                            */
/*    Convert External Time to Internal Time                                  */
/*                                                                            */
/*    The Convert External Time to Internal Time routine converts an external time    */
/*    interval into a VMS internal format delta time.                         */
/*                                                                            */
/*+~lib$cvt_to_internal_time~+*/
unsigned long int lib$cvt_to_internal_time(
    const unsigned long int  *operation,
    const long int  *input_time,
    unsigned int  *resultant_time [2]
    ) ;
/*~-lib$cvt_to_internal_time-~*/
/*    LIB$CVT_VECTIM                                                          */
/*                                                                            */
/*    Convert Seven-Word Vector to Internal Time                              */
/*                                                                            */
/*    The Convert Seven-Word Vector to Internal Time routine converts a       */
/*    seven-word vector                                                       */
/*    into a VMS internal format delta or absolute time.                      */
/*                                                                            */
/*+~lib$cvt_vectim~+*/
unsigned long int lib$cvt_vectim(
    const unsigned short int  *input_time [1],
    unsigned int  *resultant_time [2]
    ) ;
/*~-lib$cvt_vectim-~*/
/*    LIB$CVT_DTB                                                             */
/*                                                                            */
/*    Convert Numeric Text to Binary                                          */
/*                                                                            */
/*    The Convert Numeric Text to Binary routines return a binary representation of   */
/*    the ASCII text string representation of a decimal, hexadecimal, or octal number.*/
/*                                                                            */
/*+~lib$cvt_dtb~+*/
unsigned long int lib$cvt_dtb(
    const long int byte_count,
    const char  *numeric_string,
    long int  *result
    ) ;
/*~-lib$cvt_dtb-~*/
/*    LIB$CVT_HTB                                                             */
/*                                                                            */
/*    Convert Numeric Text to Binary                                          */
/*                                                                            */
/*    The Convert Numeric Text to Binary routines return a binary representation of   */
/*    the ASCII text string representation of a decimal, hexadecimal, or octal number.*/
/*                                                                            */
/*+~lib$cvt_htb~+*/
unsigned long int lib$cvt_htb(
    const long int byte_count,
    const char  *numeric_string,
    long int  *result
    ) ;
/*~-lib$cvt_htb-~*/
/*    LIB$CVT_OTB                                                             */
/*                                                                            */
/*    Convert Numeric Text to Binary                                          */
/*                                                                            */
/*    The Convert Numeric Text to Binary routines return a binary representation of   */
/*    the ASCII text string representation of a decimal, hexadecimal, or octal number.*/
/*                                                                            */
/*+~lib$cvt_otb~+*/
unsigned long int lib$cvt_otb(
    const long int byte_count,
    const char  *numeric_string,
    long int  *result
    ) ;
/*~-lib$cvt_otb-~*/
/*    LIB$CREATE_VM_ZONE                                                      */
/*                                                                            */
/*    Create a New Zone                                                       */
/*                                                                            */
/*    The Create a New Zone routine creates a new storage zone according to specified */
/*    arguments.                                                              */
/*                                                                            */
/*+~lib$create_vm_zone~+*/
unsigned long int lib$create_vm_zone(
    unsigned long int  *zone_id,
    ...
    /* const long int  *algorithm, */
    /* const long int  *algorithm_argument, */
    /* const unsigned long int  *flags, */
    /* const long int  *extend_size, */
    /* const long int  *initial_size, */
    /* const long int  *block_size, */
    /* const long int  *alignment, */
    /* const long int  *page_limit, */
    /* const long int  *smallest_block_size, */
    /* const struct dsc$descriptor *zone_name, */
    /* const long int  *number_of_areas, */
    /* const int *get_page, */
    /* const int *free_page */
    ) ;
/*~-lib$create_vm_zone-~*/
/*    LIB$DATE_TIME                                                           */
/*                                                                            */
/*    Date and Time Returned as a String                                      */
/*                                                                            */
/*    The Date and Time Returned as a String routine returns the VMS system date      */
/*    and time in the semantics of a user-provided string.                    */
/*                                                                            */
/*+~lib$date_time~+*/
unsigned long int lib$date_time(
    struct dsc$descriptor *date_time_string
    ) ;
/*~-lib$date_time-~*/
/*    LIB$DAY                                                                 */
/*                                                                            */
/*    Day Number Returned as a Longword Integer                               */
/*                                                                            */
/*    The Day Number Returned as a Longword Integer routine returns the number of days*/
/*    since the system zero date of November 17, 1858, or the number of days from     */
/*    November 17, 1858, to a user-supplied date.                             */
/*                                                                            */
/*+~lib$day~+*/
unsigned long int lib$day(
    long int  *number_of_days,
    ...
    /* const unsigned int  *user_time [2], */
    /* long int  *day_time */
    ) ;
/*~-lib$day-~*/
/*    LIB$DAY_OF_WEEK                                                         */
/*                                                                            */
/*    Show Numeric Day of Week                                                */
/*                                                                            */
/*    The Show Numeric Day of Week routine returns the numeric day of the week for an */
/*    input time value. If 0 is the input time value, the current day of the week is  */
/*    returned.  The days are numbered 1 through 7, with Monday as day 1 and Sunday as*/
/*    day 7.                                                                  */
/*                                                                            */
/*+~lib$day_of_week~+*/
unsigned long int lib$day_of_week(
    const unsigned int  *user_time [2],
    unsigned long int  *day_number
    ) ;
/*~-lib$day_of_week-~*/
/*    LIB$DEC_OVER                                                            */
/*                                                                            */
/*    Enable or Disable Decimal Overflow Detection                            */
/*                                                                            */
/*    The Enable or Disable Decimal Overflow Detection routine enables or disables    */
/*    decimal overflow detection for the calling routine activation.  The previous    */
/*    decimal overflow setting is returned.                                   */
/*                                                                            */
/*+~lib$dec_over~+*/
unsigned long int lib$dec_over(
    const unsigned long int  *new_setting
    ) ;
/*~-lib$dec_over-~*/
/*    LIB$DECODE_FAULT                                                        */
/*                                                                            */
/*    Decode Instruction Stream During Fault                                  */
/*                                                                            */
/*    The Decode Instruction Stream During Fault routine is a tool for building       */
/*    condition handlers that process instruction fault exceptions.  It is called     */
/*    from a condition handler.                                               */
/*                                                                            */
/*+~lib$decode_fault~+*/
unsigned long int lib$decode_fault(
    const int  *signal_arguments,
    const int  *mechanism_arguments,
    const struct dsc$descriptor *user_procedure,
    ...
    /* const int unspecified_user_argument, */
    /* const unsigned char  *instruction_definitions [1] */
    ) ;
/*~-lib$decode_fault-~*/
/*    LIB$DELETE_FILE                                                         */
/*                                                                            */
/*    Delete One Or More Files                                                */
/*                                                                            */
/*    The Delete One or More Files routine deletes one or more files. The     */
/*    specification of the file(s) to be deleted may include wildcards.       */
/*                                                                            */
/*    LIB$DELETE_FILE is similar in function to the DCL command DELETE.       */
/*                                                                            */
/*+~lib$delete_file~+*/
unsigned long int lib$delete_file(
    const struct dsc$descriptor *filespec,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const struct dsc$descriptor *related_filespec, */
    /* const int *user_success_procedure, */
    /* const int *user_error_procedure, */
    /* const int *user_confirm_procedure, */
    /* const int user_specified_argument, */
    /* struct dsc$descriptor *resultant_name, */
    /* unsigned long int  *file_scan_context */
    ) ;
/*~-lib$delete_file-~*/
/*    LIB$DIGIT_SEP                                                           */
/*                                                                            */
/*    Get Digit Separator Symbol                                              */
/*                                                                            */
/*    The Get Digit Separator Symbol routine returns the system's digit separator     */
/*    symbol.                                                                 */
/*                                                                            */
/*+~lib$digit_sep~+*/
unsigned long int lib$digit_sep(
    struct dsc$descriptor *digit_separator_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$digit_sep-~*/
/*    LIB$DISABLE_CTRL                                                        */
/*                                                                            */
/*    Disable CLI Interception of Control Characters                          */
/*                                                                            */
/*    The Disable CLI Interception of Control Characters routine requests the calling */
/*    process's Command Language Interpreter (CLI) to not intercept the selected      */
/*    control characters when they are typed during an interactive terminal session.  */
/*    LIB$DISABLE_CTRL provides the same function as the DCL command SET NOCONTROL.   */
/*                                                                            */
/*+~lib$disable_ctrl~+*/
unsigned long int lib$disable_ctrl(
    const unsigned long int  *disable_mask,
    ...
    /* unsigned long int  *old_mask */
    ) ;
/*~-lib$disable_ctrl-~*/
/*    LIB$DELETE_LOGICAL                                                      */
/*                                                                            */
/*    Delete Logical Name                                                     */
/*                                                                            */
/*    The Delete Logical Name routine requests the calling process's Command Language */
/*    Interpreter (CLI) to delete a supervisor-mode process logical name.     */
/*    LIB$DELETE_LOGICAL provides the same function as the DCL command DEASSIGN.      */
/*                                                                            */
/*+~lib$delete_logical~+*/
unsigned long int lib$delete_logical(
    const struct dsc$descriptor *logical_name,
    ...
    /* const struct dsc$descriptor *table_name */
    ) ;
/*~-lib$delete_logical-~*/
/*    LIB$DO_COMMAND                                                          */
/*                                                                            */
/*    Execute Command                                                         */
/*                                                                            */
/*    The Execute Command routine stops program execution and directs the Command     */
/*    Language Interpreter to execute a command which you supply as the argument. If  */
/*    successful, LIB$DO_COMMAND does not return control to the calling program.      */
/*    Instead, LIB$DO_COMMAND begins execution of the specified command.      */
/*                                                                            */
/*    If you want control to return to the caller, use LIB$SPAWN instead.     */
/*                                                                            */
/*+~lib$do_command~+*/
unsigned long int lib$do_command(
    const struct dsc$descriptor *command_string
    ) ;
/*~-lib$do_command-~*/
/*    LIB$DELETE_SYMBOL                                                       */
/*                                                                            */
/*    Delete CLI Symbol                                                       */
/*                                                                            */
/*    The Delete CLI Symbol routine requests the calling process's Command Language   */
/*    Interpreter (CLI) to delete an existing CLI symbol.                     */
/*                                                                            */
/*+~lib$delete_symbol~+*/
unsigned long int lib$delete_symbol(
    const struct dsc$descriptor *symbol,
    ...
    /* const long int  *table_type_indicator */
    ) ;
/*~-lib$delete_symbol-~*/
/*    LIB$FORMAT_DATE_TIME                                                    */
/*                                                                            */
/*    Format Date And/Or Time                                                 */
/*                                                                            */
/*    The Format Date And/Or Time routine allows the user to select at run time a     */
/*    specific output language and format for a date or time, or both.        */
/*                                                                            */
/*+~lib$format_date_time~+*/
unsigned long int lib$format_date_time(
    struct dsc$descriptor *date_string,
    ...
    /* const unsigned int  *date [2], */
    /* unsigned long int  *user_context, */
    /* long int  *date_length, */
    /* const unsigned long int  *flags */
    ) ;
/*~-lib$format_date_time-~*/
/*    LIB$DELETE_VM_ZONE                                                      */
/*                                                                            */
/*    Delete Virtual Memory Zone                                              */
/*                                                                            */
/*    The Delete Virtual Memory Zone routine deletes a zone and returns all pages     */
/*    owned by the zone to the processwide page pool.                         */
/*                                                                            */
/*+~lib$delete_vm_zone~+*/
unsigned long int lib$delete_vm_zone(
    const unsigned long int  *zone_id
    ) ;
/*~-lib$delete_vm_zone-~*/
/*    LIB$EDIV                                                                */
/*                                                                            */
/*    Extended-Precision Divide                                               */
/*                                                                            */
/*    The Extended-Precision Divide routine performs extended-precision division.     */
/*    LIB$EDIV makes the VAX EDIV instruction available as a callable routine.        */
/*                                                                            */
/*+~lib$ediv~+*/
unsigned long int lib$ediv(
    const long int  *longword_integer_divisor,
    const int  *quadword_integer_dividend [2],
    long int  *longword_integer_quotient,
    long int  *remainder
    ) ;
/*~-lib$ediv-~*/
/*    LIB$EMODD                                                               */
/*                                                                            */
/*    Extended Multiply and Integerize Routines for D-floating Point Values   */
/*                                                                            */
/*    The Extended Multiply and Integerize routine (D-floating point values) allows   */
/*    higher-level language users to perform accurate range reduction of D-floating   */
/*    arguments.                                                              */
/*                                                                            */
/*+~lib$emodd~+*/
unsigned long int lib$emodd(
    const double float  *floating_point_multiplier,
    const unsigned char  *multiplier_extension,
    const double float  *floating_point_multiplicand,
    long int  *integer_portion,
    double float  *fractional_portion
    ) ;
/*~-lib$emodd-~*/
/*    LIB$EMODF                                                               */
/*                                                                            */
/*    Extended Multiply and Integerize Routines for F-floating Point Values   */
/*                                                                            */
/*    The Extended Multiply and Integerize routine (F-floating point values) allows   */
/*    higher-level language users to perform accurate range reduction of F-floating   */
/*    arguments.                                                              */
/*                                                                            */
/*+~lib$emodf~+*/
unsigned long int lib$emodf(
    const float  *floating_point_multiplier,
    const unsigned char  *multiplier_extension,
    const float  *floating_point_multiplicand,
    long int  *integer_portion,
    float  *fractional_portion
    ) ;
/*~-lib$emodf-~*/
/*    LIB$EMODG                                                               */
/*                                                                            */
/*    Extended Multiply and Integerize Routines for G-floating Point Values   */
/*                                                                            */
/*    The Extended Multiply and Integerize routine (G-floating point values) allows   */
/*    higher-level language users to perform accurate range reduction of G-floating   */
/*    arguments.                                                              */
/*                                                                            */
/*+~lib$emodg~+*/
unsigned long int lib$emodg(
    const double float  *floating_point_multiplier,
    const unsigned short int  *multiplier_extension,
    const double float  *floating_point_multiplicand,
    long int  *integer_portion,
    double float  *fractional_portion
    ) ;
/*~-lib$emodg-~*/
/*    LIB$EMODH                                                               */
/*                                                                            */
/*    Extended Multiply and Integerize Routines for H-floating Point Values   */
/*                                                                            */
/*    The Extended Multiply and Integerize routine (H-floating point values) allows   */
/*    higher-level language users to perform accurate range reduction of H-floating   */
/*    arguments.                                                              */
/*                                                                            */
/*+~lib$emodh~+*/
unsigned long int lib$emodh(
    const struct {int floating$$ret_0_ [4];}  *floating_point_multiplier,
    const unsigned short int  *multiplier_extension,
    const struct {int floating$$ret_1_ [4];}  *floating_point_multiplicand,
    long int  *integer_portion,
    struct {int fraction$$ret_0_ [4];}  *fractional_portion
    ) ;
/*~-lib$emodh-~*/
/*    LIB$EMUL                                                                */
/*                                                                            */
/*    Extended-Precision Multiply                                             */
/*                                                                            */
/*    The Extended-Precision Multiply routine performs extended-precision     */
/*    multiplication. LIB$EMUL makes the VAX EMUL instruction available as a callable */
/*    routine.                                                                */
/*                                                                            */
/*+~lib$emul~+*/
unsigned long int lib$emul(
    const long int  *longword_integer_multiplier,
    const long int  *longword_integer_multiplicand,
    const long int  *addend,
    int  *product [2]
    ) ;
/*~-lib$emul-~*/
/*    LIB$ENABLE_CTRL                                                         */
/*                                                                            */
/*    Enable CLI Interception of Control Characters                           */
/*                                                                            */
/*    The Enable CLI Interception of Control Characters routine requests the calling  */
/*    process's Command Language Interpreter (CLI) to resume interception of the      */
/*    selected control characters when they are typed during an interactive terminal  */
/*    session. LIB$ENABLE_CTRL provides the same function as the DCL command SET      */
/*    CONTROL.                                                                */
/*                                                                            */
/*+~lib$enable_ctrl~+*/
unsigned long int lib$enable_ctrl(
    const unsigned long int  *enable_mask,
    ...
    /* unsigned long int  *old_mask */
    ) ;
/*~-lib$enable_ctrl-~*/
/*    LIB$ESTABLISH                                                           */
/*                                                                            */
/*    Establish a Condition Handler                                           */
/*                                                                            */
/*    The Establish a Condition Handler routine moves the address of a condition      */
/*    handling routine (which can be a user-written or a library routine) to  */
/*    longword 0 of the stack frame of the caller of LIB$ESTABLISH.           */
/*                                                                            */
/*+~lib$establish~+*/
int *lib$establish(
    const int *new_handler
    ) ;
/*~-lib$establish-~*/
/*    LIB$EXTV                                                                */
/*                                                                            */
/*    Extract a Field and Sign-Extend                                         */
/*                                                                            */
/*    The Extract a Field and Sign-Extend routine returns a sign-extended longword    */
/*    field that has been extracted from the specified variable bit field. LIB$EXTV   */
/*    makes the VAX EXTV instruction available as a callable routine.         */
/*                                                                            */
/*+~lib$extv~+*/
long int lib$extv(
    const long int  *position,
    const unsigned char  *size,
    const int *base_address
    ) ;
/*~-lib$extv-~*/
/*    LIB$EXTZV                                                               */
/*                                                                            */
/*    Extract a Zero-Extended Field                                           */
/*                                                                            */
/*    The Extract a Zero-Extended Field routine returns a longword zero-extended field*/
/*    that has been extracted from the specified variable bit field. LIB$EXTZV makes  */
/*    the VAX EXTZV instruction available as a callable routine.              */
/*                                                                            */
/*+~lib$extzv~+*/
long int lib$extzv(
    const long int  *position,
    const unsigned char  *size,
    const int *base_address
    ) ;
/*~-lib$extzv-~*/
/*    LIB$FREE_DATE_TIME_CONTEXT                                              */
/*                                                                            */
/*    Free The Context Area Used When Formatting Dates And Times for Input or Output  */
/*                                                                            */
/*    The Free The Context Area Used When Formatting Dates And Times for      */
/*    Input or Output routine frees                                           */
/*    the virtual memory associated with the context area used by the date/time       */
/*    input and output Formatting Routines.                                   */
/*                                                                            */
/*+~lib$free_date_time_context~+*/
unsigned long int lib$free_date_time_context(
    /* unsigned long int  *user_context */
    ) ;
/*~-lib$free_date_time_context-~*/
/*    LIB$FREE_EF                                                             */
/*                                                                            */
/*    Free Event Flag                                                         */
/*                                                                            */
/*    The Free Event Flag routine frees a local event flag previously allocated by    */
/*    LIB$GET_EF. LIB$FREE_EF is the complement of LIB$GET_EF.                */
/*                                                                            */
/*+~lib$free_ef~+*/
unsigned long int lib$free_ef(
    const unsigned long int  *event_flag_number
    ) ;
/*~-lib$free_ef-~*/
/*    LIB$FIND_FILE_END                                                       */
/*                                                                            */
/*    End of Find File                                                        */
/*                                                                            */
/*    The End of Find File routine is called once after each sequence of calls to     */
/*    LIB$FIND_FILE. LIB$FIND_FILE_END deallocates any saved Record Management Service*/
/*    (RMS) context and deallocates the virtual memory used to hold the allocated     */
/*    context block.                                                          */
/*                                                                            */
/*+~lib$find_file_end~+*/
unsigned long int lib$find_file_end(
    const unsigned long int  *context
    ) ;
/*~-lib$find_file_end-~*/
/*    LIB$FIND_FILE                                                           */
/*                                                                            */
/*    Find File                                                               */
/*                                                                            */
/*    The Find File routine is called with a wildcard file specification for which it */
/*    searches.  LIB$FIND_FILE returns all file specifications that satisfy   */
/*    that wildcard file specification.                                       */
/*                                                                            */
/*+~lib$find_file~+*/
unsigned long int lib$find_file(
    const struct dsc$descriptor *filespec,
    struct dsc$descriptor *resultant_filespec,
    unsigned long int  *context,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const struct dsc$descriptor *related_filespec, */
    /* unsigned long int  *status_value, */
    /* const unsigned long int  *flags */
    ) ;
/*~-lib$find_file-~*/
/*    LIB$FFC                                                                 */
/*                                                                            */
/*    Find First Clear or Set Bit                                             */
/*                                                                            */
/*    The Find First Clear or Set Bit routines search the field specified by the start*/
/*    position, size, and base for the first clear or set bit. LIB$FFC and LIB$FFS    */
/*    make the VAX FFC and FFS instructions available as callable routines.   */
/*                                                                            */
/*+~lib$ffc~+*/
unsigned long int lib$ffc(
    const long int  *position,
    const unsigned char  *size,
    const int * *base,
    long int  *find_position
    ) ;
/*~-lib$ffc-~*/
/*    LIB$FFS                                                                 */
/*                                                                            */
/*    Find First Clear or Set Bit                                             */
/*                                                                            */
/*    The Find First Clear or Set Bit routines search the field specified by the start*/
/*    position, size, and base for the first clear or set bit. LIB$FFC and LIB$FFS    */
/*    make the VAX FFC and FFS instructions available as callable routines.   */
/*                                                                            */
/*+~lib$ffs~+*/
unsigned long int lib$ffs(
    const long int  *position,
    const unsigned char  *size,
    const int * *base,
    long int  *find_position
    ) ;
/*~-lib$ffs-~*/
/*    LIB$FID_TO_NAME                                                         */
/*                                                                            */
/*    Convert Device and File ID to File Specification                        */
/*                                                                            */
/*    The Convert Device and File ID to File Specification routine converts a disk    */
/*    device name and file identifier to a file specification.                */
/*                                                                            */
/*+~lib$fid_to_name~+*/
unsigned long int lib$fid_to_name(
    const struct dsc$descriptor *device_name,
    const unsigned short int  *file_id,
    struct dsc$descriptor *filespec,
    ...
    /* unsigned short int  *filespec_length, */
    /* const unsigned short int  *directory_id [1], */
    /* unsigned long int  *acp_status */
    ) ;
/*~-lib$fid_to_name-~*/
/*    LIB$FIND_IMAGE_SYMBOL                                                   */
/*                                                                            */
/*    Find Universal Symbol in Shareable Image File                           */
/*                                                                            */
/*    The Find Universal Symbol in Shareable Image File routine reads universal       */
/*    symbols from the shareable image file. This routine then dynamically activates a*/
/*    shareable image into the P0 address space of a process.                 */
/*                                                                            */
/*+~lib$find_image_symbol~+*/
unsigned long int lib$find_image_symbol(
    const struct dsc$descriptor *filename,
    const struct dsc$descriptor *symbol,
    long int  *symbol_value,
    ...
    /* const struct dsc$descriptor *image_name */
    ) ;
/*~-lib$find_image_symbol-~*/
/*    LIB$FIXUP_FLT                                                           */
/*                                                                            */
/*    Fix Floating Reserved Operand                                           */
/*                                                                            */
/*    The Fix Floating Reserved Operand routine finds the reserved operand of any     */
/*    F_floating, D_floating, G_floating, or H_floating instruction (with some*/
/*    exceptions) after a reserved operand fault has been signaled. LIB$FIXUP_FLT     */
/*    changes the reserved operand from --0.0 to the value of the             */
/*    new-operand argument, if present; or to +0.0 if                         */
/*    new-operand is absent.                                                  */
/*                                                                            */
/*+~lib$fixup_flt~+*/
unsigned long int lib$fixup_flt(
    const int  *signal_arguments,
    const int  *mechanism_arguments,
    ...
    /* const float  *new_operand */
    ) ;
/*~-lib$fixup_flt-~*/
/*    LIB$FLT_UNDER                                                           */
/*                                                                            */
/*    Floating-Point Underflow Detection                                      */
/*                                                                            */
/*    The Floating-Point Underflow Detection routine enables or disables      */
/*    floating-point underflow detection for the calling routine activation.  The     */
/*    previous setting is returned as a function value.                       */
/*                                                                            */
/*+~lib$flt_under~+*/
unsigned long int lib$flt_under(
    const unsigned long int  *new_setting
    ) ;
/*~-lib$flt_under-~*/
/*    LIB$FREE_LUN                                                            */
/*                                                                            */
/*    Free Logical Unit Number                                                */
/*                                                                            */
/*    The Free Logical Unit Number routine releases a logical unit number allocated by*/
/*    LIB$GET_LUN to the pool of available numbers. LIB$FREE_LUN is the complement of */
/*    LIB$GET_LUN.                                                            */
/*                                                                            */
/*+~lib$free_lun~+*/
unsigned long int lib$free_lun(
    const long int  *logical_unit_number
    ) ;
/*~-lib$free_lun-~*/
/*    LIB$FREE_VM_PAGE                                                        */
/*                                                                            */
/*    Free Virtual Memory Page                                                */
/*                                                                            */
/*    The Free Virtual Memory Page routine deallocates a block of contiguous pages    */
/*    that were allocated by previous calls to LIB$GET_VM_PAGE.               */
/*                                                                            */
/*+~lib$free_vm_page~+*/
unsigned long int lib$free_vm_page(
    const long int  *number_of_pages,
    const int * *base_address
    ) ;
/*~-lib$free_vm_page-~*/
/*    LIB$FILE_SCAN                                                           */
/*                                                                            */
/*    File Scan                                                               */
/*                                                                            */
/*    The File Scan routine searches an area, such as a directory, for all files      */
/*    matching the file specification given and transfers program execution to the    */
/*    specified user-written routine.  Wildcards are acceptable. An action routine is */
/*    called for each file and/or error found. LIB$FILE_SCAN allows the search*/
/*    sequence to continue even if an error occurs while processing a particular file.*/
/*                                                                            */
/*+~lib$file_scan~+*/
unsigned long int lib$file_scan(
    const int  *fab,
    const int *user_success_procedure,
    const int *user_error_procedure,
    ...
    /* unsigned long int  *context */
    ) ;
/*~-lib$file_scan-~*/
/*    LIB$FILE_SCAN_END                                                       */
/*                                                                            */
/*    End-of-File Scan                                                        */
/*                                                                            */
/*    The End of File Scan routine is called after each sequence of calls to  */
/*    LIB$FILE_SCAN. LIB$FILE_SCAN_END deallocates any saved Record Management Service*/
/*    (RMS) context and/or deallocates the virtual memory that had been allocated for */
/*    holding the related file specification information.                     */
/*                                                                            */
/*+~lib$file_scan_end~+*/
unsigned long int lib$file_scan_end(
    /* int  *fab, */
    /* unsigned long int  *context */
    ) ;
/*~-lib$file_scan_end-~*/
/*    LIB$FREE_TIMER                                                          */
/*                                                                            */
/*    Free Timer Storage                                                      */
/*                                                                            */
/*    The Free Timer Storage routine frees the storage allocated by LIB$INIT_TIMER.   */
/*                                                                            */
/*+~lib$free_timer~+*/
unsigned long int lib$free_timer(
    int * *handle_address
    ) ;
/*~-lib$free_timer-~*/
/*    LIB$FREE_VM                                                             */
/*                                                                            */
/*    Free Virtual Memory from Program Region                                 */
/*                                                                            */
/*    The Free Virtual Memory from Program Region routine deallocates an entire block */
/*    of contiguous bytes that were allocated by a previous call to LIB$GET_VM. The   */
/*    arguments passed are the same as for LIB$GET_VM.                        */
/*                                                                            */
/*+~lib$free_vm~+*/
unsigned long int lib$free_vm(
    const long int  *number_of_bytes,
    const int * *base_address,
    ...
    /* const unsigned long int  *zone_id */
    ) ;
/*~-lib$free_vm-~*/
/*    LIB$FIND_VM_ZONE                                                        */
/*                                                                            */
/*    Return the Next Valid Zone Identifier                                   */
/*                                                                            */
/*    The Return the Next Valid Zone Identifier routine returns the           */
/*    zone identifier of the next valid zone in the heap management           */
/*    database.                                                               */
/*                                                                            */
/*+~lib$find_vm_zone~+*/
unsigned long int lib$find_vm_zone(
    unsigned long int  *context,
    unsigned long int  *zone_id
    ) ;
/*~-lib$find_vm_zone-~*/
/*    LIB$GET_COMMAND                                                         */
/*                                                                            */
/*    Get Line from SYS$COMMAND                                               */
/*                                                                            */
/*    The Get Line from SYS$COMMAND routine gets  one record of ASCII text  from the  */
/*    current controlling input device, specified by the logical name SYS$COMMAND.    */
/*                                                                            */
/*+~lib$get_command~+*/
unsigned long int lib$get_command(
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$get_command-~*/
/*    LIB$GET_COMMON                                                          */
/*                                                                            */
/*    Get String from Common                                                  */
/*                                                                            */
/*    The Get String from Common routine copies a string in the common area to the    */
/*    destination string. (The common area is an area of storage which remains defined*/
/*    across multiple image activations in a process.) The string length is taken from*/
/*    the first longword of the common area.                                  */
/*                                                                            */
/*+~lib$get_common~+*/
unsigned long int lib$get_common(
    struct dsc$descriptor *resultant_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$get_common-~*/
/*    LIB$GET_DATE_FORMAT                                                     */
/*                                                                            */
/*    Get the User's Date Input Format                                        */
/*                                                                            */
/*    The Get The User's Date Input Format routine returns information about  */
/*    the user's choice of a date/time input format.                          */
/*                                                                            */
/*+~lib$get_date_format~+*/
unsigned long int lib$get_date_format(
    struct dsc$descriptor *format_string,
    ...
    /* unsigned long int  *user_context */
    ) ;
/*~-lib$get_date_format-~*/
/*    LIB$GET_MAXIMUM_DATE_LENGTH                                             */
/*                                                                            */
/*    Retrieve the Maximum Length of a Date/Time String                       */
/*                                                                            */
/*    Given an output format and language, the Retrieve the Maximum Length of a       */
/*    Date/Time String routine determines the maximum possible length for the */
/*    date-string string returned by LIB$FORMAT_DATE_TIME.                    */
/*                                                                            */
/*+~lib$get_maximum_date_length~+*/
unsigned long int lib$get_maximum_date_length(
    long int  *date_length,
    ...
    /* unsigned long int  *user_context, */
    /* const unsigned long int  *flags */
    ) ;
/*~-lib$get_maximum_date_length-~*/
/*    LIB$GETDVI                                                              */
/*                                                                            */
/*    Get Device/Volume Information                                           */
/*                                                                            */
/*    The Get Device/Volume Information routine provides a simplified interface to the*/
/*    $GETDVI system service. It returns information about the primary and secondary  */
/*    device characteristics of an I/O device. The calling process need not have a    */
/*    channel assigned to the device about which it wants information.        */
/*                                                                            */
/*+~lib$getdvi~+*/
unsigned long int lib$getdvi(
    const long int  *item_code,
    ...
    /* const unsigned short int  *channel, */
    /* const struct dsc$descriptor *device_name, */
    /* long int  *longword_integer_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$getdvi-~*/
/*    LIB$GET_EF                                                              */
/*                                                                            */
/*    Get Event Flag                                                          */
/*                                                                            */
/*    The Get Event Flag routine allocates one local event flag from a process-wide   */
/*    pool and returns the number of the allocated flag to the caller. If no flags are*/
/*    available, LIB$GET_EF returns an error as its function value.           */
/*                                                                            */
/*+~lib$get_ef~+*/
unsigned long int lib$get_ef(
    unsigned long int  *event_flag_number
    ) ;
/*~-lib$get_ef-~*/
/*    LIB$GET_FOREIGN                                                         */
/*                                                                            */
/*    Get Foreign Command Line                                                */
/*                                                                            */
/*    The Get Foreign Command Line routine requests the calling image's Command       */
/*    Language Interpreter (CLI) to return the contents of the foreign        */
/*    command line that activated the current image.                          */
/*    foreign                                                                 */
/*                                                                            */
/*+~lib$get_foreign~+*/
unsigned long int lib$get_foreign(
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length, */
    /* unsigned long int  *flags */
    ) ;
/*~-lib$get_foreign-~*/
/*    LIB$GET_INPUT                                                           */
/*                                                                            */
/*    Get Line from SYS$INPUT                                                 */
/*                                                                            */
/*    The Get Line from SYS$INPUT routine gets  one record of ASCII text  from the    */
/*    current controlling input device, specified by SYS$INPUT.               */
/*                                                                            */
/*+~lib$get_input~+*/
unsigned long int lib$get_input(
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$get_input-~*/
/*    LIB$GETJPI                                                              */
/*                                                                            */
/*    Get Job/Process Information                                             */
/*                                                                            */
/*    The Get Job/Process Information routine provides a simplified interface to the  */
/*    $GETJPI system service. It provides accounting, status, and identification      */
/*    information about a specified process.                                  */
/*                                                                            */
/*    LIB$GETJPI obtains only one item of information in a single call.       */
/*                                                                            */
/*+~lib$getjpi~+*/
unsigned long int lib$getjpi(
    const long int  *item_code,
    ...
    /* unsigned long int  *process_id, */
    /* const struct dsc$descriptor *process_name, */
    /* int  *resultant_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$getjpi-~*/
/*    LIB$GET_USERS_LANGUAGE                                                  */
/*                                                                            */
/*    Return the User's Language                                              */
/*                                                                            */
/*    The Return The User's Language routine determines the user's choice of a natural*/
/*    language. The choice is determined by translating the logical SYS$LANGUAGE.     */
/*                                                                            */
/*+~lib$get_users_language~+*/
unsigned long int lib$get_users_language(
    struct dsc$descriptor *language
    ) ;
/*~-lib$get_users_language-~*/
/*    LIB$GET_LUN                                                             */
/*                                                                            */
/*    Get Logical Unit Number                                                 */
/*                                                                            */
/*    The Get Logical Unit Number routine allocates one logical unit number from a    */
/*    process-wide pool.  If a unit is available, its number is returned to the       */
/*    caller.  Otherwise, an error is returned as the function value.         */
/*                                                                            */
/*+~lib$get_lun~+*/
unsigned long int lib$get_lun(
    long int  *logical_unit_number
    ) ;
/*~-lib$get_lun-~*/
/*    LIB$GET_VM_PAGE                                                         */
/*                                                                            */
/*    Get Virtual Memory Page                                                 */
/*                                                                            */
/*    The Get Virtual Memory Page routine allocates a specified number of contiguous  */
/*    pages of memory in the program region and returns the virtual address of the    */
/*    first page allocated.                                                   */
/*                                                                            */
/*+~lib$get_vm_page~+*/
unsigned long int lib$get_vm_page(
    const long int  *number_of_pages,
    int * *base_address
    ) ;
/*~-lib$get_vm_page-~*/
/*    LIB$GETQUI                                                              */
/*                                                                            */
/*    Get Queue Information                                                   */
/*                                                                            */
/*    The Get Queue Information routine provides a simplified interface to the*/
/*    $GETQUI system service. It provides queue, job, file, characteristic,   */
/*    and form                                                                */
/*    information about a specified process.                                  */
/*                                                                            */
/*    LIB$GETQUI obtains only one item of information in a single call.       */
/*                                                                            */
/*+~lib$getqui~+*/
unsigned long int lib$getqui(
    const long int  *function_code,
    ...
    /* const long int  *item_code, */
    /* const long int  *search_number, */
    /* const struct dsc$descriptor *search_name, */
    /* const unsigned long int  *search_flags, */
    /* int  *resultant_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* short int  *resultant_length */
    ) ;
/*~-lib$getqui-~*/
/*    LIB$GETSYI                                                              */
/*                                                                            */
/*    Get Systemwide Information                                              */
/*                                                                            */
/*    The Get Systemwide Information routine provides a simplified interface to the   */
/*    $GETSYI system service. The $GETSYI system service obtains status and   */
/*    identification information about the system. LIB$GETSYI returns only one item of*/
/*    information in a single call.                                           */
/*                                                                            */
/*+~lib$getsyi~+*/
unsigned long int lib$getsyi(
    const long int  *item_code,
    ...
    /* int  *resultant_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* unsigned short int  *resultant_length, */
    /* unsigned long int  *cluster_system_id, */
    /* const struct dsc$descriptor *node_name */
    ) ;
/*~-lib$getsyi-~*/
/*    LIB$GET_SYMBOL                                                          */
/*                                                                            */
/*    Get Value of CLI Symbol                                                 */
/*                                                                            */
/*    The Get Value of CLI Symbol routine requests the calling process's Command      */
/*    Language Interpreter (CLI) to return the value of a CLI symbol as a string.     */
/*    LIB$GET_SYMBOL then returns the string to the caller. Optionally, LIB$GET_SYMBOL*/
/*    can return the length of the returned value and the table in which the symbol   */
/*    was found.                                                              */
/*                                                                            */
/*+~lib$get_symbol~+*/
unsigned long int lib$get_symbol(
    const struct dsc$descriptor *symbol,
    struct dsc$descriptor *resultant_string,
    ...
    /* unsigned short int  *resultant_length, */
    /* long int  *table_type_indicator */
    ) ;
/*~-lib$get_symbol-~*/
/*    LIB$GET_VM                                                              */
/*                                                                            */
/*    Allocate Virtual Memory                                                 */
/*                                                                            */
/*    The Allocate Virtual Memory routine allocates a specified number of contiguous  */
/*    bytes in the program region and returns the virtual address of the first byte   */
/*    allocated.                                                              */
/*                                                                            */
/*+~lib$get_vm~+*/
unsigned long int lib$get_vm(
    const long int  *number_of_bytes,
    int * *base_address,
    ...
    /* const unsigned long int  *zone_id */
    ) ;
/*~-lib$get_vm-~*/
/*    LIB$ICHAR                                                               */
/*                                                                            */
/*    Convert First Character of String to Integer                            */
/*                                                                            */
/*    The Convert First Character of String to Integer routine converts the first     */
/*    character of a source string to an 8-bit ASCII integer extended to a longword.  */
/*                                                                            */
/*+~lib$ichar~+*/
unsigned long int lib$ichar(
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$ichar-~*/
/*    LIB$INDEX                                                               */
/*                                                                            */
/*    Index to Relative Position of Substring                                 */
/*                                                                            */
/*    The Index to Relative Position of Substring routine returns an index, which is  */
/*    the relative position of the first occurrence of a substring in the source      */
/*    string.                                                                 */
/*                                                                            */
/*+~lib$index~+*/
unsigned long int lib$index(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *sub_string
    ) ;
/*~-lib$index-~*/
/*    LIB$INIT_TIMER                                                          */
/*                                                                            */
/*    Initialize Times and Counts                                             */
/*                                                                            */
/*    The Initialize Times and Counts routine stores the current values of specified  */
/*    times and counts for use by LIB$SHOW_TIMER or LIB$STAT_TIMER.           */
/*                                                                            */
/*+~lib$init_timer~+*/
unsigned long int lib$init_timer(
    /* unsigned long int  *context */
    ) ;
/*~-lib$init_timer-~*/
/*    LIB$INSERT_TREE                                                         */
/*                                                                            */
/*    Insert Entry in a Balanced Binary Tree                                  */
/*                                                                            */
/*    The Insert Entry in a Balanced Binary Tree routine inserts a node in a balanced */
/*    binary tree.                                                            */
/*                                                                            */
/*+~lib$insert_tree~+*/
long int lib$insert_tree(
    int * *treehead,
    const int  *symbol,
    const unsigned long int  *flags,
    const int *user_compare_routine,
    const int *user_allocation_procedure,
    int * *new_node,
    ...
    /* const int user_data */
    ) ;
/*~-lib$insert_tree-~*/
/*    LIB$INSQHI                                                              */
/*                                                                            */
/*    Insert Entry at Head of Queue                                           */
/*                                                                            */
/*    The Insert Entry at Head of Queue routine inserts a queue entry at the head of  */
/*    the specified self-relative interlocked queue. LIB$INSQHI makes the VMS */
/*    INSQHI instruction available as a callable routine.                     */
/*                                                                            */
/*+~lib$insqhi~+*/
unsigned long int lib$insqhi(
    int  *entry,
    int  *header [2],
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$insqhi-~*/
/*    LIB$INSQTI                                                              */
/*                                                                            */
/*    Insert Entry at Tail of Queue                                           */
/*                                                                            */
/*    The Insert Entry at Tail of Queue routine inserts a queue entry at the tail of  */
/*    the specified self-relative interlocked queue. LIB$INSQTI makes the VAX INSQTI  */
/*    instruction available as a callable routine.                            */
/*                                                                            */
/*+~lib$insqti~+*/
unsigned long int lib$insqti(
    int  *entry,
    int  *header [2],
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$insqti-~*/
/*    LIB$INSV                                                                */
/*                                                                            */
/*    Insert a Variable Bit Field                                             */
/*                                                                            */
/*    The Insert a Variable Bit Field routine replaces the variable bit field */
/*    specified by the base, position, and size arguments with bits 0 through */
/*    size - 1 of the source field. If the size of the bit field              */
/*    is zero, nothing is inserted. LIB$INSV makes the VAX INSV instruction available */
/*    as a callable routine.                                                  */
/*                                                                            */
/*+~lib$insv~+*/
int lib$insv(
    const long int  *longword_integer_source,
    const long int  *position,
    const unsigned char  *size,
    const unsigned long int base_address
    ) ;
/*~-lib$insv-~*/
/*    LIB$INT_OVER                                                            */
/*                                                                            */
/*    Integer Overflow Detection                                              */
/*                                                                            */
/*    The Integer Overflow Detection routine enables or disables integer overflow     */
/*    detection for the calling routine activation.  The previous integer overflow    */
/*    enable setting is returned.                                             */
/*                                                                            */
/*+~lib$int_over~+*/
unsigned long int lib$int_over(
    const unsigned long int  *new_setting
    ) ;
/*~-lib$int_over-~*/
/*    LIB$INIT_DATE_TIME_CONTEXT                                              */
/*                                                                            */
/*    Initialize the Context Area Used in Formatting Dates and Times for Input or Output      */
/*                                                                            */
/*    The Initialize The Context Area Used In Formatting Dates and Times for  */
/*    Input or Output                                                         */
/*    routine allows the user to initialize the context area used by          */
/*    LIB$FORMAT_DATE_TIME or LIB$CONVERT_DATE_STRING with specific strings,  */
/*    instead of through logical name translation.                            */
/*                                                                            */
/*+~lib$init_date_time_context~+*/
unsigned long int lib$init_date_time_context(
    unsigned long int  *user_context,
    const long int  *component,
    const struct dsc$descriptor *init_string
    ) ;
/*~-lib$init_date_time_context-~*/
/*    LIB$LEN                                                                 */
/*                                                                            */
/*    Length of String Returned as Longword Value                             */
/*                                                                            */
/*    The Length of String Returned as Longword Value routine returns the length of a */
/*    string.                                                                 */
/*                                                                            */
/*+~lib$len~+*/
unsigned short int lib$len(
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$len-~*/
/*    LIB$LOCC                                                                */
/*                                                                            */
/*    Locate a Character                                                      */
/*                                                                            */
/*    The Locate a Character routine locates a character in a string by comparing     */
/*    successive bytes in the string with the character specified. The search */
/*    continues until the character is found or the string has no more characters.    */
/*    LIB$LOCC makes the VAX LOCC instruction available as a callable routine.        */
/*                                                                            */
/*+~lib$locc~+*/
unsigned long int lib$locc(
    const struct dsc$descriptor *character_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$locc-~*/
/*    LIB$LOOKUP_KEY                                                          */
/*                                                                            */
/*    Look Up Keyword in Table                                                */
/*                                                                            */
/*    The Look Up Keyword In Table routine scans a table of keywords to find one that */
/*    matches the keyword or keyword abbreviation specified by                */
/*    search-string.                                                          */
/*                                                                            */
/*+~lib$lookup_key~+*/
unsigned long int lib$lookup_key(
    const struct dsc$descriptor *search_string,
    const int  *key_table_array,
    ...
    /* unsigned long int  *key_value, */
    /* struct dsc$descriptor *keyword_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$lookup_key-~*/
/*    LIB$LOOKUP_TREE                                                         */
/*                                                                            */
/*    Look Up an Entry in a Balanced Binary Tree                              */
/*                                                                            */
/*    The Look Up an Entry in a Balanced Binary Tree routine looks up an entry in a   */
/*    balanced binary tree.                                                   */
/*                                                                            */
/*+~lib$lookup_tree~+*/
unsigned long int lib$lookup_tree(
    const int * *treehead,
    const int  *symbol,
    const int *user_compare_routine,
    int * *new_node
    ) ;
/*~-lib$lookup_tree-~*/
/*    LIB$LP_LINES                                                            */
/*                                                                            */
/*    Lines on Each Printer Page                                              */
/*                                                                            */
/*    The Lines on Each Printer Page routine computes the default number of lines on a*/
/*    printer page. This routine can be used by native-mode VMS utilities that*/
/*    produce listing files and paginate files.                               */
/*                                                                            */
/*+~lib$lp_lines~+*/
long int lib$lp_lines() ;
/*~-lib$lp_lines-~*/
/*    LIB$MATCHC                                                              */
/*                                                                            */
/*    Match Characters, Return Relative Position                              */
/*                                                                            */
/*    The Match Characters and Return Relative Position routine searches a source     */
/*    string for a specified substring and returns an index, which is the relative    */
/*    position of the first occurrence of a substring in the source string.   */
/*    The relative character positions returned by LIB$MATCHC are numbered    */
/*    1, 2, ..., n. Thus, zero means that the substring was not found.        */
/*    LIB$MATCHC makes the VAX MATCHC instruction available as a callable     */
/*    routine.                                                                */
/*                                                                            */
/*+~lib$matchc~+*/
unsigned long int lib$matchc(
    const struct dsc$descriptor *sub_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$matchc-~*/
/*    LIB$MATCH_COND                                                          */
/*                                                                            */
/*    Match Condition Values                                                  */
/*                                                                            */
/*    The Match Condition Values routine checks to see if a given condition value     */
/*    matches a list of condition values that you supply.                     */
/*                                                                            */
/*+~lib$match_cond~+*/
unsigned long int lib$match_cond(
    const unsigned long int  *match_condition_value,
    const unsigned long int  *compare_condition_value
    ) ;
/*~-lib$match_cond-~*/
/*    LIB$MOVC3                                                               */
/*                                                                            */
/*    Move Characters                                                         */
/*                                                                            */
/*    The Move Characters routine makes the VAX MOVC3 instruction available as a      */
/*    callable routine. The source item is moved to the destination item. Overlap of  */
/*    the source and destination items does not affect the result.            */
/*                                                                            */
/*+~lib$movc3~+*/
int lib$movc3(
    const unsigned short int  *word_integer_length,
    const int  *source,
    int  *destination
    ) ;
/*~-lib$movc3-~*/
/*    LIB$MOVC5                                                               */
/*                                                                            */
/*    Move Characters with Fill                                               */
/*                                                                            */
/*    The Move Characters with Fill routine makes the VAX MOVC5 instruction available */
/*    as a callable routine. The source item is moved to the destination item.*/
/*    Overlap of the source and destination items does not affect the result. */
/*                                                                            */
/*+~lib$movc5~+*/
int lib$movc5(
    const unsigned short int  *word_integer_source_length,
    const int  *source,
    const char  *fill,
    const unsigned short int  *word_integer_destination_length,
    int  *destination
    ) ;
/*~-lib$movc5-~*/
/*    LIB$MOVTC                                                               */
/*                                                                            */
/*    Move Translated Characters                                              */
/*                                                                            */
/*    The Move Translated Characters routine moves the source string, character by    */
/*    character, to the destination string after translating each character using the */
/*    specified translation table. LIB$MOVTC makes the VAX MOVTC instruction available*/
/*    as a callable routine.                                                  */
/*                                                                            */
/*+~lib$movtc~+*/
unsigned long int lib$movtc(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *fill_character,
    const struct dsc$descriptor *translation_table,
    struct dsc$descriptor *destination_string
    ) ;
/*~-lib$movtc-~*/
/*    LIB$MOVTUC                                                              */
/*                                                                            */
/*    Move Translated Until Character                                         */
/*                                                                            */
/*    The Move Translated Until Character routine moves the source string, character  */
/*    by character, to the destination string after translating each character using  */
/*    the specified translation table until the stop character is encountered.*/
/*    LIB$MOVTUC makes the VAX MOVTUC instruction available as a callable routine.    */
/*                                                                            */
/*+~lib$movtuc~+*/
unsigned long int lib$movtuc(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *stop_character,
    const struct dsc$descriptor *translation_table,
    struct dsc$descriptor *destination_string,
    ...
    /* const struct dsc$descriptor *fill_character */
    ) ;
/*~-lib$movtuc-~*/
/*    LIB$MULT_DELTA_TIME                                                     */
/*                                                                            */
/*    Multiply Delta Time by Scalar                                           */
/*                                                                            */
/*    The Multiply Delta Time by Scalar routine multiplies a delta time by a longword integer */
/*    scalar.                                                                 */
/*                                                                            */
/*+~lib$mult_delta_time~+*/
unsigned long int lib$mult_delta_time(
    const long int  *multiplier,
    unsigned int  *delta_time [2]
    ) ;
/*~-lib$mult_delta_time-~*/
/*    LIB$MULTF_DELTA_TIME                                                    */
/*                                                                            */
/*    Multiply Delta Time by an F_floating Scalar                             */
/*                                                                            */
/*    The Multiply Delta Time by an F-Floating Scalar routine multiplies a delta time */
/*    by an F-floating scalar.                                                */
/*                                                                            */
/*+~lib$multf_delta_time~+*/
unsigned long int lib$multf_delta_time(
    const float  *multiplier,
    unsigned int  *delta_time [2]
    ) ;
/*~-lib$multf_delta_time-~*/
/*    LIB$PAUSE                                                               */
/*                                                                            */
/*    Pause Program Execution                                                 */
/*                                                                            */
/*    The Pause Program Execution routine suspends program execution and returns      */
/*    control to the calling command level.                                   */
/*                                                                            */
/*+~lib$pause~+*/
unsigned long int lib$pause() ;
/*~-lib$pause-~*/
/*    LIB$POLYD                                                               */
/*                                                                            */
/*    Evaluate Polynomials                                                    */
/*                                                                            */
/*    The Evaluate Polynomials routine (D-floating point values) allows higher-level  */
/*    language users to evaluate D-floating point value polynomials.          */
/*                                                                            */
/*+~lib$polyd~+*/
unsigned long int lib$polyd(
    const double float  *polynomial_argument,
    const short int  *degree,
    const double float  *coefficient [1],
    double float  *floating_point_result
    ) ;
/*~-lib$polyd-~*/
/*    LIB$POLYF                                                               */
/*                                                                            */
/*    Evaluate Polynomials                                                    */
/*                                                                            */
/*    The Evaluate Polynomials routine (F-floating point values) allows higher-level  */
/*    language users to evaluate F-floating point polynomials.                */
/*                                                                            */
/*+~lib$polyf~+*/
unsigned long int lib$polyf(
    const float  *polynomial_argument,
    const short int  *degree,
    const float  *coefficient [1],
    float  *floating_point_result
    ) ;
/*~-lib$polyf-~*/
/*    LIB$POLYG                                                               */
/*                                                                            */
/*    Evaluate Polynomials                                                    */
/*                                                                            */
/*    The Evaluate Polynomials routine (G-floating point values) allows higher-level  */
/*    language users to evaluate G-floating point value polynomials.          */
/*                                                                            */
/*+~lib$polyg~+*/
unsigned long int lib$polyg(
    const double float  *polynomial_argument,
    const short int  *degree,
    const double float  *coefficient [1],
    double float  *floating_point_result
    ) ;
/*~-lib$polyg-~*/
/*    LIB$POLYH                                                               */
/*                                                                            */
/*    Evaluate Polynomials                                                    */
/*                                                                            */
/*    The Evaluate Polynomials routine (H-floating point values) allows higher-level  */
/*    language users to evaluate H-floating point value polynomials.          */
/*                                                                            */
/*+~lib$polyh~+*/
unsigned long int lib$polyh(
    const struct {int polynomi$$ret_0_ [4];}  *polynomial_argument,
    const short int  *degree,
    const struct {int coeffici$$ret_0_ [4];}  *coefficient [1],
    struct {int floating$$ret_0_ [4];}  *floating_point_result
    ) ;
/*~-lib$polyh-~*/
/*    LIB$PUT_COMMON                                                          */
/*                                                                            */
/*    Put String to Common                                                    */
/*                                                                            */
/*    The Put String to Common routine copies the contents of a string into the common*/
/*    area. The common area is an area of storage which remains defined across*/
/*    multiple image activations in a process. Optionally, LIB$PUT_COMMON returns the */
/*    actual number of characters copied. The maximum number of characters that can be*/
/*    copied is 252.                                                          */
/*                                                                            */
/*+~lib$put_common~+*/
unsigned long int lib$put_common(
    const struct dsc$descriptor *source_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$put_common-~*/
/*    LIB$PUT_OUTPUT                                                          */
/*                                                                            */
/*    Put Line to SYS$OUTPUT                                                  */
/*                                                                            */
/*    The Put Line to SYS$OUTPUT routine writes a record to the current controlling   */
/*    output device, specified by SYS$OUTPUT using the RMS $PUT service.      */
/*                                                                            */
/*+~lib$put_output~+*/
unsigned long int lib$put_output(
    const struct dsc$descriptor *message_string
    ) ;
/*~-lib$put_output-~*/
/*    LIB$RADIX_POINT                                                         */
/*                                                                            */
/*    Radix Point Symbol                                                      */
/*                                                                            */
/*    The Radix Point Symbol routine returns the system's radix point symbol. This    */
/*    symbol is used inside a digit string to separate the integer part from the      */
/*    fraction part. This routine works by attempting to translate the logical name   */
/*    SYS$RADIX_POINT as a process, group, or system logical name.            */
/*                                                                            */
/*+~lib$radix_point~+*/
unsigned long int lib$radix_point(
    struct dsc$descriptor *radix_point_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$radix_point-~*/
/*    LIB$REMQHI                                                              */
/*                                                                            */
/*    Remove Entry from Head of Queue                                         */
/*                                                                            */
/*    The Remove Entry from Head of Queue routine removes an entry from the head of   */
/*    the specified self-relative interlocked queue. LIB$REMQHI makes the VAX REMQHI  */
/*    instruction available as a callable routine.                            */
/*                                                                            */
/*+~lib$remqhi~+*/
unsigned long int lib$remqhi(
    int  *header [2],
    int * *remque_address,
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$remqhi-~*/
/*    LIB$REMQTI                                                              */
/*                                                                            */
/*    Remove Entry from Tail of Queue                                         */
/*                                                                            */
/*    The Remove Entry from Tail of Queue routine removes an entry from the tail of   */
/*    the specified self-relative interlocked queue. LIB$REMQTI makes the VAX REMQTI  */
/*    instruction available as a callable routine.                            */
/*                                                                            */
/*+~lib$remqti~+*/
unsigned long int lib$remqti(
    int  *header [2],
    int * *remque_address,
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$remqti-~*/
/*    LIB$RENAME_FILE                                                         */
/*                                                                            */
/*    Rename One or More Files                                                */
/*                                                                            */
/*    The Rename One or More Files routine changes the names of one or more files.    */
/*    The specification of the files to be renamed may include wildcards.     */
/*                                                                            */
/*    LIB$RENAME_FILE is similar in function to the DCL command RENAME.       */
/*                                                                            */
/*+~lib$rename_file~+*/
unsigned long int lib$rename_file(
    const struct dsc$descriptor *old_filespec,
    const struct dsc$descriptor *new_filespec,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const struct dsc$descriptor *related_filespec, */
    /* const unsigned long int  *flags, */
    /* const int *user_success_procedure, */
    /* const int *user_error_procedure, */
    /* const int *user_confirm_procedure, */
    /* const int user_specified_argument, */
    /* struct dsc$descriptor *old_resultant_name, */
    /* struct dsc$descriptor *new_resultant_name, */
    /* unsigned long int  *file_scan_context */
    ) ;
/*~-lib$rename_file-~*/
/*    LIB$RESERVE_EF                                                          */
/*                                                                            */
/*    Reserve Event Flag                                                      */
/*                                                                            */
/*    The Reserve Event Flag routine allocates a local event flag number specified by */
/*    event-flag-number.                                                      */
/*                                                                            */
/*+~lib$reserve_ef~+*/
unsigned long int lib$reserve_ef(
    const unsigned long int  *event_flag_number
    ) ;
/*~-lib$reserve_ef-~*/
/*    LIB$RESET_VM_ZONE                                                       */
/*                                                                            */
/*    Reset Virtual Memory Zone                                               */
/*                                                                            */
/*    The Reset Virtual Memory Zone routine frees all blocks of memory that were      */
/*    previously allocated from the zone.                                     */
/*                                                                            */
/*+~lib$reset_vm_zone~+*/
unsigned long int lib$reset_vm_zone(
    const unsigned long int  *zone_id
    ) ;
/*~-lib$reset_vm_zone-~*/
/*    LIB$REVERT                                                              */
/*                                                                            */
/*    Revert to the Handler of the Routine Activator                          */
/*                                                                            */
/*    The Revert to the Handler of the Routine Activator routine deletes the  */
/*    condition handler established by LIB$ESTABLISH by clearing the address pointing */
/*    to the condition handler from the activated routine's stack frame.      */
/*                                                                            */
/*+~lib$revert~+*/
int *lib$revert() ;
/*~-lib$revert-~*/
/*    LIB$RUN_PROGRAM                                                         */
/*                                                                            */
/*    Run New Program                                                         */
/*                                                                            */
/*    The Run New Program routine causes the current program to stop running and      */
/*    begins execution of another program.                                    */
/*                                                                            */
/*+~lib$run_program~+*/
unsigned long int lib$run_program(
    const struct dsc$descriptor *program_name
    ) ;
/*~-lib$run_program-~*/
/*    LIB$SYS_ASCTIM                                                          */
/*                                                                            */
/*    Invoke $ASCTIM to Convert Binary Time to ASCII String                   */
/*                                                                            */
/*    The Invoke $ASCTIM to Convert Binary Time to ASCII String routine calls the     */
/*    system service $ASCTIM to convert a binary date and time value, returning the   */
/*    ASCII string using the semantics of the caller's string.                */
/*                                                                            */
/*+~lib$sys_asctim~+*/
unsigned long int lib$sys_asctim(
    unsigned short int  *resultant_length,
    struct dsc$descriptor *time_string,
    ...
    /* const unsigned int  *user_time [2], */
    /* const unsigned long int  *flags */
    ) ;
/*~-lib$sys_asctim-~*/
/*    LIB$SCANC                                                               */
/*                                                                            */
/*    Scan for Characters, Return Relative Position                           */
/*                                                                            */
/*    The Scan for Characters and Return Relative Position routine is used to find a  */
/*    specified set of characters in the source string. LIB$SCANC makes the VAX SCANC */
/*    instruction available as a callable routine.                            */
/*                                                                            */
/*+~lib$scanc~+*/
unsigned long int lib$scanc(
    const struct dsc$descriptor *source_string,
    const unsigned char  *table_array [1],
    const unsigned char  *byte_integer_mask
    ) ;
/*~-lib$scanc-~*/
/*    LIB$SCOPY_DXDX                                                          */
/*                                                                            */
/*    Copy Source String Passed by Descriptor to Destination                  */
/*                                                                            */
/*    The Copy Source String Passed by Descriptor to Destination routine copies a     */
/*    source string passed by descriptor to a destination string.             */
/*                                                                            */
/*+~lib$scopy_dxdx~+*/
unsigned long int lib$scopy_dxdx(
    const struct dsc$descriptor *source_string,
    struct dsc$descriptor *destination_string
    ) ;
/*~-lib$scopy_dxdx-~*/
/*    LIB$SCOPY_R_DX                                                          */
/*                                                                            */
/*    Copy Source String Passed by Reference to Destination String            */
/*                                                                            */
/*    The Copy Source String Passed by Reference to Destination String routine copies */
/*    a source string passed by reference to a destination string.            */
/*                                                                            */
/*+~lib$scopy_r_dx~+*/
unsigned long int lib$scopy_r_dx(
    const unsigned short int  *word_integer_source_length,
    const int *source_string_address,
    const struct dsc$descriptor *destination_string
    ) ;
/*~-lib$scopy_r_dx-~*/
/*    LIB$SET_LOGICAL                                                         */
/*                                                                            */
/*    Set Logical Name                                                        */
/*                                                                            */
/*    The Set Logical Name routine requests the calling process's Command Language    */
/*    Interpreter (CLI) to define or redefine a supervisor-mode process logical name. */
/*    It provides the same function as the DCL DEFINE command.                */
/*                                                                            */
/*+~lib$set_logical~+*/
unsigned long int lib$set_logical(
    const struct dsc$descriptor *logical_name,
    ...
    /* const struct dsc$descriptor *value_string, */
    /* const struct dsc$descriptor *table, */
    /* const unsigned long int  *attributes, */
    /* const int  *item_list */
    ) ;
/*~-lib$set_logical-~*/
/*    LIB$SET_SYMBOL                                                          */
/*                                                                            */
/*    Set Value of CLI Symbol                                                 */
/*                                                                            */
/*    The Set Value of CLI Symbol routine requests the calling process's Command      */
/*    Language Interpreter (CLI) to define or redefine a CLI symbol.          */
/*                                                                            */
/*+~lib$set_symbol~+*/
unsigned long int lib$set_symbol(
    const struct dsc$descriptor *symbol,
    const struct dsc$descriptor *value_string,
    ...
    /* const long int  *table_type_indicator */
    ) ;
/*~-lib$set_symbol-~*/
/*    LIB$SYS_FAO                                                             */
/*                                                                            */
/*    Invoke $FAO System Service to Format Output                             */
/*                                                                            */
/*    The Invoke $FAO System Service to Format Output routine calls $FAO, returning a */
/*    string in the semantics you provide. If called with other than a fixed-length   */
/*    string for output, the length of the resultant string is limited to 256 bytes   */
/*    and truncation will occur.                                              */
/*                                                                            */
/*+~lib$sys_fao~+*/
unsigned long int lib$sys_fao(
    const struct dsc$descriptor *character_string,
    unsigned short int  *resultant_length,
    struct dsc$descriptor *resultant_string,
    ...
    /* const int  *directive_argument */
    ) ;
/*~-lib$sys_fao-~*/
/*    LIB$SYS_FAOL                                                            */
/*                                                                            */
/*    Invoke $FAOL System Service to Format Output                            */
/*                                                                            */
/*    The Invoke $FAOL System Service to Format Output routine calls the system       */
/*    service routine $FAOL, returning the string in the semantics you provide. If    */
/*    called with other than a fixed-length string for output, the length of the      */
/*    resultant string is limited to 256 bytes and truncation will occur.     */
/*                                                                            */
/*+~lib$sys_faol~+*/
unsigned long int lib$sys_faol(
    const struct dsc$descriptor *character_string,
    unsigned short int  *resultant_length,
    struct dsc$descriptor *resultant_string,
    const unsigned long int  *directive_argument_address [1]
    ) ;
/*~-lib$sys_faol-~*/
/*    LIB$SFREE1_DD                                                           */
/*                                                                            */
/*    Free One Dynamic String                                                 */
/*                                                                            */
/*    The Free One Dynamic String routine returns one dynamic string area to free     */
/*    storage.                                                                */
/*                                                                            */
/*+~lib$sfree1_dd~+*/
unsigned long int lib$sfree1_dd(
    unsigned int  *descriptor_address [2]
    ) ;
/*~-lib$sfree1_dd-~*/
/*    LIB$SFREEN_DD                                                           */
/*                                                                            */
/*    Free One or More Dynamic Strings                                        */
/*                                                                            */
/*    The Free One or More Dynamic Strings routine returns one or more dynamic strings*/
/*    to free storage.                                                        */
/*                                                                            */
/*+~lib$sfreen_dd~+*/
unsigned long int lib$sfreen_dd(
    const unsigned long int  *number_of_descriptors,
    unsigned int  *first_descriptor_array [2] [1]
    ) ;
/*~-lib$sfreen_dd-~*/
/*    LIB$SGET1_DD                                                            */
/*                                                                            */
/*    Get One Dynamic String                                                  */
/*                                                                            */
/*    The Get One Dynamic String routine allocates dynamic virtual memory to the      */
/*    string descriptor you specify.                                          */
/*                                                                            */
/*+~lib$sget1_dd~+*/
unsigned long int lib$sget1_dd(
    const unsigned short int  *word_integer_length,
    unsigned int  *descriptor_part [2]
    ) ;
/*~-lib$sget1_dd-~*/
/*    LIB$SYS_GETMSG                                                          */
/*                                                                            */
/*    Invoke $GETMSG System Service to Get Message Text                       */
/*                                                                            */
/*    The Invoke $GETMSG System Service to Get Message Text routine calls the System  */
/*    Service $GETMSG and returns a message string into destination-string    */
/*    using the semantics of the caller's string.                             */
/*                                                                            */
/*+~lib$sys_getmsg~+*/
unsigned long int lib$sys_getmsg(
    const unsigned long int  *message_id,
    unsigned short int  *message_length,
    struct dsc$descriptor *destination_string,
    ...
    /* const unsigned long int  *flags, */
    /* int  *unsigned_resultant_array */
    ) ;
/*~-lib$sys_getmsg-~*/
/*    LIB$SHOW_TIMER                                                          */
/*                                                                            */
/*    Show Accumulated Times and Counts                                       */
/*                                                                            */
/*    The Show Accumulated Times and Counts routine returns times and counts  */
/*    accumulated since the last call to LIB$INIT_TIMER and displays them on  */
/*    SYS$OUTPUT. (LIB$INIT_TIMER must be called prior to invoking this       */
/*    routine.) A user-supplied action routine may change this default        */
/*    behavior.                                                               */
/*                                                                            */
/*+~lib$show_timer~+*/
unsigned long int lib$show_timer(
    /* const int * *handle_address, */
    /* const long int  *code, */
    /* const int *user_action_procedure, */
    /* const int user_argument_value */
    ) ;
/*~-lib$show_timer-~*/
/*    LIB$SHOW_VM                                                             */
/*                                                                            */
/*    Show Virtual Memory Statistics                                          */
/*                                                                            */
/*    The Show Virtual Memory Statistics routine returns the statistics accumulated   */
/*    from calls to LIB$GET_VM/LIB$FREE_VM and LIB$GET_VM_PAGE/LIB$FREE_VM_PAGE.      */
/*                                                                            */
/*+~lib$show_vm~+*/
unsigned long int lib$show_vm(
    /* const long int  *code, */
    /* const int *user_action_procedure, */
    /* const int user_specified_argument */
    ) ;
/*~-lib$show_vm-~*/
/*    LIB$SHOW_VM_ZONE                                                        */
/*                                                                            */
/*    Return Information About a Zone                                         */
/*                                                                            */
/*    The Return Information About a Zone routine returns formatted information about */
/*    the specified zone, detailing such information as the zone's name,      */
/*    characteristics, and areas, and then passes the information to the specified or */
/*    default action routine.                                                 */
/*                                                                            */
/*+~lib$show_vm_zone~+*/
unsigned long int lib$show_vm_zone(
    const unsigned long int  *zone_id,
    ...
    /* const long int  *detail_level, */
    /* const int *user_action_procedure, */
    /* const int user_arg */
    ) ;
/*~-lib$show_vm_zone-~*/
/*    LIB$SIGNAL                                                              */
/*                                                                            */
/*    Signal Exception Condition                                              */
/*                                                                            */
/*    The Signal Exception Condition routine generates a signal that indicates that an*/
/*    exception condition has occurred in your program. If a condition handler does   */
/*    not take corrective action and the condition is severe, then your program will  */
/*    exit.                                                                   */
/*                                                                            */
/*+~lib$signal~+*/
int lib$signal(
    const unsigned long int condition_value,
    ...
    /* const long int number_of_arguments, */
    /* const int fao_argument */
    ) ;
/*~-lib$signal-~*/
/*    LIB$SIG_TO_RET                                                          */
/*                                                                            */
/*    Signal Converted to a Return Status                                     */
/*                                                                            */
/*    The Signal Converted to a Return Status routine converts any signaled condition */
/*    value to a value returned as a function. The signaled condition is returned to  */
/*    the caller of the user routine that established the handler that is calling     */
/*    LIB$SIG_TO_RET. This routine may be established as or called from a condition   */
/*    handler.                                                                */
/*                                                                            */
/*+~lib$sig_to_ret~+*/
unsigned long int lib$sig_to_ret(
    const int  *signal_arguments,
    const int  *mechanism_arguments
    ) ;
/*~-lib$sig_to_ret-~*/
/*    LIB$SIG_TO_STOP                                                         */
/*                                                                            */
/*    Convert a Signaled Condition to a Signaled Stop                         */
/*                                                                            */
/*    The Convert a Signaled Condition to a Signaled Stop routine converts a signaled */
/*    condition to a signaled condition that cannot be continued.             */
/*                                                                            */
/*+~lib$sig_to_stop~+*/
unsigned long int lib$sig_to_stop(
    int  *signal_arguments,
    const int  *mechanism_arguments
    ) ;
/*~-lib$sig_to_stop-~*/
/*    LIB$SIM_TRAP                                                            */
/*                                                                            */
/*    Simulate Floating Trap                                                  */
/*                                                                            */
/*    The Simulate Floating Trap routine converts floating faults to floating traps.  */
/*    It can be enabled as a condition handler or can be called by one.       */
/*                                                                            */
/*+~lib$sim_trap~+*/
unsigned long int lib$sim_trap(
    int  *signal_arguments,
    const int  *mechanism_arguments
    ) ;
/*~-lib$sim_trap-~*/
/*    LIB$SKPC                                                                */
/*                                                                            */
/*    Skip Equal Characters                                                   */
/*                                                                            */
/*    The Skip Equal Characters routine compares each character of a given string with*/
/*    a given character and returns the relative position of the first nonequal       */
/*    character as an index. LIB$SKPC makes the VAX SKPC instruction available as a   */
/*    callable routine.                                                       */
/*                                                                            */
/*+~lib$skpc~+*/
unsigned long int lib$skpc(
    const struct dsc$descriptor *character_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$skpc-~*/
/*    LIB$SPANC                                                               */
/*                                                                            */
/*    Skip Selected Characters                                                */
/*                                                                            */
/*    The Skip Selected Characters routine is used to skip a specified set of */
/*    characters in the source string. LIB$SPANC makes the VAX SPANC instruction      */
/*    available as a callable routine.                                        */
/*                                                                            */
/*+~lib$spanc~+*/
unsigned long int lib$spanc(
    const struct dsc$descriptor *source_string,
    const unsigned char  *table_array [1],
    const unsigned char  *byte_integer_mask
    ) ;
/*~-lib$spanc-~*/
/*    LIB$SPAWN                                                               */
/*                                                                            */
/*    Spawn Subprocess                                                        */
/*                                                                            */
/*    The Spawn Subprocess routine requests the command language interpreter (CLI) of */
/*    the calling process to spawn a subprocess for executing CLI commands.  LIB$SPAWN*/
/*    provides the same function as the DCL SPAWN command.                    */
/*                                                                            */
/*+~lib$spawn~+*/
unsigned long int lib$spawn(
    /* const struct dsc$descriptor *command_string, */
    /* const struct dsc$descriptor *input_file, */
    /* const struct dsc$descriptor *output_file, */
    /* const unsigned long int  *flags, */
    /* const struct dsc$descriptor *process_name, */
    /* unsigned long int  *process_id, */
    /* const int *completion_status_address, */
    /* const unsigned char  *byte_integer_event_flag_num, */
    /* const int *ast_address, */
    /* const int varying_ast_argument, */
    /* const struct dsc$descriptor *prompt_string, */
    /* const struct dsc$descriptor *cli */
    ) ;
/*~-lib$spawn-~*/
/*    LIB$STAT_TIMER                                                          */
/*                                                                            */
/*    Statistics, Return Accumulated Times and Counts                         */
/*                                                                            */
/*    The Statistics, Return Accumulated Times and Counts routine returns to its      */
/*    caller one of five available statistics accumulated since the last call to      */
/*    LIB$INIT_TIMER. Unlike LIB$SHOW_TIMER, which formats the values for output,     */
/*    LIB$STAT_TIMER returns the value as an unsigned longword or quadword.   */
/*                                                                            */
/*+~lib$stat_timer~+*/
unsigned long int lib$stat_timer(
    const long int  *code,
    int  *value_argument,
    ...
    /* const int * *handle_address */
    ) ;
/*~-lib$stat_timer-~*/
/*    LIB$STAT_VM                                                             */
/*                                                                            */
/*    Return Virtual Memory Statistics                                        */
/*                                                                            */
/*    The Return Virtual Memory Statistics routine returns to its caller one of six   */
/*    statistics available from calls to LIB$GET_VM/LIB$FREE_VM and           */
/*    LIB$GET_VM_PAGE/LIB$FREE_VM_PAGE. Unlike LIB$SHOW_VM, which formats the values  */
/*    for output and displays them on SYS$OUTPUT, LIB$STAT_VM returns the statistic in*/
/*    the value-argument argument. Only one of the statistics is returned     */
/*    by each call to LIB$STAT_VM.                                            */
/*                                                                            */
/*+~lib$stat_vm~+*/
unsigned long int lib$stat_vm(
    const long int  *code,
    int  *value_argument
    ) ;
/*~-lib$stat_vm-~*/
/*    LIB$STOP                                                                */
/*                                                                            */
/*    Stop Execution and Signal the Condition                                 */
/*                                                                            */
/*    The Stop Execution and Signal the Condition routine generates a signal that     */
/*    indicates that an exception condition has occurred in your program. Exception   */
/*    conditions signaled by LIB$STOP cannot be continued from the point of the       */
/*    signal.                                                                 */
/*                                                                            */
/*+~lib$stop~+*/
int lib$stop(
    const unsigned long int condition_value,
    ...
    /* const long int number_of_arguments, */
    /* const int fao_argument */
    ) ;
/*~-lib$stop-~*/
/*    LIB$SYS_TRNLOG                                                          */
/*                                                                            */
/*    Invoke $TRNLOG\System Service to Translate Logical Name                 */
/*                                                                            */
/*    The Invoke $TRNLOG System Service to Translate Logical Name routine uses the    */
/*    system service $TRNLOG to translate a logical name, LIB$SYS_TRNLOG returns the  */
/*    logical name's translation using the semantics of the caller's string.  */
/*                                                                            */
/*+~lib$sys_trnlog~+*/
unsigned long int lib$sys_trnlog(
    const struct dsc$descriptor *logical_name,
    unsigned short int  *word_integer_dest_length,
    struct dsc$descriptor *destination_string,
    ...
    /* char  *byte_integer_table, */
    /* unsigned char  *access_mode, */
    /* const unsigned char  *byte_integer_disable_mask */
    ) ;
/*~-lib$sys_trnlog-~*/
/*    LIB$STAT_VM_ZONE                                                        */
/*                                                                            */
/*    Return Information About a Zone                                         */
/*                                                                            */
/*    The Return Information About a Zone routine returns a single piece of   */
/*    information about the specified zone.                                   */
/*                                                                            */
/*+~lib$stat_vm_zone~+*/
unsigned long int lib$stat_vm_zone(
    const unsigned long int  *zone_id,
    const long int  *item_code,
    ...
    /* long int  *resultant_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$stat_vm_zone-~*/
/*    LIB$SUB_TIMES                                                           */
/*                                                                            */
/*    Subtract Two Quadword Times                                             */
/*                                                                            */
/*    The Subtract Two Quadword Times routine subtracts two VMS               */
/*    internal-time-format times.                                             */
/*                                                                            */
/*+~lib$sub_times~+*/
unsigned long int lib$sub_times(
    const unsigned int  *time1 [2],
    const unsigned int  *time2 [2],
    unsigned int  *resultant_time [2]
    ) ;
/*~-lib$sub_times-~*/
/*    LIB$SUBX                                                                */
/*                                                                            */
/*    Multiple-Precision Binary Subtraction                                   */
/*                                                                            */
/*    The Multiple-Precision Binary Subtraction routine performs subtraction on signed*/
/*    two's complement integers of arbitrary length.                          */
/*                                                                            */
/*+~lib$subx~+*/
unsigned long int lib$subx(
    const int  *minuend_array,
    const int  *subtrahend_array,
    int  *difference_array,
    ...
    /* const long int  *array_length */
    ) ;
/*~-lib$subx-~*/
/*    LIB$TPARSE                                                              */
/*                                                                            */
/*    Table-Driven Finite-State Parser                                        */
/*                                                                            */
/*    The Table-Driven Finite State Parser routine is a general-purpose, table-driven */
/*    parser implemented as a finite-state automaton, with extensions that make it    */
/*    suitable for a wide range of applications. LIB$TPARSE parses a string and       */
/*    returns a message indicating whether or not the input string is valid.  */
/*                                                                            */
/*+~lib$tparse~+*/
unsigned long int lib$tparse(
    int * *argument_block,
    const int * *state_table,
    const int * *key_table
    ) ;
/*~-lib$tparse-~*/
/*    LIB$TRA_ASC_EBC                                                         */
/*                                                                            */
/*    Translate ASCII to EBCDIC                                               */
/*                                                                            */
/*    The Translate ASCII to EBCDIC routine translates an ASCII string to an EBCDIC   */
/*    string.                                                                 */
/*                                                                            */
/*+~lib$tra_asc_ebc~+*/
unsigned long int lib$tra_asc_ebc(
    const struct dsc$descriptor *source_string,
    struct dsc$descriptor *byte_integer_dest_string
    ) ;
/*~-lib$tra_asc_ebc-~*/
/*    LIB$TRA_EBC_ASC                                                         */
/*                                                                            */
/*    Translate EBCDIC to ASCII                                               */
/*                                                                            */
/*    The Translate EBCDIC to ASCII routine translates an EBCDIC string to an ASCII   */
/*    string.                                                                 */
/*                                                                            */
/*+~lib$tra_ebc_asc~+*/
unsigned long int lib$tra_ebc_asc(
    const struct dsc$descriptor *byte_integer_source_string,
    struct dsc$descriptor *destination_string
    ) ;
/*~-lib$tra_ebc_asc-~*/
/*    LIB$TRAVERSE_TREE                                                       */
/*                                                                            */
/*    Traverse a Balanced Binary Tree                                         */
/*                                                                            */
/*    The Traverse a Balanced Binary Tree routine calls an action routine for each    */
/*    node in a binary tree.                                                  */
/*                                                                            */
/*+~lib$traverse_tree~+*/
unsigned long int lib$traverse_tree(
    const int * *treehead,
    const int *user_action_procedure,
    ...
    /* const int  *user_data_address */
    ) ;
/*~-lib$traverse_tree-~*/
/*    LIB$TRIM_FILESPEC                                                       */
/*                                                                            */
/*    Fit Long File Specification into Fixed Field                            */
/*                                                                            */
/*    The Fit Long File Specification into Fixed Field routine takes a file   */
/*    specification, such as an RMS resultant name string, and shortens it (if*/
/*    necessary) so that it fits into a field of fixed width.                 */
/*                                                                            */
/*+~lib$trim_filespec~+*/
unsigned long int lib$trim_filespec(
    const struct dsc$descriptor *old_filespec,
    struct dsc$descriptor *new_filespec,
    ...
    /* const unsigned short int  *word_integer_width, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$trim_filespec-~*/
/*    LIB$VERIFY_VM_ZONE                                                      */
/*                                                                            */
/*    Verify a Zone                                                           */
/*                                                                            */
/*    The Verify a Zone routine performs verification of a zone.              */
/*                                                                            */
/*+~lib$verify_vm_zone~+*/
unsigned long int lib$verify_vm_zone(
    const unsigned long int  *zone_id
    ) ;
/*~-lib$verify_vm_zone-~*/
/*    LIB$WAIT                                                                */
/*                                                                            */
/*    Wait a Specified Period of Time                                         */
/*                                                                            */
/*    The Wait a Specified Period of Time routine places the current process into     */
/*    hibernation for the number of seconds specified in its argument.        */
/*                                                                            */
/*+~lib$wait~+*/
unsigned long int lib$wait(
    const float  *seconds
    ) ;
/*~-lib$wait-~*/
#endif
