/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:24:58 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]PPL$ROUTINE */
#ifndef PPL$ROUTINES_H
#define PPL$ROUTINES_H
 
/*** MODULE PPL$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    PPL$ADJUST_QUORUM                                                       */
/*                                                                            */
/*    Adjust Barrier Quorum                                                   */
/*                                                                            */
/*    The Adjust Barrier Quorum routine increments or decrements the quorum   */
/*    associated with the specified barrier, thus allowing a barrier to       */
/*    dynamically alter the number of participants required to conclude a     */
/*    wait on that barrier.  The barrier must have been created by            */
/*    PPL$CREATE_BARRIER. (See PPL$CREATE_BARRIER for more information        */
/*    about quorums.)                                                         */
/*                                                                            */
/*+~ppl$adjust_quorum~+*/
unsigned long int ppl$adjust_quorum(
    const unsigned long int  *barrier_id,
    const short int  *amount
    ) ;
/*~-ppl$adjust_quorum-~*/
/*    PPL$AWAIT_EVENT                                                         */
/*                                                                            */
/*    Await Event Occurrence                                                  */
/*                                                                            */
/*    The Await Event Occurrence routine blocks the caller until an event     */
/*    occurs.                                                                 */
/*                                                                            */
/*+~ppl$await_event~+*/
unsigned long int ppl$await_event(
    const unsigned long int  *event_id
    ) ;
/*~-ppl$await_event-~*/
/*    PPL$CREATE_BARRIER                                                      */
/*                                                                            */
/*    Create a Barrier                                                        */
/*                                                                            */
/*    The Create a Barrier routine creates and initializes a                  */
/*    barrier, and returns the barrier identifier.                            */
/*    You use the barrier identifier to perform all operations on that        */
/*    barrier.                                                                */
/*                                                                            */
/*+~ppl$create_barrier~+*/
unsigned long int ppl$create_barrier(
    unsigned long int  *barrier_id,
    ...
    /* const struct dsc$descriptor *barrier_name, */
    /* const short int  *quorum */
    ) ;
/*~-ppl$create_barrier-~*/
/*    PPL$CREATE_EVENT                                                        */
/*                                                                            */
/*    Create an Event                                                         */
/*                                                                            */
/*    The Create an Event routine creates an arbitrary user-defined event     */
/*    and returns the event identifier. You use the event identifier to       */
/*    perform all operations on that event.                                   */
/*                                                                            */
/*+~ppl$create_event~+*/
unsigned long int ppl$create_event(
    unsigned long int  *event_id,
    ...
    /* const struct dsc$descriptor *event_name */
    ) ;
/*~-ppl$create_event-~*/
/*    PPL$CREATE_SPIN_LOCK                                                    */
/*                                                                            */
/*    Create Spin Lock                                                        */
/*                                                                            */
/*    The Create Spin Lock routine creates and initializes a simple (spin)    */
/*    lock, and returns the lock identifier. You use that lock identifier to  */
/*    get and free the lock.                                                  */
/*                                                                            */
/*+~ppl$create_spin_lock~+*/
unsigned long int ppl$create_spin_lock(
    unsigned long int  *lock_id,
    ...
    /* const struct dsc$descriptor *lock_name */
    ) ;
/*~-ppl$create_spin_lock-~*/
/*    PPL$CREATE_SHARED_MEMORY                                                */
/*                                                                            */
/*    Create Shared Memory                                                    */
/*                                                                            */
/*    The Create Shared Memory routine creates (if necessary) and maps a      */
/*    section of memory that can be shared by multiple processes.             */
/*                                                                            */
/*+~ppl$create_shared_memory~+*/
unsigned long int ppl$create_shared_memory(
    const struct dsc$descriptor *section_name,
    unsigned long int  *memory_area [1],
    ...
    /* const unsigned long int flags, */
    /* const struct dsc$descriptor *file_name */
    ) ;
/*~-ppl$create_shared_memory-~*/
/*    PPL$CREATE_SEMAPHORE                                                    */
/*                                                                            */
/*    Create a Semaphore                                                      */
/*                                                                            */
/*    The Create a Semaphore routine creates and initializes a                */
/*    semaphore with a waiting queue, and returns the semaphore identifier.   */
/*    You use the semaphore identifier to perform all operations on that      */
/*    semaphore.                                                              */
/*                                                                            */
/*+~ppl$create_semaphore~+*/
unsigned long int ppl$create_semaphore(
    unsigned long int  *semaphore_id,
    ...
    /* const struct dsc$descriptor *semaphore_name, */
    /* const short int  *semaphore_maximum, */
    /* const short int  *semaphore_initial */
    ) ;
/*~-ppl$create_semaphore-~*/
/*    PPL$CREATE_VM_ZONE                                                      */
/*                                                                            */
/*    Create a New Virtual Memory Zone                                        */
/*                                                                            */
/*    The Create a New Virtual Memory Zone routine creates a new storage      */
/*    zone, according to specified arguments, which is available to all       */
/*    participants in the application.                                        */
/*                                                                            */
/*+~ppl$create_vm_zone~+*/
unsigned long int ppl$create_vm_zone(
    unsigned long int  *zone_id,
    ...
    /* const long int  *algorithm, */
    /* const long int  *algorithm_argument, */
    /* const unsigned long int  *flags, */
    /* const long int  *extend_size, */
    /* const long int  *initial_size, */
    /* const long int  *block_size, */
    /* const long int  *alignment, */
    /* const long int  *page_limit, */
    /* const long int  *smallest_block_size, */
    /* const struct dsc$descriptor *zone_name */
    ) ;
/*~-ppl$create_vm_zone-~*/
/*    PPL$DECREMENT_SEMAPHORE                                                 */
/*                                                                            */
/*    Decrement a Semaphore                                                   */
/*                                                                            */
/*    The Decrement a Semaphore routine waits for a semaphore to have a       */
/*    value greater than 0, then decrements the value                         */
/*    by 1 to indicate the allocation of a resource.                          */
/*    If the value of the semaphore is 0 at the time of the call,             */
/*    the caller is put in the associated queue and is suspended.             */
/*    The semaphore must have been created by PPL$CREATE_SEMAPHORE.           */
/*                                                                            */
/*+~ppl$decrement_semaphore~+*/
unsigned long int ppl$decrement_semaphore(
    const unsigned long int  *semaphore_id,
    ...
    /* const unsigned long int  *flags */
    ) ;
/*~-ppl$decrement_semaphore-~*/
/*    PPL$DELETE_SHARED_MEMORY                                                */
/*                                                                            */
/*    Delete Shared Memory                                                    */
/*                                                                            */
/*    The Delete Shared Memory routine deletes or unmaps from a global        */
/*    section that you created using the PPL$CREATE_SHARED_MEMORY routine.    */
/*    Optionally, this routine writes the contents of the global section to   */
/*    disk before deleting the section.                                       */
/*                                                                            */
/*+~ppl$delete_shared_memory~+*/
unsigned long int ppl$delete_shared_memory(
    const struct dsc$descriptor *section_name,
    ...
    /* const unsigned long int  *memory_area [1], */
    /* const unsigned long int flags */
    ) ;
/*~-ppl$delete_shared_memory-~*/
/*    PPL$ENABLE_EVENT_AST                                                    */
/*                                                                            */
/*    Enable AST Notification of an Event                                     */
/*                                                                            */
/*    The Enable AST Notification of an Event routine specifies the address of*/
/*    an AST routine (and optionally an argument to that routine) to be delivered     */
/*    when an event occurs.                                                   */
/*                                                                            */
/*+~ppl$enable_event_ast~+*/
unsigned long int ppl$enable_event_ast(
    const unsigned long int  *event_id,
    const int * *astadr,
    ...
    /* const int astprm */
    ) ;
/*~-ppl$enable_event_ast-~*/
/*    PPL$ENABLE_EVENT_SIGNAL                                                 */
/*                                                                            */
/*    Enable Signal Notification of an Event                                  */
/*                                                                            */
/*    The Enable Signal Notification of an Event routine specifies a          */
/*    condition value to be signaled when the event occurs.                   */
/*                                                                            */
/*+~ppl$enable_event_signal~+*/
unsigned long int ppl$enable_event_signal(
    const unsigned long int  *event_id,
    ...
    /* const unsigned long int signal_value */
    ) ;
/*~-ppl$enable_event_signal-~*/
/*    PPL$FLUSH_SHARED_MEMORY                                                 */
/*                                                                            */
/*    Flush Shared Memory                                                     */
/*                                                                            */
/*    The Flush Shared Memory routine writes (flushes) to disk the contents   */
/*    of a global section that you created using the PPL$CREATE_SHARED_MEMORY */
/*    routine. Only pages that have been modified are flushed to disk.        */
/*                                                                            */
/*+~ppl$flush_shared_memory~+*/
unsigned long int ppl$flush_shared_memory(
    const struct dsc$descriptor *section_name,
    ...
    /* const unsigned long int  *memory_area [1], */
    /* const unsigned long int flags */
    ) ;
/*~-ppl$flush_shared_memory-~*/
/*    PPL$FIND_SYNCH_ELEMENT_ID                                               */
/*                                                                            */
/*    Find                                                                    */
/*                                                                            */
/*    Given the name of a spin lock, semaphore, barrier, or event, the        */
/*    Find Synchronization Element Identification routine returns the         */
/*    identifier of the associated synchronization element.                   */
/*                                                                            */
/*+~ppl$find_synch_element_id~+*/
unsigned long int ppl$find_synch_element_id(
    unsigned long int  *element_id,
    const struct dsc$descriptor *element_name
    ) ;
/*~-ppl$find_synch_element_id-~*/
/*    PPL$GET_INDEX                                                           */
/*                                                                            */
/*    Get Index of a Participant                                              */
/*                                                                            */
/*    The Get Index of a Participant routine returns an index that is unique  */
/*    within the application. A value of zero signifies the main or           */
/*    main participant. The other participants in the application             */
/*    always return an index greater than zero.                               */
/*                                                                            */
/*+~ppl$get_index~+*/
unsigned long int ppl$get_index(
    unsigned long int  *participant_index
    ) ;
/*~-ppl$get_index-~*/
/*    PPL$INCREMENT_SEMAPHORE                                                 */
/*                                                                            */
/*    Increment a Semaphore                                                   */
/*                                                                            */
/*    The Increment a Semaphore routine increments the value of the semaphore */
/*    by 1, analogous to the signal protocol.  If any other participants      */
/*    are blocked on a call to PPL$DECREMENT_SEMAPHORE for this semaphore,    */
/*    one is removed from the queue and awakened.                             */
/*    The semaphore must have been created by PPL$CREATE_SEMAPHORE.           */
/*                                                                            */
/*+~ppl$increment_semaphore~+*/
unsigned long int ppl$increment_semaphore(
    const unsigned long int  *semaphore_id
    ) ;
/*~-ppl$increment_semaphore-~*/
/*    PPL$INDEX_TO_PID                                                        */
/*                                                                            */
/*    Convert Participant-Index to VMS PID                                    */
/*                                                                            */
/*    The Convert Participant-Index to VMS PID routine returns the VMS PID    */
/*    of the process or subprocess associated with the specified index.       */
/*                                                                            */
/*+~ppl$index_to_pid~+*/
unsigned long int ppl$index_to_pid(
    const unsigned long int  *participant_index,
    unsigned long int  *pid
    ) ;
/*~-ppl$index_to_pid-~*/
/*    PPL$INITIALIZE                                                          */
/*                                                                            */
/*    Initialize the PPL$ Facility                                            */
/*                                                                            */
/*    The Initialize the PPL$ Facility routine informs the PPL$ facility that the     */
/*    caller is forming or joining the parallel application.  Calling this    */
/*    routine is optional, because PPL$ initializes itself at the             */
/*    first call to a PPL$ routine.                                           */
/*                                                                            */
/*+~ppl$initialize~+*/
unsigned long int ppl$initialize(
    /* const unsigned long int  *size */
    ) ;
/*~-ppl$initialize-~*/
/*    PPL$PID_TO_INDEX                                                        */
/*                                                                            */
/*    Convert VMS PID to Participant-Index                                    */
/*                                                                            */
/*    The Convert VMS PID to Participant-Index routine returns the PPL$-defined       */
/*    participant index of the process or subprocess associated with the      */
/*    specified VMS PID.                                                      */
/*                                                                            */
/*+~ppl$pid_to_index~+*/
unsigned long int ppl$pid_to_index(
    const unsigned long int  *pid,
    unsigned long int  *participant_index
    ) ;
/*~-ppl$pid_to_index-~*/
/*    PPL$READ_BARRIER                                                        */
/*                                                                            */
/*    Read a Barrier                                                          */
/*                                                                            */
/*    The Read a Barrier routine returns the specified barrier's current quorum and   */
/*    the number of participants currently waiting (blocked) at the barrier.  The     */
/*    barrier must have been created by PPL$CREATE_BARRIER.                   */
/*                                                                            */
/*+~ppl$read_barrier~+*/
unsigned long int ppl$read_barrier(
    const unsigned long int  *barrier_id,
    short int  *quorum,
    short int  *waiters
    ) ;
/*~-ppl$read_barrier-~*/
/*    PPL$READ_EVENT                                                          */
/*                                                                            */
/*    Read an Event State                                                     */
/*                                                                            */
/*    The Read an Event State routine returns the current state of the specified      */
/*    event.                                                                  */
/*    The state can be not_occurred  or not_occurred.                         */
/*                                                                            */
/*+~ppl$read_event~+*/
unsigned long int ppl$read_event(
    const unsigned long int  *event_id,
    unsigned long int  *occurred
    ) ;
/*~-ppl$read_event-~*/
/*    PPL$READ_SEMAPHORE                                                      */
/*                                                                            */
/*    Read Semaphore Values                                                   */
/*                                                                            */
/*    The Read Semaphore Values routine returns the current or                */
/*    maximum values, or both, of the specified counting semaphore.           */
/*    The semaphore must have been created by                                 */
/*    PPL$CREATE_SEMAPHORE.                                                   */
/*                                                                            */
/*+~ppl$read_semaphore~+*/
unsigned long int ppl$read_semaphore(
    const unsigned long int  *semaphore_id,
    ...
    /* short int  *semaphore_value, */
    /* short int  *semaphore_maximum */
    ) ;
/*~-ppl$read_semaphore-~*/
/*    PPL$RELEASE_SPIN_LOCK                                                   */
/*                                                                            */
/*    Release Spin Lock                                                       */
/*                                                                            */
/*    The Release Spin Lock routine relinquishes the spin lock by clearing the*/
/*    bit representing the lock. The lock must have been created by           */
/*    PPL$CREATE_SPIN_LOCK.                                                   */
/*                                                                            */
/*+~ppl$release_spin_lock~+*/
unsigned long int ppl$release_spin_lock(
    const unsigned long int  *lock_id
    ) ;
/*~-ppl$release_spin_lock-~*/
/*    PPL$SPAWN                                                               */
/*                                                                            */
/*    Initiate Parallel Execution                                             */
/*                                                                            */
/*    The Initiate Parallel Execution routine executes code in parallel       */
/*    with the caller by creating one or more subordinate threads of execution*/
/*    (VMS subprocesses).                                                     */
/*                                                                            */
/*+~ppl$spawn~+*/
unsigned long int ppl$spawn(
    unsigned long int  *copies,
    ...
    /* const struct dsc$descriptor *program_name, */
    /* unsigned long int  *children_ids, */
    /* const unsigned long int  *flags, */
    /* const struct dsc$descriptor *std_input_file, */
    /* const struct dsc$descriptor *std_output_file */
    ) ;
/*~-ppl$spawn-~*/
/*    PPL$SET_QUORUM                                                          */
/*                                                                            */
/*    Set Barrier Quorum                                                      */
/*                                                                            */
/*    The Set Barrier Quorum routine dynamically sets a value for the         */
/*    specified barrier's quorum.  This allows you to easily reuse a barrier  */
/*    for different work items with various numbers of participants.          */
/*    The barrier must have been created by PPL$CREATE_BARRIER.               */
/*                                                                            */
/*+~ppl$set_quorum~+*/
unsigned long int ppl$set_quorum(
    const unsigned long int  *barrier_id,
    const short int  *quorum
    ) ;
/*~-ppl$set_quorum-~*/
/*    PPL$STOP                                                                */
/*                                                                            */
/*    Stop a Participant                                                      */
/*                                                                            */
/*    The Stop a Participant routine terminates the execution of the specified*/
/*    participant in this application.                                        */
/*                                                                            */
/*+~ppl$stop~+*/
unsigned long int ppl$stop(
    const unsigned long int  *participant_index
    ) ;
/*~-ppl$stop-~*/
/*    PPL$SEIZE_SPIN_LOCK                                                     */
/*                                                                            */
/*    Seize Spin Lock                                                         */
/*                                                                            */
/*    The Seize Spin Lock routine retrieves a simple (spin) lock by waiting in a      */
/*    spin loop until the lock is free. The lock must have been created by    */
/*    PPL$CREATE_SPIN_LOCK.                                                   */
/*                                                                            */
/*+~ppl$seize_spin_lock~+*/
unsigned long int ppl$seize_spin_lock(
    const unsigned long int  *lock_id,
    ...
    /* const unsigned long int  *flags */
    ) ;
/*~-ppl$seize_spin_lock-~*/
/*    PPL$TERMINATE                                                           */
/*                                                                            */
/*    Abort PPL$ Participation                                                */
/*                                                                            */
/*    The Abort PPL$ Participation routine ends the caller's                  */
/*    participation in the application prematurely --- that is, at some time  */
/*    before the caller actually completes its execution.                     */
/*                                                                            */
/*+~ppl$terminate~+*/
unsigned long int ppl$terminate(
    /* const unsigned long int  *flags */
    ) ;
/*~-ppl$terminate-~*/
/*    PPL$TRIGGER_EVENT                                                       */
/*                                                                            */
/*    Trigger an Event                                                        */
/*                                                                            */
/*    The Trigger an Event routine causes the event's state to become         */
/*    occurred.  You control whether all pending actions for                  */
/*    the event are processed (made to occur), or just one is processed.      */
/*    A pending action can be an AST, a signal (condition), or a wakeup.      */
/*                                                                            */
/*+~ppl$trigger_event~+*/
unsigned long int ppl$trigger_event(
    const unsigned long int  *event_id,
    ...
    /* const unsigned long int event_param, */
    /* const unsigned long int flags */
    ) ;
/*~-ppl$trigger_event-~*/
/*    PPL$UNIQUE_NAME                                                         */
/*                                                                            */
/*    Produce a Unique Name                                                   */
/*                                                                            */
/*    The Produce a Unique Name routine returns an application-unique name.   */
/*    A system-unique string specific to the calling application is appended  */
/*    to the string specified by the user.                                    */
/*    The resulting name is identical for all participants in                 */
/*    the application, but different from those for all other applications on that    */
/*    system.                                                                 */
/*                                                                            */
/*+~ppl$unique_name~+*/
unsigned long int ppl$unique_name(
    const struct dsc$descriptor *name_string,
    struct dsc$descriptor *resultant_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-ppl$unique_name-~*/
/*    PPL$WAIT_AT_BARRIER                                                     */
/*                                                                            */
/*    Synchronize at a Barrier                                                */
/*                                                                            */
/*    The Synchronize at a Barrier routine causes the caller to               */
/*    wait at the specified barrier.                                          */
/*    The barrier is in effect from the time the first participant calls      */
/*    PPL$WAIT_AT_BARRIER until each member of the                            */
/*    quorum has issued the call.  At that time, the wait concludes and       */
/*    all are released for further execution.                                 */
/*                                                                            */
/*+~ppl$wait_at_barrier~+*/
unsigned long int ppl$wait_at_barrier(
    const unsigned long int  *barrier_id
    ) ;
/*~-ppl$wait_at_barrier-~*/
#endif
