/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:27:01 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]RMSUSR.SDI; */
#ifndef RMSUSR_H
#define RMSUSR_H
 
/*** MODULE $FABDEF ***/
/*+++++*****                                                                  */
/*   the fields thru ctx must not be modified due to                          */
/*   commonality between fab/rab/xab                                          */
#define FAB$C_BID 3     /* code for fab                                       */
#define FAB$M_PPF_RAT 0x00003FC0
#define FAB$M_PPF_IND 0x00004000
#define FAB$M_ASY 0x00000001
#define FAB$M_MXV 0x00000002
#define FAB$M_SUP 0x00000004
#define FAB$M_TMP 0x00000008
#define FAB$M_TMD 0x00000010
#define FAB$M_DFW 0x00000020
#define FAB$M_SQO 0x00000040
#define FAB$M_RWO 0x00000080
#define FAB$M_POS 0x00000100
#define FAB$M_WCK 0x00000200
#define FAB$M_NEF 0x00000400
#define FAB$M_RWC 0x00000800
#define FAB$M_DMO 0x00001000
#define FAB$M_SPL 0x00002000
#define FAB$M_SCF 0x00004000
#define FAB$M_DLT 0x00008000
#define FAB$M_NFS 0x00010000
#define FAB$M_UFO 0x00020000
#define FAB$M_PPF 0x00040000
#define FAB$M_INP 0x00080000
#define FAB$M_CTG 0x00100000
#define FAB$M_CBT 0x00200000
#define FAB$M_SYNCSTS 0x00400000
#define FAB$M_RCK 0x00800000
#define FAB$M_NAM 0x01000000
#define FAB$M_CIF 0x02000000
#define FAB$M_ESC 0x08000000
#define FAB$M_TEF 0x10000000
#define FAB$M_OFP 0x20000000
#define FAB$M_KFO 0x40000000
#define FAB$M_PUT 0x00000001
#define FAB$M_GET 0x00000002
#define FAB$M_DEL 0x00000004
#define FAB$M_UPD 0x00000008
#define FAB$M_TRN 0x00000010
#define FAB$M_BIO 0x00000020
#define FAB$M_BRO 0x00000040
#define FAB$M_EXE 0x00000080
#define FAB$M_SHRPUT 0x00000001
#define FAB$M_SHRGET 0x00000002
#define FAB$M_SHRDEL 0x00000004
#define FAB$M_SHRUPD 0x00000008
#define FAB$M_MSE 0x00000010
#define FAB$M_NIL 0x00000020
#define FAB$M_UPI 0x00000040
#define FAB$M_ORG 0x000000F0
#define FAB$C_SEQ 0     /* sequential                                         */
#define FAB$C_REL 16    /* relative                                           */
#define FAB$C_IDX 32    /* indexed                                            */
#define FAB$C_HSH 48    /* hashed                                             */
#define FAB$M_FTN 0x00000001
#define FAB$M_CR 0x00000002
#define FAB$M_PRN 0x00000004
#define FAB$M_BLK 0x00000008
#define FAB$C_RFM_DFLT 2        /* var len is default                         */
#define FAB$C_UDF 0     /* undefined (also stream binary)                     */
#define FAB$C_FIX 1     /* fixed length records                               */
#define FAB$C_VAR 2     /* variable length records                            */
#define FAB$C_VFC 3     /* variable fixed control                             */
#define FAB$C_STM 4     /* RMS-11 stream (valid only for sequential org)      */
#define FAB$C_STMLF 5   /* LF stream (valid only for sequential org)          */
#define FAB$C_STMCR 6   /* CR stream (valid only for sequential org)          */
#define FAB$C_MAXRFM 6  /* maximum rfm supported                              */
#define FAB$M_ONLY_RU 0x00000001
#define FAB$M_RU 0x00000002
#define FAB$M_BI 0x00000004
#define FAB$M_AI 0x00000008
#define FAB$M_AT 0x00000010
#define FAB$M_NEVER_RU 0x00000020
#define FAB$M_JOURNAL_FILE 0x00000040
#define FAB$M_RCF_RU 0x00000001
#define FAB$M_RCF_AI 0x00000002
#define FAB$M_RCF_BI 0x00000004
#define FAB$K_BLN 80    /* length of fab                                      */
#define FAB$C_BLN 80    /* length of fab                                      */
struct fabdef {
    unsigned char fab$b_bid;    /* block id                                   */
    unsigned char fab$b_bln;    /* block len                                  */
    union {
        unsigned short int fab$w_ifi;   /* internal file index                */
        struct {
            unsigned fabdef$$_fill_1 : 6;       /* move to bit 6              */
            unsigned fab$v_ppf_rat : 8; /* rat value for process-permanent files      */
            unsigned fab$v_ppf_ind : 1; /* indirect access to process-permanent file  */
/* (i.e., restricted operations)                                              */
            unsigned fab$v_fill_0 : 1;
            } fab$r_ifi_bits;
        } fab$r_ifi_overlay;
    union {
        unsigned long int fab$l_fop;    /* file options                       */
        struct {
            unsigned fab$v_asy : 1;     /* asynchronous operations            */
            unsigned fab$v_mxv : 1;     /* maximize version number            */
            unsigned fab$v_sup : 1;     /* supersede existing file            */
            unsigned fab$v_tmp : 1;     /* create temporary file              */
            unsigned fab$v_tmd : 1;     /* create temp file marked for delete */
            unsigned fab$v_dfw : 1;     /* deferred write (rel and idx)       */
            unsigned fab$v_sqo : 1;     /* sequential access only             */
            unsigned fab$v_rwo : 1;     /* rewind mt on open                  */
            unsigned fab$v_pos : 1;     /* use next magtape position          */
            unsigned fab$v_wck : 1;     /* write checking                     */
            unsigned fab$v_nef : 1;     /* inhibit end of file positioning    */
            unsigned fab$v_rwc : 1;     /* rewind mt on close                 */
            unsigned fab$v_dmo : 1;     /* dismount mt on close (not implemented)     */
            unsigned fab$v_spl : 1;     /* spool file on close                */
            unsigned fab$v_scf : 1;     /* submit command file on close       */
            unsigned fab$v_dlt : 1;     /* delete sub-option                  */
            unsigned fab$v_nfs : 1;     /* non-file structured operation      */
            unsigned fab$v_ufo : 1;     /* user file open - no rms operations */
            unsigned fab$v_ppf : 1;     /* process permanent file (pio segment)       */
            unsigned fab$v_inp : 1;     /* process-permanent file is 'input'  */
            unsigned fab$v_ctg : 1;     /* contiguous extension               */
            unsigned fab$v_cbt : 1;     /* contiguous best try                */
            unsigned fab$v_syncsts : 1; /* Synchronous status notification for asynchronous routines. */
            unsigned fab$v_rck : 1;     /* read checking                      */
            unsigned fab$v_nam : 1;     /* use name block dvi, did, and/or fid fields for open        */
            unsigned fab$v_cif : 1;     /* create if non-existent             */
            unsigned fabdef$$_fill_3 : 1;       /* reserved (was UFM bitfield)*/
            unsigned fab$v_esc : 1;     /* 'escape' to non-standard function ($modify)        */
            unsigned fab$v_tef : 1;     /* truncate at eof on close (write-accessed seq. disk file only)      */
            unsigned fab$v_ofp : 1;     /* output file parse (only name type sticky)  */
            unsigned fab$v_kfo : 1;     /* known file open (image activator only release 1)   */
            unsigned fabdef$$_fill_4 : 1;       /* reserved (not implemented) */
            } fab$r_fop_bits;
        } fab$r_fop_overlay;
    unsigned long int fab$l_sts;        /* status                             */
    unsigned long int fab$l_stv;        /* status value                       */
    unsigned long int fab$l_alq;        /* allocation quantity                */
    unsigned short int fab$w_deq;       /* default allocation quantity        */
    union {
        unsigned char fab$b_fac;        /* file access                        */
        struct {
            unsigned fab$v_put : 1;     /* put access                         */
            unsigned fab$v_get : 1;     /* get access                         */
            unsigned fab$v_del : 1;     /* delete access                      */
            unsigned fab$v_upd : 1;     /* update access                      */
            unsigned fab$v_trn : 1;     /* truncate access                    */
            unsigned fab$v_bio : 1;     /* block i/o access                   */
            unsigned fab$v_bro : 1;     /* block and record i/o access        */
            unsigned fab$v_exe : 1;     /* execute access (caller must be exec or kernel mode,        */
/*  ufo must also be set)                                                     */
            } fab$r_fac_bits;
        } fab$r_fac_overlay;
    union {
        unsigned char fab$b_shr;        /* file sharing                       */
        struct {
            unsigned fab$v_shrput : 1;  /* put access                         */
            unsigned fab$v_shrget : 1;  /* get access                         */
            unsigned fab$v_shrdel : 1;  /* delete access                      */
            unsigned fab$v_shrupd : 1;  /* update access                      */
            unsigned fab$v_mse : 1;     /* multi-stream connects enabled      */
            unsigned fab$v_nil : 1;     /* no sharing                         */
            unsigned fab$v_upi : 1;     /* user provided interlocking (allows multiple        */
/*  writers to seq. files)                                                    */
            unsigned fab$v_fill_1 : 1;
            } fab$r_shr_bits;
        } fab$r_shr_overlay;
    unsigned long int fab$l_ctx;        /* user context                       */
/*-----*****                                                                  */
    char fab$b_rtv;     /* retrieval window size                              */
    union {
        unsigned char fab$b_org;        /* file organization                  */
        struct {
            unsigned fabdef$$_fill_5 : 4;
            unsigned fab$v_org : 4;
            } fab$r_org_bits;
        } fab$r_org_overlay;
    union {
        unsigned char fab$b_rat;        /* record format                      */
        struct {
            unsigned fab$v_ftn : 1;     /* fortran carriage-ctl               */
            unsigned fab$v_cr : 1;      /* lf-record-cr carriage ctl          */
            unsigned fab$v_prn : 1;     /* print-file carriage ctl            */
            unsigned fab$v_blk : 1;     /* records don't cross block boundaries       */
            unsigned fab$v_fill_2 : 4;
            } fab$r_rat_bits;
        } fab$r_rat_overlay;
    unsigned char fab$b_rfm;    /* record format                              */
    union {
        unsigned char fab$b_journal;    /* journaling options (from FH2$B_JOURNAL)    */
        struct {        /* note: only one of RU, ONLY_RU, NEVER_RU            */
/* may be set at a time                                                       */
            unsigned fab$v_only_ru : 1; /* file is accessible only in recovery unit   */
            unsigned fab$v_ru : 1;      /* enable recovery unit journal       */
            unsigned fab$v_bi : 1;      /* enable before image journal        */
            unsigned fab$v_ai : 1;      /* enable after image journal         */
            unsigned fab$v_at : 1;      /* enable audit trail journal         */
            unsigned fab$v_never_ru : 1;        /* file is never accessible in recovery unit  */
            unsigned fab$v_journal_file : 1;    /* this is a journal file     */
            unsigned fab$v_fill_3 : 1;
            } fab$r_journal_bits;
        } fab$r_journal_overlay;
    unsigned char fab$b_ru_facility;    /* recoverable facility id number     */
    short int fabdef$$_fill_7;  /* (spare)                                    */
    unsigned long int fab$l_xab;        /* xab address                        */
    unsigned long int fab$l_nam;        /* nam block address                  */
    unsigned long int fab$l_fna;        /* file name string address           */
    unsigned long int fab$l_dna;        /* default file name string addr      */
    unsigned char fab$b_fns;    /* file name string size                      */
    unsigned char fab$b_dns;    /* default name string size                   */
    unsigned short int fab$w_mrs;       /* maximum record size                */
    unsigned long int fab$l_mrn;        /* maximum record number              */
    unsigned short int fab$w_bls;       /* blocksize for tape                 */
    unsigned char fab$b_bks;    /* bucket size                                */
    unsigned char fab$b_fsz;    /* fixed header size                          */
    unsigned long int fab$l_dev;        /* device characteristics             */
    unsigned long int fab$l_sdc;        /* spooling device characteristics    */
    unsigned short int fab$w_gbc;       /* Global buffer count                */
    union {
        unsigned char fab$b_acmodes;    /* agent access modes                 */
        struct {
            unsigned fab$v_lnm_mode : 2;        /* ACMODE for log nams        */
            unsigned fab$v_chan_mode : 2;       /* ACMODE for channel         */
            unsigned fab$v_file_mode : 2;       /* ACMODE to use for determining file accessibility   */
            unsigned fab$v_callers_mode : 2;    /* ACMODE for user structure probing; */
/* maximized with actual mode of caller                                       */
            } fab$r_acmodes_bits;
        } fab$r_acmodes_overlay;
    union {     /* recovery control flags                                     */
        unsigned char fab$b_rcf;        /* (only for use by RMS Recovery)     */
        struct {
            unsigned fab$v_rcf_ru : 1;  /* recovery unit recovery             */
            unsigned fab$v_rcf_ai : 1;  /* after image recovery               */
            unsigned fab$v_rcf_bi : 1;  /* before image recovery              */
            unsigned fab$v_fill_4 : 5;
            } fab$r_rcf_bits;
        } fab$r_rcf_overlay;
    long int fabdef$$_fill_9;   /* (spare)                                    */
} ;
 
/*** MODULE $RABDEF ***/
/*                                                                            */
/*         record access block (rab) definitions                              */
/*                                                                            */
/*  there is one rab per connected stream                                     */
/*  it is used for all communications between the user                        */
/*  and rms concerning operations on the stream                               */
/*                                                                            */
/*+++++*****                                                                  */
/*  the fields thru ctx cannot be changed due to commonality                  */
/*  with the fab                                                              */
/*                                                                            */
#define RAB$C_BID 1     /* code for rab                                       */
#define RAB$M_PPF_RAT 0x00003FC0
#define RAB$M_PPF_IND 0x00004000
#define RAB$M_ASY 0x00000001
#define RAB$M_TPT 0x00000002
#define RAB$M_REA 0x00000004
#define RAB$M_RRL 0x00000008
#define RAB$M_UIF 0x00000010
#define RAB$M_MAS 0x00000020
#define RAB$M_FDL 0x00000040
#define RAB$M_HSH 0x00000080
#define RAB$M_EOF 0x00000100
#define RAB$M_RAH 0x00000200
#define RAB$M_WBH 0x00000400
#define RAB$M_BIO 0x00000800
#define RAB$M_CDK 0x00001000
#define RAB$M_LOA 0x00002000
#define RAB$M_LIM 0x00004000
#define RAB$M_SYNCSTS 0x00008000
#define RAB$M_LOC 0x00010000
#define RAB$M_WAT 0x00020000
#define RAB$M_ULK 0x00040000
#define RAB$M_RLK 0x00080000
#define RAB$M_NLK 0x00100000
#define RAB$M_KGE 0x00200000
#define RAB$M_KGT 0x00400000
#define RAB$M_NXR 0x00800000
#define RAB$M_RNE 0x01000000
#define RAB$M_TMO 0x02000000
#define RAB$M_CVT 0x04000000
#define RAB$M_RNF 0x08000000
#define RAB$M_ETO 0x10000000
#define RAB$M_PTA 0x20000000
#define RAB$M_PMT 0x40000000
#define RAB$M_CCO 0x80000000
#define RAB$M_EQNXT 0x00200000
#define RAB$M_NXT 0x00400000
#define RAB$C_SEQ 0     /* sequential access                                  */
#define RAB$C_KEY 1     /* keyed access                                       */
#define RAB$C_RFA 2     /* rfa access                                         */
#define RAB$C_STM 3     /* stream access (valid only for sequential org)      */
#define RAB$C_MAXRAC 2  /* Maximum RAC value currently supported by RMS       */
#define RAB$K_BLN 68    /* length of rab                                      */
#define RAB$C_BLN 68    /* length of rab                                      */
struct rabdef {
    unsigned char rab$b_bid;    /* block id                                   */
    unsigned char rab$b_bln;    /* block length                               */
    union {
        unsigned short int rab$w_isi;   /* internal stream index              */
/* (ifi in fab)                                                               */
        struct {
            unsigned rabdef$$_fill_1 : 6;       /* move to bit 6              */
            unsigned rab$v_ppf_rat : 8; /* rat value for process-permanent files      */
            unsigned rab$v_ppf_ind : 1; /* indirect access to process-permanent file  */
/* (i.e., restricted operations)                                              */
            unsigned rab$v_fill_5 : 1;
            } rab$r_isi_bits;
        } rab$r_isi_overlay;
    union {
        unsigned long int rab$l_rop;    /* record options                     */
        struct {
            unsigned rab$v_asy : 1;     /* asynchronous operations            */
            unsigned rab$v_tpt : 1;     /* truncate put - allow sequential put not at */
/*   eof, thus truncating file (seq. org only)                                */
/*                                                                            */
/* these next two should be in the byte for bits                              */
/* input to $find or $get, but there is no room there                         */
/*                                                                            */
            unsigned rab$v_rea : 1;     /* lock record for read only, allow other readers     */
            unsigned rab$v_rrl : 1;     /* read record regardless of lock     */
/*                                                                            */
            unsigned rab$v_uif : 1;     /* update if existent                 */
            unsigned rab$v_mas : 1;     /* mass-insert mode                   */
            unsigned rab$v_fdl : 1;     /* fast record deletion               */
            unsigned rab$v_hsh : 1;     /* use hash code in bkt               */
/*                                                                            */
            unsigned rab$v_eof : 1;     /* connect to eof                     */
            unsigned rab$v_rah : 1;     /* read ahead                         */
            unsigned rab$v_wbh : 1;     /* write behind                       */
            unsigned rab$v_bio : 1;     /* connect for bio only               */
            unsigned rab$v_cdk : 1;     /* check for duplicate keys on $GET   */
            unsigned rab$v_loa : 1;     /* use bucket fill percentage         */
            unsigned rab$v_lim : 1;     /* compare for key limit reached on $get/$find seq. (idx only)        */
            unsigned rab$v_syncsts : 1; /* Synchronous status notification for asynchronous routines. */
/*                                                                            */
/* the following bits are input to                                            */
/* $find or $get, (see above also REA and RRL)                                */
/* (separate byte)                                                            */
/*                                                                            */
            unsigned rab$v_loc : 1;     /* use locate mode                    */
            unsigned rab$v_wat : 1;     /* wait if record not available       */
            unsigned rab$v_ulk : 1;     /* manual unlocking                   */
            unsigned rab$v_rlk : 1;     /* allow readers for this locked record       */
            unsigned rab$v_nlk : 1;     /* do not lock record                 */
            unsigned rab$v_kge : 1;     /* key > or =                         */
            unsigned rab$v_kgt : 1;     /* key greater than                   */
            unsigned rab$v_nxr : 1;     /* get non-existent record            */
/*                                                                            */
/*  the following bits are terminal qualifiers only                           */
/*  (separate byte)                                                           */
/*                                                                            */
            unsigned rab$v_rne : 1;     /* read no echo                       */
            unsigned rab$v_tmo : 1;     /* use time-out period                */
            unsigned rab$v_cvt : 1;     /* convert to upper case              */
            unsigned rab$v_rnf : 1;     /* read no filter                     */
            unsigned rab$v_eto : 1;     /* extended terminal operation        */
            unsigned rab$v_pta : 1;     /* purge type ahead                   */
            unsigned rab$v_pmt : 1;     /* use prompt buffer                  */
            unsigned rab$v_cco : 1;     /* cancel control o on output         */
            } rab$r_rop_bits0;
        struct {
            unsigned rabdef$$_fill_6 : 21;
            unsigned rab$v_eqnxt : 1;   /* Synonyms for KGE and               */
            unsigned rab$v_nxt : 1;     /*   KGT                              */
            unsigned rab$v_fill_6 : 1;
            } rab$r_rop_bits1;
/* the following bits may be                                                  */
/* input to various rab-related                                               */
/* operations                                                                 */
/*                                                                            */
        struct {
            char rabdef$$_fill_3;
            unsigned char rab$b_rop1;   /* various options                    */
            unsigned char rab$b_rop2;   /* get/find options (use of this field discouraged    */
/* due to REA and RRL being in a different byte)                              */
            unsigned char rab$b_rop3;   /* terminal read options              */
/*                                                                            */
            } rab$r_rop_fields;
        } rab$r_rop_overlay;
    unsigned long int rab$l_sts;        /* status                             */
    union {
        unsigned long int rab$l_stv;    /* status value                       */
        struct {
            unsigned short int rab$w_stv0;      /* low word of stv            */
            unsigned short int rab$w_stv2;      /* high word of stv           */
            } rab$r_stv_fields;
        } rab$r_stv_overlay;
    union {
        unsigned short int rab$w_rfa [3];       /* record's file address      */
        struct {
            unsigned long int rab$l_rfa0;
            unsigned short int rab$w_rfa4;
            } rab$r_rfa_fields;
        } rab$r_rfa_overlay;
    short int rabdef$$_fill_4;  /* (reserved - rms release 1 optimizes stores */
/*  to the rfa field to be a move quad, overwriting                           */
/*  this reserved word)                                                       */
    unsigned long int rab$l_ctx;        /* user context                       */
/*-----*****                                                                  */
    short int rabdef$$_fill_5;  /* (spare)                                    */
    unsigned char rab$b_rac;    /* record access                              */
    unsigned char rab$b_tmo;    /* time-out period                            */
    unsigned short int rab$w_usz;       /* user buffer size                   */
    unsigned short int rab$w_rsz;       /* record buffer size                 */
    unsigned long int rab$l_ubf;        /* user buffer address                */
    unsigned long int rab$l_rbf;        /* record buffer address              */
    unsigned long int rab$l_rhb;        /* record header buffer addr          */
    union {
        unsigned long int rab$l_kbf;    /* key buffer address                 */
        unsigned long int rab$l_pbf;    /* prompt buffer addr                 */
        } rab$r_kbf_overlay;
    union {
        unsigned char rab$b_ksz;        /* key buffer size                    */
        unsigned char rab$b_psz;        /* prompt buffer size                 */
        } rab$r_ksz_overlay;
    unsigned char rab$b_krf;    /* key of reference                           */
    char rab$b_mbf;     /* multi-buffer count                                 */
    unsigned char rab$b_mbc;    /* multi-block count                          */
    union {
        unsigned long int rab$l_bkt;    /* bucket hash code, vbn, or rrn      */
        unsigned long int rab$l_dct;    /* duplicates count on key accessed on alternate key  */
        } rab$r_bkt_overlay;
    unsigned long int rab$l_fab;        /* related fab for connect            */
    unsigned long int rab$l_xab;        /* XAB address                        */
} ;
 
/*** MODULE $NAMDEF ***/
/*                                                                            */
/*         name block field definitions                                       */
/*                                                                            */
/*  the nam block is used to communicate optional                             */
/*  filename-related information                                              */
/*                                                                            */
#define NAM$C_BID 2     /* code for nam block                                 */
#define NAM$C_MAXRSS 255        /* maximum resultant name string size (network)       */
#define NAM$C_MAXRSSLCL 255     /* maximum resultant name string size (local) */
#define NAM$M_PWD 0x00000001
#define NAM$M_FILL_1 0x00000002
#define NAM$M_FILL_2 0x00000004
#define NAM$M_SYNCHK 0x00000008
#define NAM$M_NOCONCEAL 0x00000010
#define NAM$M_SLPARSE 0x00000020
#define NAM$M_SRCHXABS 0x00000040
#define NAM$C_UFS 0     /* Unknown file system for remote file access or      */
/*  not applicable for local file access or                                   */
#define NAM$C_NO_RFS 0  /*  task-to-task operation                            */
#define NAM$C_RMS11 1   /* RMS-11                                             */
#define NAM$C_RMS20 2   /* RMS-20                                             */
#define NAM$C_RMS32 3   /* RMS-32                                             */
#define NAM$C_FCS11 4   /* FCS-11                                             */
#define NAM$C_RT11FS 5  /* RT-11 file system                                  */
#define NAM$C_TOPS20FS 7        /* TOPS-20 file system                        */
#define NAM$C_TOPS10FS 8        /* TOPS-10 file system                        */
#define NAM$C_RMS32S 10 /* RMS-32 subset (e.g., VAXELAN)                      */
#define NAM$C_CPMFS 11  /* CP/M file system                                   */
#define NAM$C_MS_DOSFS 12       /* MS/DOS file system                         */
#define NAM$C_ULTRIX32_FS 13    /* Ultrix-32 file system                      */
#define NAM$C_ULTRIX11_FS 14    /* Ultrix-11 file system                      */
#define DAP$K_SNADTF_FS 15      /* SNADTF compatable FS                       */
/*+++++++++++++++++++++++                                                     */
#define NAM$C_DVI 16    /* length of dvi field                                */
/*+++++*****                                                                  */
#define NAM$M_IFI 0x00010000
#define NAM$M_SRCHNMF 0x40000000
#define NAM$M_SVCTX 0x80000000
#define NAM$K_BLN_V2 56 /* Version 2 name block length                        */
#define NAM$C_BLN_V2 56 /* Version 2 name block length                        */
#define NAM$M_EXP_VER 0x00000001
#define NAM$M_EXP_TYPE 0x00000002
#define NAM$M_EXP_NAME 0x00000004
#define NAM$M_WILD_VER 0x00000008
#define NAM$M_WILD_TYPE 0x00000010
#define NAM$M_WILD_NAME 0x00000020
#define NAM$M_EXP_DIR 0x00000040
#define NAM$M_EXP_DEV 0x00000080
#define NAM$M_WILDCARD 0x00000100
#define NAM$M_SEARCH_LIST 0x00000800
#define NAM$M_CNCL_DEV 0x00001000
#define NAM$M_ROOT_DIR 0x00002000
#define NAM$M_LOWVER 0x00004000
#define NAM$M_HIGHVER 0x00008000
#define NAM$M_PPF 0x00010000
#define NAM$M_NODE 0x00020000
#define NAM$M_QUOTED 0x00040000
#define NAM$M_GRP_MBR 0x00080000
#define NAM$M_WILD_DIR 0x00100000
#define NAM$M_DIR_LVLS 0x00E00000
#define NAM$M_WILD_UFD 0x01000000
#define NAM$M_WILD_SFD1 0x02000000
#define NAM$M_WILD_SFD2 0x04000000
#define NAM$M_WILD_SFD3 0x08000000
#define NAM$M_WILD_SFD4 0x10000000
#define NAM$M_WILD_SFD5 0x20000000
#define NAM$M_WILD_SFD6 0x40000000
#define NAM$M_WILD_SFD7 0x80000000
#define NAM$M_WILD_GRP 0x01000000
#define NAM$M_WILD_MBR 0x02000000
#define NAM$K_BLN_DIRWC 96      /* Not documented optional length             */
#define NAM$C_BLN_DIRWC 96      /* Not documented optional length             */
#define NAM$K_BLN 96    /* Name block length                                  */
#define NAM$C_BLN 96    /* Name block length                                  */
struct namdef {
    unsigned char nam$b_bid;    /* block id                                   */
    unsigned char nam$b_bln;    /* block length                               */
/*+++++++++++++++++++++++                                                     */
/*  the following 3 fields must not be rearranged relative to each other      */
/*                                                                            */
    unsigned char nam$b_rss;    /* resultant string area size                 */
    unsigned char nam$b_rsl;    /* resultant string length                    */
    unsigned long int nam$l_rsa;        /* resultant string area address      */
/*-----------------------                                                     */
    union {
        unsigned char nam$b_nop;        /* Name options                       */
        struct {
            unsigned nam$v_pwd : 1;     /* Return password if present in nodespec string and any      */
/* other task-specific data of the form /netacp_data"                         */
/*  (default is to mask out password from expanded and                        */
/*  resultant name strings and to create a logical name                       */
/*  whose equivalence string is the unaltered nodespec)                       */
            unsigned nam$v_fill_1 : 1;  /* unused.  (used to be undocumented ROD)     */
            unsigned nam$v_fill_2 : 1;  /* unused.  (used to be undocumented SOD)     */
            unsigned nam$v_synchk : 1;  /* Only do syntax check on $parse operation   */
            unsigned nam$v_noconceal : 1;       /* Do not conceal device/root directory       */
            unsigned nam$v_slparse : 1; /* Parse search list (not documented) -- used by BACKUP.      */
            unsigned nam$v_srchxabs : 1;        /* Fill in attached XABS on $SEARCH operations over the       */
/*  network (not documented) -- used by directory.                            */
            unsigned nam$v_fill_7 : 1;
            } nam$r_nop_bits;
        } nam$r_nop_overlay;
    unsigned char nam$b_rfs;    /* Remote file system type (currently not documented) */
/* Note: This field is reserved for use by Digital                            */
/*  the following 3 fields must not be rearranged relative to each other      */
/*                                                                            */
    unsigned char nam$b_ess;    /* espanded string area size                  */
    unsigned char nam$b_esl;    /* expanded string length                     */
    unsigned long int nam$l_esa;        /* expanded string area address       */
/*-----------------------                                                     */
    unsigned long int nam$l_rlf;        /* related file nam block addr        */
    char nam$t_dvi [16];        /* device id                                  */
/*  the location of the following fields must not                             */
/*  be changed due to their commonality with the fib                          */
    union {
        unsigned short int nam$w_fid [3];       /* file id                    */
        struct {
            unsigned short int nam$w_fid_num;   /* file number                */
            unsigned short int nam$w_fid_seq;   /* sequence number            */
            union {
                unsigned short int nam$w_fid_rvn;       /* relative volume number     */
                struct {
                    unsigned char nam$b_fid_rvn;        /* alternate format RVN       */
                    unsigned char nam$b_fid_nmx;        /* alternate format file number extension     */
                    } nam$r_fid_rvn_fields;
                } nam$r_fid_rvn_overlay;
            } nam$r_fid_fields;
        } nam$r_fid_overlay;
    union {
        unsigned short int nam$w_did [3];       /* directory id               */
        struct {
            unsigned short int nam$w_did_num;   /* file number                */
            unsigned short int nam$w_did_seq;   /* sequence number            */
            union {
                unsigned short int nam$w_did_rvn;       /* relative volume number     */
                struct {
                    unsigned char nam$b_did_rvn;        /* alternate format RVN       */
                    unsigned char nam$b_did_nmx;        /* alternate format file number extension     */
                    } nam$r_did_rvn_fields;
                } nam$r_did_rvn_overlay;
            } nam$r_did_fields;
        } nam$r_did_overlay;
    union {
        unsigned long int nam$l_wcc;    /* wild card context                  */
        struct {
            unsigned namdef$$_fill_1 : 16;      /* the first word is reserved for IFI/ACP context     */
            unsigned nam$v_ifi : 1;     /* the first word contains an IFI     */
            unsigned namdef$$_fill_2 : 13;      /* grow from top down, start at top bit       */
            unsigned nam$v_srchnmf : 1; /* no-more-files has been encountered on a search     */
            unsigned nam$v_svctx : 1;   /* save context across search calls   */
            } nam$r_wcc_bits;
        } nam$r_wcc_overlay;
    union {
        unsigned long int nam$l_fnb;    /* file name status bits              */
        struct {
            unsigned nam$v_exp_ver : 1; /* version was explicit               */
            unsigned nam$v_exp_type : 1;        /* type was explicit          */
            unsigned nam$v_exp_name : 1;        /* name was explicit          */
            unsigned nam$v_wild_ver : 1;        /* version contained a wild card      */
            unsigned nam$v_wild_type : 1;       /* type contained a wild card */
            unsigned nam$v_wild_name : 1;       /* name contained a wild card */
            unsigned nam$v_exp_dir : 1; /* directory was explicit             */
            unsigned nam$v_exp_dev : 1; /* device was explicit                */
            unsigned nam$v_wildcard : 1;        /* filename string included a wild card       */
/* (inclusive or of other wild card bits)                                     */
            unsigned namdef$$_fill_3 : 2;       /* (spares)                   */
            unsigned nam$v_search_list : 1;     /* search list present        */
            unsigned nam$v_cncl_dev : 1;        /* concealed device present   */
            unsigned nam$v_root_dir : 1;        /* root directory present     */
            unsigned nam$v_lowver : 1;  /* lower numbered version(s) of file exist(s) */
            unsigned nam$v_highver : 1; /* higher "                           */
/*                                                                            */
            unsigned nam$v_ppf : 1;     /* process-permanent file referenced indirectly       */
            unsigned nam$v_node : 1;    /* filename specification included a nodename */
            unsigned nam$v_quoted : 1;  /* filename spec included a quoted string     */
            unsigned nam$v_grp_mbr : 1; /* directory spec was of group-member format  */
            unsigned nam$v_wild_dir : 1;        /* directory spec included a wild card        */
            unsigned nam$v_dir_lvls : 3;        /* number of directory levels (0=ufd only)    */
            } nam$r_fnb_bits0;
        struct {
            unsigned namdef$$_fill_4 : 24;      /* separate byte for wild card directory flags        */
            unsigned nam$v_wild_ufd : 1;        /* ufd included a wild card   */
            unsigned nam$v_wild_sfd1 : 1;       /* sfd1 included a wild card  */
            unsigned nam$v_wild_sfd2 : 1;       /* sfd2 included a wild card  */
            unsigned nam$v_wild_sfd3 : 1;       /* sfd3 included a wild card  */
            unsigned nam$v_wild_sfd4 : 1;       /* sfd4 included a wild card  */
            unsigned nam$v_wild_sfd5 : 1;       /* sfd5 included a wild card  */
            unsigned nam$v_wild_sfd6 : 1;       /* sfd6 included a wild card  */
            unsigned nam$v_wild_sfd7 : 1;       /* sfd7 included a wild card  */
            } nam$r_fnb_bits1;
        struct {
            unsigned namdef$$_fill_5 : 24;      /* alternate definitions for wild_ufd and wild_sfd1   */
            unsigned nam$v_wild_grp : 1;        /* group contained a wild card        */
            unsigned nam$v_wild_mbr : 1;        /* member contained a wild card       */
            unsigned nam$v_fill_8 : 6;
            } nam$r_fnb_bits2;
/*-----*****                                                                  */
/* (prior to 40 byte extension)                                               */
/*                                                                            */
/* Extend the NAM block by 40 bytes.                                          */
/*                                                                            */
        } nam$r_fnb_overlay;
    unsigned char nam$b_node;   /* Nodespec length                            */
    unsigned char nam$b_dev;    /* Device length                              */
    unsigned char nam$b_dir;    /* Directory length                           */
    unsigned char nam$b_name;   /* Filename length                            */
    unsigned char nam$b_type;   /* Filetype length                            */
    unsigned char nam$b_ver;    /* Version number length                      */
    char namdef$$_fill_6 [2];   /* Currently unused                           */
    unsigned long int nam$l_node;       /* Nodespec address                   */
    unsigned long int nam$l_dev;        /* Device address                     */
    unsigned long int nam$l_dir;        /* Directory address                  */
    unsigned long int nam$l_name;       /* Filename address                   */
    unsigned long int nam$l_type;       /* Filetype address                   */
    unsigned long int nam$l_ver;        /* Version number address             */
    long int namdef$$_fill_7 [2];       /* Currently unused                   */
} ;
 
/*** MODULE $XABDEF ***/
/*                                                                            */
/*         definitions for all xabs                                           */
/*                $xabdef                                                     */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  the first four fields are shared in common between all xabs               */
/*  and hence are defined only once                                           */
/*  (the only exception is that the spare word may be used by some xabs)      */
/*                                                                            */
struct xabdef {
    unsigned char xab$b_cod;    /* xab id code                                */
    unsigned char xab$b_bln;    /* block length                               */
    short int xabdef$$_fill_1;  /* (spare)                                    */
    unsigned long int xab$l_nxt;        /* xab chain link                     */
/*WITH POSSIBLE EXCEPTION OF SPARE FIELD                                      */
    unsigned short int xab$w_rvn;
    short int xabdef$$_fill_2;
    union {
        int xab$q_rdt [2];
        struct {
            unsigned long int xab$l_rdt0;
            long int xab$l_rdt4;
/*COMMON AMONG DAT AND RDT XABS                                               */
            } xab$r_rdt_fields;
        } xab$r_rdt_overlay;
} ;
struct xabdef1 {
    char xabdef$$_fill_3 [8];
    char xabdef$$_fill_4;       /*THESE FIELDS WILL BE DEFINED LATER          */
    char xabdef$$_fill_5;
    short int xabdef$$_fill_6;
    long int xabdef$$_fill_7;
    long int xabdef$$_fill_8;
    short int xabdef$$_fill_9;
    unsigned char xab$b_bkz;    /*COMMON TO FHC AND ALQ XABS                  */
} ;
#define XAB$C_CXT_VER1 1        /* RMS Context Extraction version 1           */
 
/*** MODULE $XABFHCDEF ***/
/*++                                                                          */
/*        file header characteristics xab definitions                         */
/*                $xabfhcdef                                                  */
/*                                                                            */
/*+++++*****                                                                  */
/*  the fields of this xab cannot be rearranged since                         */
/*  they correspond to an on-disk structure                                   */
/*                                                                            */
#define XAB$C_FHC 29    /* xabfhc id code                                     */
#define XAB$M_FTN 0x00000001
#define XAB$M_CR 0x00000002
#define XAB$M_PRN 0x00000004
#define XAB$M_BLK 0x00000008
#define XAB$K_FHCLEN 44 /* length of xabfhc                                   */
#define XAB$C_FHCLEN 44 /* length of xabfhc                                   */
struct xabfhcdef {
    char xabfhcdef$$_fill_1;
    char xabfhcdef$$_fill_2;
    short int xabfhcdef$$_fill_3;
    long int xabfhcdef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    unsigned char xab$b_rfo;    /* record format and file org                 */
    union {
        unsigned char xab$b_atr;        /* record attributes                  */
        struct {
            unsigned xab$v_ftn : 1;     /* fortran carriage-ctl               */
            unsigned xab$v_cr : 1;      /* lf-record-cr carriage ctl          */
            unsigned xab$v_prn : 1;     /* print-file carriage ctl            */
            unsigned xab$v_blk : 1;     /* records don't cross block boundaries       */
            unsigned xab$v_fill_11 : 4;
            } xab$r_fill_10;
        } xab$r_fill_9;
    unsigned short int xab$w_lrl;       /* longest record's length            */
    union {
        unsigned long int xab$l_hbk;    /* hi vbn allocated                   */
/* (n.b. reversed on disk!)                                                   */
        struct {
            unsigned short int xab$w_hbk0;
            unsigned short int xab$w_hbk2;
            } xab$r_hbk_fields;
        } xab$r_hbk_overlay;
    union {
        unsigned long int xab$l_ebk;    /* eof vbn                            */
/* (n.b. reversed on disk)                                                    */
        struct {
            unsigned short int xab$w_ebk0;
            unsigned short int xab$w_ebk2;
            } xab$r_ebk_fields;
        } xab$r_ebk_overlay;
    unsigned short int xab$w_ffb;       /* first free byte in eof block       */
    char xabfhcdef$$_fill_5;    /* bucket size for fhc ( note: field name is bkz,     */
/* defined above in $xabdef, since it is shared                               */
/* by the all xab)                                                            */
    unsigned char xab$b_hsz;    /* header size for vfc                        */
    unsigned short int xab$w_mrz;       /* max record size                    */
    unsigned short int xab$w_dxq;       /* default extend quantity            */
    unsigned short int xab$w_gbc;       /* global buffer count                */
    char xabfhcdef$$_fill_6 [8];        /* spares (pad to last word)          */
    unsigned short int xab$w_verlimit;  /* version limit for file.            */
/*-----*****                                                                  */
    unsigned long int xab$l_sbn;        /* starting lbn if contiguous         */
} ;
 
/*** MODULE $XABALLDEF ***/
/*--                                                                          */
/*++                                                                          */
/*                                                                            */
/*        allocation xab definitions                                          */
/*                $xaballdef                                                  */
/*                                                                            */
/*                                                                            */
/*+++++*****                                                                  */
/*  the fields thru bkz cannot be rearranged due to                           */
/*  their commonality with fab                                                */
#define XAB$C_ALL 20    /* xaball id code                                     */
#define XAB$M_HRD 0x00000001
#define XAB$M_ONC 0x00000002
#define XAB$M_CBT 0x00000020
#define XAB$M_CTG 0x00000080
#define XAB$C_ANY 0     /* any allocation o.k.                                */
#define XAB$C_CYL 1     /* cylinder boundary                                  */
#define XAB$C_LBN 2     /* allocate at specified lbn                          */
#define XAB$C_VBN 3     /* allocate near specified vbn                        */
#define XAB$C_RFI 4     /* allocate near related file                         */
#define XAB$K_ALLLEN 32 /* length of xaball                                   */
#define XAB$C_ALLLEN 32 /* length of xaball                                   */
struct xaballdef {
    char xaballdef$$_fill_1;
    char xaballdef$$_fill_2;
    short int xaballdef$$_fill_3;
    long int xaballdef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    union {
        unsigned char xab$b_aop;        /* allocation options                 */
        struct {
            unsigned xab$v_hrd : 1;     /* fail if requested alignment impossible     */
            unsigned xab$v_onc : 1;     /* locate allocated space within a cylinder   */
            unsigned xaballdef$$_fill_5 : 3;    /* (spares)                   */
            unsigned xab$v_cbt : 1;     /* contiguous alllocation, best try   */
            unsigned xaballdef$$_fill_6 : 1;    /* spare                      */
            unsigned xab$v_ctg : 1;     /* contiguous allocation              */
            } xab$r_aop_bits;
        } xab$r_aop_overlay;
    unsigned char xab$b_aln;    /* alignment type                             */
    unsigned short int xab$w_vol;       /* relative volume no. for allocation */
/* (not applicable if aln = vbn or rfi)                                       */
    unsigned long int xab$l_loc;        /* allocation location                */
    unsigned long int xab$l_alq;        /* allocation quantity                */
    unsigned short int xab$w_deq;       /* default allocation quantity        */
    char xaballdef$$_fill_7;    /* bucket size for area (note: field name is bkz,     */
/* defined above in $xabdef,since it is shared by the fhc                     */
/* xab and has the same offset, of course)                                    */
/*-----*****                                                                  */
    unsigned char xab$b_aid;    /* area id number                             */
    union {
        unsigned short int xab$w_rfi [3];       /* related file id            */
        struct {
            unsigned short int xab$w_rfi0;      /* file number                */
            unsigned short int xab$w_rfi2;      /* seq number                 */
            unsigned short int xab$w_rfi4;      /* rev number                 */
            } xab$r_rfi_fields;
        } xab$r_rfi_overlay;
    short int xaballdef$$_fill_8;       /* (spare)                            */
} ;
 
/*** MODULE $XABDATDEF ***/
/*--                                                                          */
/*++                                                                          */
/*                                                                            */
/*        date/time xab definitions                                           */
/*                $xabdatdef                                                  */
/*                                                                            */
#define XAB$C_DAT 18    /* xabdat id code                                     */
#define XAB$K_DATLEN_V2 36      /* Version 2 XABDAT length                    */
#define XAB$C_DATLEN_V2 36      /* Version 2 XABDAT length                    */
#define XAB$K_DATLEN 44 /* length of XABDAT                                   */
#define XAB$C_DATLEN 44 /* length of XABDAT                                   */
struct xabdatdef {
    char xabdatdef$$_fill_1;
    char xabdatdef$$_fill_2;
    short int xabdatdef$$_fill_3;
    long int xabdatdef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    short int xabdatdef$$_fill_5;       /*REVISION !,DEFINED IN $XABDEF,SINCE COMMON TO DAT & RDT     */
    short int xabdatdef$$_fill_6;       /* spare                              */
    int xabdatdef$$_fill_7 [2]; /* revision date & time,defined in $xabdef    */
    union {
        int xab$q_cdt [2];      /* creation date & time                       */
        struct {
            unsigned long int xab$l_cdt0;
            long int xab$l_cdt4;
            } xab$r_cdt_fields;
        } xab$r_cdt_overlay;
    union {
        int xab$q_edt [2];      /* expiration date & time                     */
        struct {
            unsigned long int xab$l_edt0;
            long int xab$l_edt4;
            } xab$r_edt_fields;
        } xab$r_edt_overlay;
    union {
        int xab$q_bdt [2];      /* backup date and time                       */
        struct {
            unsigned long int xab$l_bdt0;
            long int xab$l_bdt4;
            } xab$r_bdt_fields;
        } xab$r_bdt_overlay;
} ;
 
/*** MODULE $XABRDTDEF ***/
/*--                                                                          */
/*++                                                                          */
/*                                                                            */
/*        revision date/time xab definitions                                  */
/*                $xabrdtdef                                                  */
#define XAB$C_RDT 30    /* xabrdt id code                                     */
#define XAB$K_RDTLEN 20 /* length of rdt xab                                  */
#define XAB$C_RDTLEN 20 /* length of rdt xab                                  */
struct xabrdtdef {
    char xabrdtdef$$_fill_1;
    char xabrdtdef$$_fill_2;
    short int xabrdtdef$$_fill_3;
    long int xabrdtdef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    short int xabrdtdef$$_fill_5;       /*REVISION !,DEFINED IN $XABDEF,SINCE COMMON TO DAT & RDT     */
    short int xabrdtdef$$_fill_6;       /* spare                              */
    int xabrdtdef$$_fill_7 [2]; /* revision date & time,defined in $xabdef    */
} ;
 
/*** MODULE $XABPRODEF ***/
/*--                                                                          */
/*++                                                                          */
/*                                                                            */
/*        protection xab field definitions                                    */
/*                $xabprodef                                                  */
/*                                                                            */
/*                                                                            */
#define XAB$C_PRO 19    /* xabpro id code                                     */
#define XAB$M_NOREAD 0x00000001
#define XAB$M_NOWRITE 0x00000002
#define XAB$M_NOEXE 0x00000004
#define XAB$M_NODEL 0x00000008
union xabprodef {
    struct {
        unsigned xab$v_noread : 1;      /* deny read access                   */
        unsigned xab$v_nowrite : 1;     /* deny write access                  */
        unsigned xab$v_noexe : 1;       /* deny execution access              */
        unsigned xab$v_nodel : 1;       /* deny delete access                 */
        unsigned xab$v_fill_12 : 4;
        } xab$r_xabprodef_bits;
} ;
#define XAB$M_PROPAGATE 0x00000001
#define XAB$K_PROLEN_V3 16      /* V3a xabpro length                          */
#define XAB$C_PROLEN_V3 16      /* V3a xabpro length                          */
#define XAB$K_PROLEN 88 /* xabpro length                                      */
#define XAB$C_PROLEN 88 /* xabpro length                                      */
struct xabprodef1 {
    char xabprodef$$_fill_1;
    char xabprodef$$_fill_2;
    short int xabprodef$$_fill_3;
    long int xabprodef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    union {
        unsigned short int xab$w_pro;   /* protection mask                    */
        struct {
            unsigned xab$v_sys : 4;     /* system                             */
            unsigned xab$v_own : 4;     /* owner                              */
            unsigned xab$v_grp : 4;     /* group                              */
            unsigned xab$v_wld : 4;     /* world                              */
            } xab$r_pro_bits;
        } xab$r_pro_overlay;
    unsigned char xab$b_mtacc;  /* Magtape access control char.               */
    union {
        unsigned char xab$b_prot_opt;   /* XABPRO options field               */
        struct {
            unsigned xab$v_propagate : 1;       /* Propagate security attributes on $ENTER and $RENAME*/
            unsigned xab$v_fill_13 : 7;
            } xab$r_prot_opt_fields;
        } xab$r_prot_opt_overlay;
    union {
        unsigned long int xab$l_uic;    /* uic code                           */
        struct {
            unsigned short int xab$w_mbm;       /* member code                */
            unsigned short int xab$w_grp;       /* group code                 */
            } xab$r_uic_fields;
        } xab$r_uic_overlay;
    union {     /* RWED/mode protection for file                              */
        int xab$q_prot_mode [2];        /* eventually may be a quadword       */
        struct {
            unsigned char xab$b_prot_mode;      /* but currently only a byte  */
            } xab$r_prot_mode_fields;
        } xab$r_prot_mode_overlay;
    unsigned long int xab$l_aclbuf;     /* address of user's ACL buffer       */
    unsigned short int xab$w_aclsiz;    /* size of user's ACL buffer          */
    unsigned short int xab$w_acllen;    /* return length of entire ACL        */
    unsigned long int xab$l_aclctx;     /* ACL context field                  */
    unsigned long int xab$l_aclsts;     /* ACL return err status              */
    long int xabprodef$$_fill_10;       /* spare                              */
    long int xabprodef$$_fill_11;       /* spare                              */
    long int xabprodef$$_fill_12;       /* spare                              */
    long int xabprodef$$_fill_13;       /* spare                              */
    long int xabprodef$$_fill_14;       /* spare                              */
    long int xabprodef$$_fill_15;       /* spare                              */
    long int xabprodef$$_fill_16;       /* spare                              */
    long int xabprodef$$_fill_17;       /* spare                              */
    long int xabprodef$$_fill_18;       /* spare                              */
    long int xabprodef$$_fill_19;       /* spare                              */
    long int xabprodef$$_fill_20;       /* spare                              */
    long int xabprodef$$_fill_21;       /* spare                              */
} ;
 
/*** MODULE $XABTRMDEF ***/
/*--                                                                          */
/*++                                                                          */
/*                                                                            */
/*        terminal control xab field definitions                              */
/*                $xabtrmdef                                                  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
#define XAB$C_TRM 31    /*XABTRM ID CODE                                      */
#define XAB$K_TRMLEN 36 /* length of xab of type terminal control             */
#define XAB$C_TRMLEN 36 /* length of xab of type terminal control             */
struct xabtrmdef {
    char xabtrmdef$$_fill_1;
    char xabtrmdef$$_fill_2;
    short int xabtrmdef$$_fill_3;
    long int xabtrmdef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    unsigned long int xab$l_itmlst;     /* item list address                  */
    unsigned short int xab$w_itmlst_len;        /* item list length           */
    short int xabtrmdef$$_fill_5;       /* spare                              */
    long int xabtrmdef$$_fill_6;        /* spare                              */
    long int xabtrmdef$$_fill_7;        /* spare                              */
    long int xabtrmdef$$_fill_8;        /* spare                              */
    long int xabtrmdef$$_fill_9;        /* spare                              */
    long int xabtrmdef$$_fill_10;       /* spare                              */
} ;
 
/*** MODULE $XABSUMDEF ***/
/*--                                                                          */
/*++                                                                          */
/*                                                                            */
/*        summary xab field definitions                                       */
/*                $xabsumdef                                                  */
/*                                                                            */
/*                                                                            */
#define XAB$C_SUM 22    /* xabsum id code                                     */
#define XAB$K_SUMLEN 12 /* xabsum length                                      */
#define XAB$C_SUMLEN 12 /* xabsum length                                      */
struct xabsumdef {
    char xabsumdef$$_fill_1;
    char xabsumdef$$_fill_2;
    short int xabsumdef$$_fill_3;
    long int xabsumdef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    unsigned char xab$b_noa;    /* number of defined areas for index file     */
    unsigned char xab$b_nok;    /* number of defined keys for index file      */
    unsigned short int xab$w_pvn;       /* prologue version number (relative and index files) */
} ;
 
/*** MODULE $XABKEYDEF ***/
/*--                                                                          */
/*++                                                                          */
/*                                                                            */
/*        key definition xab field definitions                                */
/*                $xabkeydef                                                  */
/*                                                                            */
/*                                                                            */
#define XAB$C_KEY 21    /* xabkey id code                                     */
#define XAB$M_DUP 0x00000001
#define XAB$M_CHG 0x00000002
#define XAB$M_NUL 0x00000004
#define XAB$M_IDX_NCMPR 0x00000008
#define XAB$M_KEY_NCMPR 0x00000040
#define XAB$M_DAT_NCMPR 0x00000080
#define XAB$C_STG 0     /* string                                             */
#define XAB$C_IN2 1     /* signed 15 bit integer (2 bytes)                    */
#define XAB$C_BN2 2     /* 2 byte binary                                      */
#define XAB$C_IN4 3     /* signed 31 bit integer (4 bytes)                    */
#define XAB$C_BN4 4     /* 4 byte binary                                      */
#define XAB$C_PAC 5     /* packed decimal (1-16 bytes)                        */
#define XAB$C_IN8 6     /* signed 63 bit integer (4 bytes)                    */
#define XAB$C_BN8 7     /* 8 byte binary                                      */
#define XAB$C_COL 8     /* collated                                           */
#define XAB$C_MAX_ASCEND 8      /* maximum ascending type                     */
#define XAB$C_DSTG 32   /* descending string                                  */
#define XAB$C_DIN2 33   /*     "      signed word                             */
#define XAB$C_DBN2 34   /*     "      unsigned word                           */
#define XAB$C_DIN4 35   /*     "      signed longword                         */
#define XAB$C_DBN4 36   /*     "      unsigned longword                       */
#define XAB$C_DPAC 37   /*     "      packed decimal                          */
#define XAB$C_DIN8 38   /*     "      signed quadword                         */
#define XAB$C_DBN8 39   /*     "      unsigned quadword                       */
#define XAB$C_DCOL 40   /*     "      collated                                */
#define XAB$C_MAXDTP 40 /* max. legal data type                               */
#define XAB$K_KEYLEN_V2 64      /* old xabkey length                          */
#define XAB$C_KEYLEN_V2 64      /* old xabkey length                          */
/*                                                                            */
#define XAB$C_PRG3 3    /* Prologue version three                             */
#define XAB$C_PRG2 2    /* Prologue version two                               */
#define XAB$C_PRG1 1    /* Prologue versoin one                               */
#define XAB$K_KEYLEN_V4 76      /* xabkey length until V5                     */
#define XAB$C_KEYLEN_V4 76      /* xabkey length until V5                     */
#define XAB$K_KEYLEN 100        /* xabkey length for V5                       */
#define XAB$C_KEYLEN 100        /* xabkey length for V5                       */
/*--                                                                          */
struct xabkeydef {
    char xabkeydef$$_fill_1;
    char xabkeydef$$_fill_2;
    short int xabkeydef$$_fill_3;
    long int xabkeydef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
/*                                                                            */
/* the field layout of the key xab is such that it matchs as                  */
/* closely as possible the layout of a key decriptor in the                   */
/* index file prologue. this is so the contents may be moved                  */
/* between the two structures as efficiently as possible.                     */
/*                                                                            */
    unsigned char xab$b_ian;    /* index level area number                    */
    unsigned char xab$b_lan;    /* lowest index level area number             */
    unsigned char xab$b_dan;    /* data level area number                     */
    unsigned char xab$b_lvl;    /* level of root bucket                       */
    unsigned char xab$b_ibs;    /* size of index buckets in virtual blocks    */
    unsigned char xab$b_dbs;    /* size of data buckets in virtual blocks     */
    unsigned long int xab$l_rvb;        /* root bucket start vbn              */
    union {
        unsigned char xab$b_flg;        /* key option flags                   */
        struct {
            unsigned xab$v_dup : 1;     /* duplicate key values allowed       */
            unsigned xab$v_chg : 1;     /* alt key only --key field may change on update      */
            unsigned xab$v_nul : 1;     /* alt key only --null key value enable       */
            unsigned xab$v_idx_ncmpr : 1;       /* indicate index records for given key are not compressed    */
            unsigned xabkeydef$$_fill_5 : 2;    /* spare                      */
            unsigned xab$v_key_ncmpr : 1;       /* indicates key is not compressed in data record     */
            unsigned xab$v_fill_14 : 1;
            } xab$r_flg_bits0;
        struct {
            unsigned xabkeydef$$_fill_6 : 1;    /* space over dup             */
            unsigned xabkeydef$$_fill_7 : 2;    /* spare                      */
            unsigned xabkeydef$$_fill_8 : 1;    /* space over idx_ncmpr       */
            unsigned xabkeydef$$_fill_9 : 2;    /* spare                      */
            unsigned xabkeydef$$_fill_10 : 1;   /* space over key_ncmpr       */
            unsigned xab$v_dat_ncmpr : 1;       /* data record is not compressed      */
            } xab$r_flg_bits1;
        } xab$r_flg_overlay;
    unsigned char xab$b_dtp;    /* key field data type                        */
    unsigned char xab$b_nsg;    /* number of key segments                     */
    unsigned char xab$b_nul;    /* nul key character                          */
    unsigned char xab$b_tks;    /* total key field size (bytes)               */
    unsigned char xab$b_ref;    /* key of reference (0=prim key,              */
/* 1-254 = alternate keys)                                                    */
    unsigned short int xab$w_mrl;       /* minimun record length to contain key field */
    unsigned short int xab$w_ifl;       /* index bucket fill size (bytes)     */
    unsigned short int xab$w_dfl;       /* data bucket fil size (bytes)       */
    union {
        unsigned short int xab$w_pos [8];       /* key field record offset positions  */
        struct {
            unsigned short int xab$w_pos0;      /* segment 0                  */
            unsigned short int xab$w_pos1;      /* segment 1                  */
            unsigned short int xab$w_pos2;      /* segment 2                  */
            unsigned short int xab$w_pos3;      /* segment 3                  */
            unsigned short int xab$w_pos4;      /* segment 4                  */
            unsigned short int xab$w_pos5;      /* segment 5                  */
            unsigned short int xab$w_pos6;      /* segment 6                  */
            unsigned short int xab$w_pos7;      /* segment 7                  */
            } xab$r_pos_fields;
        } xab$r_pos_overlay;
    union {
        unsigned char xab$b_siz [8];    /* key field segment sizes            */
        struct {
            unsigned char xab$b_siz0;   /* segment 0                          */
            unsigned char xab$b_siz1;   /* segment 1                          */
            unsigned char xab$b_siz2;   /* segment 2                          */
            unsigned char xab$b_siz3;   /* segment 3                          */
            unsigned char xab$b_siz4;   /* segment 4                          */
            unsigned char xab$b_siz5;   /* segment 5                          */
            unsigned char xab$b_siz6;   /* segment 6                          */
            unsigned char xab$b_siz7;   /* segment 7                          */
            } xab$r_siz_fields;
        } xab$r_siz_overlay;
    short int xabkeydef$$_fill_11;      /* spare                              */
/*                                                                            */
/* the positions of the above fields are dictated by the key descriptor       */
/* record layout in the index file prologue.                                  */
/*                                                                            */
    unsigned long int xab$l_knm;        /* pointer to 32 character key name buffer    */
    unsigned long int xab$l_dvb;        /* first data bucket start vbn        */
/* Additions for prologue 3 files                                             */
/*                                                                            */
    union {
        unsigned char xab$b_typ [8];    /* key field segment types            */
        struct {
            unsigned char xab$b_typ0;   /* segment 0                          */
            unsigned char xab$b_typ1;   /* segment 1                          */
            unsigned char xab$b_typ2;   /* segment 2                          */
            unsigned char xab$b_typ3;   /* segment 3                          */
            unsigned char xab$b_typ4;   /* segment 4                          */
            unsigned char xab$b_typ5;   /* segment 5                          */
            unsigned char xab$b_typ6;   /* segment 6                          */
            unsigned char xab$b_typ7;   /* segment 7                          */
            } xab$r_typ_fields;
        } xab$r_typ_overlay;
    unsigned char xab$b_prolog; /* indicate prologue version desired (primary key only)       */
    char xabkeydef$$_fill_12;   /* spare                                      */
    short int xabkeydef$$_fill_13;      /* spare                              */
    unsigned long int xab$l_coltbl;     /* address of collate table           */
    unsigned long int xab$l_colsiz;     /* size of collate table              */
    unsigned long int xab$l_colnam;     /* name of collate table              */
    long int xabkeydef$$_fill_14;       /* spare                              */
    long int xabkeydef$$_fill_15;       /* spare                              */
    long int xabkeydef$$_fill_16;       /* spare                              */
/*++                                                                          */
} ;
 
/*** MODULE $XABCXFDEF ***/
/*                                                                            */
/*        RMS Context XAB associated with the FAB                             */
/*                $xabcxfdef                                                  */
/*                                                                            */
/*                                                                            */
#define XAB$C_CXF 32    /* XABCXF id code                                     */
#define XAB$M_CXFRST 0x00000001
#define XAB$K_CXFLEN 60 /* length of xab type CXF                             */
#define XAB$C_CXFLEN 60 /* length of xab type CXF                             */
struct xabcxfdef {
    char xabcxfdef$$_fill_1;    /* COD - xab id code                          */
    char xabcxfdef$$_fill_2;    /* BLN - block length                         */
    short int xabcxfdef$$_fill_3;       /* (spare)                            */
    long int xabcxfdef$$_fill_4;        /* NXT - xab chain link               */
/* UP TILL NOW COMMON AMONG ALL XABS                                          */
/*                                                                            */
/*        Following in common with the CXR block, too.                        */
/*        Do not rearrange without changing both.                             */
/*                                                                            */
    unsigned long int xab$l_cxfsts;     /* Status of the last file operation. */
    unsigned long int xab$l_cxfstv;     /* Status Value of the last file operation.   */
/*                                                                            */
/* Top four bits of the options longword are reserved for the XABCXR.  These  */
/* bits describe the version of the key buffer.                               */
/*                                                                            */
    union {
        unsigned long int xab$l_cxfcop; /* Context Options.                   */
        struct {
            unsigned xab$v_cxfrst : 1;  /* Restore file state - use context blk as input.     */
            unsigned xab$v_fill_15 : 7;
            } xab$r_cxfcop_bits;
        } xab$r_cxfcop_overlay;
    unsigned long int xab$l_cxfbkp;     /* Bookkeeping bits                   */
    unsigned short int xab$w_cxfifi;    /* Internal File Identifier           */
    unsigned char xab$b_cxfver; /* prologue version num                       */
    char xabcxfdef$$_fill_5;    /* spare to longword align commonality        */
    long int xabcxfdef$$_fill_6;        /* spare                              */
/*                                                                            */
/*        Up Till now in common with XABCXR, too.                             */
/*                                                                            */
/*        The following fields correspond to those in the FAB or IFB          */
/*        They should not be rearranged as their order is assumed for         */
/*        purposes of moving large chunks of data rather than a byte          */
/*        or word at a time.  Note: ASSUME is used in the actual code         */
/*                                                                            */
    unsigned short int xab$w_cxfdeq;    /* Default extention quantity         */
    unsigned char xab$b_cxffac; /* File access                                */
    unsigned char xab$b_cxfshr; /* File Sharing                               */
    unsigned short int xab$w_cxfrte;    /* (Not used)                         */
    char xabcxfdef$$_fill_7;    /* spare                                      */
    unsigned char xab$b_cxforg; /* file organization                          */
    unsigned short int xab$w_cxfgbc;    /* global buffer count                */
    unsigned char xab$b_cxfrtv; /* retrieval window                           */
    char xabcxfdef$$_fill_8;
    long int xabcxfdef$$_fill_9 [4];    /* spares                             */
} ;
 
/*** MODULE $XABCXRDEF ***/
/*                                                                            */
/*        RMS Context XAB associated with the RAB                             */
/*                $xabcxrdef                                                  */
/*                                                                            */
/*                                                                            */
#define XAB$C_CXR 33    /* XABCXR id code                                     */
#define XAB$M_CXRRST 0x00000001
#define XAB$C_CXB_VER1 1
#define XAB$C_CXRBLEN 512       /* Length of CXRBUF (bytes)                   */
#define XAB$K_CXRLEN 84 /* Length of XAB type CXR                             */
#define XAB$C_CXRLEN 84 /* Length of XAB type CXR                             */
struct xabcxrdef {
    char xabcxrdef$$_fill_1;    /* COD - xab id code                          */
    char xabcxrdef$$_fill_2;    /* BLN - block length                         */
    short int xabcxrdef$$_fill_3;       /* (spare)                            */
    long int xabcxrdef$$_fill_4;        /* NXT - xab chain link               */
/* UP TILL NOW COMMON AMONG ALL XABS                                          */
/*                                                                            */
/*        Following in common with the CXF block, too.                        */
/*        Do not rearrange without changing it.                               */
/*                                                                            */
    unsigned long int xab$l_cxrsts;     /* Status of the last record operation.       */
    unsigned long int xab$l_cxrstv;     /* Status Value of the last record operation. */
    union {
        unsigned long int xab$l_cxrcop; /* Context Options.                   */
        struct {
            unsigned xab$v_cxrrst : 1;  /* Restore file/record state - use context blk as input.      */
            unsigned xabcxrdef$$_fill_5 : 27;
            unsigned xab$v_cxrbver : 4; /* Version of Key buffer              */
            } xab$r_cxrcop_bits;
        } xab$r_cxrcop_overlay;
    unsigned long int xab$l_cxrbkp;     /* Bookkeeping bits                   */
    unsigned short int xab$w_cxrisi;    /* Internal Record Identifier         */
    unsigned char xab$b_cxrver; /* prologue version num.                      */
    char xabcxrdef$$_fill_6;    /* spare to longword align commonality        */
    long int xabcxrdef$$_fill_7;        /* spare                              */
/*                                                                            */
/*        Up Till now in common with XABCXF, too.                             */
/*                                                                            */
/*                                                                            */
/*        The following elements are arranged such that large amounts of      */
/*        data can be moved at a time rather than words or bytes.  Do not     */
/*        rearrange them without this consideration in mind.                  */
/*                                                                            */
/*        The following elements are stream dependent regardless of file org. */
/*                                                                            */
    unsigned char xab$b_cxrmbf; /* Multibuffer count                          */
    unsigned char xab$b_cxrmbc; /* Multiblock count                           */
    unsigned short int xab$w_cxrbfz;    /* sz in byte of CXRBUF               */
/*                                                                            */
/*      The following elements are necessary for saving the NRP context for   */
/*      Sequential and Relative files.                                        */
/*                                                                            */
    unsigned long int xab$l_cxrvbn;     /* NRP VBN                            */
    unsigned short int xab$w_cxroff;    /* NRP offset in VBN                  */
    unsigned short int xab$w_fill_8;    /* mbz - longword align               */
/*                                                                            */
/*      The following elements are necessary for saving the NRP context for   */
/*      ISAM files.                                                           */
/*                                                                            */
    unsigned long int xab$l_cxrpos0;    /* Primary Positioning RFA            */
    unsigned short int xab$w_cxrpos4;
    short int xabcxrdef$$_fill_9;       /* Spare MBZ                          */
    unsigned long int xab$l_cxrcur0;    /* Current Positioning RFA            */
    unsigned short int xab$w_cxrcur4;
    short int xabcxrdef$$_fill_10;      /* Spare MBZ                          */
    unsigned long int xab$l_cxrsid0;    /* SIDR positioning RFA               */
    unsigned short int xab$w_cxrsid4;
    short int xabcxrdef$$_fill_11;      /* Spare MBZ                          */
    unsigned short int xab$w_cxrcnt;    /* SIDR array count                   */
    unsigned char xab$b_cxrkref;        /* Cur Key of Reference               */
    unsigned char xab$b_cxrklen;        /* Length of key                      */
    unsigned long int xab$l_cxrbuf;     /* address of key buf                 */
    long int xabcxrdef$$_fill_12 [2];   /* Spares                             */
} ;
 
/*** MODULE $XABJNLDEF ***/
/*++                                                                          */
/*                                                                            */
/*        Journal XAB definitions                                             */
/*                $xabjnldef                                                  */
/*                                                                            */
/*                                                                            */
#define XAB$C_JNL 34    /* xabjnl id code                                     */
#define XAB$C_JNL_TYPE_NONE 0
#define XAB$C_AI 1      /* AI journal                                         */
#define XAB$C_BI 2      /* BI journal                                         */
#define XAB$C_AT 3      /* AT journal                                         */
#define XAB$C_RU_DEFAULT 4      /* default RU volume                          */
#define XAB$M_JOURNAL_DISABLED 0x00000001
#define XAB$M_BACKUP_DONE 0x00000002
#define XAB$K_JNLLEN 80
#define XAB$C_JNLLEN 80
struct xabjnldef {
    char xabjnldef$$_fill_1;
    char xabjnldef$$_fill_2;
    short int xabjnldef$$_fill_3;
    long int xabjnldef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    unsigned char xab$b_xabjnl_type;    /* type of $XABJNL                    */
    char xabjnldef$$_fill_5;
    union {
        unsigned short int xab$w_jnl_flags;     /* journal flags (from ACE$W_RMSJNL_FLAGS)    */
        struct {
            unsigned xab$v_journal_disabled : 1;        /* journaling disabled by BACKUP (AI/BI/AT)   */
            unsigned xab$v_backup_done : 1;     /* Backup done since last $OPEN       */
            unsigned xab$v_fill_16 : 6;
            } xab$r_jnl_flags_bits;
        } xab$r_jnl_flags_overlay;
    unsigned long int xab$l_jnl_fab;    /* address of journal file FAB        */
    unsigned long int xab$l_volnam_buf; /* address of journal volume name buffer      */
    unsigned short int xab$w_volnam_siz;        /* size of journal volume name buffer */
    unsigned short int xab$w_volnam_len;        /* return length of journal volume name       */
    unsigned int xab$q_jnl_verify_cdate [2];    /* journal file creation date (from ACE$Q_CDATE)      */
/* (to match with journal file's creation date)                               */
    unsigned long int xab$l_jnlidx;     /* Journal stream index within journal file   */
    unsigned long int xab$l_backup_seqno;       /* Backup sequence number.    */
    unsigned int xab$q_jnl_mod_time [2];        /* Timestamp of last backup or last journal   */
/* entry recovered.                                                           */
    long int xabjnldef$$_fill_7;
    long int xabjnldef$$_fill_8;
    long int xabjnldef$$_fill_9;
    long int xabjnldef$$_fill_10;
    long int xabjnldef$$_fill_11;
    long int xabjnldef$$_fill_12;
    long int xabjnldef$$_fill_13;
    long int xabjnldef$$_fill_14;
} ;
 
/*** MODULE $XABITMDEF ***/
/*++                                                                          */
/*                                                                            */
/*        Item XAB definitions                                                */
/*                                                                            */
/*                                                                            */
#define XAB$C_ITM 36    /* xabitm id code                                     */
/* The following set of flags exactly mimic the FCHDEF flags defined in STARLET.      */
/* They are here to provide an unsupported interface to the UCHAR longword maintained */
/* by the file system.                                                        */
/*                                                                            */
#define XAB$M_WASCONTIG 0x00000001
#define XAB$M_NOBACKUP 0x00000002
#define XAB$M_WRITEBACK 0x00000004
#define XAB$M_READCHECK 0x00000008
#define XAB$M_WRITCHECK 0x00000010
#define XAB$M_CONTIGB 0x00000020
#define XAB$M_LOCKED 0x00000040
#define XAB$M_CONTIG 0x00000080
#define XAB$M_RESERVED1 0x00000100
#define XAB$M_RESERVED2 0x00000200
#define XAB$M_RESERVED3 0x00000400
#define XAB$M_BADACL 0x00000800
#define XAB$M_SPOOL 0x00001000
#define XAB$M_DIRECTORY 0x00002000
#define XAB$M_BADBLOCK 0x00004000
#define XAB$M_MARKDEL 0x00008000
#define XAB$M_NOCHARGE 0x00010000
#define XAB$M_ERASE 0x00020000
struct uchar_flags {    /* mimics $FCHDEF                                     */
    unsigned xab$v_wascontig : 1;
    unsigned xab$v_nobackup : 1;
    unsigned xab$v_writeback : 1;
    unsigned xab$v_readcheck : 1;
    unsigned xab$v_writcheck : 1;
    unsigned xab$v_contigb : 1;
    unsigned xab$v_locked : 1;
    unsigned xab$v_contig : 1;
    unsigned xab$v_reserved1 : 1;
    unsigned xab$v_reserved2 : 1;
    unsigned xab$v_reserved3 : 1;
    unsigned xab$v_badacl : 1;
    unsigned xab$v_spool : 1;
    unsigned xab$v_directory : 1;
    unsigned xab$v_badblock : 1;
    unsigned xab$v_markdel : 1;
    unsigned xab$v_nocharge : 1;
    unsigned xab$v_erase : 1;
    unsigned xab$v_fill_17 : 6;
} ;
#define XAB$_NET_BUFFER_SIZE 1  /* (sense)      negociated buffer size        */
#define XAB$_NET_BLOCK_COUNT 2  /* (set,sense)  requested block count         */
#define XAB$_NET_REMOTE_SYSTEM 3        /* (sense)      remote system type    */
#define XAB$_NET_REMOTE_FILE_SYSTEM 4   /* (sense)      remote file system type       */
#define XAB$_NET_EXTPROT 5      /* (set,sense)  actual extended protection    */
#define XAB$_NET_SYSCAP_LOCAL 6 /* (sense)      DAP SYSCAP of local system    */
#define XAB$_NET_SYSCAP_REMOTE 7        /* (sense)      DAP SYSCAP of remote system   */
#define XAB$_NET_DAPVER_LOCAL 8 /* (sense)      DAP version - local system    */
#define XAB$_NET_DAPVER_REMOTE 9        /* (sense)      DAP version - remote system   */
#define XAB$_NET_LINK_TIMEOUT 10        /* (set,sense)  logical link timeout (seconds)        */
#define XAB$_NET_DATA_CRC_ENABLE 11     /* (set,sense)  DAP level CRC         */
#define XAB$_NET_LINK_CACHE_ENABLE 12   /* (set,sense)  Logical link cache enable     */
/*      ,NET_DATA_COMPRESSION   /* (set,sense)  do data compression (FUTURE)  */
#define XAB$K_NET_MIN 1
#define XAB$K_NET_MAX 12
#define XAB$_STAT_ENABLE 64     /* (set,sense)  Read statistics enable        */
#define XAB$K_STAT_MIN 64
#define XAB$K_STAT_MAX 64
#define XAB$_UCHAR 128  /* (sense)      Read file characteristics (obsolete)  */
#define XAB$_UCHAR_WASCONTIG 129        /* (sense)      FCH$V_WASCONTIG       */
#define XAB$_UCHAR_NOBACKUP 130 /* (set,sense)  FCH$V_NOBACKUP                */
#define XAB$_UCHAR_WRITEBACK 131        /* (sense)      FCH$V_WRITEBACK       */
#define XAB$_UCHAR_READCHECK 132        /* (set,sense)  FCH$V_READCHECK       */
#define XAB$_UCHAR_WRITECHECK 133       /* (set,sense)  FCH$V_WRITECHECK      */
#define XAB$_UCHAR_CONTIGB 134  /* (set,sense)  FCH$V_CONTIGB                 */
#define XAB$_UCHAR_LOCKED 135   /* (set,sense)  FCH$V_LOCKED                  */
#define XAB$_UCHAR_CONTIG 136   /* (sense)      FCH$V_CONTIG                  */
#define XAB$_UCHAR_BADACL 137   /* (sense)      FCH$V_BADACL                  */
#define XAB$_UCHAR_SPOOL 138    /* (sense)      FCH$V_SPOOL                   */
#define XAB$_UCHAR_DIRECTORY 139        /* (sense)      FCH$V_DIRECTORY       */
#define XAB$_UCHAR_BADBLOCK 140 /* (sense)      FCH$V_BADBLOCK                */
#define XAB$_UCHAR_MARKDEL 141  /* (sense)      FCH$V_BADBLOCK                */
#define XAB$_UCHAR_NOCHARGE 142 /* (sense)      FCH$V_NOCHARGE                */
#define XAB$_UCHAR_ERASE 143    /* (set,sense)  FCH$V_ERASE                   */
#define XAB$K_UCHAR_MIN 128
#define XAB$K_UCHAR_MAX 143
#define XAB$_STORED_SEMANTICS 192       /* (set,sense)  Stored semantics of the file  */
#define XAB$_ACCESS_SEMANTICS 193       /* (set,sense)  Access semantics of the file  */
#define XAB$_RMS_EXTENSION 194  /* (set,sense)  Required RMS processing extension     */
#define XAB$K_XLATE_MIN 192
#define XAB$K_XLATE_MAX 194
#define XAB$C_SEMANTICS_MAX_LEN 64      /* max length for stored or access semantics  */
#define XAB$K_SEMANTICS_MAX_LEN 64      /* max length for stored or access semantics  */
#define XAB$_MULTIBUFFER_COUNT 256      /* (set-only)  Multibuffer count (not limited to 127) */
/*  legal only on $CONNECT                                                    */
#define XAB$K_MISC_MIN 256
#define XAB$K_MISC_MAX 256
#define XAB$K_SENSEMODE 1
#define XAB$K_SETMODE 2
#define XAB$K_ITMLEN 32
#define XAB$C_ITMLEN 32
struct xabitmdef {
    char xabitmdef$$_fill_1;
    char xabitmdef$$_fill_2;
    short int xabitmdef$$_fill_3;
    long int xabitmdef$$_fill_4;        /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    unsigned long int xab$l_itemlist;   /* Address of the item list           */
/* In the user interface, item codes are arbitrary integer values, so         */
/* we may as well allow logical groups to have contiguous codes, with         */
/* room for expansion (to allow table driven code).                           */
    unsigned char xab$b_mode;   /* must be either SETMODE or SENSEMODE        */
    char xab$b_itm_fill1 [3];   /* Reserved space for future definition       */
    long int xab$l_itm_fill2 [4];       /* Reserved space for future definition       */
} ;
#define XAB$K_DISABLE 0
#define XAB$K_ENABLE 1
#define XAB$K_RT11 1
#define XAB$K_RSTS 2
#define XAB$K_RSX11S 3
#define XAB$K_RSX11M 4
#define XAB$K_RSX11D 5
#define XAB$K_IAS 6
#define XAB$K_VAXVMS 7
#define XAB$K_TOPS20 8
#define XAB$K_TOPS10 9
#define XAB$K_RTS8 10
#define XAB$K_OS8 11
#define XAB$K_RSX11MP 12
#define XAB$K_COPOS11 13
#define XAB$K_P_OS 14
#define XAB$K_VAXELN 15
#define XAB$K_CPM 16
#define XAB$K_MS_DOS 17
#define XAB$K_ULTRIX_32 18
#define XAB$K_ULTRIX_11 19
#define XAB$K_RMS11 1
#define XAB$K_RMS20 2
#define XAB$K_RMS32 3
#define XAB$K_FCS11 4
#define XAB$K_RT11FS 5
#define XAB$K_NO_FS 6
#define XAB$K_TOPS20FS 7
#define XAB$K_TOPS10FS 8
#define XAB$K_OS8FS 9
#define XAB$K_RMS32S 10
#define XAB$K_CPMFS 11
#define XAB$K_MS_DOSFS 12
#define XAB$K_ULTRIX32_FS 13
#define XAB$K_ULTRIX11_FS 14
#define XAB$M_NET_NOREAD 0x00000001
#define XAB$M_NET_NOWRITE 0x00000002
#define XAB$M_NET_NOEXECUTE 0x00000004
#define XAB$M_NET_NODELETE 0x00000008
#define XAB$M_NET_NOAPPEND 0x00000010
#define XAB$M_NET_NODIRECTORY 0x00000020
#define XAB$M_NET_NOUPDATE 0x00000040
#define XAB$M_NET_NOCHANGE 0x00000080
#define XAB$M_NET_NOEXTEND 0x00000100
struct xabnetextprot {
    union {
        unsigned short int xab$w_system_acc;
        struct {
            unsigned xab$v_net_noread : 1;
            unsigned xab$v_net_nowrite : 1;
            unsigned xab$v_net_noexecute : 1;
            unsigned xab$v_net_nodelete : 1;
            unsigned xab$v_net_noappend : 1;
            unsigned xab$v_net_nodirectory : 1;
            unsigned xab$v_net_noupdate : 1;
            unsigned xab$v_net_nochange : 1;
            unsigned xab$v_net_noextend : 1;
            unsigned xab$v_fill_20 : 7;
            } xab$r_fill_19;
        } xab$r_fill_18;
    unsigned short int xab$w_owner_acc;
    unsigned short int xab$w_group_acc;
    unsigned short int xab$w_world_acc;
} ;
struct xabnetdapver {
    unsigned char xab$b_ver_dap;
    unsigned char xab$b_ver_eco;
    unsigned char xab$b_ver_cus;
    unsigned char xab$b_ver_dsv;
    unsigned char xab$b_ver_csv;
} ;
struct xabnetcapdef {
    unsigned xab$v_cap_filall : 1;
    unsigned xab$v_cap_seqorg : 1;
    unsigned xab$v_cap_relorg : 1;
    unsigned xab$v_cap_fill_21 : 1;
    unsigned xab$v_cap_extend : 1;
    unsigned xab$v_cap_seqfil : 1;
    unsigned xab$v_cap_ranrrn : 1;
    unsigned xab$v_cap_ranvbn : 1;
    unsigned xab$v_cap_rankey : 1;
    unsigned xab$v_cap_fill_22 : 1;
    unsigned xab$v_cap_ranrfa : 1;
    unsigned xab$v_cap_idxorg : 1;
    unsigned xab$v_cap_swmode : 1;
    unsigned xab$v_cap_append : 1;
    unsigned xab$v_cap_submit : 1;
    unsigned xab$v_cap_fill_23 : 1;
    unsigned xab$v_cap_mds : 1;
    unsigned xab$v_cap_display : 1;
    unsigned xab$v_cap_msgblk : 1;
    unsigned xab$v_cap_unrblk : 1;
    unsigned xab$v_cap_bigblk : 1;
    unsigned xab$v_cap_dapcrc : 1;
    unsigned xab$v_cap_keyxab : 1;
    unsigned xab$v_cap_allxab : 1;
    unsigned xab$v_cap_sumxab : 1;
    unsigned xab$v_cap_directory : 1;
    unsigned xab$v_cap_timxab : 1;
    unsigned xab$v_cap_proxab : 1;
    unsigned xab$v_cap_fill_24 : 1;
    unsigned xab$v_cap_fopspl : 1;
    unsigned xab$v_cap_fopscf : 1;
    unsigned xab$v_cap_fopdlt : 1;
    unsigned xab$v_cap_fill_26 : 1;
    unsigned xab$v_cap_seqrac : 1;
    unsigned xab$v_cap_fill_27 : 1;
    unsigned xab$v_cap_bitopt : 1;
    unsigned xab$v_cap_warning : 1;
    unsigned xab$v_cap_rename : 1;
    unsigned xab$v_cap_wildcard : 1;
    unsigned xab$v_cap_gngopt : 1;
    unsigned xab$v_cap_nammsg : 1;
    unsigned xab$v_cap_segmsg : 1;
    unsigned xab$v_cap_chgattcls : 1;
    unsigned xab$v_cap_chgtimcls : 1;
    unsigned xab$v_cap_chgprocls : 1;
    unsigned xab$v_cap_chgnamcls : 1;
    unsigned xab$v_cap_modattcre : 1;
    unsigned xab$v_cap_nam3part : 1;
    unsigned xab$v_cap_chgattren : 1;
    unsigned xab$v_cap_chgtimren : 1;
    unsigned xab$v_cap_chgproren : 1;
    unsigned xab$v_cap_ctlblkcnt : 1;
    unsigned xab$v_cap_octalver : 1;
    unsigned xab$v_fill_21 : 3;
} ;
#define XAB$S_BUFFER_SIZE 4
#define XAB$S_NETWORK_BLOCK_COUNT 4
#define XAB$S_REMOTE_SYSTEM 4
#define XAB$S_REMOTE_FILE_SYSTEM 4
#define XAB$S_EXTPROT_LOCAL 8
#define XAB$S_EXTPROT_REMOTE 8
#define XAB$S_CAPABIL_LOCAL 8
#define XAB$S_CAPABIL_REMOTE 8
#define XAB$S_DAPVER_LOCAL 5
#define XAB$S_DAPVER_REMOTE 5
#define XAB$S_CACHE_TMO 4
 
/*** MODULE $XABRUDEF ***/
/*++                                                                          */
/*                                                                            */
/*        Recovery Unit XAB definitions                                       */
/*                $xabrudef                                                   */
/*                                                                            */
/*                                                                            */
#define XAB$C_RU 35     /* xabru id code                                      */
#define XAB$M_NOJOIN 0x00000001
#define XAB$K_RULEN 48
#define XAB$C_RULEN 48
struct xabrudef {
    char xabrudef$$_fill_1;
    char xabrudef$$_fill_2;
    short int xabrudef$$_fill_3;
    long int xabrudef$$_fill_4; /*HAS SAME COD, BLN, SPARE AND NXT FIELD      */
/*THESE 4 FIELDS ARE COMMON TO ALL XABS AND                                   */
/*HAVE BEEN DEFINED BY $XABDEF                                                */
    union {
        unsigned short int xab$w_ru_flags;      /* Flags                      */
        struct {
            unsigned xab$v_nojoin : 1;  /* Do not join any recovery unit      */
            unsigned xab$v_fill_22 : 7;
            } xab$r_ru_flags_bits;
        } xab$r_ru_flags_overlay;
    short int xabrudef$$_fill_5;
    unsigned long int xab$l_ru_handle;  /* RU handle to join (input field)    */
    unsigned long int xab$l_ru_handle_joined;   /* RU handle joined (output field)    */
    long int xabrudef$$_fill_7;
    long int xabrudef$$_fill_8;
    long int xabrudef$$_fill_9;
    long int xabrudef$$_fill_10;
    long int xabrudef$$_fill_11;
    long int xabrudef$$_fill_12;
    long int xabrudef$$_fill_13;
} ;
 
/*** MODULE $FSCNDEF ***/
/*++                                                                          */
/*                                                                            */
/*        Descriptor codes for SYS$FILESCAN                                   */
/*                                                                            */
/*                                                                            */
#define FSCN$M_NODE 0x00000001
#define FSCN$M_DEVICE 0x00000002
#define FSCN$M_ROOT 0x00000004
#define FSCN$M_DIRECTORY 0x00000008
#define FSCN$M_NAME 0x00000010
#define FSCN$M_TYPE 0x00000020
#define FSCN$M_VERSION 0x00000040
struct fldflags {
    unsigned fscn$v_node : 1;   /* Node name present                          */
    unsigned fscn$v_device : 1; /* Device name present                        */
    unsigned fscn$v_root : 1;   /* Root directory present                     */
    unsigned fscn$v_directory : 1;      /* Directory present                  */
    unsigned fscn$v_name : 1;   /* File name present                          */
    unsigned fscn$v_type : 1;   /* File type present                          */
    unsigned fscn$v_version : 1;        /* File version present               */
    unsigned fscn$v_fill_23 : 1;
} ;
#define FSCN$_FILESPEC 1        /* complete filespec                          */
#define FSCN$_NODE 2    /* node:: field                                       */
#define FSCN$_DEVICE 3  /* device: field                                      */
#define FSCN$_ROOT 4    /* [root.] field                                      */
#define FSCN$_DIRECTORY 5       /* [directory] field                          */
#define FSCN$_NAME 6    /* name field                                         */
#define FSCN$_TYPE 7    /* .typ field                                         */
#define FSCN$_VERSION 8 /* ;version field                                     */
#define FSCN$S_ITEM_LEN 8
struct fscndef {
    unsigned short int fscn$w_length;   /* return length word                 */
    unsigned short int fscn$w_item_code;        /* item code value            */
    unsigned long int fscn$l_addr;      /* return length pointer              */
} ;
 
/*** MODULE $RMEDEF ***/
/*                                                                            */
/*                rms escape definitions                                      */
/*                                                                            */
/*  the following values identify various requests for non-standard rms       */
/*  functions.  they are currently input to the $modify function in the       */
/*  ctx field of the fab only if the esc bit is set in fop.  incorrect        */
/*  use of these capabilties could cause rms to fail, hence great caution     */
/*  should be exercised in their use.                                         */
/*                                                                            */
#define RME$C_SETRFM 1  /* change rfm, mrs, and fsz (if vfc) in ifab only     */
#define RME$C_PPFECHO 2 /* enable echo of SYS$INPUT to SYS$OUTPUT             */
#define RME$C_SETRCF 3  /* change recovery mode                               */
#define RME$C_KEEP_LOCK_ON 4    /* Turn on Keep Lock behavior                 */
#define RME$C_KEEP_LOCK_OFF 5   /* Turn off Keep Lock behavior                */
#endif
