/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:40:11 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARLET.SDI */
#ifndef STARLET_H
#define STARLET_H
 
/*** MODULE STARLET ***/
/*                                                                            */
/* SYSTEM SERVICE ENTRY POINT DESCRIPTIONS                                    */
/*                                                                            */
/*                                                                            */
/*  $ADD_HOLDER                                                               */
/*                                                                            */
/*    Add Holder Record To The Rights Database                                */
/*                                                                            */
/*      $ADD_HOLDER id, holder, [attrib]                                      */
/*                                                                            */
/*      id      = identifier longword to associate the                        */
/*        holder record with                                                  */
/*      holder  = address of the holder identifier quadword                   */
/*      attrib  = attributes longword to grant to the holder                  */
/*                                                                            */
/*+~sys$add_holder~+*/
long int sys$add_holder(
    const unsigned long int id,
    const unsigned int  *holder [2],
    const unsigned long int attrib
    ) ;
/*~-sys$add_holder-~*/
/*                                                                            */
/*  $ADD_IDENT                                                                */
/*                                                                            */
/*    Add Identifier To The Rights Database                                   */
/*                                                                            */
/*      $ADD_IDENT name, [id], [attrib], [resid]                              */
/*                                                                            */
/*      name    = address of the identifier name character                    */
/*        string descriptor                                                   */
/*      id      = identifier longword to associate with 'name'                */
/*      attrib  = attributes longword to grant to the                         */
/*        identifier                                                          */
/*      resid   = address of a longword to return the assigned                */
/*        identifier                                                          */
/*                                                                            */
/*+~sys$add_ident~+*/
long int sys$add_ident(
    const struct dsc$descriptor *name,
    const unsigned long int id,
    const unsigned long int attrib,
    unsigned long int  *resid
    ) ;
/*~-sys$add_ident-~*/
/*                                                                            */
/*  $ADJSTK                                                                   */
/*                                                                            */
/*    Adjust Outer Mode Stack Pointer                                         */
/*                                                                            */
/*      $ADJSTK [acmode] ,[adjust] ,newadr                                    */
/*                                                                            */
/*      acmode = access mode for which to adjust stack pointer                */
/*      adjust = 16-bit signed adjustment value                               */
/*      newadr = address of longword to store updated value                   */
/*                                                                            */
/*+~sys$adjstk~+*/
long int sys$adjstk(
    const unsigned long int acmode,
    const short int adjust,
    unsigned long int  *newadr
    ) ;
/*~-sys$adjstk-~*/
/*                                                                            */
/*  $ADJWSL                                                                   */
/*                                                                            */
/*    Adjust Working Set Limit                                                */
/*                                                                            */
/*      $ADJWSL [pagcnt] ,[wsetlm]                                            */
/*                                                                            */
/*      pagcnt = number of pages to add to working set (if  positive).        */
/*               Number  of  pages  to  subtract  from working set (if        */
/*               negative).                                                   */
/*      wsetlm = address of longword to receive new working set limit,        */
/*               or current working set limit if pagcnt not specified.        */
/*                                                                            */
/*+~sys$adjwsl~+*/
long int sys$adjwsl(
    const long int pagcnt,
    unsigned long int  *wsetlm
    ) ;
/*~-sys$adjwsl-~*/
/*                                                                            */
/*  $ALLOC                                                                    */
/*                                                                            */
/*    Allocate Device                                                         */
/*                                                                            */
/*      $ALLOC devnam ,[phylen] ,[phybuf] ,[acmode] ,[flags]                  */
/*                                                                            */
/*      devnam = address  of  device  name  or  logical  name   string        */
/*               descriptor                                                   */
/*      phylen = address of word to receive length of physical name           */
/*      phybuf = address of physical name buffer descriptor                   */
/*      acmode = access mode associated with allocated device                 */
/*      flags  = options flags longword                                       */
/*                                                                            */
/*+~sys$alloc~+*/
long int sys$alloc(
    const struct dsc$descriptor *devnam,
    unsigned short int  *phylen,
    struct dsc$descriptor *phybuf,
    const unsigned long int acmode,
    const unsigned long int flags
    ) ;
/*~-sys$alloc-~*/
/*                                                                            */
/*  $ASCEFC                                                                   */
/*                                                                            */
/*    Associate Common Event Flag Cluster                                     */
/*                                                                            */
/*      $ASCEFC  efn ,name ,[prot] ,[perm]                                    */
/*                                                                            */
/*      efn    = number of any event flag in the cluster with which to        */
/*               associate                                                    */
/*      name   = address of the text name string descriptor                   */
/*      prot   = protection indicator for the cluster                         */
/*               0 -> default, any process in group                           */
/*               1 -> only owner's UIC                                        */
/*      perm   = permanent indicator                                          */
/*               0 -> temporary cluster                                       */
/*               1 -> permanent cluster                                       */
/*                                                                            */
/*+~sys$ascefc~+*/
long int sys$ascefc(
    const unsigned long int efn,
    const struct dsc$descriptor *name,
    const char prot,
    const char perm
    ) ;
/*~-sys$ascefc-~*/
/*                                                                            */
/*  $ASCTIM                                                                   */
/*                                                                            */
/*    Convert Binary Time to ASCII String                                     */
/*                                                                            */
/*      $ASCTIM  [timlen] ,timbuf ,[timadr] ,[cvtflg]                         */
/*                                                                            */
/*      timlen = address of a word to receive the number of characters        */
/*               inserted into the output buffer.                             */
/*      timbuf = address  of a  character string descriptor describing        */
/*               the buffer to receive the converted time.                    */
/*      timadr = address of the quadword containing the 64-bit time to        */
/*               be converted to ASCII.  If 0, use current time.              */
/*      cvtflg = conversion indicator                                         */
/*               0 -> return full date and time                               */
/*               1 -> return converted time only                              */
/*                                                                            */
/*+~sys$asctim~+*/
long int sys$asctim(
    unsigned short int  *timlen,
    struct dsc$descriptor *timbuf,
    const unsigned int  *timadr [2],
    const char cvtflg
    ) ;
/*~-sys$asctim-~*/
/*                                                                            */
/*  $ASCTOID                                                                  */
/*                                                                            */
/*    Ascii To Identifier Conversion                                          */
/*                                                                            */
/*      $ASCTOID name, [id], [attrib]                                         */
/*                                                                            */
/*      name    = address of the identifier name character                    */
/*        string descriptor to be converted                                   */
/*      id      = address to return the identifier longword                   */
/*      attrib  = address to return the attributes longword                   */
/*                                                                            */
/*+~sys$asctoid~+*/
long int sys$asctoid(
    const struct dsc$descriptor *name,
    unsigned long int  *id,
    unsigned long int  *attrib
    ) ;
/*~-sys$asctoid-~*/
/*                                                                            */
/*  $ASSIGN                                                                   */
/*                                                                            */
/*    Assign I/O Channel                                                      */
/*                                                                            */
/*      $ASSIGN  devnam ,chan ,[acmode]  ,[mbxnam]                            */
/*                                                                            */
/*      devnam = address  of  device  name  or  logical  name   string        */
/*               descriptor                                                   */
/*      chan   = address of word to receive channel number assigned           */
/*      acmode = access mode associated with channel                          */
/*      mbxnam = address of mailbox logical name string descriptor, if        */
/*               mailbox associated with device                               */
/*                                                                            */
/*+~sys$assign~+*/
long int sys$assign(
    const struct dsc$descriptor *devnam,
    unsigned short int  *chan,
    const unsigned long int acmode,
    const struct dsc$descriptor *mbxnam
    ) ;
/*~-sys$assign-~*/
/*                                                                            */
/*  $BINTIM                                                                   */
/*                                                                            */
/*    Convert ASCII String to Binary Time                                     */
/*                                                                            */
/*      $BINTIM  timbuf ,timadr                                               */
/*                                                                            */
/*      timbuf = address of string descriptor for ASCII time string           */
/*      timadr = address of quadword to  receive  64-bit  binary  time        */
/*               value                                                        */
/*                                                                            */
/*          Absolute time strings are specified in the format:                */
/*               dd-mmm-yyyy hh:mm:ss.cc                                      */
/*          Delta time strings are specified in the format:                   */
/*               dddd hh:mm:ss.cc                                             */
/*                                                                            */
/*+~sys$bintim~+*/
long int sys$bintim(
    const struct dsc$descriptor *timbuf,
    unsigned int  *timadr [2]
    ) ;
/*~-sys$bintim-~*/
/*                                                                            */
/*  $BRDCST                                                                   */
/*                                                                            */
/*    Broadcast                                                               */
/*                                                                            */
/*      $BRDCST  msgbuf ,[devnam]                                             */
/*                                                                            */
/*      msgbuf   = address of message buffer string descriptor                */
/*      devnam   = terminal device name string descriptor.  If 0, send        */
/*                 message   to  all  terminals.   If  first  word  in        */
/*                 descriptor is 0,  send  message  to  all  allocated        */
/*                 terminals.                                                 */
/*                                                                            */
/*+~sys$brdcst~+*/
long int sys$brdcst(
    const struct dsc$descriptor *msgbuf,
    const struct dsc$descriptor *devnam,
    const unsigned long int flags,
    const unsigned long int carcon
    ) ;
/*~-sys$brdcst-~*/
/*  $BRKTHRU                                                                  */
/*                                                                            */
/*    Write to terminal breakthru                                             */
/*                                                                            */
/*     $BRKTHRU     [efn] ,msgbuf, [sendto], [sndtyp], [iosb],                */
/*      ($BRKTHRUW) [carcon], [flags], [reqid], [timout],                     */
/*          [astadr], [astprm]                                                */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     msgbuf = address of message buffer descriptor                          */
/*                                                                            */
/*     sendto = address of send address descriptor                            */
/*                                                                            */
/*     sndtyp = value to describe sendto                                      */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*     carcon = carriage control                                              */
/*                                                                            */
/*     flags = flags to modify broadcast                                      */
/*                                                                            */
/*     reqid = broadcast class requestor id                                   */
/*                                                                            */
/*     timout = address of timeout value                                      */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine as an argument              */
/*                                                                            */
/*                                                                            */
/*+~sys$brkthru~+*/
long int sys$brkthru(
    const unsigned long int efn,
    const struct dsc$descriptor *msgbuf,
    const struct dsc$descriptor *sendto,
    const unsigned long int sndtyp,
    unsigned int  *iosb [2],
    const unsigned long int carcon,
    const unsigned long int flags,
    const unsigned long int reqid,
    const unsigned long int timout,
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$brkthru-~*/
/*+~sys$brkthruw~+*/
long int sys$brkthruw(
    const unsigned long int efn,
    const struct dsc$descriptor *msgbuf,
    const struct dsc$descriptor *sendto,
    const unsigned long int sndtyp,
    unsigned int  *iosb [2],
    const unsigned long int carcon,
    const unsigned long int flags,
    const unsigned long int reqid,
    const unsigned long int timout,
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$brkthruw-~*/
/*                                                                            */
/*  $CANCEL                                                                   */
/*                                                                            */
/*    Cancel I/O on Channel                                                   */
/*                                                                            */
/*      $CANCEL  chan                                                         */
/*                                                                            */
/*      chan   = number of the channel on which I/O is to be canceled         */
/*                                                                            */
/*+~sys$cancel~+*/
long int sys$cancel(
    const unsigned short int chan
    ) ;
/*~-sys$cancel-~*/
/*                                                                            */
/*  $CANEXH                                                                   */
/*                                                                            */
/*    Cancel Exit Handler                                                     */
/*                                                                            */
/*      $CANEXH  [desblk]                                                     */
/*                                                                            */
/*      desblk = address of exit control block describing exit handler        */
/*               to be deleted.  If 0, delete all.                            */
/*                                                                            */
/*+~sys$canexh~+*/
long int sys$canexh(
    const int  *desblk
    ) ;
/*~-sys$canexh-~*/
/*                                                                            */
/*  $CANTIM                                                                   */
/*                                                                            */
/*    Cancel Timer Request                                                    */
/*                                                                            */
/*      $CANTIM  [reqidt] ,[acmode]                                           */
/*                                                                            */
/*      reqidt = request identification for request  to  be  canceled.        */
/*               If 0, all requests canceled.                                 */
/*      acmode = access mode of requests to be canceled                       */
/*                                                                            */
/*+~sys$cantim~+*/
long int sys$cantim(
    const unsigned long int reqidt,
    const unsigned long int acmode
    ) ;
/*~-sys$cantim-~*/
/*                                                                            */
/*  $CANWAK                                                                   */
/*                                                                            */
/*    Cancel Wakeup                                                           */
/*                                                                            */
/*      $CANWAK  [pidadr] ,[prcnam]                                           */
/*                                                                            */
/*      pidadr = address of  process  identification  of  process  for        */
/*               which wakeups are to be canceled                             */
/*      prcnam = address of process name string descriptor                    */
/*                                                                            */
/*+~sys$canwak~+*/
long int sys$canwak(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam
    ) ;
/*~-sys$canwak-~*/
/*  $CHANGE_ACL                                                               */
/*                                                                            */
/*    Set or modify an object's ACL                                           */
/*                                                                            */
/*      $CHANGE_ACL     [chan], objtyp, [objnam],                             */
/*      itmlst, [acmode], [iosb],                                             */
/*      [contxt] , [routin], [orbadr]                                         */
/*                                                                            */
/*      chan   = number of a channel assigned to the object or                */
/*       0 if object is specified by the objnam parameter                     */
/*                                                                            */
/*      objtyp = address of an object type code                               */
/*                                                                            */
/*      objnam = address of object name                                       */
/*                                                                            */
/*      itmlst = address of a list of item descriptors                        */
/*                                                                            */
/*      acmode = address of a byte containing the access mode in              */
/*       which the arguments will be validated                                */
/*                                                                            */
/*      iosb   = address of a quadword I/O status block                       */
/*                                                                            */
/*      contxt = address of a context long word (used for iterative           */
/*       calls or a multi-entry item list)                                    */
/*                                                                            */
/*      routin = address of routine to be executed in kernel mode             */
/*       (obsolete)                                                           */
/*                                                                            */
/*      orbadr = address of a user supplied ORB                               */
/*                                                                            */
/*+~sys$change_acl~+*/
long int sys$change_acl(
    const unsigned short int chan,
    const unsigned long int  *objtyp,
    const struct dsc$descriptor *objnam,
    const int  *itmlst,
    const unsigned long int  *acmode,
    unsigned int  *iosb [2],
    unsigned long int  *contxt,
    const int * *routin,
    const unsigned long int  *orbadr
    ) ;
/*~-sys$change_acl-~*/
/*  $CHANGE_CLASS       objtyp, [objnam], itmlst                              */
/*      [acmode], [orbadr]                                                    */
/*                                                                            */
/*    Modify an objects access class                                          */
/*                                                                            */
/*     objtyp = address of an object type code                                */
/*                                                                            */
/*     objnam = address of an object name descriptor                          */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     acmode = address of a byte containing the access mode in               */
/*      which the arguments will be validated                                 */
/*                                                                            */
/*     orbadr = address of routine to be executed in kernel mode              */
/*                                                                            */
/*                                                                            */
/*+~sys$change_class~+*/
long int sys$change_class(
    const unsigned long int  *objtyp,
    const struct dsc$descriptor *objnam,
    const int  *itmlst,
    const unsigned long int acmode,
    const unsigned long int  *orbadr
    ) ;
/*~-sys$change_class-~*/
/*  $CHECK_ACCESS                                                             */
/*                                                                            */
/*    Check User Access to an Object                                          */
/*                                                                            */
/*     objtyp = address of an object type code                                */
/*                                                                            */
/*     objnam = address of an object name descriptor                          */
/*                                                                            */
/*     usrnam = address of a user name descriptor                             */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     orbadr = address of a user supplied ORB                                */
/*                                                                            */
/*+~sys$check_access~+*/
long int sys$check_access(
    const unsigned long int  *objtyp,
    const struct dsc$descriptor *objnam,
    const struct dsc$descriptor *usrnam,
    const int  *itmlst,
    const unsigned long int  *orbadr
    ) ;
/*~-sys$check_access-~*/
/*                                                                            */
/*  $CHKPRO                                                                   */
/*                                                                            */
/*      Check Access Protection                                               */
/*                                                                            */
/*      $CHKPRO itmlst                                                        */
/*                                                                            */
/*      itmlst = address of a list of item descriptors                        */
/*                                                                            */
/*+~sys$chkpro~+*/
long int sys$chkpro(
    const int  *itmlst
    ) ;
/*~-sys$chkpro-~*/
/*                                                                            */
/*  $CLREF                                                                    */
/*                                                                            */
/*    Clear Event Flag                                                        */
/*                                                                            */
/*      $CLREF efn                                                            */
/*                                                                            */
/*      efn    = number of event flag to be cleared                           */
/*                                                                            */
/*+~sys$clref~+*/
long int sys$clref(
    const unsigned long int efn
    ) ;
/*~-sys$clref-~*/
/*                                                                            */
/*  $CLOSE                                                                    */
/*                                                                            */
/*    Close File                                                              */
/*                                                                            */
/*      $CLOSE fab, [err], [suc]                                              */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$close~+*/
long int sys$close(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$close-~*/
/*                                                                            */
/*  $CMEXEC                                                                   */
/*                                                                            */
/*    Change to Executive Mode                                                */
/*                                                                            */
/*      $CMEXEC  routin ,[arglst]                                             */
/*                                                                            */
/*      routin = address of the routine to be  executed  in  executive        */
/*               mode                                                         */
/*      arglst = address of  argument  list  to  be  supplied  to  the        */
/*               routine                                                      */
/*                                                                            */
/*+~sys$cmexec~+*/
long int sys$cmexec(
    const int * *routin,
    const int  *arglst
    ) ;
/*~-sys$cmexec-~*/
/*  $CMKRNL                                                                   */
/*                                                                            */
/*    Change to Kernel Mode                                                   */
/*                                                                            */
/*     $CMKRNL  routin ,[arglst]                                              */
/*                                                                            */
/*     routin = address of routine to be executed in kernel mode              */
/*                                                                            */
/*     arglst = address of argument list to be supplied to routine            */
/*                                                                            */
/*+~sys$cmkrnl~+*/
long int sys$cmkrnl(
    const int * *routin,
    const int  *arglst
    ) ;
/*~-sys$cmkrnl-~*/
/*                                                                            */
/*  $CONNECT                                                                  */
/*                                                                            */
/*    Connect File                                                            */
/*                                                                            */
/*      $CONNECT rab, [err], [suc]                                            */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$connect~+*/
long int sys$connect(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$connect-~*/
/*  $CNTREG                                                                   */
/*                                                                            */
/*    Contract Program/Control Region                                         */
/*                                                                            */
/*     $CNTREG  pagcnt ,[retadr] ,[acmode] ,[region]                          */
/*                                                                            */
/*     pagcnt = number of pages to be deleted from end of region              */
/*                                                                            */
/*     retadr = address  of  2-longword  array  to  receive   virtual         */
/*           addresses of starting and ending page of deleted area            */
/*                                                                            */
/*     acmode = access mode for which service is performed                    */
/*                                                                            */
/*     region = region indicator                                              */
/*      0 -> program (P0) region   1 -> control (P1) region                   */
/*                                                                            */
/*+~sys$cntreg~+*/
long int sys$cntreg(
    const unsigned long int pagcnt,
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const char region
    ) ;
/*~-sys$cntreg-~*/
/*                                                                            */
/*  $CREATE                                                                   */
/*                                                                            */
/*    Create File                                                             */
/*                                                                            */
/*      $CREATE fab, [err], [suc]                                             */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$create~+*/
long int sys$create(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$create-~*/
/*                                                                            */
/*  $CREATE_RDB                                                               */
/*                                                                            */
/*    Create The Rights Database                                              */
/*                                                                            */
/*      $CREATE_RDB [sysid]                                                   */
/*                                                                            */
/*      sysid   = address of the quadword system identifier                   */
/*        to store in the maintenance record                                  */
/*                                                                            */
/*+~sys$create_rdb~+*/
long int sys$create_rdb(
    const unsigned int  *sysid [2]
    ) ;
/*~-sys$create_rdb-~*/
/*  $CRELNM                                                                   */
/*                                                                            */
/*    Create Logical Name                                                     */
/*                                                                            */
/*     $CRELNM  [attr], tabnam, lognam, [acmode], [itemlist]                  */
/*                                                                            */
/*     attr = address of logical name attributes                              */
/*                                                                            */
/*      Attribute       Meaning                                               */
/*      LNM$M_CONFINE   Logical name not to be copied into sub-process        */
/*      LNM$M_NO_ALIAS  Logical name can not be aliased                       */
/*      LNM$M_CRELOG    Logical name created using $CRELOG                    */
/*                                                                            */
/*     tabnam = address of logical name table string descriptor               */
/*                                                                            */
/*     lognam = address of logical name string descriptor                     */
/*                                                                            */
/*     acmode = address of access mode for logical name                       */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*+~sys$crelnm~+*/
long int sys$crelnm(
    const unsigned long int  *attr,
    const struct dsc$descriptor *tabnam,
    const struct dsc$descriptor *lognam,
    const unsigned char  *acmode,
    const int  *itmlst
    ) ;
/*~-sys$crelnm-~*/
/*  $CRELNT                                                                   */
/*                                                                            */
/*    Create Logical Name Table                                               */
/*                                                                            */
/*     $CRELNT  [attr], [resnam], [reslen], [quota],                          */
/*              [promsk], [tabnam], [acmode], [partab]                        */
/*                                                                            */
/*     attr = address of logical name table attributes                        */
/*                                                                            */
/*     resnam = address of descriptor of a buffer to receive the              */
/*          created table's name                                              */
/*                                                                            */
/*     reslen = address of word to recieve length of created table's          */
/*          name                                                              */
/*                                                                            */
/*     quota = address of quota associated with logical name table            */
/*                                                                            */
/*     promsk = address of protection mask                                    */
/*                                                                            */
/*     tabnam = address of descriptor of logical name table name to be created        */
/*                                                                            */
/*     partab = address of name of table parent string descriptor             */
/*                                                                            */
/*     acmode = address of access mode for logical name                       */
/*                                                                            */
/*+~sys$crelnt~+*/
long int sys$crelnt(
    const unsigned long int  *attr,
    struct dsc$descriptor *resnam,
    unsigned short int  *reslen,
    const unsigned long int  *quota,
    const unsigned short int  *promsk,
    const struct dsc$descriptor *tabnam,
    const struct dsc$descriptor *partab,
    const unsigned char  *acmode
    ) ;
/*~-sys$crelnt-~*/
/*  $CRELOG                                                                   */
/*                                                                            */
/*    Create Logical Name                                                     */
/*                                                                            */
/*     $CRELOG  [tblflg] ,lognam ,eqlnam ,[acmode]                            */
/*                                                                            */
/*     tblflg = logical name table number                                     */
/*       0 -> system (default)   1 -> group    2 -> process                   */
/*                                                                            */
/*     lognam = address of logical name string descriptor                     */
/*                                                                            */
/*     eqlnam = address of equivalence name string descriptor                 */
/*                                                                            */
/*     acmode = access mode for logical name (process table only)             */
/*                                                                            */
/*+~sys$crelog~+*/
long int sys$crelog(
    const unsigned long int tblflg,
    const struct dsc$descriptor *lognam,
    const struct dsc$descriptor *eqlnam,
    const unsigned long int acmode
    ) ;
/*~-sys$crelog-~*/
/*  $CREMBX                                                                   */
/*                                                                            */
/*    Create Mailbox and Assign Channel                                       */
/*                                                                            */
/*     $CREMBX  [prmflg] ,chan ,[maxmsg] ,[bufquo] ,[promsk] ,[acmode] ,[lognam]      */
/*                                                                            */
/*     prmflg = permanent flag                                                */
/*       0 -> temporary (default)   1 -> permanent                            */
/*                                                                            */
/*     chan   = address of word to receive channel                            */
/*                                                                            */
/*     maxmsg = maximum message size that may be received                     */
/*                                                                            */
/*     bufquo = number of bytes that can be used to buffer messages           */
/*                                                                            */
/*     promsk = protection mask                                               */
/*                                                                            */
/*     acmode = access mode of created mailbox                                */
/*                                                                            */
/*     lognam = address of logical name string descriptor for mailbox         */
/*                                                                            */
/*+~sys$crembx~+*/
long int sys$crembx(
    const char prmflg,
    unsigned short int  *chan,
    const unsigned long int maxmsg,
    const unsigned long int bufquo,
    const unsigned long int promsk,
    const unsigned long int acmode,
    const struct dsc$descriptor *lognam
    ) ;
/*~-sys$crembx-~*/
/*  $CREPRC                                                                   */
/*                                                                            */
/*    Create Process                                                          */
/*                                                                            */
/*     $CREPRC  [pidadr] ,[image] ,[input] ,[output] ,[error] ,[prvadr]       */
/*     ,[quota] ,[prcnam] ,[baspri] ,[uic] ,[mbxunt] ,[stsflg] ,[itmlst]      */
/*                                                                            */
/*     pidadr = address of longword to return id of created process           */
/*                                                                            */
/*     image  = address of string descriptor for image name                   */
/*                                                                            */
/*     input  = address of string descriptor for SYS$INPUT                    */
/*                                                                            */
/*     output = address of string descriptor for SYS$OUTPUT                   */
/*                                                                            */
/*     error  = address of string descriptor for SYS$ERROR                    */
/*                                                                            */
/*     prvadr = address of quadword privilege list                            */
/*                                                                            */
/*     quota  = address of quota list                                         */
/*                                                                            */
/*     prcnam = address of string descriptor for process name                 */
/*                                                                            */
/*     baspri = base priority (0-31)                                          */
/*                                                                            */
/*     uic    = user identification code.  If 0, create a subprocess          */
/*                                                                            */
/*     mbxunt = mailbox unit for termination message                          */
/*                                                                            */
/*     stsflg = status and mode flag bits                                     */
/*                                                                            */
/*          Bit  Meaning                                                      */
/*                                                                            */
/*           0   disable resource wait mode                                   */
/*           1   enable system service failure exception mode                 */
/*           2   inhibit process swapping                                     */
/*           3   disable accounting messages                                  */
/*           4   batch process                                                */
/*           5   cause created process to hibernate                           */
/*           6   allow login without authorization file check                 */
/*           7   process is a network connect object                          */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*+~sys$creprc~+*/
long int sys$creprc(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *image,
    const struct dsc$descriptor *input,
    const struct dsc$descriptor *output,
    const struct dsc$descriptor *error,
    const unsigned int  *prvadr [2],
    const int  *quota,
    const struct dsc$descriptor *prcnam,
    const unsigned long int baspri,
    const unsigned long int uic,
    const unsigned short int mbxunt,
    const unsigned long int stsflg,
    const int  *itmlst
    ) ;
/*~-sys$creprc-~*/
/*  $CRETVA                                                                   */
/*                                                                            */
/*    Create Virtual Address Space                                            */
/*                                                                            */
/*     $CRETVA  inadr ,[retadr] ,[acmode]                                     */
/*                                                                            */
/*     inadr  = address of 2-longword array containing  starting  and         */
/*              ending virtual address of pages to be created                 */
/*                                                                            */
/*     retadr = address of a 2-longword array to receive starting and         */
/*              ending virtual address of pages actually created              */
/*                                                                            */
/*     acmode = access  mode  for  the  new  pages   (protection   is         */
/*              read/write for acmode and more privileged modes)              */
/*                                                                            */
/*+~sys$cretva~+*/
long int sys$cretva(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode
    ) ;
/*~-sys$cretva-~*/
/*  $CRMPSC                                                                   */
/*                                                                            */
/*    Create and Map Section                                                  */
/*                                                                            */
/*     $CRMPSC  [inadr] ,[retadr] ,[acmode] ,[flags] ,[gsdnam] ,[ident]       */
/*              ,[relpag] ,[chan] ,[pagcnt] ,[vbn] ,[prot] ,[pfc]             */
/*                                                                            */
/*     inadr  = address of 2-longword array containing  starting  and         */
/*              ending virtual addresses of space to map section              */
/*                                                                            */
/*     retadr = address of  2-longword  array  to  receive  addresses         */
/*              actually mapped                                               */
/*                                                                            */
/*     acmode = access mode of owner of pages                                 */
/*                                                                            */
/*     flags  = section characteristics                                       */
/*                                                                            */
/*       Flag         Meaning                                                 */
/*                                                                            */
/*       SEC$M_GBL    Global section                                          */
/*       SEC$M_CRF    Copy-on-reference pages                                 */
/*       SEC$M_DZRO   Demand zero pages                                       */
/*       SEC$M_EXPREG Find first available space                              */
/*       SEC$M_PERM   Permanent section                                       */
/*       SEC$M_PFNMAP Physical page frame section                             */
/*       SEC$M_SYSGBL System global section                                   */
/*       SEC$M_WRT    Read/write section                                      */
/*                                                                            */
/*     gsdnam = address of global section name string descriptor              */
/*                                                                            */
/*     ident  = address of quadword containing version id and match control   */
/*                                                                            */
/*     relpag = relative page number within section                           */
/*                                                                            */
/*     chan   = number of channel on which file is accessed                   */
/*                                                                            */
/*     pagcnt = number of pages in section                                    */
/*                                                                            */
/*     vbn    = virtual block  number  of  beginning  of  section  or         */
/*              physical page frame number of beginning of section            */
/*                                                                            */
/*     prot   = protection mask                                               */
/*                                                                            */
/*     pfc    = page fault cluster size                                       */
/*                                                                            */
/*+~sys$crmpsc~+*/
long int sys$crmpsc(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const unsigned long int flags,
    const struct dsc$descriptor *gsdnam,
    const unsigned int  *ident [2],
    const unsigned long int relpag,
    const unsigned short int chan,
    const unsigned long int pagcnt,
    const unsigned long int vbn,
    const unsigned long int prot,
    const unsigned long int pfc
    ) ;
/*~-sys$crmpsc-~*/
/*  $DACEFC                                                                   */
/*                                                                            */
/*    Disassociate Common Event Flag Cluster                                  */
/*                                                                            */
/*     $DACEFC  efn                                                           */
/*                                                                            */
/*     efn    = number of any event flag in the cluster                       */
/*                                                                            */
/*+~sys$dacefc~+*/
long int sys$dacefc(
    const unsigned long int efn
    ) ;
/*~-sys$dacefc-~*/
/*  $DALLOC                                                                   */
/*                                                                            */
/*    Deallocate Device                                                       */
/*                                                                            */
/*     $DALLOC  [devnam] ,[acmode]                                            */
/*                                                                            */
/*     devnam = address of device name descriptor.  If 0, deallocate all      */
/*                                                                            */
/*     acmode = access mode associated with device                            */
/*                                                                            */
/*+~sys$dalloc~+*/
long int sys$dalloc(
    const struct dsc$descriptor *devnam,
    const unsigned long int acmode
    ) ;
/*~-sys$dalloc-~*/
/*  $DASSGN                                                                   */
/*                                                                            */
/*    Deassign I/O Channel                                                    */
/*                                                                            */
/*     $DASSGN  chan                                                          */
/*                                                                            */
/*     chan   = number of channel to be deassigned                            */
/*                                                                            */
/*+~sys$dassgn~+*/
long int sys$dassgn(
    const unsigned short int chan
    ) ;
/*~-sys$dassgn-~*/
/*  $DCLAST                                                                   */
/*                                                                            */
/*    Declare AST                                                             */
/*                                                                            */
/*     $DCLAST  astadr ,[astprm] ,[acmode]                                    */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine                             */
/*                                                                            */
/*     acmode = access mode for which the AST is to be declared               */
/*                                                                            */
/*+~sys$dclast~+*/
long int sys$dclast(
    const int * *astadr,
    const unsigned long int astprm,
    const unsigned long int acmode
    ) ;
/*~-sys$dclast-~*/
/*  $DCLCMH                                                                   */
/*                                                                            */
/*    Declare Change Mode or Compatibility Mode Handler                       */
/*                                                                            */
/*     $DCLCMH  addres ,[prvhnd] ,[type]                                      */
/*                                                                            */
/*     addres = address of handler                                            */
/*                                                                            */
/*     prvhnd = address of longword to receive previous handler address       */
/*                                                                            */
/*     type   = handler type indicator                                        */
/*               0 -> change mode (current mode)   1 -> compatibility mode    */
/*                                                                            */
/*+~sys$dclcmh~+*/
long int sys$dclcmh(
    const int * *addres,
    unsigned long int  *prvhnd,
    const char type
    ) ;
/*~-sys$dclcmh-~*/
/*  $DCLEXH                                                                   */
/*                                                                            */
/*    Declare Exit Handler                                                    */
/*                                                                            */
/*     $DCLEXH  desblk                                                        */
/*                                                                            */
/*     desblk = address of exit control block containing:                     */
/*                                                                            */
/*      +-------------------------------+                                     */
/*      |         forward link          |                                     */
/*      +-------------------------------+                                     */
/*      |     exit handler address      |                                     */
/*      +-------------------------------+                                     */
/*      |        argument count         |                                     */
/*      +-------------------------------+                                     */
/*      |   address to store reason     |                                     */
/*      +-------------------------------+                                     */
/*      |     additional arguments      |                                     */
/*      +--      for exit handler,    --+                                     */
/*      |            if any             |                                     */
/*      +-------------------------------+                                     */
/*                                                                            */
/*+~sys$dclexh~+*/
long int sys$dclexh(
    const int  *desblk
    ) ;
/*~-sys$dclexh-~*/
/*                                                                            */
/*  $DELETE                                                                   */
/*                                                                            */
/*    Delete Record                                                           */
/*                                                                            */
/*      $DELETE rab, [err], [suc]                                             */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$delete~+*/
long int sys$delete(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$delete-~*/
/*  $DELLNM                                                                   */
/*                                                                            */
/*    Delete Logical Name and/or Table                                        */
/*                                                                            */
/*     $DELLNM  [tabnam], [lognam], [acmode]                                  */
/*                                                                            */
/*     tabnam = address of descriptor of logical name table name string       */
/*                                                                            */
/*     lognam = address of descriptor of logical name string                  */
/*                                                                            */
/*     acmode = address of access mode for logical name                       */
/*                                                                            */
/*+~sys$dellnm~+*/
long int sys$dellnm(
    const struct dsc$descriptor *tabnam,
    const struct dsc$descriptor *lognam,
    const unsigned char  *acmode
    ) ;
/*~-sys$dellnm-~*/
/*  $DELLOG                                                                   */
/*                                                                            */
/*    Delete Logical Name                                                     */
/*                                                                            */
/*     $DELLOG  [tblflg] ,[lognam] ,[acmode]                                  */
/*                                                                            */
/*     tblflg = logical name table number                                     */
/*                0 -> system   1 -> group   2 -> process                     */
/*                                                                            */
/*     lognam = address of logical name string descriptor.  If 0,             */
/*              delete all names                                              */
/*                                                                            */
/*     acmode = access mode of logical name (process table only)              */
/*                                                                            */
/*+~sys$dellog~+*/
long int sys$dellog(
    const unsigned long int tblflg,
    const struct dsc$descriptor *lognam,
    const unsigned long int acmode
    ) ;
/*~-sys$dellog-~*/
/*  $DELMBX                                                                   */
/*                                                                            */
/*    Delete Mailbox                                                          */
/*                                                                            */
/*     $DELMBX  chan                                                          */
/*                                                                            */
/*     chan   = channel number assigned to the mailbox                        */
/*                                                                            */
/*+~sys$delmbx~+*/
long int sys$delmbx(
    const unsigned short int chan
    ) ;
/*~-sys$delmbx-~*/
/*  $DELPRC                                                                   */
/*                                                                            */
/*    Delete Process                                                          */
/*                                                                            */
/*     $DELPRC  [pidadr] ,[prcnam]                                            */
/*                                                                            */
/*     pidadr = address of longword containing id of process to be deleted    */
/*                                                                            */
/*     prcnam = address of string descriptor for process name to be deleted   */
/*                                                                            */
/*+~sys$delprc~+*/
long int sys$delprc(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam
    ) ;
/*~-sys$delprc-~*/
/*  $DELTVA                                                                   */
/*                                                                            */
/*    Delete Virtual Address Space                                            */
/*                                                                            */
/*     $DELTVA  inadr ,[retadr] ,[acmode]                                     */
/*                                                                            */
/*     inadr  = address of 2-longword array containing  starting  and         */
/*              ending virtual addresses of pages to delete                   */
/*                                                                            */
/*     retadr = address of 2-longword array to receive  starting  and         */
/*              ending addresses of pages actually deleted                    */
/*                                                                            */
/*     acmode = access mode for which service is performed                    */
/*                                                                            */
/*+~sys$deltva~+*/
long int sys$deltva(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode
    ) ;
/*~-sys$deltva-~*/
/*  $DEQ                                                                      */
/*                                                                            */
/*    Dequeue Lock                                                            */
/*                                                                            */
/*     $DEQ  [lkid] ,[valblk] ,[acmode] ,[flags]                              */
/*                                                                            */
/*     lkid   = lock ID of the lock to be dequeued                            */
/*                                                                            */
/*     valblk = address of the lock value block                               */
/*                                                                            */
/*     acmode = access mode of the locks to be dequeued                       */
/*                                                                            */
/*     flags  = optional flags.                                               */
/*                                                                            */
/*                   LCK$M_DEQALL                                             */
/*                                                                            */
/*+~sys$deq~+*/
long int sys$deq(
    const unsigned long int lkid,
    int  *valblk,
    const unsigned long int acmode,
    const unsigned long int flags
    ) ;
/*~-sys$deq-~*/
/*  $DGBLSC                                                                   */
/*                                                                            */
/*    Delete Global Section                                                   */
/*                                                                            */
/*     $DGBLSC  [flags] ,gsdnam ,[ident]                                      */
/*                                                                            */
/*     flags  = type of section                                               */
/*                0 -> group section   SEC$M_SYSGBL -> system section         */
/*                                                                            */
/*     gsdnam = address of global section name string descriptor              */
/*                                                                            */
/*     ident  = address of quadword containing version id and match control   */
/*                                                                            */
/*+~sys$dgblsc~+*/
long int sys$dgblsc(
    const unsigned long int flags,
    const struct dsc$descriptor *gsdnam,
    const unsigned int  *ident [2]
    ) ;
/*~-sys$dgblsc-~*/
/*                                                                            */
/*  $DISCONNECT                                                               */
/*                                                                            */
/*    Disconnect Record Stream                                                */
/*                                                                            */
/*      $DISCONNECT rab, [err], [suc]                                         */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$disconnect~+*/
long int sys$disconnect(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$disconnect-~*/
/*  $DISMOU                                                                   */
/*                                                                            */
/*    Dismount Volume                                                         */
/*                                                                            */
/*     $DISMOU devnam ,[flags]                                                */
/*                                                                            */
/*     devnam = address of device name string descriptor                      */
/*                                                                            */
/*     flags  = 32-bit status mask  selecting options for  the  dismount      */
/*              The  symbols  for  the flags are  defined by the $DMTDEF      */
/*              macro.                                                        */
/*                                                                            */
/*               Flag      Meaning                                            */
/*                                                                            */
/*           DMT$M_NOUNLOAD   Do not unload the volume.                       */
/*                                                                            */
/*           DMT$M_UNIT       Dismount the specified device, rather           */
/*                            than the entire volume set.                     */
/*                                                                            */
/*+~sys$dismou~+*/
long int sys$dismou(
    const struct dsc$descriptor *devnam,
    const unsigned long int flags
    ) ;
/*~-sys$dismou-~*/
/*                                                                            */
/*  $DISPLAY                                                                  */
/*                                                                            */
/*    Display File                                                            */
/*                                                                            */
/*      $DISPLAY fab, [err], [suc]                                            */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$display~+*/
long int sys$display(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$display-~*/
/*  $DLCEFC                                                                   */
/*                                                                            */
/*    Delete Common Event Flag Cluster                                        */
/*                                                                            */
/*     $DLCEFC  name                                                          */
/*                                                                            */
/*     name   = address of cluster name string descriptor                     */
/*                                                                            */
/*+~sys$dlcefc~+*/
long int sys$dlcefc(
    const struct dsc$descriptor *name
    ) ;
/*~-sys$dlcefc-~*/
/*  $ENQ                                                                      */
/*                                                                            */
/*    Enqueue Lock Request                                                    */
/*                                                                            */
/*     $ENQ     [efn] ,lkmode ,lksb ,[flags] ,[resnam] ,[parid]               */
/*     ($ENQW)  ,[astadr] ,[astprm] ,[blkast] ,[acmode], [prot]               */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     lkmode = type of lock mode requested.  Modes are:                      */
/*                                                                            */
/*               LCK$K_NLMODE null lock                                       */
/*               LCK$K_CRMODE concurrent read                                 */
/*               LCK$K_CWMODE concurrent write                                */
/*               LCK$K_PRMODE protected read                                  */
/*               LCK$K_PWMODE protected write                                 */
/*               LCK$K_EXMODE exclusive lock                                  */
/*                                                                            */
/*     lksb  = address of the lock status block                               */
/*                                                                            */
/*     flags = flags defining the characteristics of the lock.  These are:    */
/*                                                                            */
/*               LCK$M_NOQUEUE                                                */
/*               LCK$M_SYNCSTS                                                */
/*               LCK$M_SYSTEM                                                 */
/*               LCK$M_VALBLK                                                 */
/*               LCK$M_CONVERT                                                */
/*                                                                            */
/*     resnam = address of string descriptor of the resource name             */
/*                                                                            */
/*     parid  = lock ID of the parent lock                                    */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine                             */
/*                                                                            */
/*     blkast = address of entry mask of blocking AST routine                 */
/*                                                                            */
/*     acmode = Access mode to be associated with the lock                    */
/*                                                                            */
/*      prot  = optional additional arg for extension                         */
/*                                                                            */
/*+~sys$enq~+*/
long int sys$enq(
    const unsigned long int efn,
    const unsigned long int lkmode,
    int  *lksb,
    const unsigned long int flags,
    const struct dsc$descriptor *resnam,
    const unsigned long int parid,
    const int * *astadr,
    const unsigned long int astprm,
    const int * *blkast,
    const unsigned long int acmode,
    const unsigned long int prot
    ) ;
/*~-sys$enq-~*/
/*+~sys$enqw~+*/
long int sys$enqw(
    const unsigned long int efn,
    const unsigned long int lkmode,
    int  *lksb,
    const unsigned long int flags,
    const struct dsc$descriptor *resnam,
    const unsigned long int parid,
    const int * *astadr,
    const unsigned long int astprm,
    const int * *blkast,
    const unsigned long int acmode,
    const unsigned long int prot
    ) ;
/*~-sys$enqw-~*/
/*                                                                            */
/*  $ENTER                                                                    */
/*                                                                            */
/*    Enter File                                                              */
/*                                                                            */
/*      $ENTER fab, [err], [suc]                                              */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$enter~+*/
long int sys$enter(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$enter-~*/
/*  $ERAPAT                                                                   */
/*                                                                            */
/*    Generate a security erase pattern.                                      */
/*                                                                            */
/*      $ERAPAT type, [count], patadr                                         */
/*                                                                            */
/*      type    = type of security erase                                      */
/*                                                                            */
/*      count   = iteration count (seed for erase pattern)                    */
/*                                                                            */
/*      patadr  = address of longword to receive erase pattern                */
/*                                                                            */
/*+~sys$erapat~+*/
long int sys$erapat(
    const long int type,
    const unsigned long int count,
    unsigned long int  *patadr
    ) ;
/*~-sys$erapat-~*/
/*  $ERASE                                                                    */
/*                                                                            */
/*    Erase File                                                              */
/*                                                                            */
/*      $ERASE fab, [err], [suc]                                              */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$erase~+*/
long int sys$erase(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$erase-~*/
/*  $EXIT                                                                     */
/*                                                                            */
/*    Exit image                                                              */
/*                                                                            */
/*     $EXIT    [code]                                                        */
/*                                                                            */
/*     code   = longword completion status                                    */
/*                                                                            */
/*+~sys$exit~+*/
long int sys$exit(
    const unsigned long int code
    ) ;
/*~-sys$exit-~*/
/*  $EXPREG                                                                   */
/*                                                                            */
/*    Expand Program/Control Region                                           */
/*                                                                            */
/*     $EXPREG  pagcnt ,[retadr] ,[acmode] ,[region]                          */
/*                                                                            */
/*     pagcnt = number of pages to add to end of specified region             */
/*                                                                            */
/*     retadr = address  of  2-longword  array  to  receive   virtual         */
/*              addresses of starting and ending pages                        */
/*                                                                            */
/*     acmode = access mode of the new pages                                  */
/*                                                                            */
/*     region = region indicator                                              */
/*               0 -> program (P0) region   1 -> control (P1) region          */
/*                                                                            */
/*+~sys$expreg~+*/
long int sys$expreg(
    const unsigned long int pagcnt,
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const char region
    ) ;
/*~-sys$expreg-~*/
/*                                                                            */
/*  $EXTEND                                                                   */
/*                                                                            */
/*    Extend File                                                             */
/*                                                                            */
/*      $EXTEND fab, [err], [suc]                                             */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$extend~+*/
long int sys$extend(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$extend-~*/
/*  $FAO                                                                      */
/*                                                                            */
/*    Formatted ASCII Output                                                  */
/*                                                                            */
/*     $FAO     ctrstr ,[outlen] ,outbuf ,[p1] ,[p2]...[pn]                   */
/*                                                                            */
/*     ctrstr = address of string descriptor for control string               */
/*                                                                            */
/*     outlen = address of word in which to store output length               */
/*                                                                            */
/*     outbuf = address of output buffer string descriptor                    */
/*                                                                            */
/*     p1...  = variable number of arguments to FAO                           */
/*                                                                            */
/*+~sys$fao~+*/
long int sys$fao(
    const struct dsc$descriptor *ctrstr,
    unsigned short int  *outlen,
    struct dsc$descriptor *outbuf,
    const long int p1
    ) ;
/*~-sys$fao-~*/
/*  $FAOL                                                                     */
/*                                                                            */
/*    Formatted ASCII Output With List Parameter                              */
/*                                                                            */
/*     $FAOL    ctrstr ,[outlen] ,outbuf ,prmlst                              */
/*                                                                            */
/*     ctrstr = address of string descriptor for control string               */
/*                                                                            */
/*     outlen = address of word to receive output string length               */
/*                                                                            */
/*     outbuf = address of output buffer string descriptor                    */
/*                                                                            */
/*     prmlst = address of a list of longword parameters                      */
/*                                                                            */
/*+~sys$faol~+*/
long int sys$faol(
    const struct dsc$descriptor *ctrstr,
    unsigned short int  *outlen,
    struct dsc$descriptor *outbuf,
    const int  *prmlst
    ) ;
/*~-sys$faol-~*/
/*  $FILESCAN                                                                 */
/*                                                                            */
/*    Scan a string and identify a file specification                         */
/*                                                                            */
/*     $FILESCAN    srcstr, [valuelst], [fldflags]                            */
/*                                                                            */
/*     srcstr = address of string descriptor for source string                */
/*                                                                            */
/*     valuelst = address of a list of item descriptors                       */
/*                                                                            */
/*      fldflags = address of a longword to receive flags                     */
/*                                                                            */
/*+~sys$filescan~+*/
long int sys$filescan(
    const struct dsc$descriptor *srcstr,
    int  *valuelst,
    unsigned long int  *fldflags
    ) ;
/*~-sys$filescan-~*/
/*                                                                            */
/*  $FIND                                                                     */
/*                                                                            */
/*    Find Record in File                                                     */
/*                                                                            */
/*      $FIND rab, [err], [suc]                                               */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$find~+*/
long int sys$find(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$find-~*/
/*                                                                            */
/*  $FIND_HELD                                                                */
/*                                                                            */
/*    Find Identifiers Held By Holder                                         */
/*                                                                            */
/*      $FIND_HELD holder, [id], [attrib], [contxt]                           */
/*                                                                            */
/*      holder  = address of a quadword which specifies the holder            */
/*        id of the records to find                                           */
/*      id      = address to return the identifier longword                   */
/*      attrib  = address to return the holder attributes longword            */
/*      contxt  = address of a longword containing the record stream          */
/*        context. initially should be zero, value output                     */
/*        on first call, value input on subsequent calls.                     */
/*                                                                            */
/*+~sys$find_held~+*/
long int sys$find_held(
    const unsigned int  *holder [2],
    unsigned long int  *id,
    unsigned long int  *attrib,
    unsigned long int  *contxt
    ) ;
/*~-sys$find_held-~*/
/*                                                                            */
/*  $FIND_HOLDER                                                              */
/*                                                                            */
/*    Find Holder Of Identifier                                               */
/*                                                                            */
/*      $FIND_HOLDER id, [holder], [attrib], [contxt]                         */
/*                                                                            */
/*      id      = identifier longword whose holder records                    */
/*        are to be found                                                     */
/*      holder  = address to return the holder id quadword                    */
/*      attrib  = address to return the attributes longword                   */
/*      contxt  = address of a longword containing the record stream          */
/*        context. initially should be zero, value output                     */
/*        on first call, value input on subsequent calls.                     */
/*                                                                            */
/*+~sys$find_holder~+*/
long int sys$find_holder(
    const unsigned long int id,
    unsigned int  *holder [2],
    unsigned long int  *attrib,
    unsigned long int  *contxt
    ) ;
/*~-sys$find_holder-~*/
/*                                                                            */
/*  $FINISH_RDB                                                               */
/*                                                                            */
/*    Clean up RMS Stream                                                     */
/*                                                                            */
/*      $FINISH_RDB contxt                                                    */
/*                                                                            */
/*      contxt  = address of a longword containing the record stream          */
/*        context.                                                            */
/*                                                                            */
/*+~sys$finish_rdb~+*/
long int sys$finish_rdb(
    unsigned long int  *contxt
    ) ;
/*~-sys$finish_rdb-~*/
/*  $FORCEX                                                                   */
/*                                                                            */
/*    Force Exit                                                              */
/*                                                                            */
/*     $FORCEX  [pidadr] ,[prcnam] ,[code]                                    */
/*                                                                            */
/*     pidadr = address of process id of process to be forced to exit         */
/*                                                                            */
/*     prcnam = address of process name descriptor for forced process         */
/*                                                                            */
/*     code   = longword completion status for exit service                   */
/*                                                                            */
/*+~sys$forcex~+*/
long int sys$forcex(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    const unsigned long int code
    ) ;
/*~-sys$forcex-~*/
/*                                                                            */
/*  $FORMAT_ACL                                                               */
/*                                                                            */
/*    Format an Access Control list Entry                                     */
/*                                                                            */
/*      $FORMAT_ACL acl-entry, [acl-length], acl-string,                      */
/*          [line-width], [term-desc], [line-indent],                         */
/*          [bit-names], [routin]                                             */
/*                                                                            */
/*      acl-entry       = address of a descriptor of a buffer which           */
/*        contains the ACE                                                    */
/*                                                                            */
/*      acl-length      = address of a word to receive the length of          */
/*        the output string                                                   */
/*                                                                            */
/*      acl-string      = address of a descriptor of a buffer into            */
/*        which the output string is to be stored                             */
/*                                                                            */
/*      line-width      = address of the maximum line width                   */
/*        (0 = infinite)                                                      */
/*                                                                            */
/*      term_desc       = address of a character descriptor containing        */
/*        a character string to be inserted whenever                          */
/*        the line segment length exceeds the line-width                      */
/*                                                                            */
/*      line-indent     = address of the number of columns to indent          */
/*        the output line segment                                             */
/*                                                                            */
/*      bit-names       = address of a access bit name table (32 entries)     */
/*                                                                            */
/*      routin  = address of routine to be executed in kernel mode            */
/*                                                                            */
/*+~sys$format_acl~+*/
long int sys$format_acl(
    const struct dsc$descriptor *aclent,
    unsigned short int  *acllen,
    struct dsc$descriptor *aclstr,
    const unsigned short int  *width,
    const struct dsc$descriptor *trmdsc,
    const unsigned short int  *indent,
    const int  *accnam,
    const int * *routin
    ) ;
/*~-sys$format_acl-~*/
/*  $FORMAT_CLASS       itmlst, [routin]                                      */
/*                                                                            */
/*    Format access class strings                                             */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     routin = address of routine to be executed in kernel mode              */
/*                                                                            */
/*                                                                            */
/*+~sys$format_class~+*/
long int sys$format_class(
    const int  *itmlst,
    const int * *routin
    ) ;
/*~-sys$format_class-~*/
/*                                                                            */
/*  $FREE                                                                     */
/*                                                                            */
/*    Free Record                                                             */
/*                                                                            */
/*      $FREE rab, [err], [suc]                                               */
/*                                                                            */
/*      rab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$free~+*/
long int sys$free(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$free-~*/
/*                                                                            */
/*  $FLUSH                                                                    */
/*                                                                            */
/*    Flush Record                                                            */
/*                                                                            */
/*      $FLUSH rab, [err], [suc]                                              */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$flush~+*/
long int sys$flush(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$flush-~*/
/*                                                                            */
/*  $GET                                                                      */
/*                                                                            */
/*    Get Record from File                                                    */
/*                                                                            */
/*      $GET rab, [err], [suc]                                                */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$get~+*/
long int sys$get(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$get-~*/
/*  $GETCHN                                                                   */
/*                                                                            */
/*    Get I/O Channel Information                                             */
/*                                                                            */
/*     $GETCHN  chan ,[prilen] ,[pribuf] ,[scdlen] ,[scdbuf]                  */
/*                                                                            */
/*     chan   = number of a channel assigned to the device                    */
/*                                                                            */
/*     prilen = address of word to receive length of primary buffer           */
/*                                                                            */
/*     pribuf = address of primary buffer descriptor                          */
/*                                                                            */
/*     scdlen = address of word to receive length of secondary buffer         */
/*                                                                            */
/*     scdbuf = address of secondary buffer descriptor                        */
/*                                                                            */
/*+~sys$getchn~+*/
long int sys$getchn(
    const unsigned short int chan,
    unsigned short int  *prilen,
    struct dsc$descriptor *pribuf,
    unsigned short int  *scdlen,
    struct dsc$descriptor *scdbuf
    ) ;
/*~-sys$getchn-~*/
/*  $GETDEV                                                                   */
/*                                                                            */
/*    Get I/O Device Information                                              */
/*                                                                            */
/*     $GETDEV  devnam  ,[prilen] ,[pribuf] ,[scdlen] ,[scdbuf]               */
/*                                                                            */
/*     devnam = address of device name or logical name descriptor             */
/*                                                                            */
/*     prilen = address of word to receive length of primary buffer           */
/*                                                                            */
/*     pribuf = address of primary buffer descriptor                          */
/*                                                                            */
/*     scdlen = address of word to receive length of secondary buffer         */
/*                                                                            */
/*     scdbuf = address of secondary buffer descriptor                        */
/*                                                                            */
/*+~sys$getdev~+*/
long int sys$getdev(
    const struct dsc$descriptor *devnam,
    unsigned short int  *prilen,
    struct dsc$descriptor *pribuf,
    unsigned short int  *scdlen,
    struct dsc$descriptor *scdbuf
    ) ;
/*~-sys$getdev-~*/
/*  $GETDVI                                                                   */
/*                                                                            */
/*    Get Device/Volume Information                                           */
/*                                                                            */
/*     $GETDVI  [efn] ,[chan] ,[devnam] ,itmlst ,[iosb] ,[astadr]             */
/*    ($GETDVIW)          ,[astprm] ,[nullarg]                                */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     chan   = number of a channel assigned to the device or                 */
/*              0 if device is specified by the devnam parameter              */
/*                                                                            */
/*     devnam = address of device name or logical name descriptor             */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine                             */
/*                                                                            */
/*     nullarg = reserved argument                                            */
/*                                                                            */
/*                                                                            */
/*+~sys$getdvi~+*/
long int sys$getdvi(
    const unsigned long int efn,
    const unsigned short int chan,
    const struct dsc$descriptor *devnam,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm,
    const unsigned int  *nullarg [2]
    ) ;
/*~-sys$getdvi-~*/
/*+~sys$getdviw~+*/
long int sys$getdviw(
    const unsigned long int efn,
    const unsigned short int chan,
    const struct dsc$descriptor *devnam,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm,
    const unsigned int  *nullarg [2]
    ) ;
/*~-sys$getdviw-~*/
/*  $GETJPI                                                                   */
/*                                                                            */
/*    Get Job/Process Information                                             */
/*                                                                            */
/*     $GETJPI  [efn] ,[pidadr] ,[prcnam] ,itmlst ,[iosb], [astadr],          */
/*     ($GETJPIW)   [astprm]                                                  */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     pidadr = address of process identification                             */
/*                                                                            */
/*     prcnam = address of process name string descriptor                     */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine as an argument              */
/*                                                                            */
/*                                                                            */
/*+~sys$getjpi~+*/
long int sys$getjpi(
    const unsigned long int efn,
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$getjpi-~*/
/*+~sys$getjpiw~+*/
long int sys$getjpiw(
    const unsigned long int efn,
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$getjpiw-~*/
/*  $GETLKI                                                                   */
/*                                                                            */
/*    Get Lock Information                                                    */
/*                                                                            */
/*     $GETLKI  [efn] ,lkidadr ,itmlst ,[iosb], [astadr], [astprm],           */
/*     ($GETLKIW)   [reserved]                                                */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     lkidadr = address of lock identification                               */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine as an argument              */
/*                                                                            */
/*     reserved = reserved parameter                                          */
/*                                                                            */
/*                                                                            */
/*+~sys$getlki~+*/
long int sys$getlki(
    const unsigned long int efn,
    unsigned long int  *lkidadr,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm,
    const unsigned long int reserved
    ) ;
/*~-sys$getlki-~*/
/*+~sys$getlkiw~+*/
long int sys$getlkiw(
    const unsigned long int efn,
    unsigned long int  *lkidadr,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm,
    const unsigned long int reserved
    ) ;
/*~-sys$getlkiw-~*/
/*  $GETMSG                                                                   */
/*                                                                            */
/*    Get Message                                                             */
/*                                                                            */
/*     $GETMSG  msgid ,msglen ,bufadr ,[flags] ,[outadr]                      */
/*                                                                            */
/*     msgid  = identification of message to be retrieved                     */
/*                                                                            */
/*     msglen = address  of  a  word  to  receive  length  of  string         */
/*       returned                                                             */
/*                                                                            */
/*     bufadr = address of buffer descriptor  of  buffer  to  receive         */
/*       string                                                               */
/*                                                                            */
/*     flags  = flag bits for message content (macro default = 15)            */
/*                                                                            */
/*           Bit  Value/Meaning                                               */
/*                                                                            */
/*            0  1 Include text                                               */
/*               0 Do not include text                                        */
/*            1  1 Include identifier                                         */
/*               0 Do not include identifier                                  */
/*            2  1 Include severity                                           */
/*               0 Do not include severity                                    */
/*            3  1 Include component                                          */
/*               0 Do not include component                                   */
/*                                                                            */
/*     outadr = address of 4-byte array to receive the following values:      */
/*                                                                            */
/*       Byte       Contents                                                  */
/*                                                                            */
/*        0  Reserved                                                         */
/*        1  Count of FAO arguments                                           */
/*        2  User value                                                       */
/*        3  Reserved                                                         */
/*                                                                            */
/*+~sys$getmsg~+*/
long int sys$getmsg(
    const unsigned long int msgid,
    unsigned short int  *msglen,
    struct dsc$descriptor *bufadr,
    const unsigned long int flags,
    unsigned char  *outadr [4]
    ) ;
/*~-sys$getmsg-~*/
/*  $GETPTI                                                                   */
/*                                                                            */
/*    Get Page Table Information                                              */
/*                                                                            */
/*     $GETPTI  [inadr],[retadr],[acmode],[mask],[pagcnt]                     */
/*                                                                            */
/*     inadr    = address of two longwords containing starting                */
/*      and ending virtual address to operate on                              */
/*                                                                            */
/*     retadr   = address of two longwords into which starting                */
/*      and ending address of pages operated on is returned                   */
/*                                                                            */
/*     acmode   = access mode against which ownership is checked              */
/*                                                                            */
/*     mask     = mask of page table information control bits                 */
/*                                                                            */
/*     pagcnt   = minimum page count                                          */
/*                                                                            */
/*                                                                            */
/*+~sys$getpti~+*/
long int sys$getpti(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const unsigned long int mask,
    const unsigned long int pagcnt
    ) ;
/*~-sys$getpti-~*/
/*  $GETQUI                                                                   */
/*                                                                            */
/*    Get Queue Information                                                   */
/*                                                                            */
/*     $GETQUI   [efn], func, [nullarg], [itmlst],                            */
/*    ($GETQUIW) [iosb], [astadr], [astprm]                                   */
/*                                                                            */
/*     efn     = event flag to be set when request completes                  */
/*     func    = code specifying function to be performed                     */
/*     nullarg = reserved argument for similarity with $getxxx services       */
/*     itmlst  = address of a list of item descriptors for the operation      */
/*     iosb    = address of a quadword status block to receive the final status       */
/*     astadr  = address of an ast routine to be called when request completes*/
/*     astprm  = 32-bit ast parameter                                         */
/*                                                                            */
/*+~sys$getqui~+*/
long int sys$getqui(
    const unsigned long int efn,
    const unsigned short int func,
    const unsigned long int nullarg,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$getqui-~*/
/*+~sys$getquiw~+*/
long int sys$getquiw(
    const unsigned long int efn,
    const unsigned short int func,
    const unsigned long int nullarg,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$getquiw-~*/
/*  $GETSYI                                                                   */
/*                                                                            */
/*    Get System-Wide Information                                             */
/*                                                                            */
/*     $GETSYI  [efn] ,[csidadr],[nodename],itmlst ,[iosb] ,[astadr],         */
/*    ($GETSYIW)  [astprm]                                                    */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     csidadr = address of cluster system identification                     */
/*                                                                            */
/*     nodename = address of node name string descriptor                      */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine                             */
/*                                                                            */
/*                                                                            */
/*     The second and third arguments in the $GETSYI argument list are        */
/*     not used; they are reserved for future use.                            */
/*                                                                            */
/*+~sys$getsyi~+*/
long int sys$getsyi(
    const unsigned long int efn,
    unsigned long int  *csidadr,
    const struct dsc$descriptor *nodename,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$getsyi-~*/
/*+~sys$getsyiw~+*/
long int sys$getsyiw(
    const unsigned long int efn,
    unsigned long int  *csidadr,
    const struct dsc$descriptor *nodename,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$getsyiw-~*/
/*  $GETTIM                                                                   */
/*                                                                            */
/*    Get Time                                                                */
/*                                                                            */
/*     $GETTIM  timadr                                                        */
/*                                                                            */
/*     timadr = address of a quadword to receive 64-bit current time value    */
/*                                                                            */
/*+~sys$gettim~+*/
long int sys$gettim(
    unsigned int  *timadr [2]
    ) ;
/*~-sys$gettim-~*/
/*  $GETUAI                                                                   */
/*                                                                            */
/*    Get User Authorization Information                                      */
/*                                                                            */
/*     $GETUAI  [efn] ,[contxt] ,usrnam ,itmlst ,[iosb] ,[astadr]             */
/*      ,[astprm]                                                             */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     contxt = address of a context longword (UAF IFI & ISI)                 */
/*                                                                            */
/*     usrnam = address of user name descriptor                               */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine                             */
/*                                                                            */
/*                                                                            */
/*+~sys$getuai~+*/
long int sys$getuai(
    const unsigned long int efn,
    const unsigned long int  *contxt,
    const struct dsc$descriptor *usrnam,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$getuai-~*/
/*                                                                            */
/*  $GRANTID                                                                  */
/*                                                                            */
/*    Grant Identifier to Process                                             */
/*                                                                            */
/*      $GRANTID [pidadr], [prcnam], [id], [name], [prvatr]                   */
/*                                                                            */
/*      pidadr  = address of PID of affected process                          */
/*      prcnam  = address of string descriptor of process name                */
/*      id      = address of quadword identifier and attributes               */
/*      name    = address of string descriptor of identifier name             */
/*      prvatr  = address to store attributes of superseded id                */
/*                                                                            */
/*+~sys$grantid~+*/
long int sys$grantid(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    unsigned int  *id [2],
    const struct dsc$descriptor *name,
    unsigned long int  *prvatr
    ) ;
/*~-sys$grantid-~*/
/*                                                                            */
/*  $GRANT_LICENSE                                                            */
/*                                                                            */
/*  Grant authorization to execute licensed software product.                 */
/*                                                                            */
/*      $GRANT_LICENSE  prdnam ,prducer [,contxt] [,itmlst]                   */
/*                                                                            */
/*      prdnam  = address of descriptor for software product name             */
/*      prducer = address of descriptor for software producer name            */
/*      contxt  = address of context buffer (4 longwords)                     */
/*      itmlst  = address of a list of item descriptors                       */
/*                                                                            */
/*+~sys$grant_license~+*/
long int sys$grant_license(
    const struct dsc$descriptor *prdnam,
    const struct dsc$descriptor *prducer,
    const unsigned long int  *contxt [4],
    const int  *itmlst
    ) ;
/*~-sys$grant_license-~*/
/*  $HIBER                                                                    */
/*                                                                            */
/*    Hibernate                                                               */
/*                                                                            */
/*     $HIBER_S                                                               */
/*                                                                            */
/*+~sys$hiber~+*/
long int sys$hiber() ;
/*~-sys$hiber-~*/
/*                                                                            */
/*  $IDTOASC                                                                  */
/*                                                                            */
/*    Identifier To Ascii Conversion                                          */
/*                                                                            */
/*      $IDTOASC id, [namlen], [nambuf], [resid], [attrib], [contxt]          */
/*                                                                            */
/*      id      = identifier longword to convert, or zero to                  */
/*        find all identifiers (wildcarding)                                  */
/*      namlen  = address of a word to store the length of the                */
/*        identifier name                                                     */
/*      nambuf  = address of a character string descriptor that               */
/*        describes the buffer to return the identifier name                  */
/*      resid   = address of a longword to return the id found                */
/*        while wildcarding                                                   */
/*      attrib  = address to return the attributes longword                   */
/*      contxt  = address of a longword containing the record stream          */
/*        context. initially should be zero, value output                     */
/*        on first call, value input on subsequent calls.                     */
/*                                                                            */
/*+~sys$idtoasc~+*/
long int sys$idtoasc(
    const unsigned long int id,
    unsigned short int  *namlen,
    struct dsc$descriptor *nambuf,
    unsigned long int  *resid,
    unsigned long int  *attrib,
    unsigned long int  *contxt
    ) ;
/*~-sys$idtoasc-~*/
/*  $IMGACT                                                                   */
/*                                                                            */
/*    Image Activation                                                        */
/*                                                                            */
/*     $IMGACT  name,[dflnam],hdrbuf,[imgctl],[inadr],                        */
/*      [retadr], [ident], [acmode]                                           */
/*                                                                            */
/*                                                                            */
/*     name     = address of descriptor for file name string                  */
/*                                                                            */
/*     dflnam   = descriptor for file name string                             */
/*                                                                            */
/*     hdrbuf   = address of 512 byte buffer to write in                      */
/*                                                                            */
/*     imgctl   = image activation control flags                              */
/*                                                                            */
/*     inadr    = address of quadword specifying virtual address              */
/*        range to be mapped                                                  */
/*                                                                            */
/*     retadr   = address of quadword specifying virtual address              */
/*        range actually mapped                                               */
/*                                                                            */
/*     ident    = address of quadword holding image section match             */
/*        control and identifier                                              */
/*                                                                            */
/*     acmode   = access mode to be the owner of the created pages            */
/*                                                                            */
/*+~sys$imgact~+*/
long int sys$imgact(
    const struct dsc$descriptor *name,
    const struct dsc$descriptor *dflnam,
    int * *hdrbuf,
    const unsigned long int imgctl,
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned int  *ident [2],
    const unsigned long int acmode
    ) ;
/*~-sys$imgact-~*/
/*  $IMGFIX                                                                   */
/*                                                                            */
/*    Image Address Fixup Service                                             */
/*                                                                            */
/*     $IMGFIX                                                                */
/*                                                                            */
/*+~sys$imgfix~+*/
long int sys$imgfix() ;
/*~-sys$imgfix-~*/
/*  $LCKPAG                                                                   */
/*                                                                            */
/*    Lock Pages in Memory                                                    */
/*                                                                            */
/*     $LCKPAG  inadr ,[retadr] ,[acmode]                                     */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending addresses of pages to be locked                        */
/*                                                                            */
/*     retadr = address of 2-longword array to receive addresses of           */
/*              pages actually locked                                         */
/*                                                                            */
/*     acmode = access mode to check against the owner of the pages           */
/*                                                                            */
/*+~sys$lckpag~+*/
long int sys$lckpag(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode
    ) ;
/*~-sys$lckpag-~*/
/*  $LKWSET                                                                   */
/*                                                                            */
/*    Lock Pages in Working Set                                               */
/*                                                                            */
/*     $LKWSET  inadr ,[retadr] ,[acmode]                                     */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending virtual addresses of pages to be locked                */
/*                                                                            */
/*     retadr = address of a 2-longword array to receive starting and         */
/*              ending virtual addresses of pages actually locked             */
/*                                                                            */
/*     acmode = access mode to be checked against the page owner              */
/*                                                                            */
/*+~sys$lkwset~+*/
long int sys$lkwset(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode
    ) ;
/*~-sys$lkwset-~*/
/*  $MGBLSC                                                                   */
/*                                                                            */
/*    Map Global Section                                                      */
/*                                                                            */
/*     $MGBLSC  inadr ,[retadr] ,[acmode] ,[flags] ,gsdnam ,[ident] ,[relpag] */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending addresses of pages to be mapped                        */
/*                                                                            */
/*     retadr = address of 2-longword array to receive virtual                */
/*              addresses of pages mapped                                     */
/*                                                                            */
/*     acmode = access mode of owner of mapped pages                          */
/*                                                                            */
/*     flags  = flags overriding default section characteristics              */
/*                                                                            */
/*         Flag        Meaning                                                */
/*                                                                            */
/*       SEC$M_WRT      Read/write section                                    */
/*       SEC$M_SYSGBL   System global section                                 */
/*       SEC$M_EXPREG   Find first available space                            */
/*                                                                            */
/*     gsdnam = address of global section name descriptor                     */
/*                                                                            */
/*     ident  = address of quadword containing version id and match control   */
/*                                                                            */
/*     relpag = relative page number within global section                    */
/*                                                                            */
/*+~sys$mgblsc~+*/
long int sys$mgblsc(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const unsigned long int flags,
    const struct dsc$descriptor *gsdnam,
    const unsigned int  *ident [2],
    const unsigned long int relpag
    ) ;
/*~-sys$mgblsc-~*/
/*                                                                            */
/*  $MODIFY                                                                   */
/*                                                                            */
/*    Modify File                                                             */
/*                                                                            */
/*      $MODIFY fab, [err], [suc]                                             */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$modify~+*/
long int sys$modify(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$modify-~*/
/*                                                                            */
/*  $MOD_HOLDER                                                               */
/*                                                                            */
/*    Modify Holder Record In Rights Database                                 */
/*                                                                            */
/*      $MOD_HOLDER id, holder, [set_attrib], [clr_attrib]                    */
/*                                                                            */
/*      id         = identifier longword                                      */
/*      holder     = address of the holder identifier quadword                */
/*      set_attrib = longword containing the attributes to set                */
/*           into the holder record                                           */
/*      clr_attrib = longword containing the attributes to clear              */
/*           in the holder record                                             */
/*                                                                            */
/*+~sys$mod_holder~+*/
long int sys$mod_holder(
    const unsigned long int id,
    const unsigned int  *holder [2],
    const unsigned long int set_attrib,
    const unsigned long int clr_attrib
    ) ;
/*~-sys$mod_holder-~*/
/*                                                                            */
/*  $MOD_IDENT                                                                */
/*                                                                            */
/*    Modify Identifier Record In Rights Database                             */
/*                                                                            */
/*      $MOD_IDENT id, [set_attrib], [clr_attrib], [new_name], [new_value]    */
/*                                                                            */
/*      id         = identifier longword                                      */
/*      set_attrib = longword containing the attributes                       */
/*           to set into the identifier record                                */
/*      clr_attrib = longword containing the attributes                       */
/*           to clear in the identifier record                                */
/*      new_name   = address of the new identifier name character             */
/*                   string descriptor                                        */
/*      new_value  = new identifier value longword                            */
/*                                                                            */
/*+~sys$mod_ident~+*/
long int sys$mod_ident(
    const unsigned long int id,
    const unsigned long int set_attrib,
    const unsigned long int clr_attrib,
    const struct dsc$descriptor *new_name,
    const unsigned long int new_value
    ) ;
/*~-sys$mod_ident-~*/
/*  $MOUNT                                                                    */
/*                                                                            */
/*    Mount Volume                                                            */
/*                                                                            */
/*     $MOUNT  itmlst                                                         */
/*                                                                            */
/*     itmlst = Address of a list of item identifiers                         */
/*                                                                            */
/*+~sys$mount~+*/
long int sys$mount(
    const int  *itmlst
    ) ;
/*~-sys$mount-~*/
/*  $MTACCESS                                                                 */
/*                                                                            */
/*    Installation specific accessibility routine                             */
/*                                                                            */
/*  $MTACCESS lblnam, [uic], [std_version], [access_char],                    */
/*            [access_spec],type                                              */
/*                                                                            */
/*    lblnam =    On input this field is the address of the                   */
/*        VOL1 or HDR1 label read off the magnetic tape. On                   */
/*        output of labels this field is zero. The type                       */
/*        of label is determined by the TYPE field.                           */
/*    uic   =     This field contains the longword volme UIC passed           */
/*        by value.                                                           */
/*    std_version =  This field contains a byte value of the                  */
/*           decimal equivalent of the version number                         */
/*           gotten from the VOL1 label, passed by value.                     */
/*    access_char =  This field contins the byte value of the                 */
/*           accessibility character specified by the user,                   */
/*           passed by value. For output of labels only.                      */
/*    access_spec =  This field determines if the character passed            */
/*           in ACCESS_CHAR  was specified by user, passed                    */
/*           by value.  It must contain one of the following                  */
/*           values:                                                          */
/*      MTA$K_CHARVALID = YES                                                 */
/*      MTA$K_NOCHAR = NO                                                     */
/*                   For output of labels only.                               */
/*    type = This field contains the type of accessibility to process,        */
/*           passed by value. It must contain one of the following            */
/*           values:                                                          */
/*      MTA$K_INVOL1 = Input a VOL1 label                                     */
/*      MTA$K_INHDR1 = Input a HDR1 label                                     */
/*      MTA$K_OUTVOL1 = Output a VOL1 label                                   */
/*      MTA$K_OUTHDR1 = Output a HDR1 label                                   */
/*                                                                            */
/*+~sys$mtaccess~+*/
long int sys$mtaccess(
    const unsigned long int  *lblnam,
    const unsigned long int uic,
    const unsigned long int std_version,
    const unsigned long int access_char,
    const unsigned long int access_spec,
    const unsigned long int type
    ) ;
/*~-sys$mtaccess-~*/
/*  $NUMTIM                                                                   */
/*                                                                            */
/*    Convert Binary Time to Numeric Time                                     */
/*                                                                            */
/*     $NUMTIM  timbuf ,[timadr]                                              */
/*                                                                            */
/*     timbuf = address of a 7-word buffer to receive numeric time            */
/*              information                                                   */
/*                                                                            */
/*     timadr = address of a quadword containing the 64-bit time.  If         */
/*              0, use current time                                           */
/*                                                                            */
/*+~sys$numtim~+*/
long int sys$numtim(
    unsigned short int  *timbuf [7],
    const unsigned int  *timadr [2]
    ) ;
/*~-sys$numtim-~*/
/*                                                                            */
/*  $NXTVOL                                                                   */
/*                                                                            */
/*    Go to Next Volume                                                       */
/*                                                                            */
/*      $NXTVOL rab, [err], [suc]                                             */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$nxtvol~+*/
long int sys$nxtvol(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$nxtvol-~*/
/*                                                                            */
/*  $OPEN                                                                     */
/*                                                                            */
/*    Open File                                                               */
/*                                                                            */
/*      $OPEN fab, [err], [suc]                                               */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$open~+*/
long int sys$open(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$open-~*/
/*                                                                            */
/*  $PARSE                                                                    */
/*                                                                            */
/*    Parse File Name                                                         */
/*                                                                            */
/*      $PARSE fab, [err], [suc]                                              */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$parse~+*/
long int sys$parse(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$parse-~*/
/*                                                                            */
/*  $PARSE_ACL                                                                */
/*                                                                            */
/*    Parse an Access Control list Entry                                      */
/*                                                                            */
/*      $PARSE_ACL acl-string ,acl-entry ,[error-position],                   */
/*         [bit-names], [routin]                                              */
/*                                                                            */
/*      acl-string      = address of a descriptor of a buffer which           */
/*        contains the text to be parsed                                      */
/*                                                                            */
/*      acl-entry       = address of a descriptor of a buffer into            */
/*        which the converted ACE is to be written                            */
/*                                                                            */
/*      error-position  = address of a word to receive the number of          */
/*        characters actually processed by the service.                       */
/*        If the service fails, this count points to                          */
/*        the failing point in the input string.                              */
/*                                                                            */
/*      bit-names       = address of a access bit name table (32 entries)     */
/*                                                                            */
/*      routin  = address of routine to be executed in kernel mode            */
/*                                                                            */
/*+~sys$parse_acl~+*/
long int sys$parse_acl(
    const struct dsc$descriptor *aclstr,
    struct dsc$descriptor *aclent,
    unsigned short int  *errpos,
    const int  *accnam,
    const int * *routin
    ) ;
/*~-sys$parse_acl-~*/
/*  $PARSE_CLASSitmlst, [routin]                                              */
/*                                                                            */
/*    Parse access class strings                                              */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     routin = address of routine to be executed in kernel mode              */
/*                                                                            */
/*                                                                            */
/*+~sys$parse_class~+*/
long int sys$parse_class(
    const int  *itmlst,
    const int * *routin
    ) ;
/*~-sys$parse_class-~*/
/*  $PURGWS                                                                   */
/*                                                                            */
/*    Purge Working Set                                                       */
/*                                                                            */
/*     $PURGWS  inadr                                                         */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending addresses of pages to be removed                       */
/*                                                                            */
/*+~sys$purgws~+*/
long int sys$purgws(
    const unsigned long int  *inadr [2]
    ) ;
/*~-sys$purgws-~*/
/*                                                                            */
/*  $PUT                                                                      */
/*                                                                            */
/*    Put Record to File                                                      */
/*                                                                            */
/*      $PUT rab, [err], [suc]                                                */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$put~+*/
long int sys$put(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$put-~*/
/*  $PUTMSG                                                                   */
/*                                                                            */
/*    Put Message                                                             */
/*                                                                            */
/*     $PUTMSG  msgvec ,[actrtn] ,[facnam], [actprm]                          */
/*                                                                            */
/*     msgvec = address of message argument vector                            */
/*                                                                            */
/*     actrtn = address of entry mask of action routine                       */
/*                                                                            */
/*     facnam = address of facility name string descriptor                    */
/*                                                                            */
/*     actprm = parameter to pass to action routine                           */
/*                                                                            */
/*+~sys$putmsg~+*/
long int sys$putmsg(
    const int  *msgvec,
    const int * *actrtn,
    const struct dsc$descriptor *facnam,
    const unsigned long int actprm
    ) ;
/*~-sys$putmsg-~*/
/*  $QIO                                                                      */
/*                                                                            */
/*    Queue I/O Request                                                       */
/*                                                                            */
/*     $QIO     [efn] ,chan ,func ,[iosb] ,[astadr] ,[astprm]                 */
/*     ($QIOW)  ,[p1] ,[p2] ,[p3] ,[p4] ,[p5] ,[p6]                           */
/*                                                                            */
/*     efn    = number of event flag to set on completion                     */
/*                                                                            */
/*     chan   = number of channel on which I/O is directed                    */
/*                                                                            */
/*     func   = function code specifying action to be performed               */
/*                                                                            */
/*     iosb   = address of quadword I/O status block to receive final         */
/*              completion status                                             */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine as argument                 */
/*                                                                            */
/*     p1...  = optional device- and function-specific parameters             */
/*                                                                            */
/*+~sys$qio~+*/
long int sys$qio(
    const unsigned long int efn,
    const unsigned short int chan,
    const unsigned short int func,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm,
    const int  *p1,
    const long int p2,
    const long int p3,
    const long int p4,
    const long int p5,
    const long int p6
    ) ;
/*~-sys$qio-~*/
/*+~sys$qiow~+*/
long int sys$qiow(
    const unsigned long int efn,
    const unsigned short int chan,
    const unsigned short int func,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm,
    const int  *p1,
    const long int p2,
    const long int p3,
    const long int p4,
    const long int p5,
    const long int p6
    ) ;
/*~-sys$qiow-~*/
/*                                                                            */
/*  $READ                                                                     */
/*                                                                            */
/*    Read Block from File                                                    */
/*                                                                            */
/*      $READ rab, [err], [suc]                                               */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$read~+*/
long int sys$read(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$read-~*/
/*  $READEF                                                                   */
/*                                                                            */
/*    Read Event Flag                                                         */
/*                                                                            */
/*     $READEF  efn ,state                                                    */
/*                                                                            */
/*     efn    = event flag number of any flag in the cluster                  */
/*                                                                            */
/*     state  = address of a longword to receive current state of all         */
/*              flags in the cluster                                          */
/*                                                                            */
/*+~sys$readef~+*/
long int sys$readef(
    const unsigned long int efn,
    unsigned long int  *state
    ) ;
/*~-sys$readef-~*/
/*                                                                            */
/*  $RELEASE                                                                  */
/*                                                                            */
/*    Release Record                                                          */
/*                                                                            */
/*      $RELEASE rab, [err], [suc]                                            */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$release~+*/
long int sys$release(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$release-~*/
/*                                                                            */
/*  $RELEASE_LICENSE                                                          */
/*                                                                            */
/*  Release authorization to execute licensed software product.               */
/*                                                                            */
/*      $RELEASE_LICENSE  context                                             */
/*                                                                            */
/*      contxt  = address of context buffer returned by                       */
/*        $grant_license (4 longwords)                                        */
/*                                                                            */
/*+~sys$release_license~+*/
long int sys$release_license(
    const int  *contxt
    ) ;
/*~-sys$release_license-~*/
/*                                                                            */
/*  $REMOVE                                                                   */
/*                                                                            */
/*    Remove File                                                             */
/*                                                                            */
/*      $REMOVE fab, [err], [suc]                                             */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$remove~+*/
long int sys$remove(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$remove-~*/
/*                                                                            */
/*  $REM_HOLDER                                                               */
/*                                                                            */
/*    Remove Holder Record From Rights Database                               */
/*                                                                            */
/*      $REM_HOLDER id, holder                                                */
/*                                                                            */
/*      id      = identifier longword                                         */
/*      holder  = address of the holder identifier quadword                   */
/*                                                                            */
/*+~sys$rem_holder~+*/
long int sys$rem_holder(
    const unsigned long int id,
    const unsigned int  *holder [2]
    ) ;
/*~-sys$rem_holder-~*/
/*                                                                            */
/*  $REM_IDENT                                                                */
/*                                                                            */
/*    Remove Identifier From Rights Database                                  */
/*                                                                            */
/*      $REM_IDENT id                                                         */
/*                                                                            */
/*      id      = identifier longword                                         */
/*                                                                            */
/*+~sys$rem_ident~+*/
long int sys$rem_ident(
    const unsigned long int id
    ) ;
/*~-sys$rem_ident-~*/
/*                                                                            */
/*  $RENAME                                                                   */
/*                                                                            */
/*    Rename File                                                             */
/*                                                                            */
/*      $RENAME oldfab, [err], [suc], newfab                                  */
/*                                                                            */
/*      oldfab  = address of oldfab                                           */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*      newfab  = address of new fab                                          */
/*+~sys$rename~+*/
long int sys$rename(
    int  *oldfab,
    const int * *err,
    const int * *suc,
    int  *newfab
    ) ;
/*~-sys$rename-~*/
/*  $RESUME                                                                   */
/*                                                                            */
/*    Resume Suspended Process                                                */
/*                                                                            */
/*     $RESUME  [pidadr] ,[prcnam]                                            */
/*                                                                            */
/*     pidadr = address of process id of process to be resumed                */
/*                                                                            */
/*     prcnam = address of process name string descriptor                     */
/*                                                                            */
/*+~sys$resume~+*/
long int sys$resume(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam
    ) ;
/*~-sys$resume-~*/
/*                                                                            */
/*  $REVOKID                                                                  */
/*                                                                            */
/*    Revoke Identifier from Process                                          */
/*                                                                            */
/*      $REVOKID [pidadr], [prcnam], [id], [name], [prvatr]                   */
/*                                                                            */
/*      pidadr  = address of PID of affected process                          */
/*      prcnam  = address of string descriptor of process name                */
/*      id      = address of quadword identifier and attributes               */
/*      name    = address of string descriptor of identifier name             */
/*      prvatr  = address to store attributes of superseded id                */
/*                                                                            */
/*+~sys$revokid~+*/
long int sys$revokid(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    unsigned int  *id [2],
    const struct dsc$descriptor *name,
    unsigned long int  *prvatr
    ) ;
/*~-sys$revokid-~*/
/*                                                                            */
/*  $REWIND                                                                   */
/*                                                                            */
/*    Rewind File                                                             */
/*                                                                            */
/*      $REWIND rab, [err], [suc]                                             */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$rewind~+*/
long int sys$rewind(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$rewind-~*/
/*  $RUNDWN                                                                   */
/*                                                                            */
/*    Rundown Process                                                         */
/*                                                                            */
/*     $RUNDWN  [acmode]                                                      */
/*                                                                            */
/*     acmode = access mode to rundown; this and all less                     */
/*      privileged access modes are rundown                                   */
/*                                                                            */
/*+~sys$rundwn~+*/
long int sys$rundwn(
    const unsigned long int acmode
    ) ;
/*~-sys$rundwn-~*/
/*  $SCHDWK                                                                   */
/*                                                                            */
/*    Schedule Wakeup                                                         */
/*                                                                            */
/*     $SCHDWK  [pidadr] ,[prcnam] ,daytim ,[reptim]                          */
/*                                                                            */
/*     pidadr = address of process id of process to be awakened               */
/*                                                                            */
/*     prcnam = address of process name string descriptor                     */
/*                                                                            */
/*     daytim = address of quadword containing time to wake                   */
/*                                                                            */
/*     reptim = address of quadword containing repeat time interval           */
/*                                                                            */
/*+~sys$schdwk~+*/
long int sys$schdwk(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    const unsigned int  *daytim [2],
    const unsigned int  *reptim [2]
    ) ;
/*~-sys$schdwk-~*/
/*                                                                            */
/*  $SEARCH                                                                   */
/*                                                                            */
/*    Search for File Name                                                    */
/*                                                                            */
/*      $SEARCH fab, [err], [suc]                                             */
/*                                                                            */
/*      fab     = address of fab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$search~+*/
long int sys$search(
    int  *fab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$search-~*/
/*  $SETAST                                                                   */
/*                                                                            */
/*    Set AST Enable                                                          */
/*                                                                            */
/*     $SETAST  enbflg                                                        */
/*                                                                            */
/*     enbflg = AST enable indicator for current access mode                  */
/*                0 -> disable    1 -> enable                                 */
/*                                                                            */
/*+~sys$setast~+*/
long int sys$setast(
    const char enbflg
    ) ;
/*~-sys$setast-~*/
/*  $SETEF                                                                    */
/*                                                                            */
/*    Set Event Flag                                                          */
/*                                                                            */
/*     $SETEF  efn                                                            */
/*                                                                            */
/*     efn    = event flag number of flag to set                              */
/*                                                                            */
/*+~sys$setef~+*/
long int sys$setef(
    const unsigned long int efn
    ) ;
/*~-sys$setef-~*/
/*  $SETEXV                                                                   */
/*                                                                            */
/*    Set Exception Vector                                                    */
/*                                                                            */
/*     $SETEXV  [vector] ,[addres] ,[acmode] ,[prvhnd]                        */
/*                                                                            */
/*     vector = vector number                                                 */
/*                0 -> primary vector   1 -> secondary    2 -> last chance    */
/*                                                                            */
/*     addres = exception handler address (0 indicates deassign vector)       */
/*                                                                            */
/*     acmode = access mode for which vector is set                           */
/*                                                                            */
/*     prvhnd = address of longword to receive previous handler address       */
/*                                                                            */
/*+~sys$setexv~+*/
long int sys$setexv(
    const unsigned long int vector,
    const int * *addres,
    const unsigned long int acmode,
    unsigned long int  *prvhnd
    ) ;
/*~-sys$setexv-~*/
/*  $SETIME                                                                   */
/*                                                                            */
/*    Set System Time                                                         */
/*                                                                            */
/*     $SETIME [timadr]                                                       */
/*                                                                            */
/*     timadr = address of quadword containing  new  system  time  in         */
/*              64-bit  format.   If 0, recalibrate system time using         */
/*              hardware time-of-year clock.                                  */
/*                                                                            */
/*+~sys$setime~+*/
long int sys$setime(
    const unsigned int  *timadr [2]
    ) ;
/*~-sys$setime-~*/
/*  $SETIMR                                                                   */
/*                                                                            */
/*    Set Timer                                                               */
/*                                                                            */
/*     $SETIMR  [efn] ,daytim ,[astadr] ,[reqidt] ,[flags]                    */
/*                                                                            */
/*     efn    = event flag to set when timer expires                          */
/*                                                                            */
/*     daytim = address of quadword containing 64-bit time value              */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     reqidt = request identification of this timer request                  */
/*                                                                            */
/*      flags = only bit 0 used right now.  If bit 0 is set,                  */
/*       then this timer request is in terms of CPU time.                     */
/*                                                                            */
/*+~sys$setimr~+*/
long int sys$setimr(
    const unsigned long int efn,
    const unsigned int  *daytim [2],
    const int * *astadr,
    const unsigned long int reqidt,
    const unsigned long int flags
    ) ;
/*~-sys$setimr-~*/
/*  $SETPFM                                                                   */
/*                                                                            */
/*    Set Page Fault Monitoring                                               */
/*                                                                            */
/*     $SETPFM  [pfmflg] ,[astadr] ,[astprm] ,[acmode]                        */
/*                                                                            */
/*      pfmflg  = function/subfunction bits                                   */
/*                                                                            */
/*      astadr  = address of entry mask of AST routine                        */
/*                                                                            */
/*      astprm  = value to be passed to AST routine                           */
/*                                                                            */
/*      acmode  = access mode for which the AST is to be declared             */
/*                                                                            */
/*+~sys$setpfm~+*/
long int sys$setpfm(
    const unsigned long int pfmflg,
    const int * *astadr,
    const unsigned long int astprm,
    const unsigned long int acmode
    ) ;
/*~-sys$setpfm-~*/
/*  $SETPRA                                                                   */
/*                                                                            */
/*    Set Power Recovery AST                                                  */
/*                                                                            */
/*     $SETPRA  astadr ,[acmode]                                              */
/*                                                                            */
/*     astadr = address of power recovery AST routine                         */
/*                                                                            */
/*     acmode = access mode of AST                                            */
/*                                                                            */
/*+~sys$setpra~+*/
long int sys$setpra(
    const int * *astadr,
    const unsigned long int acmode
    ) ;
/*~-sys$setpra-~*/
/*  $SETPRI                                                                   */
/*                                                                            */
/*    Set Priority                                                            */
/*                                                                            */
/*     $SETPRI  [pidadr] ,[prcnam] ,pri ,[prvpri]                             */
/*                                                                            */
/*     pidadr = address of process id of process to be set                    */
/*                                                                            */
/*     prcnam = address of process name string descriptor                     */
/*                                                                            */
/*     pri    = new base priority for the process                             */
/*                                                                            */
/*     prvpri = address of longword to receive previous base priority         */
/*                                                                            */
/*+~sys$setpri~+*/
long int sys$setpri(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    const unsigned long int pri,
    unsigned long int  *prvpri
    ) ;
/*~-sys$setpri-~*/
/*  $SETPRN                                                                   */
/*                                                                            */
/*    Set Process Name                                                        */
/*                                                                            */
/*     $SETPRN  [prcnam]                                                      */
/*                                                                            */
/*     prcnam = address of the process name string descriptor                 */
/*                                                                            */
/*+~sys$setprn~+*/
long int sys$setprn(
    const struct dsc$descriptor *prcnam
    ) ;
/*~-sys$setprn-~*/
/*  $SETPRT                                                                   */
/*                                                                            */
/*    Set Protection on Pages                                                 */
/*                                                                            */
/*     $SETPRT  inadr ,[retadr] ,[acmode] ,prot ,[prvprt]                     */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending virtual addresses of pages to change                   */
/*                                                                            */
/*     retadr = address of 2-longword array containing starting and           */
/*              ending addresses of pages which were changed                  */
/*                                                                            */
/*     acmode = access mode of request                                        */
/*                                                                            */
/*     prot   = new protection                                                */
/*                                                                            */
/*     prvprt = address of byte to receive previous protection of             */
/*              last page changed                                             */
/*                                                                            */
/*+~sys$setprt~+*/
long int sys$setprt(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const unsigned long int prot,
    unsigned char  *prvprt
    ) ;
/*~-sys$setprt-~*/
/*  $SETPRV                                                                   */
/*                                                                            */
/*    Set privileges.                                                         */
/*     $SETPRV [enbflg] ,[prvadr] ,[prmflg] ,[prvprv]                         */
/*                                                                            */
/*     enbflg = enable indicator                                              */
/*                0 -> disable   1 -> enable                                  */
/*                                                                            */
/*     prvadr = 64-bit mask defining the privileges to be enabled or          */
/*              disabled                                                      */
/*                                                                            */
/*     prmflg = permanent indicator                                           */
/*                0 -> temporary (for this image)  1 -> permanent             */
/*                                                                            */
/*     prvprv = address of quadword buffer to receive previous privileges     */
/*                                                                            */
/*+~sys$setprv~+*/
long int sys$setprv(
    const char enbflg,
    const unsigned int  *prvadr [2],
    const char prmflg,
    unsigned int  *prvprv [2]
    ) ;
/*~-sys$setprv-~*/
/*  $SETRWM                                                                   */
/*                                                                            */
/*    Set Resource Wait Mode                                                  */
/*                                                                            */
/*     $SETRWM  [watflg]                                                      */
/*                                                                            */
/*     watflg = wait indicator                                                */
/*         0 -> wait for resources   1 -> return failure immediately          */
/*         (type is NUMBER rather than BOOLEAN since WATFLG=TRUE              */
/*         means don't wait, which is the opposite of what is seems)          */
/*                                                                            */
/*+~sys$setrwm~+*/
long int sys$setrwm(
    const char watflg
    ) ;
/*~-sys$setrwm-~*/
/*  $SETSFM                                                                   */
/*                                                                            */
/*    Set System Service Failure Mode                                         */
/*                                                                            */
/*     $SETSFM  [enbflg]                                                      */
/*                                                                            */
/*     enbflg = enable indicator                                              */
/*                0 -> disable generation of exceptions on service failures   */
/*                1 -> generate exceptions for system service failures        */
/*                                                                            */
/*+~sys$setsfm~+*/
long int sys$setsfm(
    const char enbflg
    ) ;
/*~-sys$setsfm-~*/
/*  $SETSSF                                                                   */
/*                                                                            */
/*    Set System Service Filter                                               */
/*                                                                            */
/*     $SETSSF  [mask]                                                        */
/*                                                                            */
/*     mask = flags for services to inhibit                                   */
/*                                                                            */
/*+~sys$setssf~+*/
long int sys$setssf(
    const unsigned long int mask
    ) ;
/*~-sys$setssf-~*/
/*  $SETSTK                                                                   */
/*                                                                            */
/*    SET VIRTUAL STACK LIMITS                                                */
/*                                                                            */
/*     $SETSTK inadr ,[retadr] ,[acmode]                                      */
/*                                                                            */
/*     inadr  = address of 2-longword array containing  starting  and         */
/*              ending virtual address of stack limits to set                 */
/*                                                                            */
/*     retadr = address of a 2-longword array to receive starting and         */
/*              ending virtual address of stack limits to set                 */
/*                                                                            */
/*     acmode = access  mode  for  the  stack to change                       */
/*                                                                            */
/*+~sys$setstk~+*/
long int sys$setstk(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode
    ) ;
/*~-sys$setstk-~*/
/*  $SETSWM                                                                   */
/*                                                                            */
/*    Set Process Swap Mode                                                   */
/*                                                                            */
/*     $SETSWM  [swpflg]                                                      */
/*                                                                            */
/*     swpflg = swap indicator                                                */
/*                0 -> enable swapping   1 -> disable swapping                */
/*                                                                            */
/*+~sys$setswm~+*/
long int sys$setswm(
    const char swpflg
    ) ;
/*~-sys$setswm-~*/
/*  $SETUAI                                                                   */
/*                                                                            */
/*    Modify User Authorization Information                                   */
/*                                                                            */
/*     $SETUAI  [efn] ,[contxt] ,usrnam ,itmlst ,[iosb] ,[astadr]             */
/*      ,[astprm]                                                             */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     contxt = address of a context longword (UAF IFI & ISI)                 */
/*                                                                            */
/*     usrnam = address of user name descriptor                               */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*     astadr = address of entry mask of AST routine                          */
/*                                                                            */
/*     astprm = value to be passed to AST routine                             */
/*                                                                            */
/*                                                                            */
/*+~sys$setuai~+*/
long int sys$setuai(
    const unsigned long int efn,
    const unsigned long int  *contxt,
    const struct dsc$descriptor *usrnam,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$setuai-~*/
/*  $SNDACC                                                                   */
/*                                                                            */
/*    Send Message to Accounting Manager                                      */
/*                                                                            */
/*     $SNDACC  msgbuf ,[chan]                                                */
/*                                                                            */
/*     msgbuf = address of message buffer string descriptor                   */
/*                                                                            */
/*     chan   = number of channel assigned to mailbox to receive reply        */
/*                                                                            */
/*+~sys$sndacc~+*/
long int sys$sndacc(
    const struct dsc$descriptor *msgbuf,
    const unsigned short int chan
    ) ;
/*~-sys$sndacc-~*/
/*  $SNDERR                                                                   */
/*                                                                            */
/*    Send Message to Error Logger                                            */
/*                                                                            */
/*     $SNDERR msgbuf                                                         */
/*                                                                            */
/*     msgbuf = address of message buffer string descriptor                   */
/*                                                                            */
/*+~sys$snderr~+*/
long int sys$snderr(
    const struct dsc$descriptor *msgbuf
    ) ;
/*~-sys$snderr-~*/
/*  $SNDOPR                                                                   */
/*                                                                            */
/*    Send Message to Operator                                                */
/*                                                                            */
/*     $SNDOPR  msgbuf ,[chan]                                                */
/*                                                                            */
/*     msgbuf = address of message buffer string descriptor                   */
/*                                                                            */
/*     chan   = number of channel assigned to mailbox to receive reply        */
/*                                                                            */
/*+~sys$sndopr~+*/
long int sys$sndopr(
    const struct dsc$descriptor *msgbuf,
    const unsigned short int chan
    ) ;
/*~-sys$sndopr-~*/
/*  $SNDSMB                                                                   */
/*                                                                            */
/*    Send Message to Symbiont Manager                                        */
/*                                                                            */
/*     $SNDSMB  msgbuf ,[chan]                                                */
/*                                                                            */
/*     msgbuf = address of message buffer string descriptor                   */
/*                                                                            */
/*     chan   = number of channel assigned to mailbox to receive reply        */
/*                                                                            */
/*+~sys$sndsmb~+*/
long int sys$sndsmb(
    const struct dsc$descriptor *msgbuf,
    const unsigned short int chan
    ) ;
/*~-sys$sndsmb-~*/
/*  $SNDJBC                                                                   */
/*                                                                            */
/*    Send Message to Job Controller                                          */
/*                                                                            */
/*     $SNDJBC   [efn], func, [nullarg], [itmlst],                            */
/*    ($SNDJBCW) [iosb], [astadr], [astprm]                                   */
/*                                                                            */
/*     efn     = event flag to be set when request completes                  */
/*     func    = code specifying function to be performed                     */
/*     nullarg = reserved argument for similarity with $getxxx services       */
/*     itmlst  = address of a list of item descriptors for the operation      */
/*     iosb    = address of a quadword status block to receive the final status       */
/*     astadr  = address of an ast routine to be called when request completes*/
/*     astprm  = 32-bit ast parameter                                         */
/*                                                                            */
/*+~sys$sndjbc~+*/
long int sys$sndjbc(
    const unsigned long int efn,
    const unsigned short int func,
    const unsigned long int nullarg,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$sndjbc-~*/
/*+~sys$sndjbcw~+*/
long int sys$sndjbcw(
    const unsigned long int efn,
    const unsigned short int func,
    const unsigned long int nullarg,
    const int  *itmlst,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$sndjbcw-~*/
/*                                                                            */
/*  $SPACE                                                                    */
/*                                                                            */
/*    Space to Record in File                                                 */
/*                                                                            */
/*      $SPACE rab, [err], [suc]                                              */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$space~+*/
long int sys$space(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$space-~*/
/*  $SUSPND                                                                   */
/*                                                                            */
/*    Suspend Process                                                         */
/*                                                                            */
/*     $SUSPND  [pidadr] ,[prcnam], [flags]                                   */
/*                                                                            */
/*     pidadr = address of process id of process to be suspended              */
/*                                                                            */
/*     prcnam = address of name string descriptor of process                  */
/*                                                                            */
/*     flags  = longword of bit flags, of which only bit 0 is                 */
/*        currently used.  If bit 0 is set, then this                         */
/*        is a hard suspend request; if clear this is                         */
/*        a soft suspend request.                                             */
/*                                                                            */
/*+~sys$suspnd~+*/
long int sys$suspnd(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam,
    const unsigned long int flags
    ) ;
/*~-sys$suspnd-~*/
/*  $SYNCH                                                                    */
/*                                                                            */
/*    Synchronize Event Completion                                            */
/*                                                                            */
/*     $SYNCH [iosb] ,[efn]                                                   */
/*                                                                            */
/*     efn    = event flag to be set at completion                            */
/*                                                                            */
/*     iosb   = address of a quadword I/O status block                        */
/*                                                                            */
/*+~sys$synch~+*/
long int sys$synch(
    const unsigned long int efn,
    unsigned int  *iosb [2]
    ) ;
/*~-sys$synch-~*/
/*  $TRNLNM                                                                   */
/*                                                                            */
/*    Translate Logical Name                                                  */
/*                                                                            */
/*     $TRNLNM  [attr], tabnam, [lognam], [acmode], [itemlist]                */
/*                                                                            */
/*     attr = address of logical name translation attributes                  */
/*                                                                            */
/*      Attribute        Meaning                                              */
/*      LNM$M_CASE_BLIND Search of string is case insensitive                 */
/*                                                                            */
/*     tabnam = address of logical name table name string descriptor          */
/*                                                                            */
/*     lognam = address of logical name string descriptor                     */
/*                                                                            */
/*     acmode = address of access mode for logical name                       */
/*                                                                            */
/*     itmlst = address of a list of item descriptors                         */
/*                                                                            */
/*+~sys$trnlnm~+*/
long int sys$trnlnm(
    const unsigned long int  *attr,
    const struct dsc$descriptor *tabnam,
    const struct dsc$descriptor *lognam,
    const unsigned char  *acmode,
    const int  *itmlst
    ) ;
/*~-sys$trnlnm-~*/
/*  $TRNLOG                                                                   */
/*                                                                            */
/*    Translate Logical Name                                                  */
/*                                                                            */
/*     $TRNLOG  lognam ,[rsllen] ,rslbuf ,[table] ,[acmode] ,[dsbmsk]         */
/*                                                                            */
/*     lognam = address of logical name string descriptor                     */
/*                                                                            */
/*     rsllen = address of word to receive length of resultant name           */
/*                                                                            */
/*     rslbuf = address of descriptor for buffer to receive resultant         */
/*              string                                                        */
/*                                                                            */
/*     table  = address of byte to receive logical name table number          */
/*                                                                            */
/*     acmode = address of byte to receive access mode of entry               */
/*              (process table only)                                          */
/*                                                                            */
/*     dsbmsk = table search disable mask                                     */
/*                                                                            */
/*       Bit Set    Meaning                                                   */
/*                                                                            */
/*          0       Do not search system table                                */
/*          1       Do not search group table                                 */
/*          2       Do not search process table                               */
/*                                                                            */
/*+~sys$trnlog~+*/
long int sys$trnlog(
    const struct dsc$descriptor *lognam,
    unsigned short int  *rsllen,
    struct dsc$descriptor *rslbuf,
    unsigned char  *table,
    unsigned char  *acmode,
    const unsigned long int dsbmsk
    ) ;
/*~-sys$trnlog-~*/
/*                                                                            */
/*  $TRUNCATE                                                                 */
/*                                                                            */
/*    Truncate Record                                                         */
/*                                                                            */
/*      $TRUNCATE rab, [err], [suc]                                           */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$truncate~+*/
long int sys$truncate(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$truncate-~*/
/*  $ULKPAG                                                                   */
/*                                                                            */
/*    Unlock Pages From Memory                                                */
/*                                                                            */
/*     $ULKPAG  inadr ,[retadr] ,[acmode]                                     */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending virtual addresses of pages to be unlocked              */
/*                                                                            */
/*     retadr = address of a 2-longword array to receive starting and         */
/*              ending virtual addresses of pages actually unlocked           */
/*                                                                            */
/*     acmode = access mode to check against the owner of the pages           */
/*                                                                            */
/*+~sys$ulkpag~+*/
long int sys$ulkpag(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode
    ) ;
/*~-sys$ulkpag-~*/
/*  $ULWSET                                                                   */
/*                                                                            */
/*    Unlock Pages From Working Set                                           */
/*                                                                            */
/*     $ULWSET  inadr ,[retadr] ,[acmode]                                     */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending virtual addresses of pages to be unlocked              */
/*                                                                            */
/*     retadr = address of a 2-longword array to receive starting and         */
/*              ending virtual addresses of pages actually unlocked           */
/*                                                                            */
/*     acmode = access mode to check against the owner of the pages           */
/*                                                                            */
/*+~sys$ulwset~+*/
long int sys$ulwset(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode
    ) ;
/*~-sys$ulwset-~*/
/*  $UNWIND                                                                   */
/*                                                                            */
/*    Unwind Call Stack                                                       */
/*                                                                            */
/*     $UNWIND  [depadr] ,[newpc]                                             */
/*                                                                            */
/*     depadr = address of longword containing number of logical frames       */
/*              (depth) to unwind call stack                                  */
/*                                                                            */
/*     newpc  = address to be given control when the unwind is complete       */
/*                                                                            */
/*+~sys$unwind~+*/
long int sys$unwind(
    const unsigned long int  *depadr,
    const unsigned long int  *newpc
    ) ;
/*~-sys$unwind-~*/
/*                                                                            */
/*  $UPDATE                                                                   */
/*                                                                            */
/*    Update Record                                                           */
/*                                                                            */
/*      $UPDATE fab, [err], [suc]                                             */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$update~+*/
long int sys$update(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$update-~*/
/*  $UPDSEC                                                                   */
/*                                                                            */
/*    Update Section File on Disk                                             */
/*                                                                            */
/*     $UPDSEC  inadr ,[retadr] ,[acmode] ,[updflg] ,[efn] ,[iosb]            */
/*     ($UPDSECW)  ,[astadr] ,[astprm]                                        */
/*                                                                            */
/*     inadr  = address of 2-longword array containing starting and           */
/*              ending  addresses  of  the  pages  to  be potentially         */
/*              written                                                       */
/*                                                                            */
/*     retadr = address of 2-longword array to receive  addresses  of         */
/*              the  first  and  last  page  queued  in the first I/O         */
/*              request                                                       */
/*                                                                            */
/*     acmode = access  mode  on  behalf  of  which  the  service  is         */
/*              performed                                                     */
/*                                                                            */
/*     updflg = update indicator for read/write global sections               */
/*                0 -> write all read/write pages in the section              */
/*                1 -> write all pages modified by the caller                 */
/*                                                                            */
/*     efn    = number of event flag to set when the section file  is         */
/*              updated                                                       */
/*                                                                            */
/*     iosb   = address of quadword I/O status block                          */
/*                                                                            */
/*     astadr = address of entry mask of an AST service routine               */
/*                                                                            */
/*     astprm = AST parameter to be passed to the AST service routine         */
/*                                                                            */
/*+~sys$updsec~+*/
long int sys$updsec(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const char updflg,
    const unsigned long int efn,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$updsec-~*/
/*+~sys$updsecw~+*/
long int sys$updsecw(
    const unsigned long int  *inadr [2],
    unsigned long int  *retadr [2],
    const unsigned long int acmode,
    const char updflg,
    const unsigned long int efn,
    unsigned int  *iosb [2],
    const int * *astadr,
    const unsigned long int astprm
    ) ;
/*~-sys$updsecw-~*/
/*                                                                            */
/*  $WAIT                                                                     */
/*                                                                            */
/*    Wait on File                                                            */
/*                                                                            */
/*      $WAIT rab                                                             */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*                                                                            */
/*+~sys$wait~+*/
long int sys$wait(
    int  *rab
    ) ;
/*~-sys$wait-~*/
/*  $WAITFR                                                                   */
/*                                                                            */
/*    Wait for Single Event Flag                                              */
/*                                                                            */
/*     $WAITFR  efn                                                           */
/*                                                                            */
/*     efn    = event flag number to wait for                                 */
/*                                                                            */
/*+~sys$waitfr~+*/
long int sys$waitfr(
    const unsigned long int efn
    ) ;
/*~-sys$waitfr-~*/
/*  $WAKE                                                                     */
/*                                                                            */
/*    Wake                                                                    */
/*                                                                            */
/*     $WAKE  [pidadr] ,[prcnam]                                              */
/*                                                                            */
/*     pidadr = address of process id  of process to be awakened              */
/*                                                                            */
/*     prcnam = address of name string descriptor of process to be            */
/*              awakened                                                      */
/*                                                                            */
/*+~sys$wake~+*/
long int sys$wake(
    unsigned long int  *pidadr,
    const struct dsc$descriptor *prcnam
    ) ;
/*~-sys$wake-~*/
/*  $WFLAND                                                                   */
/*                                                                            */
/*    Wait for Logical AND of Event Flags                                     */
/*                                                                            */
/*     $WFLAND  efn ,mask                                                     */
/*                                                                            */
/*     efn    = event flag number of any flag within the cluster              */
/*                                                                            */
/*     mask   = 32-bit mask of flags that must be set                         */
/*                                                                            */
/*+~sys$wfland~+*/
long int sys$wfland(
    const unsigned long int efn,
    const unsigned long int mask
    ) ;
/*~-sys$wfland-~*/
/*  $WFLOR                                                                    */
/*                                                                            */
/*    Wait for Logical OR of Event Flags                                      */
/*                                                                            */
/*     $WFLOR  efn ,mask                                                      */
/*                                                                            */
/*     efn    = event flag number of any flag within the cluster              */
/*                                                                            */
/*     mask   = 32-bit mask of flags, any of which must be set                */
/*                                                                            */
/*+~sys$wflor~+*/
long int sys$wflor(
    const unsigned long int efn,
    const unsigned long int mask
    ) ;
/*~-sys$wflor-~*/
/*                                                                            */
/*  $WRITE                                                                    */
/*                                                                            */
/*    Write Block to  File                                                    */
/*                                                                            */
/*      $WRITE rab, [err], [suc]                                              */
/*                                                                            */
/*      rab     = address of rab                                              */
/*                                                                            */
/*      err     = address of user error completion routine                    */
/*                                                                            */
/*      suc     = address of user success completion routine                  */
/*                                                                            */
/*+~sys$write~+*/
long int sys$write(
    int  *rab,
    ...
    /* const int * *err, */
    /* const int * *suc */
    ) ;
/*~-sys$write-~*/
#endif
