	program verb_extractor

	! VERB Version 1.0 June 1st, 1985
	! Written  by Joe Meadows Jr.,  with thanks  to the
	! Fred Hutchinson Cancer Research Center for kindly
	! allowing  me to  use  their  computing  resources.
	!
	! If  you  have any  questions, comments, ideas, or
	! whatever, feel free to contact me via US Mail :
	!	Joe Meadows Jr.
	!	4841 268th Ave. N.E.
	!	Redmond Wa. 98052
	! or via phone : (206) 827-7296

	implicit integer (a-z)
	character buffer*80,comment*132,verb*32,symbol*80
	logical all,out,list, found, anyfound, openfile
	external lib$put_output,output,lib$find_image_symbol
	byte term_char(8)
	integer*2 term_width
	equivalence (term_char(3),term_width)

	integer cli$_entnf/'38934'x/

	comment=
	1  '!***************************************'
	1//'****************************************'
	1//'****************************************'
	1//'************'	! I just love a huge comment...

	! let user specifywidth of output stream (for the heck of it, okay?)
	if (cli$present('width')) then
	 call error(cli$get_value('width',buffer,buff_len))
	 call error(ots$cvt_ti_l(buffer(:buff_len),width))
	else
	 i=get_terminal_characteristics('SYS$INPUT',term_char)
	 if (.not.i) term_width=132
	 width=term_width	! default to screen width for the heck of it
	end if

	! just want a listng of the verbs?
	list=cli$present('list')

	! use file or actual process mapped version?
	if (cli$present('table')) then
	 call error(cli$get_value('Table',buffer,buff_len))
	 call error(clex_use_command_table(buffer(:buff_len)))
	elseif (cli$present('image')) then
	 ! is there an image spec?
	 call error(cli$get_value('Image',buffer,buff_len))
	 call error(cli$get_value('Symbol',symbol,symb_len))
	 call error(lib$find_image_symbol(buffer(:buff_len)
	1				 ,symbol(:symb_len)
	2				 ,tableaddr))
	 call clex_use_image(tableaddr)
	else
	 call clex_use_process_table
	end if


	! is output going to a file?
	if (cli$present('output')) then
	 call cli$get_value('output',buffer,buff_len)
	 openfile=.true. ! wait till we've found a verb before opening file
	 call clex_init_output(output,width)
	 out=.true.
	else
	 call clex_init_output(lib$put_output,width)
	end if

	anyfound=.false.

	! they want all the verbs?
	if (cli$present('all')) then
	 verb='*'
	 verb_len=1
	 goto 15
	end if

	! get the next verb down the line
10	i=cli$get_value('Verb',verb,verb_len)	
	if (.not.i) then
	 if (anyfound) then
	  call exit
	 else
	  call exit(cli$_entnf)
	 end if
	end if

	call str$upcase(verb(:verb_len),verb(:verb_len))
15	j=0

	! locate the little bugger
	found = .false.
20	i=clex_find_verb(verb(:verb_len),j,cmd_block)
	if (.not.i) then
	 if (found) then
	  goto 10
	 else
	  call lib$signal(%val(cli$_entnf-4))
	  goto 10
	 end if
	end if
	anyfound=.true.
	found=.true.
	if (openfile) then ! we need to open the output file
	 if (buff_len.eq.0)
	1  call clex_get_verb_name(%val(cmd_block),buffer,buff_len)
	 open(file=buffer(:buff_len),err=30,unit=1,status='new'
	1	,defaultfile='.CLD',carriagecontrol='list')
	 openfile=.false.
	end if

	! get ready to output the verb
	if (list) then
	 i=clex_print_verb(%val(cmd_block))
	else
	 call clex_get_verb_name(%val(cmd_block),buffer,buff_len)
	 i=min(width,132)
	 k=i/2-buff_len/2
	 if (k.lt.1) k=1
	 i=max(i-buff_len,0)	! center verb name in middle of comment
	 if (out) then
	  call output
	1	(comment(:k)//buffer(:buff_len)//comment(k+1:i))
	 else
	  call lib$put_output
	1	(comment(:k)//buffer(:buff_len)//comment(k+1:i))
	 end if

	 ! okay, here it is
	 i=clex_print_command(%val(cmd_block))
	end if

	j=j+1	! continue search with next verb
	goto 20

30	end

	subroutine error(i)
	if (.not.i) call exit(i)
	return
	end

	integer function output (a)
	character*(*) a
	output=0
	write(1,'(a)',err=10) a
	output=1
10	return
	end
