$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	ON ERROR THEN GOTO Reset_Terminal
$	IF P1 .NES. "" THEN GOTO 'P1'
$	WRITE SYS$OUTPUT Page,"%CAI-F-NOSUB, No subroutine specified"
$	WAIT 00:00:03
$Purpose:
$	EXIT 1
$!
$Menu:
$	@SYS$INSTRUCTION:Head_Page "The VAX/VMS DELETE Command"
$	RUN SYS$INSTRUCTION:DISPLAY

You may choose:

		[1mI[mntro	   -  Introduction to the DELETE Command
		[1mQ[mualifiers -  DELETE qualifiers
		[1mF[minal	   -  Final exam
		[1m*[m	   -  All of the above
		[1mE[mxit	   -  Exit this menu
$	Do_it_all == "I!Q!F"
$		EXIT 1
$Select:
$	Test:==F
$	Result:==OK
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT 1
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF ZTmp   .EQS. "Q"  THEN GOTO Do_Qualifiers
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT 1
$!______________
$Final_Exam:
$	@SYS$INSTRUCTION:Head_Page "The Final Exam"
$	TYPE SYS$INPUT



Now let's see if you remember how to use the DELETE command.

Will the following delete command
$!______________
$	Test:==T
$	Question==""
$	Question_1=="Delete files modified after 1-Jan-1982"
$	Example_1=="DEL /SINCE=1-JAN-1982 FOO.TXT;*"
$	Answer_1=="N"
$	Reason_1=="To DELETE modified files must also include /MODIFIED."
$	Question_2=="DELETE all text files on a directory"
$	Example_2=="DEL *.TXT"
$	Answer_2=="N"
$	Reason_2=="An explicit version number is always required."
$	Question_3=="DELETE all FORTRAN source files created today"
$	Example_3=="DEL/CREATED/SINCE=TODAY *.FOR;*"
$	Answer_3=="Y"
$	Reason_3=="TODAY is also a valid date string."
$	Question_4=="Prompt for each file to delete"
$	Example_4=="DEL/CONFIRM *.TXT;*"
$	Answer_4=="Y"
$	Reason_4=="VMS will prompt to confirm the deletion of each file."
$	Question_5=="Recover a deleted file"
$	Example_5=="DEL/RECOVER *.TXT;*"
$	Answer_5=="N"
$	Reason_5=="Once a file is deleted it is "+Inverse+"GONE FOR GOOD"+No_Attr+"."
$!	Question_6=="Delete a file across the network"
$!	Example_6=="DEL FUSION::[7,250]VECTOR.TXT;*"
$!	Answer_6=="N"
$!	Reason_6=="To delete files on a remote node requires an account and password string"
$!	Nmax==6
$	Nmax==5
$	EXIT 1
$Do_Introduction:
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J		  [7mIntroduction to the VMS DELete Command[m

The VMS DELete command is used to delete files from your directory.  The command
may be abbreviated as "DEL".  It has the following syntax:

	$ DEL/qualif1..../qualifN filespec1,filespec2.....,filespecN

where the file  specifiers can  include wild cards (* or %) for directory, name,
type, or version (* only).  The  qualifiers  are  used  for  producing selective
directory formatting, or extended informational display.  One or more qualifiers
may be present  but none are required.  The DELete command will produce an error
message if you do  not explicitly  state  the  version number of  the file to be
deleted. This is done as a safety precaution. You either MUST specify a specific
version number or a wild card (*) version number.

The first  file specification  must contain  an  explicit  or  default directory
specification plus a file name,  a file type,  and a  version number. Subsequent
file specifications must contain at least a version number. A semicolon followed
by no file version number, a version number of 0, or one or more blanks, results
in the deletion of the latest version of the file.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JThe DELete  command  assumes  certain defaults  if partial  file specifiers  are
present:

	-  If no device is present, it defaults to your current device.

	-  If no  directory is specified, it  defaults to  your current
	   directory.

	-  If  multiple  file specifiers  are present,  file specifiers
	   after  the first  default to the  file name and file type of
	   the first file specified.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JNow let us observe the effects of certain DELETE commands.
$	CALL Do_Command -
		"You are warned if the file is not found." -
		"DEL DELXXXXX1.TXT;1" "" N
$!
$	CREATE DELXXXXX1.TXT
$	CALL Do_Command -
		"To DELete a file, you must supply an explicit version number." -
		"DEL DELXXXXX1.TXT" "" N
$!
$	CALL Do_Command -
		"If the file exists, and version number is supplied, the file is deleted." -
		"DELETE DELXXXXX1.TXT;*" "DIR DELXXXXX1.TXT" N
$!
$	CREATE DELXXXXX1.TXT
$	CREATE DELXXXXX1.TXT
$	CALL Do_Command -
		"The second file uses the name and type of the first file." -
		"DELETE DELXXXXX1.TXT;1,;2" "" N
$!
$	CALL Do_Command -
		"Multiple files must be separated with commas or + signs." -
		"DEL DELXXXXX1.TXT;1 DELXXXXX1.TXT;2" "" N
$!
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J[7HRemember, once a file is deleted it is [7mGONE FOR GOOD[m. For general use, the PURGE
command  can  be used  to delete  old versions of files, always keeping the most
most recent ones.  Be very careful  when using wildcards as part of file.  It is
very easy to wipe out all your work.

If you do do this,  contact the System Manager,  who may be able to recover some
or all of your files from the daily or weekly backup tapes.
!
@[23HPress [7mRETURN[m to continue...
$	EXIT 1
$!
$Do_Qualifiers:
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JA number  of  qualifiers  may  be  used  to  control the  deletion of files.  In
addition to selecting  files for deletion  based  on file name, type or version,
files may be  selected for deletion based on the dates when they were created or
modified. The qualifiers:

               /CREATED          and          /MODIFIED

select whether or not  file deletion based on creation date or modification date
is to be used.  If either /CREATED or /MODIFIED is used, it is also necessary to
specify the range of dates to delete using either or both of /BEFORE or /SINCE.

Both /BEFORE and /SINCE require a valid date string.  The syntax is:

	          /BEFORE=date_string
	          /SINCE=date_string

where date_string is governed  by the rules for  forming a VMS time/date string.
You can specify an absolute or delta time or a combination of the two.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JDetailed information on forming valid  date_strings can be found in Section 2.5
of the "DCL Concepts Manual", or by typing HELP SPECIFY DATE_TIME from DCL.  In
its simplest format a date string is:

			dd-mmm-yyyy

where		dd    -  Day of Month
		mmm   -  Month of year (Jan, Feb,....Dec)
		yyyy  -  Year (1986, 1987, etc)

So to delete all files created  after August 12 1986, one would use a command of
the form:

	$ DELETE /CREATED/SINCE=12-AUG-1986 *.*;*
!
@[23HPress [7mRETURN[m to continue...
!
[H[JAnother  useful  qualifier  is  /CONFIRM.  When  you use the /CONFIRM qualifier,
DELETE will name each file it is about to delete, and ask you whether it should
really go.  The question takes the form:

	dev:[dir]name.type;version, delete? [N]

You can answer one of:

	Yes	if you want to delete the file.
	No	if you want to keep it.  This is the default if you just press
		RETURN.
	All	if you want to delete this file, and all succeeding ones given
		in the DELete command line, without further confirmation.
	Quit	if you  do not want to delete this  file or any  others in the
		DELete command line.

Also, the /LOG qualifier displays the file specifier for each file after it is
deleted.

/NOCONFIRM and /NOLOG are also valid qualifiers, and are DELete's defaults.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JNow let us observe the effects of certain DELETE qualifiers.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	CREATE DELXXXXX1.TXT
$	CREATE DELXXXXX1.TXT
$	CALL Do_Command -
		"Display all files deleted to SYS$OUTPUT." -
		"DELETE/LOG DELXXXXX1.TXT;*" "" N
$!
$	CREATE DELXXXXX1.TXT
$	CREATE DELXXXXX2.TXT
$	CREATE DELXXXXX3.TXT
$	CALL Do_Command -
		"Please specify Y/N/A/Q for each file." -
		"DELETE/CONFIRM DELXXXXX*.TXT;*" "" N
$!
$	CREATE DELXXXXX1.TXT
$	CREATE DELXXXXX2.TXT
$	CREATE DELXXXXX3.TXT
$	Today=F$CVTIME(,"ABSOLUTE","DATE")
$	CALL Do_Command -
		"Delete the named files created since ''Today'." -
		"DIR/CREATED/SINCE=''Today' DELXXXXX%.TXT;*" -
		"DELETE/LOG/CREATED/SINCE=''Today' DELXXXXX%.TXT;*" Y
$	EXIT 1
$!
$Reset_Terminal:
$	IF F$SEARCH("DELXXXXX%.TXT").NES."" THEN DELETE DELXXXXX%.TXT;*
$	WRITE SYS$OUTPUT No_scroll,Smooth
$	EXIT 1
$!
$Do_command: SUBROUTINE ! text command1 [command2]
$	ON CONTROL_Y THEN EXIT 4
$	IF Ttype.EQS."VT52" THEN WAIT 00:00:03
$	Sh_Scroll=""
$	IF Ttype.EQS."VT52" .AND. P4 THEN Sh_Scroll="			    [Press SHIFT/SCROLL if screen fills]
$	WRITE SYS$OUTPUT EraseL05,P1
$	IF P3.EQS."" THEN WRITE SYS$OUTPUT EraseL08,Erasel07,"Execute the command:  ",Inverse,P2,No_Attr
$	IF P3.NES."" THEN WRITE SYS$OUTPUT Erasel07,"Execute the commands:	",Inverse,P2,No_Attr
$	IF P3.NES."" THEN WRITE SYS$OUTPUT Erasel08,"			",Inverse,P3,No_Attr
$	WRITE SYS$OUTPUT EraseL11,"====================",Sh_scroll
$	WRITE SYS$OUTPUT Scroll,EraseL12,Erase_rest,Smooth,"$ ",P2
$	ON ERROR THEN CONTINUE
$	DEFINE/USER SYS$INPUT SYS$COMMAND
$	'P2'
$	IF P3.EQS."" THEN GOTO No_command_2
$	WRITE SYS$OUTPUT "$ ",P3
$	DEFINE/USER SYS$INPUT SYS$COMMAND
$	'P3'
$No_command_2:
$	WRITE SYS$OUTPUT No_Scroll,EraseL22,Erase_rest
$	INQUIRE/NOPUN TMP "Press ''Inverse'RETURN''No_Attr' to continue..."
$	WRITE SYS$OUTPUT EraseL23,Jump
$	EXIT 1
$ ENDSUBROUTINE
