$	ON CONTROL_Y THEN GOTO Reset_terminal
$	ON ERROR THEN GOTO Reset_terminal
$	IF P1 .NES. "" THEN GOTO 'P1'
$	WRITE SYS$OUTPUT Page,"%CAI-E-NOSUB, No subroutine specified"
$	WAIT 00:00:03
$Purpose:
$	EXIT 1
$!
$Menu:
$	@SYS$INSTRUCTION:Head_Page "The VAX/VMS PURGE Command"
$	RUN SYS$INSTRUCTION:DISPLAY

You may choose:

		[1mI[mntro	   -  The PURGE Command
		[1mQ[mualifiers -  The PURGE qualifiers
		[1mF[minal	   -  Final exam
		[1m*[m	   -  All the above
		[1mE[mxit	   -  Exit this menu
$	Do_it_all == "I!Q!F"
$	EXIT 1
$Select:
$	Test:==F
$	Result:==OK
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT 1
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF ZTmp   .EQS. "Q"  THEN GOTO Do_Qualifiers
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT 1
$!______________
$Final_Exam:
$	@SYS$INSTRUCTION:Head_Page "The Final Exam"
$	TYPE SYS$INPUT



Now let's see if you remember how to use the PURGE command.

Will the following PURGE command
$!______________
$	Test:==T
$	Question==""
$	Question_1=="purge all but the most recent version of FOOBAR.FOO"
$	Example_1=="PUR FOOBAR.FOO;11"
$	Answer_1=="N"
$	Reason_1=="Explicit version numbers are not allowed."
$	Question_2=="prompt for files to purge"
$	Example_2=="PURGE"
$	Answer_2=="N"
$	Reason_2=="PUrge without a file specifier purges "+U_Line+"ALL"+No_Attr+ -
			" files in your directory!!"
$	Question_3=="purge all files with the prefix FOO"
$	Example_3=="PUR FOO*.*"
$	Answer_3=="Y"
$	Reason_3=="Wild cards are allowed in file specifiers."
$	Question_4=="log deleted files to a file"
$	Example_4=="PUR/LOG=LOGFILE.TXT *.*"
$	Answer_4=="N"
$	Reason_4=="Purged files can only be listed to the current SYS$OUTPUT."
$	Question_5=="Recover a purged file"
$	Example_5=="PUR/RECOVER FOO.TXT"
$	Answer_5=="N"
$	Reason_5=="Once a file is deleted is is "+U_Line+"GONE FOR GOOD"+No_Attr+"."
$!	Question_6=="Purge files across the network"
$!	Example_6=="PUR SIRA::[7,250]VECTOR.TXT"
$!	Answer_6=="N"
$!	Reason_6=="To purge files on a remote node requires an account and password string"
$!	Nmax==6
$	Nmax==5
$	EXIT 1
$Do_Introduction:
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J		  [7mIntroduction to the VMS PUrge Command[m

Every time you edit a file, compile a program, or link a task, a new output file
with a  version number one higher  than the previous version number is  created.
This creation of new  files will continue until  either all available disk space
is used up,  or VMS disk  accounting refuses to let you use more disk space.  So
that you have adequate available disk space to do your work,  it is important to
periodically remove old, obsolete, and unneeded files from your directory.

The VMS  PUrge command is  used to  delete obsolete  versions of files from your
directory.  The command  may be abbreviated to "PU".  Once a file is purged from
your directory,  it is gone for  good.  However,  the purge  command  will never
delete the  most recent  version of  a file.  If your  most recent  versions are
valid, using  the PUrge command rather than the  DELete command  protects  these
files against accidental deletion.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JThe PUrge command has the following syntax:

	$ PUR/qualif1..../qualifN filespec1,filespec2.....,filespecN

where the  file specifiers can include  wild cards (% or *) for directory, name,
or type.  Qualifiers  are used  to specify  further file  selections,  produce a
listing of purged files,  set the number of files to keep, or make the deletions
user-selective.

If more than one file is specified,  the file  specifiers must be separated with
commas "," or plus signs "+". If no file specification is given ALL files in the
current default directory are purged.

The PUrge command does not provide file name or file type defaults to use if the
file name or type is omitted.  Version numbers are not allowed. 
!
@[23HPress [7mRETURN[m to continue...
!
[H[JNow let us observe the effects of using the PUrge command.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	CALL Do_Command -
		"You are warned if a file is not found." -
		"PUR PURXXXXX1.TXT"
$!
$	CALL Do_command -
		"Explicit version numbers are not allowed." -
		"PUR PURXXXXX1.TXT;1"
$!
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CALL Do_Command -
		"Here we have many versions of the file PURXXXXX1.TXT" -
		"DIR PURXXXXX1.TXT"
$!
$	CALL Do_command -
		"Delete all but the most recent version of the file." -
		"PUR PURXXXXX1.TXT" -
		"DIR PURXXXXX1.TXT"
$!
$	CALL Do_command -
		"Multiple files must be separated with commas or + signs." -
		"PUR PURXXXXX1.TXT PURXXXXX2.TXT"
$!
$	DELETE PURXXXXX*.TXT;*
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J[11;10HRemember, once a file is purged, it is [7mGONE FOR GOOD.[m
!
@[23HPress [7mRETURN[m to continue...
$	Test:==F
$	EXIT 1
$Do_Qualifiers:
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J			[7mPURGE Command Qualifiers[m

Two of  the qualifiers  for the PUrge  command are  /KEEP and /LOG (/NOLOG). The
/KEEP qualifier controls  how many versions of a file to retain.  By default, if
it is not specified, the PUrge  command retains ONLY the most  recent version of
a file. However, if /KEEP=n is used as a qualifier to the PUrge command, the "n"
most recent versions of a file will be kept.

By default,  when files are deleted with the PUrge command,  no  notification is
given as to which  files have  been purged.  If you wish to see which files have
been deleted,  use the  /LOG qualifier.  The /LOG qualifier  will cause the file
specifications  of  each  file  to  be  displayed  as the files are deleted.  By
default, the PUrge command assumes /NOLOG.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JAnother useful qualifier is /CONFIRM. When you use the /CONFIRM qualifier, PURGE
will name each file it is about to delete,  and ask you whether it should really
go.  The question takes the form:

	dev:[dir]name.type;version, delete? [N]

You can answer one of:

	Yes	if you want to delete the file.
	No	if you want to keep it.  This is the default if you just press
		RETURN.
	All	if you want to delete this file, and all succeeding ones given
		in the PUrge command line, without further confirmation.
	Quit	if you  do not want to delete this  file or any  others in the
		PUrge command line.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JNow let us observe the effects of PUrge qualifiers.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CALL Do_command -
		"Display all files purged to SYS$OUTPUT." -
		"PURGE/LOG PURXXXXX1.TXT"
$!
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CALL Do_command -
		"Keep the most recent three versions of a file." -
		"PUR/KEEP=3 PURXXXXX1.TXT" -
		"DIR PURXXXXX1.TXT"
$!
$	CALL Do_command -
		"Purge all but the most recent version." -
		"PUR PURXXXXX1.TXT" -
		"DIR PURXXXXX1.TXT"
$!
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CALL Do_command -
		"Purge selectively. Answer questions: Yes, No, All, or Quit." -
		"PURGE/CONFIRM/LOG PURXXXXX1.TXT"
$!
$	DELETE PURXXXXX1.TXT;*
$	EXIT 1
$!
$Reset_Terminal:
$	IF F$SEARCH("PURXXXXX%.TXT").NES."" THEN DELETE PURXXXXX%.TXT;*
$	WRITE SYS$OUTPUT Noscroll,Jump
$	EXIT 1
$!
$Do_command: SUBROUTINE ! text command1 [command2]
$	ON CONTROL_Y THEN EXIT 4
$	IF Ttype.EQS."VT52" THEN WAIT 00:00:03
$	WRITE SYS$OUTPUT EraseL05,P1
$	IF P3.EQS."" THEN WRITE SYS$OUTPUT EraseL08,Erasel07,"Execute the command: ",Inverse,P2,No_Attr
$	IF P3.NES."" THEN WRITE SYS$OUTPUT Erasel07,"Execute the commands: ",Inverse,P2,No_Attr,-
					   Erasel08,"		      ",Inverse,P3,No_Attr
$	WRITE SYS$OUTPUT EraseL11,"===================="
$	WRITE SYS$OUTPUT Scroll,EraseL12,Erase_rest,Smooth,"$ ",P2
$	ON ERROR THEN CONTINUE
$	DEFINE/USER SYS$INPUT SYS$COMMAND
$	'P2'
$	IF P3.EQS."" THEN GOTO No_command_2
$	WRITE SYS$OUTPUT EraseL13,"$ ",P3
$	DEFINE/USER SYS$INPUT SYS$COMMAND
$	'P3'
$No_command_2:
$	WRITE SYS$OUTPUT No_Scroll,EraseL22,Erase_rest
$	INQUIRE/NOPUN TMP "Press ''Inverse'RETURN''No_Attr' to continue..."
$	WRITE SYS$OUTPUT EraseL23,Jump
$	EXIT 1
$ ENDSUBROUTINE
