$    SAVE_IMAGE_VERIFY = F$ENVIRONMENT("VERIFY_IMAGE")
$    SAVE_PROC_VERIFY = F$VERIFY(0,0)
$!   SET VERIFY
$
$   !	DRAWTREE.COM	Draws a directory tree
$   !
$   !	written by DMWalp	on March 7th, 1982
$   !
$   !	Parameters:  P1 - The disk directory sepcification ( will prompt if
$   !			    missing ).  Directory must not sub-level.
$   !		     P2 - Output ( default is SYS$OUTPUT, no prompting )
$   !
$   !	Modified by Chris Doran, Sira 1st October 1985
$   !		Allow it to work on a terminal without line-drawing set
$   !		  (assumed if output is to file).
$   !		Generalise escape sequences at startup, and define them for
$   !		  HP2648a (and probably other HP terminals). Type FT1 = 16
$   !		  on our system.
$   !		Use F$EDIT to do lower-case conversion. Much faster than
$   !		  looking at each character indivdually, and easy to put
$   !		  it in twice instead of a "subroutine" call.
$   !
$   !   24-Dec-86 CJD
$   !		Add modifications from B Z Lederman's version, [VAX86A.BZL]:-
$   !		  Recognise LA38, LA12, LA100, and LN03 printers as ANSI
$   !		  Prevent endless loop on ddcn:[000000]
$   !
$   !	21-Dec-87 CJD
$   !		Recognise types 181 and 246 as HP2648a
$   ON CONTROL_Y THEN GOTO EXIT
$   SET NOON
$
$   root = P1
$   GOTO prompt_Directory
$Bad_Directory:

$   WRITE SYS$OUTPUT "
",-
"DRAWTREE -- The directory ",Root," does not exist or the format of
",-
"            the directory string is invalid.  Enter directory strings
",-
"            as [dir_name].
"
$   Root=""
$ prompt_directory:
$   IF root .EQS. "" THEN INQUIRE root "Root Directory"
$ past_prompt:
$   IF root .EQS. "" THEN GOTO EXIT
$
$   !	test if the directory exists
$   !
$   parse_root = F$PARSE ( root + "*.*;*" )
$   IF parse_root .EQS. ""              THEN GOTO Bad_directory
$   IF F$SEARCH ( parse_root ) .EQS. "" THEN GOTO Bad_Directory
$
$   !	extract the disk and directory fields
$   !
$   disk	= F$PARSE ( parse_root, , , "DEVICE" )
$   dir_root	= F$PARSE ( parse_root, , , "DIRECTORY" )
$
$   !	test it is not a sub-directory
$   !	strip delimiters
$   !
$   IF F$LOCATE ( ".", dir_root ) .NES. F$LENGTH ( dir_root ) -
	THEN GOTO prompt_directory
$   dir_root = dir_root - "<" - "[" - ">" - "]"
$
$   !	Set up the output file, especially escape sequences for various terminals.
$   !
$   output_file = P2
$   IF output_file .EQS. "" THEN output_file = "SYS$OUTPUT"
$   output_device = F$PARSE ( output_file, "DEVICE" )
$   v_bar = "|"
$   st_box = ""
$   en_box = ""
$   st_line = ""
$   en_line = ""
$   left_t = "+"
$   top_t = "+"
$   lo_left = "`"
$   dash = "-"
$   setup = ""
$   IF F$GETDVI ( output_device, "DEVCLASS" ) .NE. 66 THEN GOTO device_ok
$   IF F$GETDVI( output_device, "TT_ANSICRT") THEN GOTO ansi
$!
$! Check for a series of compatible device types: any device with the	! BZL
$! VT100 line drawing character set is acceptable. Acceptable devices	! BZL
$! will either have reverse video or will ignore it (such as LA100 and	! BZL
$! LN03 printers)							! BZL
$!
$   term = F$GETDVI ( output_device, "DEVTYPE"  )			! BZL
$   IF term .EQ. 35 .OR.-			! LA38 (probably o.k.)	! BZL
       term .EQ. 36 .OR.-			! LA12			! BZL
       term .EQ. 37 .OR.-			! LA100			! BZL
       term .EQ. 40 .OR.-			! LA210			! CJD
       term .EQ. 41 THEN GOTO device_ok		! LN03			! BZL
$   IF term .NE. 16 .AND.-
       term .NE. 246 .AND.-
       term .NE. 181 THEN GOTO device_ok	! HP2648a		! CJD
$! HP 2648a with line-drawing set
$   v_bar = "."
$   st_box = "&dF"
$   en_box = "&d@"
$   st_line = ""
$   en_line = ""
$   left_t = "5"
$   top_t = "7"
$   lo_left = "F"
$   dash = ","
$   setup = ")B"				! Line-drawing set is set B
$   GOTO device_ok
$ansi:
$   v_bar = "x"
$   st_box = "[4;7m"
$   en_box = "[m"
$   st_line = ""
$   en_line = ""
$   left_t = "t"
$   top_t = "w"
$   lo_left = "m"
$   dash = "q"
$   setup = ")0"
$   GOTO device_ok
$
$ device_ok:
$   ON CONTROL_Y THEN GOTO abort
$   OPEN/WRITE output 'output_file'
$
$   WRITE output setup		! into graphics mode
$
$   !	initialize things
$   !
$   pad_chars	= dash+dash+dash+dash+dash+dash+dash+dash+dash	! graphic dash
$   line_0      = ""
$   level	= 1
$   entry_1     = dir_root
$   entry_length = F$LENGTH ( entry_'level' )
$   entry_'level'= F$EXTRACT(0,1,entry_'level') + -
	F$EDIT(F$EXTRACT(1,entry_length-1,entry_'level'),"LOWERCASE")
$   level_1_dir = dir_root
$   line_1	= en_line + st_box + entry_1 + en_box + en_box + st_line
$
$ push:
$   !	push down a level
$   !
$   old_level = level
$   level     = level + 1
$   parsed_spec_'level' = F$PARSE ( "*.DIR", disk, -
				     "<" + level_'old_level'_dir + ">")
$ no_zero:								! BZL
$   next_entry_'level'	= F$SEARCH ( parsed_spec_'level', level )
$!
$! Prevent endless loop on ddun:[000000] but still get entire device	! BZL
$!
$ ax = f$locate( "<", next_entry_'level') + 1	! start of directory	! BZL
$ as = f$extract( ax, 6, next_entry_'level')	! extract first direc.	! BZL
$ if as .nes. "000000" then goto ok_go		! if not root, no problem BZL
$ ax = f$locate( ">", next_entry_'level') + 1	! end of directory	! BZL
$ as = f$extract( ax, 6, next_entry_'level')	! extract last direct.	! BZL
$ if as .nes. "000000" then goto ok_go		! if not root, no problem BZL
$!
$! repeat parsing the root directory until we find the first directory	! BZL
$! which is not 000000.  This is where the tree really starts.		! BZL
$!
$ goto no_zero
$!
$ ok_go:
$
$   ! if search fails no more levels
$   !
$   IF next_entry_'level' .NES. "" THEN GOTO more_levels
$   WRITE output st_line+line_'old_level'
$   GOTO pop
$
$ more_levels:
$   !	mark this as the first entry and not the last entry
$   !
$   last_'level' = 0
$   first_'level' = 1
$
$ list_loop:
$   !	for each each sub-directory
$   !	test if this entry is the last in the list
$   !	make the entry the file name field
$   !	Capitalize and lower case entry name
$   !
$   entry_'level' = next_entry_'level'
$   next_entry_'level'	= F$SEARCH ( parsed_spec_'level', level )
$   IF next_entry_'level' .EQS. "" THEN last_'level' = 1
$   entry_'level' = F$PARSE ( entry_'level', , , "NAME" )
$   entry_length = F$LENGTH ( entry_'level' )
$   entry_'level'= F$EXTRACT(0,1,entry_'level') + -
	F$EDIT(F$EXTRACT(1,entry_length-1,entry_'level'),"LOWERCASE")
$
$   !	fiqure out the attaching character
$   !		  | not first |	  first
$   !	----------+-----------+----------
$   !	 not last | right "T" | down "T"
$   !	----------+-----------+----------
$   !	   last	  | right "L" |	  dash
$   !
$					     end_pad = left_t
$   IF first_'level'			THEN end_pad = top_t
$   IF			   last_'level' THEN end_pad = lo_left
$   IF first_'level' .AND. last_'level' THEN end_pad = dash
$
$   !	append dashes, attach character and new entry to line
$   !
$   line_'level' = line_'old_level' + -
		   F$EXTRACT ( F$LENGTH ( entry_'old_level' ), -
			       9, -
			       pad_chars ) + -
		   end_pad + -
		   en_line + st_box + entry_'level' + en_box + st_line
$
$   !	blank out the entry and may be add place vertical bar connector
$   !
$   entry_'old_level' = "         " + v_bar
$   IF last_'level' THEN entry_'old_level' = "          "
$
$   !	fix up the lower level output line
$   !
$   old_old_level = old_level - 1
$   line_'old_level' = line_'old_old_level' + entry_'old_level'
$
$   !	calculate the directory specification for the next level
$   !
$   level_'level'_dir = level_'old_level'_dir + "." + entry_'level'
$   GOTO push
$ pop:
$
$   ! restore parameters
$   !
$   level = old_level
$   old_level = old_level - 1
$   old_old_level = old_level - 1
$
$   IF level .EQ. 1 THEN GOTO clean_up	! initial level all done
$   first_'level' = 0			! mark end of first entry
$   entry_'old_level' = "         "	! blank out the entry
$   line_'old_level' = line_'old_old_level' + entry_'old_level'
$   IF last_'level' THEN GOTO pop	! done with this level
$   GOTO list_loop		  	! for each sub-directory loop 
$
$ abort:
$   WRITE output en_box
$ clean_up:
$   WRITE output en_line
$   CLOSE output
$EXIT:	SAVE_PROC_VERIFY = F$VERIFY(SAVE_PROC_VERIFY,SAVE_IMAGE_VERIFY)
