$	IF F$MODE() .EQS. "BATCH" THEN EXIT
$!				OPERATOR.COM
$!	   It is desirable to have a variety of operator functions which can
$!	be performed by a variety of people who do not necessarily understand
$!	all the details of the operations being performed.  The operator's
$!	account is viewed as essentially a "slave" account which provides a
$!	menu of functions for managing the system which when invoked will
$!	perform exactly the same way each and every time.  Moreover log
$!	records will be kept in the operators log of each function being
$!	done.  Together with the console listing, recovery from a disasterous
$! 	error (or clobbering of miscreant) should be easier.
$!
$!	The OPERATOR account must be set up as:
$!
$!	ADD OPERATOR/UIC=[1,5]/NOPASSWORD/DEVICE=SYS$SYSROOT -
$!	/DIRECTORY=[OPERATOR]/OWNER="OPERATOR"/ACCOUNT=DEPT41 -
$!	/LGICMD=OPERATOR/FLAGS=(CAPTIVE,LOCKPWD) -
$!	/DEFPRIV=(NETMBX,OPER,TMPMBX)
$!	/PRIV=(CMKRNL,EXQUOTA,GRPNAM,LOG_IO,NETMBX,OPER,READALL,SHARE,-
$!		SYSNAM,SYSPRV,TMPMBX,VOLPRO,WORLD)
$!	This file will allocate privileges from the above list as and when,
$!	and only while, they are needed.
$	SET NOON
$	ON CONTROL_Y THEN GOTO All_Done
$	@SYS$COMFILE:CLS
$	Next_set_logins = 0
$	NOTSYSTEM = F$GETJPI("","USERNAME").NES."SYSTEM      "	! SYSTEM debugging
$	IF F$SEARCH("OPERATOR.LOG") .EQS. "" .OR. -
		F$EXTRACT(0,11,F$FILE_ATTRIBUTES("OPERATOR.LOG","CDT")) -
			.NES. F$EXTRACT(0,11,F$TIME()) -
		THEN CREATE OPERATOR.LOG
$	OPEN/APPEND OUTPUT OPERATOR.LOG
$	WRITE OUTPUT F$TIME(),": OPERATOR logged in"
$	IF (.NOT.NOTSYSTEM) .OR. F$GETDVI("SYS$COMMAND","DEVNAM").EQS."_OPA0:" -
		THEN GOTO Enter_Name 	! Non-SYSTEM operators must use console
$	WRITE SYS$OUTPUT -
"
Operator functions must be run from the console terminal
"
$	GOTO All_done
$!
$Enter_Name:
$	ON CONTROL_Y THEN GOTO All_Done
$	SET CONTROL=Y
$	INQUIRE Last_Name -
"OPERATOR V2.5d active.
Enter your username [CR to log out, n to reply to completed request]"
$	IF Last_name .EQS. ""  THEN GOTO All_Done
$	IF F$TYPE(Last_name).NES."INTEGER" THEN GOTO Check_name
$! Entering a number allows anyone to just REPLY to a request without
$! needing to log in. Hopefully, they can be trusted to do that(?).
$	WRITE OUTPUT F$TIME(),": Anon REPLY/TO=",Last_name
$	WRITE OUTPUT F$FAO("!80*-")
$	REPLY/TO='Last_name'
$	GOTO Enter_Name
$! Verify that the last name is one of the names in the authorization file
$! for using the operator account.
$Check_Name:
$	IF F$SEARCH("OPERATORS.DAT") .EQS. "" THEN -	! See if list exists
		GOTO No_Operator_File			! Warn of error
$	SET NOCONTROL=Y					! No aborts now
$	OPEN/READ/ERROR=Read_Error INFILE OPERATORS.DAT	! See if user is OK
$Check_Loop:
$	READ/END_OF_FILE=EOF INFILE Op_rec
$	IF Last_name .NES. F$ELEMENT(0," ",Op_rec) THEN GOTO Check_Loop	! Try another name
$	CLOSE INFILE					! Found user
$	SET TERM/NOECHO
$	READ/PROMPT="Password:" SYS$COMMAND P1		! READs aren't RECALLable, INQUIREs are
$	WRITE SYS$OUTPUT "Verifying password ..."
$	SET TERM/ECHO
$	SET MESSAGE/NOTEXT/NOSEVERITY/NOIDENT/NOFACILITY
$!*	@SYS$COMFILE:CHKPASWRD/OUTPUT=NL: 'Last_Name' 'P1'
$	TMP=$SEVERITY
$	TMP=1
$	IF TMP .EQ. 1 THEN GOTO Operator_OK
$	GOTO EOF					! Password not ok
$!
$Operator_OK:
$	SET MESSAGE/TEXT/SEVERITY/IDENT/FACILITY
$	WRITE SYS$OUTPUT "Password accepted ..." 
$	ON CONTROL_Y THEN GOTO All_Done
$	SET CONTROL=Y
$	WRITE OUTPUT F$TIME(),": ''Last_name' accessed operator account"
$	TIMEOUT := /TIMEOUT=255/ERROR=Timed_out
$	IF Last_Name .EQS. "SYSTEM" THEN TIMEOUT = ""
$!
$Menu:
$	SET MESSAGE/NOSEVERITY/NOFACILITY/NOTEXT/NOIDENT! Disable msg on ^O
$	LE="!"
$	LD=""
$	IF Next_set_logins .EQ. 0 THEN GOTO LDIS
$	LE=""
$	LD="!"
$LDIS:	RUN SYS$INSTRUCTION:DISPLAY
[H[J		You may perform the following operator functions:

	Abort		-  Abort a process
	Backup		-  Perform a backup of the system disk
	CHeck		-  Check a tape or disk
	DElete		-  Delete job from queue
	DIsmount	-  Dismount device from whoever is using it
	End		-  End operator session
	Form		-  Stop/restart queue to change printer form
'LE'	Logins		-  Enable logins
'LD'	Logins		-  Disable logins
	Message 	-  Send a message to users
	Own		-  Change file ownership
	SHUtdown	-  Shut down the system
	STop/start	-  Stop and restart queue
	n		-  REPLY/TO=n

The following DCL commands are also allowed:
	BROadcast	CALc	CPU	DATe	DEVices	DIRectory	DSL
	DSM	DSU	DSY	ERRor	FRAg	FREe	HELp	HOLd	MAIl
	MONitor	NOHold	OLD	PHone	PRInt	PLOt	PROtect	REPly	SEarch
	SHB	SHL	SHOw	SHQ	SHW	TIMe	UNLock	WHO

Enter at least the upper-case part of command or menu item to select.

$	SET MESSAGE/SEVERITY/FACILITY/TEXT/IDENT	! Enable messages
$Menu_1:
$	READ/END=End_session'TIMEOUT'/PROMPT=-
	"Enter operator function or command [? for menu]: " SYS$COMMAND Function
$	IF Function.EQS."" THEN GOTO Menu_1
$	IF F$TYPE(Function).EQS."INTEGER" THEN Function := REPLY/TO='Function'
$	P4 = F$EDIT(Function,"COMPRESS,TRIM,UNCOMMENT")
$	F3 = F$EDIT(F$EXTRACT(0,3,P4),"UPCASE") 
$	P3 := ,'F3',
$	IF F$LOCATE(P3, -
",CAL,CPU,DAT,DEV,DSM,DSL,DSU,DSY,ERR,FRA,FRE,HEL,HOL,MAI,MON,NOH,SHB,SHL,SHO,SHQ,SHW,TIM,WHO,") -
	.NE. 93 THEN GOTO Do_it_quietly
$	IF F$LOCATE(P3,",PRI,PLO,PRO,REP,OLD,UNL,DIR,BRO,") .NE. 33 THEN GOTO Do_it
$	F2 = F$EXTRACT(0,2,F3)
$	F1 = F$EXTRACT(0,1,F3)
$	P1 = F$ELEMENT(1," ",P4)
$	P2 = F$ELEMENT(2," ",P4)
$	P3 = F$ELEMENT(3," ",P4)
$	NEGATE := NO
$	IF F1 .EQS. "A"		THEN GOTO Abort_Process
$	IF F1 .EQS. "B"		THEN GOTO Backup
$	IF F2 .EQS. "CH"	THEN GOTO Check_media
$	IF F2 .EQS. "DE"	THEN GOTO Delete_job
$	IF F2 .EQS. "DI"	THEN GOTO Dismount_device
$	IF F1 .EQS. "E"		THEN GOTO End_session
$	IF F1 .EQS. "F"		THEN GOTO Change_Forms
$	IF F1 .EQS. "L"		THEN GOTO Set_Logins
$	IF F1 .EQS. "M"		THEN GOTO Send_Message
$	IF F1 .EQS. "O"		THEN GOTO Change_owner
$	IF F2 .EQS. "PH"	THEN GOTO Do_it_quietly
$	IF F2 .EQS. "SE"	THEN GOTO Do_it_quietly
$	IF F3 .EQS. "SHU"	THEN GOTO Shutdown_system
$	IF F2 .EQS. "ST"	THEN GOTO Stop_start
$	IF F1 .EQS. "?"		THEN GOTO Menu
$	IF Last_name.NES."SYSTEM" THEN GOTO Not_available
$	IF F3 .EQS. "VER"	THEN SET VERIFY=PROCEDURE
$	IF F3 .EQS. "NOV"	THEN SET VERIFY=NOPROCEDURE
$	IF F3 .EQS. "VER" .OR. F3 .EQS. "NOV" THEN GOTO Menu_1
$Not_available:
$	WRITE SYS$OUTPUT -
"
The function or command you selected is not available, try again
"
$	GOTO Menu_1
$!
$Do_it:
$	WRITE OUTPUT F$TIME(),": ",Function
$Do_it_quietly:
$	DEFINE/USER/NOLOG SYS$INPUT SYS$COMMAND
$	'Function'
$	GOTO Menu_1
$!
$Abort_Who:
$	WHO/INTER/SUB/USER/BATCH/NOHEAD/NOTRAIL
$	P1 = ""
$Abort_Process:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Process ID [? to list all]: " SYS$COMMAND P1
$	IF P1 .EQS. "?" THEN GOTO Abort_Who
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT="Log out user? " SYS$COMMAND P2
$	IF P2 THEN NEGATE = ""
$	WRITE OUTPUT F$TIME(),": ABORT/CONF/''NEGATE'LOGOUT ",P1
$	SET PROCESS/PRIV=WORLD
$	DEFINE/USER/NOLOG SYS$INPUT SYS$COMMAND
$	ABORT/CONF/'NEGATE'LOGOUT 'P1'
$	SET PROCESS/PRIV=NOWORLD
$	GOTO Menu_1
$!
$Backup:
$	P1 = F$EDIT(F$EXTRACT(0,1,P1),"UPCASE")
$	IF P1.GTS." " THEN GOTO Ask_Backup_Type
$	TYPE SYS$INPUT

	Several types of disk backup procedures exist:
	 F  Full disk backup of DUA0: (normally performed weekly).
	 I  Incremental backup of all files modified today.
	 Y  Incremental backup of all files modified since yesterday.
dd-mmm-yyyy Incremental backup of files modified since given date
	 A  Starts new accounting file, backs up and deletes old one.
	 E  Starts new error log file, backs up and deletes old one.

	Note: If there is a DAILY.LOG, WEEKLY.LOG, BACKACC.LOG, or BACKERR.LOG
	file in the OPERATOR directory, answering the next question will type
	and delete it instead of doing the backup itself.
$Ask_Backup_Type:
$	P4 = F$EXTRACT(0,1,F$EDIT(P1,"COLLAPSE,UNCOMMENT,UPCASE"))
$	IF F$LOCATE(P4,"IFYEA0123456789").EQ.15 THEN READ/END=Menu_1/PROMPT=-
		"Full, Incremental today, incremental Yesterday, incremental dd-mmm-yyyy,
 Accounting, Error log [F/I/Y/A/E/dd-mmm-yyyy]: " -
		SYS$COMMAND P1
$	P4 = F$EXTRACT(0,1,F$EDIT(P1,"COLLAPSE,UNCOMMENT,UPCASE"))
$	P3 = ""
$	IF P4 .EQS. "Y" .OR. P4 .EQS. "I" .OR. (P4.GE."0" .AND. P4.LE."9") -
			THEN P3 := DAILY
$	IF P4 .EQS. "F" THEN P3 := WEEKLY
$	IF P4 .EQS. "E" THEN P3 := BACKERR
$	IF P4 .EQS. "A" THEN P3 := BACKACC
$	IF F$SEARCH("''P3'.LOG").NES."" THEN GOTO Type_backup_log
$	IF P4 .EQS. "Y" THEN P3 := DAILY/PARAMETERS=YESTERDAY
$	IF P4 .GES. "0" .AND. P4.LES."9" THEN P3 := DAILY/PARAMETERS='P1'
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT="Print log file? " SYS$COMMAND P2
$	IF P2 THEN NEGATE = ""
$	IF .NOT.P2 THEN WRITE SYS$OUTPUT -
"
When batch job completes, select function ""B ''P1'"" again to type log file"
$	WRITE OUTPUT F$TIME(),": SUBMIT/''NEGATE'PRINT ",P3
$	SUBMIT/'NEGATE'PRINT 'P3'
$	GOTO Menu_1
$Type_backup_log:
$	INQUIRE/NOPUNCT P1 "Type ''P3'.LOG? "
$	IF P1 THEN TYPE 'P3'.LOG
$	DELETE 'P3'.LOG;0
$	GOTO Menu_1
$!
$Recheck_media:
$	P1 = ""
$Check_Media:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Device name [MT, DLn, DXn, DYn]: " SYS$COMMAND P1
$	P3 = F$EXTRACT(0,2,F$EDIT(P1,"COLLAPSE,UNCOMMENT,UPCASE"))
$	P4 := TAPE
$	IF P3.EQS."MT" THEN GOTO Check_tape
$	IF P3.EQS."DU" THEN WRITE SYS$OUTPUT "
Can't check DUA0:
"
$	IF P3.EQS."DU" THEN GOTO Recheck_media
$	P4 := DISK
$Check_tape:
$	IF F$SEARCH("''P4'CHECK.LOG").NES."" THEN GOTO Type_check_log
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Print log file? " SYS$COMMAND P2
$	IF P2 THEN NEGATE = ""
$	WRITE OUTPUT F$TIME(),": SUBMIT/''NEGATE'PRINT/PARAMETER=''P1' ",P4,"CHECK"
$	SUBMIT/'NEGATE'PRINT/PARAMETER='P1' 'P4'CHECK
$	IF .NOT.P2 THEN WRITE SYS$OUTPUT -
"
When batch job completes, select function ""CH ''P1'"" again to type log file"
$	GOTO Menu_1
$Type_check_log:
$	INQUIRE/NOPUNCT P1 "Type ''P4'CHECK.LOG? "
$	IF P1 THEN TYPE 'P4'CHECK.LOG
$	DELETE 'P4'CHECK.LOG;0
$	GOTO Menu_1
$!
$Help_forms:
$	TYPE SYS$INPUT
Available forms are:
	DEFAULT		11"x14.5" ruled, 1-part
	11x9_W		11"x9.5" white, 1-part
	12x9_W		12"x9.25" white, 1-part
	LABELS		4"x1 7/16" (102x36mm) 3-wide labels
$!	11x14_2		11"x14.5" ruled, 2-part
$!	11x14_3		11"x14.5" ruled, 3-part
$!	11x14_4		11"x14.5" ruled, 4-part
$!	11x9_W2		11"x9.5" white, 2-part
$	P2 = ""
$	GOTO Change_Forms
$Change_Forms_query:
$	P1 = ""
$Change_Forms:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Printer name [LPA0, LPA1, LJA0]: " SYS$COMMAND P1
$	P1 = F$EDIT(P1,"COLLAPSE,UNCOMMENT,UPCASE")
$	IF P1.EQS."LP" .OR. P1.EQS."LJ" THEN P1 = P1+"A0"
$	IF P1.EQS."LP1" THEN P1 := LPA1
$	IF P1.NES."LPA0" .AND. P1.NES."LPA1" .AND. P1.NES."LJA0" THEN GOTO Change_Forms_query
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT=-
		"New form [CR = DEFAULT, ? for list]: " SYS$COMMAND P2
$	IF P2 .EQS. "?" THEN GOTO Help_forms
$	P4=""
$	P2=F$EXTRACT(0,2,F$EDIT(P2,"COLLAPSE,UNCOMMENT,UPCASE"))
$	P3=F$EXTRACT(0,1,P2)
$	IF P2 .EQS. "" .OR. P3.EQS."D" THEN P4 := DEFAULT
$	IF P3 .EQS. "L" THEN P4 := LABELS
$	IF P2 .EQS. "11" THEN P4 := 12CPI_NW
$	IF P2 .EQS. "12" THEN P4 := A4
$	IF P4.EQS."" THEN GOTO Help_forms
$	WRITE OUTPUT F$TIME(),": STOP/QUEUE/NEXT ",P1
$	STOP/QUEUE/NEXT 'P1'
$	READ/END=No_change/PROMPT=-
		"At end of current print job (if any), change form, then press CR" -
		SYS$COMMAND P3
$	WRITE OUTPUT F$TIME(),": START/QUEUE/FORM=''P4' ",P1
$	START/QUEUE/FORM='P4' 'P1'
$	IF $STATUS THEN GOTO Menu_1
$	START/QUEUE 'P1'
$	GOTO Change_Forms
$No_change:
$	START/QUEUE 'P1'
$	GOTO Menu_1
$!
$Delete_job:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT="Entry number(s): " SYS$COMMAND P1
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Queue name [LPA0, LPA1, LJA0, SYS$BATCH, SYS$PRINT]: " SYS$COMMAND P2
$	P2 = F$EDIT(P2,"COLLAPSE,UNCOMMENT,UPCASE")
$	IF P2.EQS."BATCH" .OR. P2.EQS."PRINT" THEN P2 = "SYS$"+P2
$	IF P2.EQS."LP" .OR. P2.EQS."LJ" THEN P2 = P2+"A0"
$	IF P2.EQS."LP1" THEN P2 := LPA1
$	IF P2.EQS."LPA0" .OR. P2.EQS."LPA1" .OR. P2.EQS."LJA1" .OR. P2.EQS."SYS$BATCH" -
		.OR. P2.EQS."SYS$PRINT" -
		THEN GOTO Queue_right
$	P2=""
$	GOTO Delete_job
$Queue_right:
$	WRITE OUTPUT F$TIME(),": DELETE/QUEUE/ENTRY=(''P1') ",P2
$	DELETE/QUEUE/ENTRY=('P1') 'P2'
$	IF .NOT.$STATUS .OR. (P2.NES."LPA0" .AND. P2.NES."LPA1" .AND. P2.NES."LJA0") THEN GOTO Menu_1
$	DELETE/QUEUE/ENTRY=('P1') SYS$PRINT
$	WRITE SYS$OUTPUT "
Reset printer to top of form
"
$	GOTO Menu_1
$!
$Dismount_device:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Device name [MT, DL, etc.]: " SYS$COMMAND P1
$	P2 = F$EXTRACT(0,2,F$EDIT(P1,"COLLAPSE,UNCOMMENT,UPCASE"))
$	IF P2 .EQS. "DU" THEN WRITE SYS$OUTPUT "
Can't dismount DUA0:
"
$	IF P2 .EQS. "DU" THEN GOTO Menu_1
$	WRITE OUTPUT F$TIME(),": DISMOUNT/ABORT ",P1
$	IF NOTSYSTEM THEN SET PROCESS/PRIV=(GRPNAM,SHARE,SYSNAM,VOLPRO)
$	DISMOUNT/ABORT 'P1'
$	IF NOTSYSTEM THEN SET PROCESS/PRIV=(NOGRPNAM,NOSHARE,NOSYSNAM,NOVOLPRO)
$	GOTO Menu_1
$!
$Set_logins:
$	WRITE OUTPUT F$TIME(),": SET LOGINS/INTERACTIVE=",Next_set_logins
$	SET LOGINS/INTERACTIVE='Next_set_logins'
$	Next_set_logins = (.NOT.Next_set_logins).AND.64
$	GOTO Menu_1
$!
$Stop_start:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Queue name [LPA0, LPA1, LJA0, SYS$PRINT, SYS$BATCH, etc.]: " SYS$COMMAND P1
$	P1 = F$EDIT(P1,"COLLAPSE,UNCOMMENT,UPCASE")
$	IF P1.EQS."LP" .OR. P1.EQS."LJ" THEN P1 = P1+"A0"
$	IF P1.EQS."LP1" THEN P1 := LPA1
$	IF P1.EQS."BATCH" .OR. P1.EQS."PRINT" THEN P1 = "SYS$"+P1
$	IF P1.NES."LPA0" .AND. P1.NES."LPA1" .AND. P1.NES."LJA0" .AND. P1.NES."SYS$BATCH" -
		.AND. P1.NES."SYS$PRINT" THEN P1 = ""
$	IF P1.EQS."" THEN GOTO Stop_start
$Stop_when:
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT=-
"Stopping current job, Immediately, End of job, Shortly [A/I/E/S]: " SYS$COMMAND P2
$	P2 = F$EXTRACT(0,1,F$EDIT(P2,"COLLAPSE,UNCOMMENT,UPCASE"))
$	IF P2.NES."I" .AND. P2.NES."E" .AND. P2.NES."S" .AND. P2.NES."A" -
		THEN P2 = ""
$	IF P2 .EQS. "" THEN GOTO Stop_when
$	P4 = ""
$	IF P2 .EQS. "I" THEN P4 := /RESET
$	IF P2 .EQS. "E" THEN P4 := /NEXT
$	IF P2 .EQS. "A" THEN P4 := /ABORT
$	IF P2 .NES. "A" .AND. P1 .NES. "SYS$BATCH" THEN GOTO Stop_queue
$	READ/END=Menu_1/PROMPT="Entry number: " SYS$COMMAND P4
$	P4 := /ABORT/ENTRY='P4'
$Stop_queue:
$	WRITE OUTPUT F$TIME(),": STOP/QUEUE''P4' ",P1
$	STOP/QUEUE'P4' 'P1'
$	IF P2 .EQS. "A" THEN GOTO Menu_1
$	IF P1 .EQS. "SYS$BATCH" THEN GOTO Restart_batch
$	IF P2 .EQS. "I" THEN WRITE SYS$OUTPUT -
	"
Ensure that printer is at top of form before restarting queue
"
$Restart_options:
$	TYPE SYS$INPUT
	You can restart the printer at various points according to your
	response to the next question:-
		 .	continues from where it stopped
		 \	at the next job
		 n	at absolute page number n (0 = top of file)
	        -n	back n pages
		+n	forward n pages
	      string	at 1st page containing "string" (not number,".","\","?")
	Answer one of the above when ready to restart.

$	IF P3.LES." " THEN READ/END=Menu_1/PROMPT=-
	  "Restart where [./\/-n/n/+n/string, ?=list options]: " SYS$COMMAND P3
$	IF P3 .EQS. "?" THEN GOTO Restart_failed
$	P5 = ""
$	IF P3 .EQS. "." THEN GOTO Restart_queue
$	P5 := /NEXT
$	IF P3 .EQS. "\" THEN GOTO Restart_queue
$	P5 = "/SEARCH=""''P3'"""
$	IF F$TYPE(P3) .EQS. "STRING" THEN GOTO Restart_queue
$	P5 := /TOP
$	IF P3.EQ.0 THEN GOTO Not_reset ! even if STOPped/RESET
$	P4 = F$EXTRACT(0,1,P3)
$	P5 = "/FORWARD="+P3-"+"
$	IF P4.EQS."+" THEN GOTO Restart_queue
$	P5 = "/BACK="+P3-"-"
$	IF P4 .EQS. "-" THEN GOTO Restart_queue
$	P3=P3-1
$	IF P3.LT.0 THEN P3=0
$	P5 := /TOP/FORWARD='P3'
$Restart_queue:
$	IF P2 .NES. "I" THEN GOTO Not_reset
$	WRITE SYS$OUTPUT "Doing a dummy start/stop to position correctly"
$	START/QUEUE 'P1'
$	STOP/QUEUE 'P1'
$Not_reset:
$	WRITE OUTPUT F$TIME(),": START/QUEUE",P5," ",P1 ! N.B. may be " in P5
$	START/QUEUE'P5' 'P1'
$	IF $SEVERITY .EQ. 1 THEN GOTO Menu_1
$Restart_failed:
$	P3 = ""
$	GOTO Restart_options
$Restart_batch:
$	INQUIRE P1 "Press CR to restart BATCH queue"
$	WRITE OUTPUT F$TIME(),": START/QUEUE SYS$BATCH"
$	START/QUEUE SYS$BATCH
$	GOTO Menu_1
$!
$Send_Message:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
		"To: [username(s), terminal(s), or * for all]: " SYS$COMMAND P1
$	P1 = F$EDIT(P1,"COMPRESS,UPCASE")
$	IF P2.LES." " THEN GOTO No_message
$! Message is rest of line, may contain > 1 word.
$	P3 = F$LENGTH(F$ELEMENT(0," ",Function))+ -
		F$LENGTH(F$ELEMENT(1," ",Function))+2
$	P2 = F$EXTRACT(P3,F$LENGTH(Function)-P3,Function)
$	GOTO Got_message
$No_message:
$	READ/END=Menu_1/PROMPT="Message: " SYS$COMMAND P2
$Got_message:
$	P3 := ALL
$	IF P1.EQS."*" THEN GOTO Send_it
$	P3 := USERNAME
$	P4 = F$EXTRACT(0,2,P1)
$	IF P4.EQS."TX" .OR. P4.EQS."OP" .OR. P4.EQS."TT" THEN P3 := TERMINAL
$Send_it:
$	IF P1 .EQS. "*" THEN P1 = ""
$	IF P1 .NES. "" THEN P1 = "=("+P1+")"
$	WRITE OUTPUT F$TIME(),": REPLY/BELL/''P3'''P1' """,P2,""""
$	REPLY/BELL/'P3''P1' "''P2'"
$	GOTO Menu_1
$!
$Change_owner:
$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Full name of file: " SYS$COMMAND P1
$	P3 = F$ELEMENT(0,".",F$PARSE(P1,,,"DIRECTORY","SYNTAX_ONLY"))-"["-"]"
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT=-
		"New owner [CR = ''P3']: " SYS$COMMAND P2
$	IF P2.EQS."" THEN P2 = P3
$	WRITE OUTPUT F$TIME(),": SET FILE/OWNER=''P2' ",P1
$	IF NOTSYSTEM THEN SET PROC/PRIV=SYSPRV
$	SET FILE/OWNER='P2' 'P1'
$	IF NOTSYSTEM THEN SET PROC/PRIV=NOSYSPRV
$	GOTO Menu_1
$!
$Shutdown_system:
$	P1 = F$EDIT(F$EXTRACT(0,1,P1),"UPCASE")
$	IF P1.GTS." " THEN GOTO Shut_type_given
$Shutdown_menu:
$	TYPE SYS$INPUT
	Shutdown options are:
		T	Shut down for reboot Tomorrow
		I	Shut down and reboot Immediately
		O	Supply special shutdown Options individually
		C	Crash system (use only if all else fails)

$	IF P1.LES." " THEN READ/END=Menu_1/PROMPT=-
"Option: reboot Tomorrow/Immediately, supply all Options, Crash [T/I/O/C]: " SYS$COMMAND P1
$	P1 = F$EXTRACT(0,1,F$EDIT(P1,"COLLAPSE,UNCOMMENT,UPCASE"))
$Shut_type_given:
$	P3 = """Switching off"" YES YES ""tomorrow"" NO NONE"
$	IF P1.EQS."T" THEN GOTO Shut_when
$	P3 = ""
$	IF P1.EQS."O" THEN GOTO Shut_down
$	P3 = """Rebooting"" NO YES ""shortly"" YES REBOOT_CHECK"
$	IF P1.EQS."I" THEN GOTO Shut_when
$	IF P1.EQS."C" THEN GOTO Crash_system
$	P1 = ""						! Illegal option, retry
$	P2 = ""
$	GOTO Shutdown_menu
$Shut_when:
$	IF P2.LES." " THEN READ/END=Menu_1/PROMPT=-
		"Minutes to wait before shutdown: " SYS$COMMAND P2
$	IF F$TYPE(P2).NES."INTEGER" THEN GOTO Shut_when
$	IF P2.EQS."" THEN P2 := MINIMUM
$Shut_down:
$	IF P1.NES."I" THEN TYPE SYS$SYSROOT:[OPERATOR]SWITCHOFF.TXT
$	WRITE OUTPUT F$TIME(),": @SYS$SYSTEM:SHUTDOWN ''P2' ",P3
$	WRITE OUTPUT F$FAO("!80*#")
$	CLOSE OUTPUT
$	IF NOTSYSTEM THEN SET PROCESS /PRIV=(CMKRNL,EXQUOTA,LOG_IO,SYSNAM,SYSPRV,WORLD)
$	ON CONTROL_Y THEN GOTO Shutdown_aborted
$	SET NOVERIFY
$	@SYS$SYSTEM:SHUTDOWN 'P2' 'P3'
$	GOTO Shutdown_aborted
$!
$Crash_System:
$	TYPE SYS$INPUT

Forcing a system crash should be done in only dire emergency situations in
which the 1-2 minutes it takes to perform an orderly shutdown is not safe.
Remember, some disk files will not get properly updated in the event of a
crash.

$	INQUIRE/NOPUNCT P1 "Are you really sure you want to crash the system [Y/N]? "
$	IF .NOT.P1 THEN GOTO Menu_1
$	TYPE SYS$SYSROOT:[OPERATOR]SWITCHOFF.TXT
$	WRITE OUTPUT F$TIME(),": RUN SYS$SYSTEM:OPCCRASH"
$	WRITE OUTPUT F$FAO("!80*#")
$	CLOSE OUTPUT
$	ON CONTROL_Y THEN GOTO Shutdown_aborted
$	IF NOTSYSTEM THEN SET PROCESS /PRIV=CMKRNL
$	RUN SYS$SYSTEM:OPCCRASH				! Shut down proc
$Shutdown_aborted:
$	ON CONTROL_Y THEN GOTO All_Done
$	IF NOTSYSTEM THEN SET PROCESS -
		/PRIV=(NOCMKRNL,NOEXQUOTA,NOLOG_IO,NOSYSNAM,NOSYSPRV,NOWORLD)
$	OPEN/APPEND OUTPUT OPERATOR.LOG
$	WRITE OUTPUT F$TIME(),": Shutdown failed or aborted -- continuing"
$	GOTO Menu_1
$!
$Timed_out:
$	TIMEOUT := /TIMEOUT=255/ERROR=Timed_out
$	P3 = "timed out"
$	GOTO Mark_end
$!
$End_session:
$	P3 = "ended session"
$Mark_end:
$	WRITE OUTPUT F$TIME(),": ''Last_Name' ",P3
$	WRITE OUTPUT F$FAO("!80*-")
$	SET NOVERIFY
$	GOTO Enter_name
$!
$All_Done:
$	WRITE OUTPUT F$TIME(),": OPERATOR logged out"
$	WRITE OUTPUT F$FAO("!80*=")
$	GOTO Exit_or_logout
$!
$No_Operator_File:
$	WRITE SYS$OUTPUT "
No operator authorisation file exists, Exiting!
"
$	GOTO Exit_or_logout
$!
$EOF:	CLOSE INFILE
$	WRITE OUTPUT -
F$TIME(),": ''Last_Name' attempted unsuccessfully to use OPERATOR account"
$	SET MESSAGE/TEXT/SEVERITY/IDENT/FACILITY
$	ON CONTROL_Y THEN GOTO All_Done
$	SET CONTROL=Y
$	WRITE SYS$OUTPUT "
You are not authorised for the operator account
"
$	GOTO Enter_Name					! Try again
$!
$Read_Error:
$	WRITE SYS$OUTPUT "
Error reading OPERATORS.DAT, Exiting!!
"
$!
$Exit_or_logout:
$	CLOSE OUTPUT
$	IF NOTSYSTEM THEN LOGOUT
$	EXIT
