C*********************************************************************
C
C	INCLUDE BLOCK FOR SCREEN ROUTINES
C
C	Developed by:
C
C		Gerald Land and Jeff Burch
C		Florida Solar Energy Center
C		300 State Road 401
C		Cape Canaveral, FL 32920
C		305-783-0300
C
C	Last modified: Feb-88 -- CJD -- translation to SMG and extensions
C
C*********************************************************************
	PARAMETER MAXFIELD=50,MAXMARK=10
	INTEGER*4 DISPLAY_ID,PASTEBOARD_ID,KEYBOARD_ID,
     &		HELP_ID,TTYPE,ILIN,ICOL,IFIELD,INUM_FIELDS,INUM_MARKS,
     &		IBOLD,IVAL(50)
	CHARACTER*80 CVAL(50)
	REAL RVAL(50)
	BYTE IPOSITION(50),LINE(50),BCOL(50),ECOL(50),TYPE(50),
     &		MCOL(10),MFIELD(10)
	COMMON /SCR_SCREEN/ DISPLAY_ID,PASTEBOARD_ID,KEYBOARD_ID,
     &		HELP_ID,TTYPE,ILIN,ICOL,IFIELD,INUM_FIELDS,INUM_MARKS,
     &		IBOLD,IPOSITION,LINE,BCOL,ECOL,TYPE,MCOL,MFIELD
	COMMON /SCR_SCREEN_VALUE/ IVAL,RVAL,CVAL
C
C	**** ARRAY DESCRIPTIONS ****
C
C	IVAL(MAXFIELD), RVAL(MAXFIELD), and CVAL(MAXFIELD) arrays contain user
C		data to be displayed on the terminal screen, modified by
C		terminal user, and returned to the caller.  
C	IPOSITION(MAXFIELD) array contains integer values which map data from
C		the IVAL, RVAL, and CVAL arrays into the respective data fields.
C	LINE(MAXFIELD) array contains the line (row) for the field.
C	BCOL(MAXFIELD) array contains the starting column number.
C	ECOL(MAXFIELD) array contains the ending column number.
C	TYPE(MAXFIELD) contains a flag indicating the data type:
C		-ve = CHARACTER, 0 = INTEGER, +ve = REAL
C		For REALs, its value is 1 + the number of decimal places
C		for the real number display.
C	MFIELD(MAXMARK),MCOL(MAXMARK) arrays contain the field number (and
C		hence line number) and column for user-positioned markers.
C
C	**** SIMPLE VARIABLE DESCRIPTIONS ****
C
C	IFIELD	contains the current field number.
C	ICOL	contains the current screen column number.
C	ILIN	contains the current screen row number.
C		NOTE: ILIN is always equal to LINE(IFIELD), but the INTEGER*4
C		value in ILIN is kept updated in parallel to save having to
C		keep converting from the INTEGER*1 LINE array entry.
C	INUM_FIELDS contains the number of data fields defined for this
C		screen. Because of the array dimensions of MAXFIELD (see above),
C		this variable is less than or equal to MAXFIELD.
C	INUM_MARKS contains the number of text position markers.
C	IBOLD contains the inverse/normal display flag for data fields.
C		This is toggled with the control-N command.
C		IBOLD = 0 is normal video. IBOLD = SMG$M_REVERSE for reverse.
C	DISPLAY_ID, PASTEBOARD_ID, KEYBOARD_ID and HELP_ID are SMG area
C		addresses for the user's TT:.
C	TTYPE is the terminal type, determined at SMG startup,
C		SMG$K_VTUNKNOWN, SMG$K_VT52=2, SMG$K_VT100=3
C	"VT100" covers any flavour of VT1xx, or upward-compatible VT2xx, VT3xx
C	These values are defined in $SMGDEF, but "unused" by SMG (it says).
