C**********************************************************************
C
C	MASTER ROUTINE TO MANIPULATE THE SCREEN
C
C**********************************************************************
	SUBROUTINE SCR_SCRIN(ISEC, IUNIT, FLAG, LOGMODE, LOGKEY)
C		---- ISEC = USER SECTION NUMBER
C		---- IUNIT = OPEN UNIT # FOR SECTION FILE
C		---- FLAG = RESPONSE TO CALLER IF ERROR HAS OCCURED
C		---- LOGMODE = .TRUE. IF IN REPLACE MODE
C		---- LOGKEY = .TRUE. IF IN KEYPAD MODE, .FALSE. IN NUMERIC MODE
	INCLUDE '($DVIDEF)'
	INCLUDE '($LIBCLIDEF)'
	INCLUDE '($SMGDEF)'
	INCLUDE 'SCREEN.FOR'
	CHARACTER*80 D_LINE,D_WORD,S_KEY,CDATE*12,CTIME*11,D_CHR*1
	LOGICAL*1 GOLD,FLAG,LOGMODE,LOGKEY
	INTEGER*4 LASTDEL,DL_LEN,DW_LEN,SK_LEN,OLDKEY,DIRECT,OLDENMSK
	INTEGER*2 ICHR
	LOGICAL SCR_GETKEY
	DATA TTYPE /-999/, IBOLD /SMG$M_REVERSE/, HELP_ID /0/,
     &	     LASTDEL /1/

C	---- SEE IF WE ARE IN BATCH OR A COMMAND FILE MODE
	CALL SCR_GETMODE(IMODE)
	IF (IMODE.NE. 1) THEN
		IF (ISEC.GE.0 .AND. ISEC .NE. ICURRENT_SECTION) THEN
			CALL SCR_RDSECT(FLAG,ISEC,IUNIT,IMODE)
			IF (FLAG) RETURN
			ICURRENT_SECTION = ISEC
		ENDIF
		CALL SCR_RDBATCH
		RETURN
	ENDIF

C	---- IF FIRST TIME HERE, INITIALIZE CHANNEL TO TT:
	IF (TTYPE .EQ. -999) CALL SCR_INITT

C	---- IF USER SECTION NUMBER IS POSITIVE, AND HAS CHANGED, GET NEW
C	---- SECTION

	IF (ISEC.GE.0 .AND. ISEC.NE.ICURRENT_SECTION ) THEN
		CALL SMG$BEGIN_DISPLAY_UPDATE(DISPLAY_ID) ! DON'T SHOW ____'S
		CALL SCR_RDSECT(FLAG, ISEC, IUNIT, IMODE)
		IF (FLAG) THEN
			CALL SMG$END_DISPLAY_UPDATE(DISPLAY_ID)
			RETURN
		ENDIF
		CALL SCR_ENCVAL		!ENCODE USER VALUES
		CALL SMG$END_DISPLAY_UPDATE(DISPLAY_ID)
		ICURRENT_SECTION = ISEC

	ELSE
C		---- SETUP USER VALUES ON SCREEN
		CALL SMG$REPAINT_SCREEN(PASTEBOARD_ID)	! MAYBE USER OVERWROTE IT
		CALL SCR_ENCVAL		!ENCODE USER VALUES
	ENDIF

C	---- DISABLE CTRL/Y (& CTRL/C) SO SCRIN CAN TRAP THEM
	CALL LIB$DISABLE_CTRL(LIB$M_CLI_CTRLY,OLDENMSK)
	CALL LIB$GETDVI(DVI$_TT_APP_KEYPAD,,'SYS$INPUT',OLDKEY)
	I=0
	IF(LOGKEY) I=1
	CALL SMG$SET_KEYPAD_MODE(KEYBOARD_ID,I)

	DIRECT=+1
1001	IFIELD=1				! START AT THE TOP
1002	ILIN=LINE(IFIELD)
	ICOL=BCOL(IFIELD)
C
C	---- MOVE THE CURSOR TO 1ST LOGICAL POSITION
1	CALL SMG$SET_CURSOR_ABS(DISPLAY_ID,ILIN,ICOL)
10	GOLD=.FALSE.		!SETUP GOLD KEY TO FALSE
11	CALL SMG$READ_KEYSTROKE(KEYBOARD_ID,ICHR)	!READ CHARACTER FROM TT:
C
C	---- NORMAL PRINTING CHARACTER (INCLUDING MULTINATIONALS) IS MOST LIKELY
	IF ((ICHR.GE.SMG$K_TRM_SPACE .AND. ICHR.LE.SMG$K_TRM_TILDE) .OR.
     &	    (ICHR.GE.'A1'X .AND. ICHR.LE.'FE'X)) THEN
		CALL SCR_PUTCHR(LOGMODE,CHAR(ICHR))
		GOTO 10
	ENDIF
C
C	---- IF DEL, BACKSPACE AND DELETE CHAR (UNLESS AT START OF FIELD)
	IF (ICHR.EQ.SMG$K_TRM_DELETE) THEN
		IF (GOLD) GOTO 1100			! GOLD/DELETE = UNDC
		IF(ICOL.NE.BCOL(IFIELD)) THEN
			ICOL = ICOL - 1
			CALL SMG$SET_CURSOR_REL(DISPLAY_ID,0,-1)
			CALL SCR_DELC(D_CHR)
			LASTDEL=2
		ENDIF
		GOTO 10
	ENDIF
C
C	---- NEXT TRY KEYPAD KEYS. ASSUMES NAUGHTILY THAT DEC WILL NEVER
C	---- CHANGE THE SMG$K_TRM DEFINITIONS, BUT THAT IS UNLIKELY
C
C	       PF1, PF2, PF3, PF4, "0", "1", "2", "3", "4", "5",
	GOTO (1000,1010,1020,1030,1040,1050,1060,1070,1080,1090,
C	       "6", "7", "8", "9", ENT, "-", ",", ".",  UP,DOWN,
     &	      1100,1110,1120,1130,1140,1150,1160,1170,1180,1190,
C	       LFT,  RT,----,----,----, F1,  F2,  F3,  F4,  F5,
     &	      1200,1210,1999,1999,1999,1999,1999,1999,1999,1999,
C	        F6,  F7,  F8,  F9, F10, F11,  BS,  LF, F14,HELP,
     &	      1300,1999,1320,1999,1340,1999,1360,1370,1999,1390,
C	        DO, F17, F18, F19, F20,----,----,----,----,----,
     &	      1400,1999,  10,1430,1440,1999,1999,1999,1999,1999,
C	      ----,----,----,----,----,FIND, INS, REM, SEL,PREV,
     &	      1999,1999,1999,1999,1999,1550,1560,1570,1580,1590,
C	      NEXT
     &	      1600),
     &	ICHR-SMG$K_TRM_PF1+1
C
C	---- FINALLY, CONTROLS
C
C		^A,  ^B,  ^C,  ^D,  ^E,  ^F,  ^G,  BS,  HT,  LF,
	GOTO (2010,2020,2030,2040,2050,1999,1999,2080,2090,2100,
C		^K,  FF,  CR,  ^N,  ^O,  ^P,  ^Q,  ^R,  ^S,  ^T,
     &	      1999,2120,2130,2140,1999,2160,1999,2180,1999,1999,
C		^U,  ^V,  ^W,  ^X,  ^Y,  ^Z
     &	      2210,2220,2230,1999,2250,2260),
     &	ICHR
C
C	---- NONE OF THE ABOVE, OR UNDEFINED KEY, WARN AND IGNORE
 1999	CALL SMG$RING_BELL(DISPLAY_ID)
	GOTO 10
C
C	------------------------------------------------------------------
C		K E Y P A D   A N D   F U N C T I O N   K E Y S
C	------------------------------------------------------------------
C
C PF1	-- SET GOLD ON
 1000	GOLD=.TRUE.
	GOTO 11
C
C PF2	-- SHOW HELP KEYPAD
 1390	CONTINUE					! ALSO "HELP" ON LK201
 1010	CALL SCR_KEYHELP(LOGMODE,LOGKEY,DIRECT)
	GOTO 10
C
C PF3	-- TOGGLE KEYPAD MODE
 1020	LOGKEY=.NOT.LOGKEY
	I=0
	IF(LOGKEY) I=1
	CALL SMG$SET_KEYPAD_MODE(KEYBOARD_ID,I)
	GOTO 10
C
C PF4	-- DELETE WHOLE FIELD;  GOLD-PF4 -- UNDELETE FIELD
 1070	IF(TTYPE.NE.SMG$K_VT52) GOTO 1999		! ALSO "3" ON VT52
 1030	IF(GOLD) THEN
 1440		CONTINUE				! "F20" = UND ON LK201
 1564		CALL SCR_UND(D_LINE,DL_LEN)
	ELSE
		ICOL=BCOL(IFIELD)
		CALL SMG$SET_CURSOR_ABS(DISPLAY_ID,,ICOL)
		CALL SCR_DELL(D_LINE,DL_LEN)
		LASTDEL=4
	ENDIF
	GOTO 10
C
C "0"	-- NEXT FIELD;  GOLD-"0" -- FIRST FIELD ON NEXT/PREVIOUS LINE
 2130	CONTINUE					! ALSO CONTROL/M = CR
 1040	IF (GOLD) THEN
		IEND=INUM_FIELDS
		IDIR=DIRECT
		IF (IDIR.LT.0) IEND=1
		DO I=IFIELD+DIRECT,IEND,DIRECT
			IF(LINE(I).NE.ILIN) THEN
				ICOL=1
				GOTO 1192		! Finish like UP/DOWN
			ENDIF
		ENDDO
	ELSE
		CALL SCR_NEXTFLD(DIRECT)
	ENDIF
	GOTO 10
C
C "1"	-- NEXT WORD;  GOLD-"1" -- CHANGE CASE
 1050	IF(GOLD)THEN
 1051		CALL SCR_CHGC
	ELSE
		CALL SCR_NEXTWD(DIRECT)
	ENDIF
	GOTO 10
C
C "2"	-- END OF FIELD;  GOLD-"2" -- DELETE TO END OF FIELD
 1060	IF(GOLD)THEN
 1320		CONTINUE				! F8 ON LK201
		CALL SCR_DELL(D_LINE,DL_LEN)
		LASTDEL=4
	ELSE
		CALL SCR_EOL(DIRECT)
	ENDIF
	GOTO 10
C
C "4"	-- ADVANCE;  GOLD-"4" -- BOTTOM
 1080	IF(GOLD) THEN
		IFIELD=INUM_FIELDS
		GOTO 1002
	ELSE
		DIRECT=+1
	ENDIF
	GOTO 10
C
C "5"	-- BACKUP;  GOLD-"5" -- TOP
 1090	IF(GOLD)GOTO 1001
	DIRECT=-1
	GOTO 10
C
C "7"	-- SWAP CHARACTERS;  GOLD-"7" -- SWAP WORDS
 1110	IF(GOLD)THEN
		CALL SCR_SWAPW
	ELSE
		CALL SCR_SWAPC
	ENDIF
	GOTO 10
C
C "8"	-- FIND;  GOLD-"8" -- READ KEY AND FIND
 1120	IF(.NOT.GOLD) GOTO 1121
 1550	CONTINUE					! LK201 "FIND" = GOLD-"8"
	IF(.NOT.SCR_GETKEY(S_KEY,SK_LEN,DIRECT)) GOTO 10
 1121	CALL SCR_FIND(S_KEY,SK_LEN,DIRECT)
	GOTO 10
C
C "ENTER" ---- INPUT PHASE IS DONE, GET VALUES, BACK TO USER
 1400	CONTINUE					! ALSO LK201 "DO"
 2260	CONTINUE					! ALSO CONTROL/Z
 1140	CALL SCR_DECVAL
	CALL SMG$SET_CURSOR_ABS(DISPLAY_ID,24,1)
	CALL SMG$SET_KEYPAD_MODE(KEYBOARD_ID,OLDKEY)
	CALL LIB$ENABLE_CTRL(OLDENMSK)
	RETURN
C
C "9"	-- VT52:  DELETE WORD;  GOLD-"9" -- UNDELETE WORD
C	-- VT100: TOGGLE INVERSE DISPLAY
 1130	IF (TTYPE.EQ.SMG$K_VT100) GOTO 2140		! AS CONTROL/N
C
C "-"	-- DELETE WORD;  GOLD-"9" -- UNDELETE WORD
 1150	IF(GOLD) THEN
 1430		CONTINUE				! F19 = UND ON LK201
 1563		CALL SCR_UND(D_WORD,DW_LEN)
	ELSE
		CALL SCR_DELW(D_WORD,DW_LEN,+1)
		LASTDEL=3
	ENDIF
	GOTO 10
C
C ","	-- DELETE CHAR;  GOLD-"," -- UNDELETE CHAR
 1100	IF (TTYPE.NE.SMG$K_VT52) GOTO 1999		! ALSO "6" ON VT52 ONLY
 1160	IF(GOLD) THEN
 1562		CALL SCR_UND(D_CHR,1)
	ELSE
		CALL SCR_DELC(D_CHR)
		LASTDEL=2
	ENDIF
	GOTO 10
C
C "."	-- TOGGLE LOGMODE;  GOLD-"." -- RESET
 1170	IF(GOLD) GOTO 10
 2010	CONTINUE					! ALSO CONTROL/A
	LOGMODE=.NOT.LOGMODE
	GOTO 10
C
C UP	-- GO TO NEAREST FIELD ABOVE
 1180	IDIR=-1
	IEND=1
	GOTO 1191
C
C DOWN	-- GO TO NEAREST FIELD BELOW
 1190	IDIR=+1
	IEND=INUM_FIELDS
C
C	---- SEARCH FOR NEXT NEAREST LINE WHICH CONTAINS A FIELD.
 1191	DO I=IFIELD+IDIR,IEND,IDIR
		IF(LINE(I).NE.ILIN) GOTO 1192
	ENDDO
	GOTO 10						! NONE FOUND
C	---- FOUND A LINE, NOW EXAMINE EACH FIELD ON IT FOR A FIELD WHICH
C	---- CONTAINS ICOL, OR STARTS/ENDS NEAREST IT
 1192	ILIN=LINE(I)
	INEWCOL=ICOL
	IDMIN=255					! ANYTHING > SCREEN WIDTH
	DO I=I,IEND,IDIR
		IF(LINE(I).NE.ILIN) GOTO 1193
		IDB=ICOL-BCOL(I)
		IDE=ECOL(I)-ICOL
		IF(IDB.GE.0 .AND. IDE.GE.0) THEN	! INCLUDED
			IFIELD=I
			GOTO 1
		ENDIF
		IDB=IABS(IDB)
		IF (IDB.LT.IDMIN) THEN
			IDMIN=IDB
			IFIELD=I
			INEWCOL=BCOL(I)
		ENDIF
		IDE=IABS(IDE)
		IF (IDE.LT.IDMIN) THEN
			IDMIN=IDE
			IFIELD=I
			INEWCOL=ECOL(I)
		ENDIF
	ENDDO
1193	ICOL=INEWCOL
	GOTO 1
C
C LEFT	-- MOVE CURSOR LEFT, TO PREVIOUS FIELD IF NECESSARY/POSSIBLE
C	-- GOLD-LEFT JUMP BACK 16 CHARACTERS, OR TO END OF THE PREVIOUS
C	   FIELD IF THAT WOULD TAKE YOU OUT OF THIS ONE
 1200	I=1
	IF (GOLD) I=16
	IF (ICOL-I.GE.BCOL(IFIELD)) THEN
		ICOL=ICOL-I
		GOTO 1
	ELSE					! CAN'T, GO TO END OF PREVIOUS FIELD
		CALL SCR_EOL(-1)
	ENDIF
	GOTO 10
C
C RIGHT	-- MOVE CURSOR RIGHT, INTO NEXT FIELD IF NECESSARY/POSSIBLE
C	-- GOLD-RIGHT JUMP FORWARDS 16 CHARACTERS, OR TO START OF THE NEXT
C	   FIELD IF THAT WOULD TAKE YOU OUT OF THIS ONE
 1210	I=1
	IF (GOLD) I=16
	IF (ICOL+I.LE.ECOL(IFIELD)) THEN
		ICOL=ICOL+I
		GOTO 1
	ELSE				! CAN'T, GO TO START OF NEXT FIELD
		CALL SCR_NEXTFLD(+1)
	ENDIF
	GOTO 10
C
C
C "Insert Here" (LK201) -- INSERT LAST-DELETED ITEM HERE
 1560	GOTO (1562,1563,1564), LASTDEL-1
	GOTO 10
C
C "Select" (LK201) -- FIND NEXT MARK
 2090	CONTINUE					! Also tab
 1580	CALL SCR_NXTMARK(DIRECT)
	GOTO 10
C
C "Previous Screen" (LK201) -- PREVIOUS FIELD
C	---- CONTROL/H = BACKSPACE (F12 ON VT220), RESET TO BEGINNING OF FIELD
 1360	CONTINUE					! ALSO F12 ON LK201
 2080	CONTINUE					! OR BACKSPACE
 1590	CALL SCR_NEXTFLD(-1)
	GOTO 10
C
C "Next Screen" (LK201) -- NEXT FIELD
 1600	CALL SCR_NEXTFLD(+1)
	GOTO 10
C
C F10	---- Change case;  GOLD-F10 -- DATE
 1340	IF(GOLD) GOTO 1051
	GOTO 2041
C
C	------------------------------------------------------------------
C				C O N T R O L S
C	------------------------------------------------------------------
C
C
C ^B	-- BACK WORD, REGARDLESS OF CURRENT 'DIRECT' SETTING
 2020	CALL SCR_NEXTWD(+1)
	GOTO 10
C
C ^C	---- EXIT
 1300	CONTINUE					! F6 ON LK201 KEYBOARD
 2250	CONTINUE					! ALSO CONTROL/Y
 2030	CALL SMG$PUT_CHARS(DISPLAY_ID,
     &		'PROGRAM ABORTED ON CONTROL C OR Y',24,1,1)
	CALL SMG$DELETE_PASTEBOARD(PASTEBOARD_ID,0)
	CALL LIB$ENABLE_CTRL(OLDENMSK)
	CALL EXIT
C
C ^D	-- INSERT CURRENT DATE;   GOLD-CONTROL/D, INSERT TIME
 2040	IF (GOLD) THEN
		CALL SYS$ASCTIM(,CTIME,,%VAL(1))
		CALL SCR_UND(CTIME,8)
	ELSE
 2041		CALL SYS$ASCTIM(,CDATE,,)
		IF (ECOL(IFIELD)-ICOL+1.GE.11) THEN
			CALL SCR_UND(CDATE,11)		! DD-MMM-YYYY WILL FIT
		ELSE
			CDATE(8:9)=CDATE(10:11)		! WON'T, TRY
			CALL SCR_UND(CDATE,9)		! DD-MMM-YY
		ENDIF
	ENDIF
	GOTO 10
C
C ^E	-- MOVE TO END OF CURRENT FIELD, REGARDLESS OF CURRENT DIRECTION. (I.E. A LA DCL)
 2050	CALL SCR_EOL(+1)
	GOTO 10
C
C LF	-- DELETE PREVIOUS WORD;  GOLD-LF -- UNDELETE WORD
 1370	CONTINUE					! F13 ON LK201
 2100	IF (GOLD) THEN
		CALL SCR_UND(D_WORD,DW_LEN)
	ELSE
		CALL SCR_DELW(D_WORD,DW_LEN,-1)
		LASTDEL=3
	ENDIF
	GOTO 10
C
C FF	-- SET MARK HERE;  GOLD-FF -- CANCEL MARK HERE
 2120	IF (GOLD) THEN
 1570		CONTINUE				! Remove on LK201
		CALL SCR_REMMARK
	ELSE
		CALL SCR_SETMARK
	ENDIF
	GOTO 10
C
C ^N	-- TOGGLE DISPLAY OF VALUES BETWEEN NORMAL/REVERSE/UNDERLINE
 2140	CALL SCR_TOGDIS
	GOTO 10
C ^P	-- PRINT SCREEN
 2160	CALL SMG$CREATE_PASTEBOARD(LP_PID,'LP:')
	CALL SMG$PASTE_VIRTUAL_DISPLAY(DISPLAY_ID,LP_PID,1,1)
	CALL SMG$SNAPSHOT(LP_PID)
	CALL SMG$DELETE_PASTEBOARD(LP_PID)
	GOTO 10
C ^U	-- DELETE TO BEGINNING OF LINE;  GOLD-CONTROL/U -- UNDELETE LINE
 2210	IF (GOLD) GOTO 1440
	CALL SCR_DELBL(D_LINE,DL_LEN)
	LASTDEL=4
	GOTO 10
C
C ^V	-- DECODE (VERIFY) VALUES, AND DISPLAY, BUT DON'T RETURN TO CALLER
 2220	CALL SCR_DECVAL
C
C ^R	-- RELOAD THE VALUES AS SET ON ENTRY, OR SINCE LAST ^V
 2180	CALL SCR_ENCVAL
	GOTO 10
C
C ^W	-- REPAINT THE SCREEN
 2230	CALL SMG$REPAINT_SCREEN(PASTEBOARD_ID)
	GOTO 1						! REPOSITION CURSOR
C
	END
