$ SET NOON
$!
$!	LOAD MICROCODE INTO PCS
$ @SYS$MANAGER:PCS750.COM
$
$! Our clock is slow (so, our engineer says, is everybody's). This adjusts
$! it by the observed daily loss, which reduces the number of times clever-dicks
$! come and complain. Also allows for changes to/from B!**$? Stupid Time.
$ DELTAT := +0:0:07.57			! Time lost by clock each day
$ IF F$CVTIME(,,"WEEKDAY").EQS."Monday" THEN DELTAT := +0:0:22.7 ! Don't work weekends!
$ DATENOW=F$EXTRACT(0,11,F$TIME())
$ IF DATENOW .EQS. "28-MAR-1988" THEN DELTAT := +1:0:22.7
$ IF DATENOW .EQS. "24-OCT-1988" THEN DELTAT := -0:59:37.3
$ SET TIME="''DELTAT'"
$!
$!  Invoke the System Dump Analyzer if the system just crashed
$!
$ ANALYZE/CRASH_DUMP SYS$SYSTEM:SYSDUMP
SET OUTPUT SYS$MANAGER:SYSDUMP.LIS	! Make listing file
SHOW CRASH				! Display crash information
SHOW STACK				! Show current operating stack
SHOW SUMMARY				! List all active processes
SHOW PROCESS/PCB/PHD/REGISTERS		! Display current process
SHOW SYMBOLS/ALL			! Print the system symbol table
COPY SYS$SYSTEM:SAVEDUMP.DMP		! Save dump file for later
SPAWN/NOLOG/NOSYM/NOWAIT BRO/MAIL/USER=SYSTEM "Crash > SYSDUMP.LIS/$SAVEDUMP.DMP"
EXIT
$!
$! 	Connect the console TU58
$ MC SYSGEN
C C
!	Connect paper tape
LOAD SYS$SYSTEM:PCDRIVER
CONNECT PCA0/ADAPTER=UB0/NUMVEC=2/VECTOR=%O70/CSR=%O777550/DRIVER=PCDRIVER
CONNECT PCA1/ADAPTER=UB0/NUMVEC=1/VECTOR=%O74/CSR=%O777554/DRIVER=PCDRIVER
EXIT
$!
$ @SYS$MANAGER:DISKSET					! Assign disks
$!
$ RUN SYS$MANAGER:TESTFPA				! Test FPA while starting
$!
$ @SYS$MANAGER:TERMSET					! Set terminal defaults
$!
$ PUR SYS$MANAGER:OPERATOR.LOG/KEEP=4			! Purge very old OPERATOR.LOG files
$ PUR SYS$SYSROOT:[OPERATOR]OPERATOR.LOG/KEEP=3
$!
$ @SYS$MANAGER:VAX11RSX TXA0:				! Install VAX-11 RSX
$ @SYS$MANAGER:VAX11RTEM TXA0:				! Install VAX-11 RTEM
$!
$ @SYS$MANAGER:GKSTARTUP				! Install GKS
$!
$ @SYS$MANAGER:STARTQ					! Start batch and print queues
$!
$! DEFINE/SYSTEM SYS$WELCOME "@SYS$MANAGER:LOGIN.TXT"	! Login message
$ DEFINE/EXEC/SYSTEM SYS$SYLOGIN SYS$MANAGER:SYLOGIN	! System-wide LOGIN.COM
$!
$ DEFINE/SYSTEM HLP$LIBRARY SYS$HELP:HELPLIB.HLB 	! Main DCL HELP library
$ DEFINE/SYSTEM HLP$LIBRARY_1 SYS$HELP:SIRAHELP.HLB 	! HELP library for SIRA supported utilities
$ DEFINE/SYSTEM HLP$LIBRARY_2 SYS$HELP:MCRHELPLIB.HLB 	! HELP library for MCR
$!
$ SET AUDIT/ALARM/ENABLE=(LOGFAILURE=(LOCAL,DIALUP), -
			  LOGIN=(LOCAL,DIALUP), -
			  LOGOUT=(LOCAL,DIALUP), -
			  MOUNT)
$!
$ INSTALL:=$INSTALL/COMMAND
$ INSTALL
! Remove unused DEC images:
DELETE SYS$SYSTEM:SHWCLSTR
DELETE SYS$SYSTEM:VPM
!DELETE SYS$SHARE:SPISHR
DELETE SYS$SHARE:ADARTL
DELETE SYS$SHARE:VAXCRTL
DELETE SYS$SHARE:VAXCRTLG
DELETE SYS$MESSAGE:NETWRKMSG
!DELETE SYS$SHARE:BASRTL
!DELETE SYS$SHARE:BASRTL2
DELETE SYS$SHARE:COBRTL
!DELETE SYS$SHARE:PASRTL		! Used by SAVOIR
DELETE SYS$SHARE:RPGRTL
!DELETE SYS$MESSAGE:PASMSG		! Used by SAVOIR
DELETE SYS$MESSAGE:PLIMSG
DELETE SYS$MESSAGE:RPGMSG
!
! Add general-purpose Sira images:
ADD SYS$SYSTEM:ABORT/PRIV=(GROUP,OPER)
ADD SYS$SYSTEM:BROADCAST/PRIV=(CMEXEC,TMPMBX,NETMBX)
ADD SYS$SYSTEM:DECMATE_TO_VAX/PRIV=CMKRNL
ADD SYS$SYSTEM:TALK/PRIV=(OPER,WORLD,ALTPRI)
ADD SYS$SYSTEM:WHO/PRIV=WORLD
ADD SYS$SHARE:RIM_SHR/SHARED
!
! Optics images:
!ADD B:[DAVIDSON.V14]V14/OPEN/HEADER/SHARED
ADD B:[DAVIDSON.V14]SLOP/OPEN/HEADER/SHARED
!ADD B:[DAVIDSON]RAY/OPEN/HEADER/SHARED
!ADD B:[DAVIDSON]TOLPRG/OPEN/HEADER/SHARED
!ADD B:[DAVIDSON.GEN]GENTRACE/OPEN/HEADER/SHARED
ADD B:[DAVIDSON.OPT]OPT/OPEN/HEADER/SHARED
EXIT
$!
$ SUBMIT/NOPRINT SYS$MANAGER:SHOWMEM
$!
$ EXIT
